# ************************************************************
# Sequel Pro SQL dump
# Version 4541
#
# http://www.sequelpro.com/
# https://github.com/sequelpro/sequelpro
#
# Host: 127.0.0.1 (MySQL 5.7.28)
# Database: wordpress
# Generation Time: 2020-04-06 23:27:11 +0000
# ************************************************************


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


# Dump of table wp_commentmeta
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_commentmeta`;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;



# Dump of table wp_comments
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_comments`;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;



# Dump of table wp_links
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_links`;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;



# Dump of table wp_options
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_options`;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

LOCK TABLES `wp_options` WRITE;
/*!40000 ALTER TABLE `wp_options` DISABLE KEYS */;

INSERT INTO `wp_options` (`option_id`, `option_name`, `option_value`, `autoload`)
VALUES
	(2,'siteurl','http://localhost:32880','yes'),
	(3,'home','http://localhost:32880','yes'),
	(4,'blogname','Test','yes'),
	(5,'blogdescription','Just another WordPress site','yes'),
	(6,'users_can_register','0','yes'),
	(7,'admin_email','anderson@publishpress.com','yes'),
	(8,'start_of_week','1','yes'),
	(9,'use_balanceTags','0','yes'),
	(10,'use_smilies','1','yes'),
	(11,'require_name_email','1','yes'),
	(12,'comments_notify','1','yes'),
	(13,'posts_per_rss','10','yes'),
	(14,'rss_use_excerpt','0','yes'),
	(15,'mailserver_url','mail.example.com','yes'),
	(16,'mailserver_login','login@example.com','yes'),
	(17,'mailserver_pass','password','yes'),
	(18,'mailserver_port','110','yes'),
	(19,'default_category','1','yes'),
	(20,'default_comment_status','open','yes'),
	(21,'default_ping_status','open','yes'),
	(22,'default_pingback_flag','1','yes'),
	(23,'posts_per_page','10','yes'),
	(24,'date_format','F j, Y','yes'),
	(25,'time_format','g:i a','yes'),
	(26,'links_updated_date_format','F j, Y g:i a','yes'),
	(27,'comment_moderation','0','yes'),
	(28,'moderation_notify','1','yes'),
	(29,'rewrite_rules','','yes'),
	(30,'hack_file','0','yes'),
	(31,'blog_charset','UTF-8','yes'),
	(32,'moderation_keys','','no'),
	(33,'active_plugins','a:1:{i:0;s:35:\"dumb-plugin-one/dumb-plugin-one.php\";}','yes'),
	(34,'category_base','','yes'),
	(35,'ping_sites','http://rpc.pingomatic.com/','yes'),
	(36,'comment_max_links','2','yes'),
	(37,'gmt_offset','0','yes'),
	(38,'default_email_category','1','yes'),
	(39,'recently_edited','','no'),
	(40,'template','twentytwenty','yes'),
	(41,'stylesheet','twentytwenty','yes'),
	(42,'comment_whitelist','1','yes'),
	(43,'blacklist_keys','','no'),
	(44,'comment_registration','0','yes'),
	(45,'html_type','text/html','yes'),
	(46,'use_trackback','0','yes'),
	(47,'default_role','subscriber','yes'),
	(48,'db_version','47018','yes'),
	(49,'uploads_use_yearmonth_folders','1','yes'),
	(50,'upload_path','','yes'),
	(51,'blog_public','1','yes'),
	(52,'default_link_category','2','yes'),
	(53,'show_on_front','posts','yes'),
	(54,'tag_base','','yes'),
	(55,'show_avatars','1','yes'),
	(56,'avatar_rating','G','yes'),
	(57,'upload_url_path','','yes'),
	(58,'thumbnail_size_w','150','yes'),
	(59,'thumbnail_size_h','150','yes'),
	(60,'thumbnail_crop','1','yes'),
	(61,'medium_size_w','300','yes'),
	(62,'medium_size_h','300','yes'),
	(63,'avatar_default','mystery','yes'),
	(64,'large_size_w','1024','yes'),
	(65,'large_size_h','1024','yes'),
	(66,'image_default_link_type','none','yes'),
	(67,'image_default_size','','yes'),
	(68,'image_default_align','','yes'),
	(69,'close_comments_for_old_posts','0','yes'),
	(70,'close_comments_days_old','14','yes'),
	(71,'thread_comments','1','yes'),
	(72,'thread_comments_depth','5','yes'),
	(73,'page_comments','0','yes'),
	(74,'comments_per_page','50','yes'),
	(75,'default_comments_page','newest','yes'),
	(76,'comment_order','asc','yes'),
	(77,'sticky_posts','a:0:{}','yes'),
	(78,'widget_categories','a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}','yes'),
	(79,'widget_text','a:0:{}','yes'),
	(80,'widget_rss','a:0:{}','yes'),
	(81,'uninstall_plugins','a:0:{}','no'),
	(82,'timezone_string','','yes'),
	(83,'page_for_posts','0','yes'),
	(84,'page_on_front','0','yes'),
	(85,'default_post_format','0','yes'),
	(86,'link_manager_enabled','0','yes'),
	(87,'finished_splitting_shared_terms','1','yes'),
	(88,'site_icon','0','yes'),
	(89,'medium_large_size_w','768','yes'),
	(90,'medium_large_size_h','0','yes'),
	(91,'wp_page_for_privacy_policy','3','yes'),
	(92,'show_comments_cookies_opt_in','1','yes'),
	(93,'admin_email_lifespan','1601767534','yes'),
	(94,'initial_db_version','47018','yes'),
	(95,'wp_user_roles','a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:61:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}','yes'),
	(96,'fresh_site','1','yes'),
	(97,'widget_search','a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}','yes'),
	(98,'widget_recent-posts','a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}','yes'),
	(99,'widget_recent-comments','a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}','yes'),
	(100,'widget_archives','a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}','yes'),
	(101,'widget_meta','a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}','yes'),
	(102,'sidebars_widgets','a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:9:\"sidebar-2\";a:3:{i:0;s:10:\"archives-2\";i:1;s:12:\"categories-2\";i:2;s:6:\"meta-2\";}s:13:\"array_version\";i:3;}','yes'),
	(103,'cron','a:5:{i:1586215534;a:5:{s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1586215562;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1586215566;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1586301934;a:1:{s:30:\"wp_site_health_scheduled_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}s:7:\"version\";i:2;}','yes'),
	(104,'widget_pages','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(105,'widget_calendar','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(106,'widget_media_audio','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(107,'widget_media_image','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(108,'widget_media_gallery','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(109,'widget_media_video','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(110,'nonce_key','+r^Mz>K:D4ya.`)z)d**g4/FYhnK )h[fAj5jQRAzY^hvAk=ZzIaP^:miD@?GJ?.','no'),
	(111,'nonce_salt','hBc]0^#z$,D@5!pqD-yT,3o4{6^_~U5]j%ONAYF{jK9cbXf5/ X=}4~#s6bR ny<','no'),
	(112,'widget_tag_cloud','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(113,'widget_nav_menu','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(114,'widget_custom_html','a:1:{s:12:\"_multiwidget\";i:1;}','yes'),
	(123,'_transient_doing_cron','1586215562.1263489723205566406250','yes'),
	(124,'_site_transient_update_core','O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-5.4.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-5.4.zip\";s:10:\"no_content\";s:68:\"https://downloads.wordpress.org/release/wordpress-5.4-no-content.zip\";s:11:\"new_bundled\";s:69:\"https://downloads.wordpress.org/release/wordpress-5.4-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"5.4\";s:7:\"version\";s:3:\"5.4\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.3\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1586215563;s:15:\"version_checked\";s:3:\"5.4\";s:12:\"translations\";a:0:{}}','no'),
	(125,'_site_transient_update_plugins','O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1586215619;s:7:\"checked\";a:4:{s:19:\"akismet/akismet.php\";s:5:\"4.1.4\";s:35:\"dumb-plugin-one/dumb-plugin-one.php\";s:5:\"0.1.0\";s:35:\"dumb-plugin-two/dumb-plugin-two.php\";s:5:\"0.1.0\";s:9:\"hello.php\";s:5:\"1.7.2\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:2:{s:19:\"akismet/akismet.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:21:\"w.org/plugins/akismet\";s:4:\"slug\";s:7:\"akismet\";s:6:\"plugin\";s:19:\"akismet/akismet.php\";s:11:\"new_version\";s:5:\"4.1.4\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/akismet.4.1.4.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:59:\"https://ps.w.org/akismet/assets/icon-256x256.png?rev=969272\";s:2:\"1x\";s:59:\"https://ps.w.org/akismet/assets/icon-128x128.png?rev=969272\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:61:\"https://ps.w.org/akismet/assets/banner-772x250.jpg?rev=479904\";}s:11:\"banners_rtl\";a:0:{}}s:9:\"hello.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:25:\"w.org/plugins/hello-dolly\";s:4:\"slug\";s:11:\"hello-dolly\";s:6:\"plugin\";s:9:\"hello.php\";s:11:\"new_version\";s:5:\"1.7.2\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/hello-dolly/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/hello-dolly.1.7.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/hello-dolly/assets/icon-256x256.jpg?rev=2052855\";s:2:\"1x\";s:64:\"https://ps.w.org/hello-dolly/assets/icon-128x128.jpg?rev=2052855\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:66:\"https://ps.w.org/hello-dolly/assets/banner-772x250.jpg?rev=2052855\";}s:11:\"banners_rtl\";a:0:{}}}}','no'),
	(126,'_site_transient_timeout_theme_roots','1586217364','no'),
	(127,'_site_transient_theme_roots','a:4:{s:14:\"twentynineteen\";s:7:\"/themes\";s:15:\"twentyseventeen\";s:7:\"/themes\";s:13:\"twentysixteen\";s:7:\"/themes\";s:12:\"twentytwenty\";s:7:\"/themes\";}','no'),
	(129,'_site_transient_timeout_browser_50dc8a117ab896bd97734b9a45b7753b','1586820366','no'),
	(130,'_site_transient_browser_50dc8a117ab896bd97734b9a45b7753b','a:10:{s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"80.0.3987.162\";s:8:\"platform\";s:9:\"Macintosh\";s:10:\"update_url\";s:29:\"https://www.google.com/chrome\";s:7:\"img_src\";s:43:\"http://s.w.org/images/browsers/chrome.png?1\";s:11:\"img_src_ssl\";s:44:\"https://s.w.org/images/browsers/chrome.png?1\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}','no'),
	(131,'_site_transient_timeout_php_check_a0c594a1902efeb727acf2a7ff080644','1586820366','no'),
	(132,'_site_transient_php_check_a0c594a1902efeb727acf2a7ff080644','a:5:{s:19:\"recommended_version\";s:3:\"7.3\";s:15:\"minimum_version\";s:6:\"5.6.20\";s:12:\"is_supported\";b:1;s:9:\"is_secure\";b:1;s:13:\"is_acceptable\";b:1;}','no'),
	(133,'can_compress_scripts','0','no'),
	(134,'_site_transient_timeout_community-events-2eef883554c6a8b141bb80b5a73a1a02','1586258770','no'),
	(135,'_site_transient_community-events-2eef883554c6a8b141bb80b5a73a1a02','a:3:{s:9:\"sandboxed\";b:0;s:8:\"location\";a:1:{s:2:\"ip\";s:10:\"172.23.0.0\";}s:6:\"events\";a:0:{}}','no'),
	(136,'_transient_timeout_feed_9bbd59226dc36b9b26cd43f15694c5c3','1586258771','no'),
	(137,'_transient_feed_9bbd59226dc36b9b26cd43f15694c5c3','a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"News –  – WordPress.org\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"https://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Apr 2020 09:24:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wordpress.org/?v=5.5-alpha-47552\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"The Month in WordPress: March 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2020/04/the-month-in-wordpress-march-2020/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 03 Apr 2020 12:01:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Month in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8532\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:363:\"The month of March was both a tough and exciting time for the WordPress open-source project. With COVID-19 declared a pandemic, in-person events have had to adapt quickly &#8211; a challenge for any community. March culminated with the release of WordPress 5.4, an exhilarating milestone only made possible by dedicated contributors. For all the latest, [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Hugh Lashbrooke\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:8588:\"\n<p>The month of March was both a tough and exciting time for the WordPress open-source project. With COVID-19 declared a pandemic, in-person events have had to adapt quickly &#8211; a challenge for any community. March culminated with the release of WordPress 5.4, an exhilarating milestone only made possible by dedicated contributors. For all the latest, read on.&nbsp;</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>WordPress 5.4 “Adderley”</h2>\n\n\n\n<p>WordPress 5.4 “Adderley” <a href=\"https://wordpress.org/news/2020/03/adderley/\">was released on March 31</a> and includes a robust list of new blocks, enhancements, and new features for both users and developers. The primary focus areas of this release included the block editor, privacy, accessibility, and developer improvements, with the full list of enhancements covered in <a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">the 5.4 field guide</a>.</p>\n\n\n\n<p>Want to get involved in building WordPress Core? Follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>, and join the #core channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>Releases of Gutenberg 7.7 and 7.8</h2>\n\n\n\n<p>It’s been another busy month for Gutenberg, this time with the release of Gutenberg <a href=\"https://make.wordpress.org/core/2020/03/11/whats-new-in-gutenberg-11-march/\">7.7</a> and <a href=\"https://make.wordpress.org/core/2020/03/26/whats-new-in-gutenberg-25-march/\">7.8</a>. Gutenberg 7.7 introduced block patterns &#8211; predefined block layouts that are ready to use and tweak. This is an important step towards Full Site Editing, which is currently targeted for inclusion in WordPress 5.6. As a first iteration, you can pick and insert patterns from the Block Patterns UI, which has been added as a sidebar plugin.</p>\n\n\n\n<p>Gutenberg 7.7 also includes a refresh of the Block UI, which better responds to the ways users interact with the editor. For more information on the User UI and Block Patterns, read <a href=\"https://make.wordpress.org/themes/2020/03/18/block-based-themes-meeting-notes/\">this summary of the most recent Block-Based Themes meeting</a>. Gutenberg 7.8, introduced on March 25, further enhanced this Block UI redesign. Both releases also included a suite of improvements, bug fixes, new APIs, documentation, and more!</p>\n\n\n\n<p>Want to get involved in building Gutenberg? Follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>, contribute to <a href=\"https://github.com/WordPress/gutenberg/\">Gutenberg on GitHub</a>, and join the #core-editor channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>WordCamp cancellations and shift to online events</h2>\n\n\n\n<p>In early March, the Community team issued <a href=\"https://make.wordpress.org/community/2020/03/11/new-recommendations-for-event-organizers-in-light-of-covid-19/\">new recommendations for event organizers</a> in light of growing concerns around COVID-19. Following this guidance, and with COVID-19 declared a pandemic, WordPress community organizers reluctantly but responsibly <a href=\"https://make.wordpress.org/community/2020/03/12/latest-updates-on-changes-to-wordcamps/\">postponed or canceled their upcoming WordCamps</a> and meetups.</p>\n\n\n\n<p>As community events are an important part of the WordPress open-source project, the Community team made suggestions for <a href=\"https://make.wordpress.org/community/2020/03/20/taking-charity-hackathons-online/\">taking charity hackathons online</a>, <a href=\"https://make.wordpress.org/community/2020/03/24/community-events-in-the-time-of-covid-19/\">proposed interim adjustments</a> to existing community event guidelines, and provided <a href=\"https://make.wordpress.org/community/2020/03/13/online-conference-organizer-training/\">training for online conference organizing</a> with Crowdcast. The team is currently working on building a <a href=\"https://make.wordpress.org/community/handbook/virtual-events/\">Virtual Events Handbook</a> that will continue to support WordPress community organizers at this time.&nbsp;</p>\n\n\n\n<p>Want to get involved with the WordPress Community team, host your own virtual WordPress event, or help improve the documentation for all of this? Follow <a href=\"https://make.wordpress.org/community/\">the Community team blog</a>, learn more about <a href=\"https://make.wordpress.org/community/handbook/virtual-events/\">virtual events</a>, and join the #community-events channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>Link your GitHub profile to WordPress.org</h2>\n\n\n\n<p>Last month, <a href=\"https://make.wordpress.org/core/2020/02/21/working-on-trac-tickets-using-github-pull-requests/\">an experimental feature</a> was added to Trac, WordPress Core’s bug-tracking system, to improve collaboration between Trac and GitHub. This month, to help make tracking contributions to the WordPress project across multiple locations easier, there is <a href=\"https://make.wordpress.org/core/2020/03/19/associating-github-accounts-with-wordpress-org-profiles/\">a new option</a> to connect your GitHub account to your WordPress.org profile. This connection allows for more accurate acknowledgement and recognition of contributors. You can connect your GitHub account to your WordPress.org account by editing your WordPress.org profile.</p>\n\n\n\n<p>For more information and instructions on how to connect your accounts, <a href=\"https://make.wordpress.org/core/2020/03/19/associating-github-accounts-with-wordpress-org-profiles/\">read the announcement post</a>.</p>\n\n\n\n<h2>Modernizing WordPress coding standards</h2>\n\n\n\n<p>Defined coding standards is an important step in creating the consistent codebase needed to prepare for requiring PHP 7.x for WordPress Core. As such, <a href=\"https://make.wordpress.org/core/2020/03/20/updating-the-coding-standards-for-modern-php/\">coding standards have been proposed</a> for implementation in WordPress Coding Standards 3.0.0. This includes new proposed standards for namespace declarations, import use statements, fully qualified names in inline code, traits and interfaces, type declarations, declare statements/strict typing, the ::class constant, operators, and more.&nbsp;</p>\n\n\n\n<p>Want to get involved or view the full list of currently proposed new coding standards? Visit and add your feedback to the post on <a href=\"https://make.wordpress.org/core/2020/03/20/updating-the-coding-standards-for-modern-php/\">updating the Coding standards for modern PHP</a> and follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>Further Reading:</h2>\n\n\n\n<ul><li>On March 16, <a href=\"https://make.wordpress.org/core/2020/03/18/auto-updates-feature-meeting-summary-march-17th-2020/\">Version 0.3 of the auto-updates feature was released</a>, including fixes to a number of issues and the introduction of email notifications.&nbsp;</li><li>WordCamp US announced that <a href=\"https://2020.us.wordcamp.org/2020/03/26/wcus-is-happening/\">the 2020 event will happen</a>, one way or another. But the team need your help to make sure that it’s another fantastic event. <a href=\"https://2020.us.wordcamp.org/2020/03/16/call-for-speakers-is-now-open/\">Consider applying to be a speaker</a>!</li><li>Speaking of WordCamp US, <a href=\"https://2020.us.wordcamp.org/2020/03/23/call-for-cities-for-wcus-2021-2022/\">the Call for Cities for WCUS 2021/2022</a> is now open. If your community is interested in being a future WCUS host, <a href=\"https://wordcampcentral.survey.fm/wcus-2021-2022\">apply today</a>!</li><li>With COVID-19 preventing in-person community events, the Diverse Speaker Training (#wpdiversity) Group encourages you to <a href=\"https://make.wordpress.org/community/2020/03/17/covid-19-and-the-diverse-speaker-training-wpdiversity-group/\">host a virtual Diverse Speaker Workshop</a> to prepare speakers for when we are able to meet in person again. To get started, <a href=\"https://tiny.cc/wpdiversity\">visit this page</a>.&nbsp;</li><li>An <a href=\"https://make.wordpress.org/updates/2020/03/06/update-progress-on-goals/\">update for progress on 2020 goals</a> has been posted, sharing some more defined targets and schedule.</li></ul>\n\n\n\n<p><em>Have a story that we should include in the next “Month in WordPress” post? Please </em><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><em>submit it here</em></a><em>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8532\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:58:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"WordPress 5.4 “Adderley”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"https://wordpress.org/news/2020/03/adderley/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 31 Mar 2020 19:04:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8455\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:255:\"Version 5.4 \"Adderley\" of WordPress is available for download or update in your WordPress dashboard. This version brings you more ways to make content come alive with your best images and helps make your vision real by putting blocks in the perfect place.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:45:\"https://s.w.org/images/core/5.4/textcolor.mp4\";s:6:\"length\";s:6:\"440616\";s:4:\"type\";s:9:\"video/mp4\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:51880:\"\n<p class=\"has-text-color has-very-dark-gray-color\">Here it is! Named “Adderley” in honor of Nat Adderley, the latest and greatest version of WordPress is available for&nbsp;<a href=\"https://wordpress.org/download/\">download</a>&nbsp;or update in your dashboard.</p>\n\n\n\n<figure class=\"wp-block-image size-large\"><img src=\"https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?resize=632%2C632&#038;ssl=1\" alt=\"\" class=\"wp-image-8484\" srcset=\"https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?resize=1024%2C1024&amp;ssl=1 1024w, https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?resize=300%2C300&amp;ssl=1 300w, https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?resize=150%2C150&amp;ssl=1 150w, https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?resize=768%2C768&amp;ssl=1 768w, https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?resize=1536%2C1536&amp;ssl=1 1536w, https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?resize=2048%2C2048&amp;ssl=1 2048w, https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?w=1264&amp;ssl=1 1264w, https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?w=1896&amp;ssl=1 1896w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<div class=\"wp-block-cover has-background-dim\" style=\"background-color:#0400e0\"><div class=\"wp-block-cover__inner-container\">\n<p style=\"font-size:32px\" class=\"has-text-align-center\"><strong>Say hello to more and better.</strong></p>\n\n\n\n<p class=\"has-text-align-center has-medium-font-size\">More ways to make your pages come alive. With easier ways to get it all done and looking better than ever—and boosts in speed you can feel.</p>\n</div></div>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 class=\"has-text-align-left\"><strong>Welcome to WordPress 5.4</strong></h2>\n\n\n\n<p style=\"font-size:15px\" class=\"has-text-align-left\"><strong>Every major release adds more to the block editor.</strong></p>\n\n\n\n<p style=\"font-size:18px\">More ways to make posts and pages come alive with your best images. More ways to bring your visitors in, and keep them engaged, with the richness of embedded media from the web’s top services.</p>\n\n\n\n<p style=\"font-size:18px\">More ways to make your vision real, and put blocks in the perfect place—even if a particular kind of block is new to you. More efficient processes.</p>\n\n\n\n<p style=\"font-size:18px\">And more speed everywhere, so as you build sections or galleries, or just type in a line of prose, you can feel how much faster your work flows.</p>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-large\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?resize=632%2C316&#038;ssl=1\" alt=\"\" class=\"wp-image-8480\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?resize=1024%2C512&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?resize=300%2C150&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?resize=768%2C384&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?resize=1536%2C768&amp;ssl=1 1536w, https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?w=2000&amp;ssl=1 2000w, https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?w=1264&amp;ssl=1 1264w, https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?w=1896&amp;ssl=1 1896w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<h3>Two new blocks. And better blocks overall.</h3>\n\n\n\n<ul><li>Two brand-new blocks: Social Icons and Buttons make adding interactive features fast and easy.</li><li>New ways with color: Gradients in the Buttons and Cover block, toolbar access to color options in Rich Text blocks, and for the first time, color options in the Group and Columns blocks.</li><li>Guess a whole lot less! Version 5.4 streamlines the whole process for placing and replacing multimedia in every block. Now it works the same way in almost every block!</li><li>And if you’ve ever thought your image in the Media+Text block should link to something else—perhaps a picture of a brochure should download that brochure as a document? Well, now it can.</li></ul>\n\n\n\n<figure class=\"wp-block-video\"><video controls src=\"https://s.w.org/images/core/5.4/textcolor.mp4\"></video></figure>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h3>Cleaner UI, clearer navigation—and easier tabbing!</h3>\n\n\n\n<ul><li>Clearer block navigation with block breadcrumbs. And easier selection once you get there.</li><li>For when you need to navigate with the keyboard, better tabbing and focus. Plus, you can tab over to the sidebar of nearly any block.</li><li>Speed! 14% faster loading of the editor, 51% faster time-to-type!</li><li>Tips are gone. In their place, a Welcome Guide window you can bring up when you need it—and only when you need it—again and again.</li><li>Know at a glance whether you’re in a block’s Edit or Navigation mode. Or, if you have restricted vision, your screen reader will tell you which mode you’re in.</li></ul>\n\n\n\n<p style=\"background-color:#f8f8f9\" class=\"has-background\">Of course, if you want to work with the very latest tools and features, <strong><a href=\"https://wordpress.org/plugins/gutenberg/\">install the Gutenberg plugin</a></strong>. You’ll get to be the first to use new and exciting features in the block editor before anyone else has seen them!</p>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-large\"><img src=\"https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?resize=632%2C316&#038;ssl=1\" alt=\"\" class=\"wp-image-8481\" srcset=\"https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?resize=1024%2C512&amp;ssl=1 1024w, https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?resize=300%2C150&amp;ssl=1 300w, https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?resize=768%2C384&amp;ssl=1 768w, https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?resize=1536%2C768&amp;ssl=1 1536w, https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?w=2000&amp;ssl=1 2000w, https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?w=1264&amp;ssl=1 1264w, https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?w=1896&amp;ssl=1 1896w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<h3>Your fundamental right: privacy</h3>\n\n\n\n<p>5.4 helps with a variety of privacy issues around the world. So when users and stakeholders ask about regulatory compliance, or how your team handles user data, the answers should be a lot easier to get right.</p>\n\n\n\n<p>Take a look:</p>\n\n\n\n<ul><li>Now personal data exports include users session information and users location data from the community events widget. Plus, a table of contents!</li><li>See progress as you process export and erasure requests through the privacy tools.</li><li>Plus, little enhancements throughout give the privacy tools a little cleaner look. Your eyes will thank you!</li></ul>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-large\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?resize=632%2C316&#038;ssl=1\" alt=\"\" class=\"wp-image-8482\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?resize=1024%2C512&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?resize=300%2C150&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?resize=768%2C384&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?resize=1536%2C768&amp;ssl=1 1536w, https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?w=2000&amp;ssl=1 2000w, https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?w=1264&amp;ssl=1 1264w, https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?w=1896&amp;ssl=1 1896w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h2><strong>Just for developers</strong></h2>\n\n\n\n<h3>Add custom fields to menu items—natively</h3>\n\n\n\n<p>Two new actions let you add custom fields to menu items—without a plugin and without writing custom walkers.</p>\n\n\n\n<p>On the Menus admin screen, <code>wp_nav_menu_item_custom_fields</code> fires just before the move buttons of a nav menu item in the menu editor.</p>\n\n\n\n<p>In the Customizer, <code>wp_nav_menu_item_custom_fields_customize_template</code> fires at the end of the menu-items form-fields template.</p>\n\n\n\n<p>Check your code and see where these new actions can replace your custom code, and if you’re concerned about duplication, add a check for the WordPress version.</p>\n\n\n\n<h3>Blocks! Simpler styling, new APIs and embeds</h3>\n\n\n\n<ul><li>Radically simpler block styling. Negative margins and default padding are gone! Now you can style blocks the way you need them. And, a refactor got rid of four redundant wrapper divs.</li><li>If you build plugins, now you can register collections of your blocks by namespace across categories—a great way to get more brand visibility.</li><li>Let users do more with two new APIs: block variations and gradients.</li><li>In embeds, now the block editor supports TikTok—and CollegeHumor is gone.</li></ul>\n\n\n\n<p style=\"background-color:#f8f8f9\" class=\"has-background\">There’s lots more for developers to love in WordPress 5.4. To discover more and learn how to make these changes shine on your sites, themes, plugins and more, check the <strong><a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a></strong>.</p>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2><strong>The Squad</strong></h2>\n\n\n\n<p>This release was led by&nbsp;<a href=\"http://ma.tt/\">Matt Mullenweg</a>,&nbsp;<a href=\"https://profiles.wordpress.org/francina\">Francesca Marano</a>, and&nbsp;<a href=\"https://dream-encode.com/blog/\">David Baumwald</a>. They were enthusiastically supported by a release squad:</p>\n\n\n\n<ul><li><strong>Editor Tech</strong>: Jorge Filipe Costa (<strong><a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">@jorgefelipecosta</a></strong>)</li><li><strong>Editor Design</strong>: Mark Uraine (<a rel=\"noreferrer noopener\" target=\"_blank\" href=\"https://profiles.wordpress.org/mapk/\"><strong>@mapk</strong></a>)</li><li><strong>Core Tech</strong>: Sergey Biryukov (<a href=\"https://profiles.wordpress.org/sergeybiryukov/\"><strong>@sergeybiryukov</strong></a>)</li><li><strong>Design</strong>: Tammie Lister (<strong><a href=\"https://profiles.wordpress.org/karmatosed/\">@karmatosed</a></strong>)</li><li><strong>Docs Coordinator</strong>:&nbsp;JB Audras (<a href=\"https://profiles.wordpress.org/audrasjb/\"><strong>@audrasjb</strong></a>)</li><li><strong>Docs &amp; Comms Wrangler</strong>: Mary Baum (<strong><a href=\"https://profiles.wordpress.org/marybaum/\">@marybaum</a></strong>)</li></ul>\n\n\n\n<p>The squad was joined throughout the release cycle by <strong>552 generous volunteer contributors</strong> who collectively worked on <strong><a href=\"https://core.trac.wordpress.org/milestone/5.4\">361</a> tickets on Trac</strong> and <strong>1226 pull requests on GitHub</strong>.</p>\n\n\n\n<p>Put on a Nat Adderley playlist, click that update button (or&nbsp;<a href=\"https://wordpress.org/download/\">download it directly</a>), and check the profiles of the fine folks that helped:</p>\n\n\n<a href=\"https://profiles.wordpress.org/0v3rth3d4wn/\">0v3rth3d4wn</a>, <a href=\"https://profiles.wordpress.org/123host/\">123host</a>, <a href=\"https://profiles.wordpress.org/1naveengiri/\">1naveengiri</a>, <a href=\"https://profiles.wordpress.org/jorbin/\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/abhijitrakas/\">Abhijit Rakas</a>, <a href=\"https://profiles.wordpress.org/abrightclearweb/\">abrightclearweb</a>, <a href=\"https://profiles.wordpress.org/acosmin/\">acosmin</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein/\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/adamboro/\">adamboro</a>, <a href=\"https://profiles.wordpress.org/addiestavlo/\">Addie</a>, <a href=\"https://profiles.wordpress.org/adnanlimdi/\">adnan.limdi</a>, <a href=\"https://profiles.wordpress.org/shaikhaezaz80/\">Aezaz Shaikh</a>, <a href=\"https://profiles.wordpress.org/aftabmuni/\">Aftab Ali Muni</a>, <a href=\"https://profiles.wordpress.org/akibjorklund/\">Aki Bj&#246;rklund</a>, <a href=\"https://profiles.wordpress.org/smallprogrammers/\">Akib</a>, <a href=\"https://profiles.wordpress.org/atachibana/\">Akira Tachibana</a>, <a href=\"https://profiles.wordpress.org/akshayar/\">akshayar</a>, <a href=\"https://profiles.wordpress.org/schlessera/\">Alain Schlesser</a>, <a href=\"https://profiles.wordpress.org/aljullu/\">Albert Juh&#233; Lluveras</a>, <a href=\"https://profiles.wordpress.org/xknown/\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/viper007bond/\">Alex Mills</a>, <a href=\"https://profiles.wordpress.org/alexholsgrove/\">AlexHolsgrove</a>, <a href=\"https://profiles.wordpress.org/alexischenal/\">alexischenal</a>, <a href=\"https://profiles.wordpress.org/alextran/\">alextran</a>, <a href=\"https://profiles.wordpress.org/alishankhan/\">alishankhan</a>, <a href=\"https://profiles.wordpress.org/allancole/\">allancole</a>, <a href=\"https://profiles.wordpress.org/allendav/\">Allen Snook</a>, <a href=\"https://profiles.wordpress.org/alpipego/\">alpipego</a>, <a href=\"https://profiles.wordpress.org/amirs17/\">Amir Seljubac</a>, <a href=\"https://profiles.wordpress.org/wpamitkumar/\">Amit Dudhat</a>, <a href=\"https://profiles.wordpress.org/amolv/\">Amol Vhankalas</a>, <a href=\"https://profiles.wordpress.org/agawish/\">Amr Gawish</a>, <a href=\"https://profiles.wordpress.org/amykamala/\">Amy Kamala</a>, <a href=\"https://profiles.wordpress.org/anantajitjg/\">Anantajit JG</a>, <a href=\"https://profiles.wordpress.org/anlino/\">Anders Nor&#233;n</a>, <a href=\"https://profiles.wordpress.org/nosolosw/\">Andr&#233;s</a>, <a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/dontdream/\">Andrea Tarantini</a>, <a href=\"https://profiles.wordpress.org/andreaitm/\">andreaitm</a>, <a href=\"https://profiles.wordpress.org/andraganescu/\">Andrei Draganescu</a>, <a href=\"https://profiles.wordpress.org/aandrewdixon/\">Andrew Dixon</a>, <a href=\"https://profiles.wordpress.org/aduth/\">Andrew Duthie</a>, <a href=\"https://profiles.wordpress.org/nacin/\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/andrewserong/\">Andrew Serong</a>, <a href=\"https://profiles.wordpress.org/eatingrules/\">Andrew Wilder</a>, <a href=\"https://profiles.wordpress.org/rarst/\">Andrey Savchenko</a>, <a href=\"https://profiles.wordpress.org/afragen/\">Andy Fragen</a>, <a href=\"https://profiles.wordpress.org/andizer/\">Andy Meerwaldt</a>, <a href=\"https://profiles.wordpress.org/apeatling/\">Andy Peatling</a>, <a href=\"https://profiles.wordpress.org/la-geek/\">Angelika Reisiger</a>, <a href=\"https://profiles.wordpress.org/ankitmaru/\">Ankit Panchal</a>, <a href=\"https://profiles.wordpress.org/antpb/\">Anthony Burchell</a>, <a href=\"https://profiles.wordpress.org/paranoia1906/\">Anthony Ledesma</a>, <a href=\"https://profiles.wordpress.org/apedog/\">apedog</a>, <a href=\"https://profiles.wordpress.org/apermo/\">Apermo</a>, <a href=\"https://profiles.wordpress.org/apieschel/\">apieschel</a>, <a href=\"https://profiles.wordpress.org/aravindajith/\">Aravind Ajith</a>, <a href=\"https://profiles.wordpress.org/archon810/\">archon810</a>, <a href=\"https://profiles.wordpress.org/arenddeboer/\">arenddeboer</a>, <a href=\"https://profiles.wordpress.org/aristath/\">Ari Stathopoulos</a>, <a href=\"https://profiles.wordpress.org/passoniate/\">Arslan Ahmed</a>, <a href=\"https://profiles.wordpress.org/ashokrd2013/\">ashokrd2013</a>, <a href=\"https://profiles.wordpress.org/ataurr/\">Ataur R</a>, <a href=\"https://profiles.wordpress.org/ate-up-with-motor/\">Ate Up With Motor</a>, <a href=\"https://profiles.wordpress.org/autotutorial/\">autotutorial</a>, <a href=\"https://profiles.wordpress.org/ayeshrajans/\">Ayesh Karunaratne</a>, <a href=\"https://profiles.wordpress.org/backups/\">BackuPs</a>, <a href=\"https://profiles.wordpress.org/bahia0019/\">bahia0019</a>, <a href=\"https://profiles.wordpress.org/b-07/\">Bappi</a>, <a href=\"https://profiles.wordpress.org/bartczyz/\">Bart Czyz</a>, <a href=\"https://profiles.wordpress.org/bengreeley/\">ben.greeley</a>, <a href=\"https://profiles.wordpress.org/benedictsinger/\">benedictsinger</a>, <a href=\"https://profiles.wordpress.org/bfintal/\">Benjamin Intal</a>, <a href=\"https://profiles.wordpress.org/bibliofille/\">bibliofille</a>, <a href=\"https://profiles.wordpress.org/bilgilabs/\">bilgilabs</a>, <a href=\"https://profiles.wordpress.org/birgire/\">Birgir Erlendsson</a>, <a href=\"https://profiles.wordpress.org/bph/\">Birgit Pauli-Haack</a>, <a href=\"https://profiles.wordpress.org/skypressatx/\">BMO</a>, <a href=\"https://profiles.wordpress.org/boga86/\">Boga86</a>, <a href=\"https://profiles.wordpress.org/boonebgorges/\">Boone Gorges</a>, <a href=\"https://profiles.wordpress.org/bwmarkle/\">Brad Markle</a>, <a href=\"https://profiles.wordpress.org/kraftbj/\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/brentswisher/\">Brent Swisher</a>, <a href=\"https://profiles.wordpress.org/cvoell/\">Cameron Voell</a>, <a href=\"https://profiles.wordpress.org/poena/\">Carolina Nymark</a>, <a href=\"https://profiles.wordpress.org/ceyhun0/\">ceyhun0</a>, <a href=\"https://profiles.wordpress.org/chetan200891/\">Chetan Prajapati</a>, <a href=\"https://profiles.wordpress.org/ketuchetan/\">Chetan Satasiya</a>, <a href=\"https://profiles.wordpress.org/chinteshprajapati/\">Chintesh Prajapati</a>, <a href=\"https://profiles.wordpress.org/chipsnyder/\">Chip Snyder</a>, <a href=\"https://profiles.wordpress.org/cklosows/\">Chris Klosowski</a>, <a href=\"https://profiles.wordpress.org/eclare/\">Chris Trynkiewicz (Sukces Strony)</a>, <a href=\"https://profiles.wordpress.org/chrisvanpatten/\">Chris Van Patten</a>, <a href=\"https://profiles.wordpress.org/pixelverbieger/\">Christian Sabo</a>, <a href=\"https://profiles.wordpress.org/christianamohr/\">Christiana Mohr</a>, <a href=\"https://profiles.wordpress.org/clayisland/\">clayisland</a>, <a href=\"https://profiles.wordpress.org/copons/\">Copons</a>, <a href=\"https://profiles.wordpress.org/coreymckrill/\">Corey McKrill</a>, <a href=\"https://profiles.wordpress.org/crdunst/\">crdunst</a>, <a href=\"https://profiles.wordpress.org/littlebigthing/\">Csaba (LittleBigThings)</a>, <a href=\"https://profiles.wordpress.org/xendo/\">Dademaru</a>, <a href=\"https://profiles.wordpress.org/retrofox/\">Damián Suárez</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber/\">Daniel Bachhuber</a>, <a href=\"https://profiles.wordpress.org/danieltj/\">Daniel James</a>, <a href=\"https://profiles.wordpress.org/diddledan/\">Daniel Llewellyn</a>, <a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>, <a href=\"https://profiles.wordpress.org/mte90/\">Daniele Scasciafratte</a>, <a href=\"https://profiles.wordpress.org/daniloercoli/\">daniloercoli</a>, <a href=\"https://profiles.wordpress.org/nerrad/\">Darren Ethier (nerrad)</a>, <a href=\"https://profiles.wordpress.org/darrenlambert/\">darrenlambert</a>, <a href=\"https://profiles.wordpress.org/davidshq/\">Dave Mackey</a>, <a href=\"https://profiles.wordpress.org/get_dave/\">Dave Smith</a>, <a href=\"https://profiles.wordpress.org/daveslaughter/\">daveslaughter</a>, <a href=\"https://profiles.wordpress.org/davewp196/\">DaveWP196</a>, <a href=\"https://profiles.wordpress.org/dartiss/\">David Artiss</a>, <a href=\"https://profiles.wordpress.org/davidbinda/\">David Binovec</a>, <a href=\"https://profiles.wordpress.org/dlh/\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dryanpress/\">David Ryan</a>, <a href=\"https://profiles.wordpress.org/dshanske/\">David Shanske</a>, <a href=\"https://profiles.wordpress.org/superdav42/\">David Stone</a>, <a href=\"https://profiles.wordpress.org/dkarfa/\">Debabrata Karfa</a>, <a href=\"https://profiles.wordpress.org/dekervit/\">dekervit</a>, <a href=\"https://profiles.wordpress.org/delowardev/\">Delowar Hossain</a>, <a href=\"https://profiles.wordpress.org/denisco/\">Denis Yanchevskiy</a>, <a href=\"https://profiles.wordpress.org/dhavalkasvala/\">Dhaval kasavala</a>, <a href=\"https://profiles.wordpress.org/dhurlburtusa/\">dhurlburtusa</a>, <a href=\"https://profiles.wordpress.org/dilipbheda/\">Dilip Bheda</a>, <a href=\"https://profiles.wordpress.org/dingo_d/\">dingo-d</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/dipeshkakadiya/\">dipeshkakadiya</a>, <a href=\"https://profiles.wordpress.org/djp424/\">djp424</a>, <a href=\"https://profiles.wordpress.org/dominic_ks/\">dominic_ks</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/dotancohen/\">Dotan Cohen</a>, <a href=\"https://profiles.wordpress.org/dphiffer/\">dphiffer</a>, <a href=\"https://profiles.wordpress.org/dragosh635/\">dragosh635</a>, <a href=\"https://profiles.wordpress.org/drewapicture/\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/eclev91/\">eclev91</a>, <a href=\"https://profiles.wordpress.org/seedsca/\">ecotechie</a>, <a href=\"https://profiles.wordpress.org/eden159/\">eden159</a>, <a href=\"https://profiles.wordpress.org/ediamin/\">Edi Amin</a>, <a href=\"https://profiles.wordpress.org/disillusia/\">edmundcwm</a>, <a href=\"https://profiles.wordpress.org/etoledom/\">Eduardo Toledo</a>, <a href=\"https://profiles.wordpress.org/ellatrix/\">Ella van Durpe</a>, <a href=\"https://profiles.wordpress.org/elmastudio/\">Ellen Bauer</a>, <a href=\"https://profiles.wordpress.org/aliveic/\">Emil E</a>, <a href=\"https://profiles.wordpress.org/epiqueras/\">Enrique Piqueras</a>, <a href=\"https://profiles.wordpress.org/nrqsnchz/\">Enrique Sánchez</a>, <a href=\"https://profiles.wordpress.org/equin0x80/\">equin0x80</a>, <a href=\"https://profiles.wordpress.org/erikkroes/\">erikkroes</a>, <a href=\"https://profiles.wordpress.org/estelaris/\">Estela Rueda</a>, <a href=\"https://profiles.wordpress.org/fabifott/\">Fabian</a>, <a href=\"https://profiles.wordpress.org/fabiankaegy/\">Fabian K&#228;gy</a>, <a href=\"https://profiles.wordpress.org/fahimmurshed/\">Fahim Murshed</a>, <a href=\"https://profiles.wordpress.org/faisal03/\">Faisal Alvi</a>, <a href=\"https://profiles.wordpress.org/felipeelia/\">Felipe Elia</a>, <a href=\"https://profiles.wordpress.org/felipeloureirosantos/\">Felipe Santos</a>, <a href=\"https://profiles.wordpress.org/flixos90/\">Felix Arntz</a>, <a href=\"https://profiles.wordpress.org/fernandovbsouza/\">Fernando Souza</a>, <a href=\"https://profiles.wordpress.org/fervillz/\">fervillz</a>, <a href=\"https://profiles.wordpress.org/fgiannar/\">fgiannar</a>, <a href=\"https://profiles.wordpress.org/flaviozavan/\">flaviozavan</a>, <a href=\"https://profiles.wordpress.org/mista-flo/\">Florian TIAR</a>, <a href=\"https://profiles.wordpress.org/fotisps/\">Fotis Pastrakis</a>, <a href=\"https://profiles.wordpress.org/efarem/\">Frank Martin</a>, <a href=\"https://profiles.wordpress.org/galbaras/\">Gal Baras</a>, <a href=\"https://profiles.wordpress.org/garrett-eclipse/\">Garrett Hyder</a>, <a href=\"https://profiles.wordpress.org/garyj/\">Gary Jones</a>, <a href=\"https://profiles.wordpress.org/pento/\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/guddu1315/\">Gaurang Dabhi</a>, <a href=\"https://profiles.wordpress.org/georgestephanis/\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/geriux/\">geriux</a>, <a href=\"https://profiles.wordpress.org/girishpanchal/\">Girish Panchal</a>, <a href=\"https://profiles.wordpress.org/glebkema/\">Gleb Kemarsky</a>, <a href=\"https://profiles.wordpress.org/hometowntrailers/\">Glenn</a>, <a href=\"https://profiles.wordpress.org/gh640/\">Goto Hayato</a>, <a href=\"https://profiles.wordpress.org/grafruessel/\">grafruessel</a>, <a href=\"https://profiles.wordpress.org/gregrickaby/\">Greg Rickaby</a>, <a href=\"https://profiles.wordpress.org/gziolo/\">Grzegorz Ziółkowski</a>, <a href=\"https://profiles.wordpress.org/grzegorzjanoszka/\">Grzegorz.Janoszka</a>, <a href=\"https://profiles.wordpress.org/bordoni/\">Gustavo Bordoni</a>, <a href=\"https://profiles.wordpress.org/gwwar/\">gwwar</a>, <a href=\"https://profiles.wordpress.org/hamedmoodi/\">hamedmoodi</a>, <a href=\"https://profiles.wordpress.org/hampzter/\">hAmpzter</a>, <a href=\"https://profiles.wordpress.org/happiryu/\">happiryu</a>, <a href=\"https://profiles.wordpress.org/hareesh-pillai/\">Hareesh Pillai</a>, <a href=\"https://profiles.wordpress.org/harry-milatz/\">Harry Milatz</a>, <a href=\"https://profiles.wordpress.org/hazdiego/\">Haz</a>, <a href=\"https://profiles.wordpress.org/helgatheviking/\">helgatheviking</a>, <a href=\"https://profiles.wordpress.org/henryholtgeerts/\">Henry Holtgeerts</a>, <a href=\"https://profiles.wordpress.org/imani3011/\">Himani Lotia</a>, <a href=\"https://profiles.wordpress.org/krynes/\">Hubert Kubiak</a>, <a href=\"https://profiles.wordpress.org/i3anaan/\">i3anaan</a>, <a href=\"https://profiles.wordpress.org/ianbelanger/\">Ian Belanger</a>, <a href=\"https://profiles.wordpress.org/iandunn/\">Ian Dunn</a>, <a href=\"https://profiles.wordpress.org/ianatkins/\">ianatkins</a>, <a href=\"https://profiles.wordpress.org/ianmjones/\">ianmjones</a>, <a href=\"https://profiles.wordpress.org/ideaboxcreations/\">IdeaBox Creations</a>, <a href=\"https://profiles.wordpress.org/shaampk1/\">Ihtisham Zahoor</a>, <a href=\"https://profiles.wordpress.org/intimez/\">intimez</a>, <a href=\"https://profiles.wordpress.org/ipstenu/\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/isabel_brison/\">Isabel Brison</a>, <a href=\"https://profiles.wordpress.org/ispreview/\">ispreview</a>, <a href=\"https://profiles.wordpress.org/whyisjake/\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/jbinda/\">Jakub Binda</a>, <a href=\"https://profiles.wordpress.org/macmanx/\">James Huff</a>, <a href=\"https://profiles.wordpress.org/jameskoster/\">James Koster</a>, <a href=\"https://profiles.wordpress.org/jnylen0/\">James Nylen</a>, <a href=\"https://profiles.wordpress.org/jameslnewell/\">jameslnewell</a>, <a href=\"https://profiles.wordpress.org/jankimoradiya/\">Janki Moradiya</a>, <a href=\"https://profiles.wordpress.org/jarretc/\">Jarret</a>, <a href=\"https://profiles.wordpress.org/studiotwee/\">Jasper van der Meer</a>, <a href=\"https://profiles.wordpress.org/jaydeep23290/\">jaydeep23290</a>, <a href=\"https://profiles.wordpress.org/jdy68/\">jdy68</a>, <a href=\"https://profiles.wordpress.org/audrasjb/\">Jean-Baptiste Audras</a>, <a href=\"https://profiles.wordpress.org/jean-david/\">Jean-David Daviet</a>, <a href=\"https://profiles.wordpress.org/jblz/\">Jeff Bowen</a>, <a href=\"https://profiles.wordpress.org/jffng/\">Jeff Ong</a>, <a href=\"https://profiles.wordpress.org/jeffpaul/\">Jeff Paul</a>, <a href=\"https://profiles.wordpress.org/phpbits/\">Jeffrey Carandang</a>, <a href=\"https://profiles.wordpress.org/jeichorn/\">jeichorn</a>, <a href=\"https://profiles.wordpress.org/jenilk/\">Jenil Kanani</a>, <a href=\"https://profiles.wordpress.org/miss_jwo/\">Jenny Wong</a>, <a href=\"https://profiles.wordpress.org/jepperask/\">jepperask</a>, <a href=\"https://profiles.wordpress.org/jeremyclarke/\">Jer Clarke</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt/\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jeherve/\">Jeremy Herve</a>, <a href=\"https://profiles.wordpress.org/jeroenrotty/\">Jeroen Rotty</a>, <a href=\"https://profiles.wordpress.org/jeryj/\">Jerry Jones</a>, <a href=\"https://profiles.wordpress.org/luminuu/\">Jessica Lyschik</a>, <a href=\"https://profiles.wordpress.org/jipmoors/\">Jip Moors</a>, <a href=\"https://profiles.wordpress.org/joedolson/\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joehoyle/\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/joemcgill/\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/joen/\">Joen Asmussen</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/johnwatkins0/\">John Watkins</a>, <a href=\"https://profiles.wordpress.org/jon81/\">Jon</a>, <a href=\"https://profiles.wordpress.org/itsjonq/\">Jon Quach</a>, <a href=\"https://profiles.wordpress.org/jonsurrell/\">Jon Surrell</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/jg-visual/\">Jonathan Goldford</a>, <a href=\"https://profiles.wordpress.org/spacedmonkey/\">Jonny Harris</a>, <a href=\"https://profiles.wordpress.org/jonoaldersonwp/\">Jono Alderson</a>, <a href=\"https://profiles.wordpress.org/joonasvanhatapio/\">Joonas Vanhatapio</a>, <a href=\"https://profiles.wordpress.org/joostdevalk/\">Joost de Valk</a>, <a href=\"https://profiles.wordpress.org/koke/\">Jorge Bernal</a>, <a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Costa</a>, <a href=\"https://profiles.wordpress.org/chanthaboune/\">Josepha Haden</a>, <a href=\"https://profiles.wordpress.org/joshuawold/\">JoshuaWold</a>, <a href=\"https://profiles.wordpress.org/joyously/\">Joy</a>, <a href=\"https://profiles.wordpress.org/jqz/\">jqz</a>, <a href=\"https://profiles.wordpress.org/jsnajdr/\">jsnajdr</a>, <a href=\"https://profiles.wordpress.org/juanfra/\">Juanfra Aldasoro</a>, <a href=\"https://profiles.wordpress.org/derweili/\">Julian Weiland</a>, <a href=\"https://profiles.wordpress.org/juliankimmig/\">julian.kimmig</a>, <a href=\"https://profiles.wordpress.org/jrf/\">Juliette Reinders Folmer</a>, <a href=\"https://profiles.wordpress.org/juliobox/\">Julio Potier</a>, <a href=\"https://profiles.wordpress.org/nukaga/\">Junko Nukaga</a>, <a href=\"https://profiles.wordpress.org/jurgen/\">jurgen</a>, <a href=\"https://profiles.wordpress.org/justdaiv/\">justdaiv</a>, <a href=\"https://profiles.wordpress.org/justinahinon/\">Justin Ahinon</a>, <a href=\"https://profiles.wordpress.org/kadamwhite/\">K. Adam White</a>, <a href=\"https://profiles.wordpress.org/kaggdesign/\">kaggdesign</a>, <a href=\"https://profiles.wordpress.org/kalpshit/\">KalpShit Akabari</a>, <a href=\"https://profiles.wordpress.org/leprincenoir/\">Kantari Samy</a>, <a href=\"https://profiles.wordpress.org/kasparsd/\">Kaspars</a>, <a href=\"https://profiles.wordpress.org/ryelle/\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/kennithnichol/\">Kennith Nichol</a>, <a href=\"https://profiles.wordpress.org/khag7/\">Kevin Hagerty</a>, <a href=\"https://profiles.wordpress.org/kharisblank/\">Kharis Sulistiyono</a>, <a href=\"https://profiles.wordpress.org/khushbu19/\">Khushbu Modi</a>, <a href=\"https://profiles.wordpress.org/killerbishop/\">killerbishop</a>, <a href=\"https://profiles.wordpress.org/kinjaldalwadi/\">kinjaldalwadi</a>, <a href=\"https://profiles.wordpress.org/kitchin/\">kitchin</a>, <a href=\"https://profiles.wordpress.org/ixkaito/\">Kite</a>, <a href=\"https://profiles.wordpress.org/kjellr/\">Kjell Reigstad</a>, <a href=\"https://profiles.wordpress.org/kkarpieszuk/\">kkarpieszuk</a>, <a href=\"https://profiles.wordpress.org/knutsp/\">Knut Sparhell</a>, <a href=\"https://profiles.wordpress.org/kokkieh/\">KokkieH</a>, <a href=\"https://profiles.wordpress.org/obenland/\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/xkon/\">Konstantinos Xenos</a>, <a href=\"https://profiles.wordpress.org/klopez8/\">Krystyna</a>, <a href=\"https://profiles.wordpress.org/kubiq/\">kubiq</a>, <a href=\"https://profiles.wordpress.org/wpkuf/\">kuflievskiy</a>, <a href=\"https://profiles.wordpress.org/sainthkh/\">Kukhyeon Heo</a>, <a href=\"https://profiles.wordpress.org/kyliesabra/\">kyliesabra</a>, <a href=\"https://profiles.wordpress.org/lakenh/\">Laken Hafner</a>, <a href=\"https://profiles.wordpress.org/leandroalonso/\">leandroalonso</a>, <a href=\"https://profiles.wordpress.org/leogermani/\">leogermani</a>, <a href=\"https://profiles.wordpress.org/lgrev01/\">lgrev01</a>, <a href=\"https://profiles.wordpress.org/linuxologos/\">linuxologos</a>, <a href=\"https://profiles.wordpress.org/lisota/\">lisota</a>, <a href=\"https://profiles.wordpress.org/lorenzof/\">Lorenzo Fracassi</a>, <a href=\"https://profiles.wordpress.org/luisherranz/\">luisherranz</a>, <a href=\"https://profiles.wordpress.org/luisrivera/\">luisrivera</a>, <a href=\"https://profiles.wordpress.org/lukaswaudentio/\">lukaswaudentio</a>, <a href=\"https://profiles.wordpress.org/ljasinskipl/\">Lukasz Jasinski</a>, <a href=\"https://profiles.wordpress.org/lukecavanagh/\">Luke Cavanagh</a>, <a href=\"https://profiles.wordpress.org/wodarekly/\">Lydia Wodarek</a>, <a href=\"https://profiles.wordpress.org/vinoth06/\">M A Vinoth Kumar</a>, <a href=\"https://profiles.wordpress.org/maciejmackowiak/\">maciejmackowiak</a>, <a href=\"https://profiles.wordpress.org/mahesh901122/\">Mahesh Waghmare</a>, <a href=\"https://profiles.wordpress.org/manzoorwanijk/\">Manzoor Wani</a>, <a href=\"https://profiles.wordpress.org/marcelo2605/\">marcelo2605</a>, <a href=\"https://profiles.wordpress.org/marcio-zebedeu/\">Marcio Zebedeu</a>, <a href=\"https://profiles.wordpress.org/marcoz/\">MarcoZ</a>, <a href=\"https://profiles.wordpress.org/mkaz/\">Marcus Kazmierczak</a>, <a href=\"https://profiles.wordpress.org/marekdedic/\">Marek Dědič</a>, <a href=\"https://profiles.wordpress.org/clorith/\">Marius Jensen</a>, <a href=\"https://profiles.wordpress.org/marius84/\">Marius84</a>, <a href=\"https://profiles.wordpress.org/markjaquith/\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/mmarzeotti/\">Mark Marzeotti</a>, <a href=\"https://profiles.wordpress.org/mapk/\">Mark Uraine</a>, <a href=\"https://profiles.wordpress.org/hinjiriyo/\">Martin Stehle</a>, <a href=\"https://profiles.wordpress.org/m-e-h/\">Marty Helmick</a>, <a href=\"https://profiles.wordpress.org/marybaum/\">Mary Baum</a>, <a href=\"https://profiles.wordpress.org/matstars/\">Mat Gargano</a>, <a href=\"https://profiles.wordpress.org/mat-lipe/\">Mat Lipe</a>, <a href=\"https://profiles.wordpress.org/imath/\">Mathieu Viet</a>, <a href=\"https://profiles.wordpress.org/matveb/\">Matias Ventura</a>, <a href=\"https://profiles.wordpress.org/mattkeys/\">Matt Keys</a>, <a href=\"https://profiles.wordpress.org/veraxus/\">Matt van Andel</a>, <a href=\"https://profiles.wordpress.org/mattchowning/\">mattchowning</a>, <a href=\"https://profiles.wordpress.org/snapfractalpop/\">Matthew Kevins</a>, <a href=\"https://profiles.wordpress.org/mattnyeus/\">mattnyeus</a>, <a href=\"https://profiles.wordpress.org/maxme/\">maxme</a>, <a href=\"https://profiles.wordpress.org/mayanksonawat/\">mayanksonawat</a>, <a href=\"https://profiles.wordpress.org/mbrailer/\">mbrailer</a>, <a href=\"https://profiles.wordpress.org/mehidi258/\">Mehidi Hassan</a>, <a href=\"https://profiles.wordpress.org/melchoyce/\">Mel Choyce-Dwan</a>, <a href=\"https://profiles.wordpress.org/mensmaximus/\">mensmaximus</a>, <a href=\"https://profiles.wordpress.org/michael-arestad/\">Michael Arestad</a>, <a href=\"https://profiles.wordpress.org/michaelecklund/\">Michael Ecklund</a>, <a href=\"https://profiles.wordpress.org/donmhico/\">Michael Panaga</a>, <a href=\"https://profiles.wordpress.org/marktimemedia/\">Michelle Schulp</a>, <a href=\"https://profiles.wordpress.org/miette49/\">miette49</a>, <a href=\"https://profiles.wordpress.org/mcsf/\">Miguel Fonseca</a>, <a href=\"https://profiles.wordpress.org/mmtr86/\">Miguel Torres</a>, <a href=\"https://profiles.wordpress.org/mihdan/\">mihdan</a>, <a href=\"https://profiles.wordpress.org/miinasikk/\">Miina Sikk</a>, <a href=\"https://profiles.wordpress.org/simison/\">Mikael Korpela</a>, <a href=\"https://profiles.wordpress.org/mauteri/\">Mike Auteri</a>, <a href=\"https://profiles.wordpress.org/mikehansenme/\">Mike Hansen</a>, <a href=\"https://profiles.wordpress.org/mikeschinkel/\">Mike Schinkel [WPLib Box project lead]</a>, <a href=\"https://profiles.wordpress.org/mikeschroder/\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/mikejdent/\">mikejdent</a>, <a href=\"https://profiles.wordpress.org/msaari/\">Mikko Saari</a>, <a href=\"https://profiles.wordpress.org/iihglobal/\">Milan Patel</a>, <a href=\"https://profiles.wordpress.org/gdragon/\">Milan Petrovic</a>, <a href=\"https://profiles.wordpress.org/mimitips/\">mimi</a>, <a href=\"https://profiles.wordpress.org/mircoraffinetti/\">mircoraffinetti</a>, <a href=\"https://profiles.wordpress.org/mjnewman/\">mjnewman</a>, <a href=\"https://profiles.wordpress.org/mlbrgl/\">mlbrgl</a>, <a href=\"https://profiles.wordpress.org/morganestes/\">Morgan Estes</a>, <a href=\"https://profiles.wordpress.org/man4toman/\">Morteza Geransayeh</a>, <a href=\"https://profiles.wordpress.org/mppfeiffer/\">mppfeiffer</a>, <a href=\"https://profiles.wordpress.org/mryoga/\">mryoga</a>, <a href=\"https://profiles.wordpress.org/musamamasood/\">Muhammad Usama Masood</a>, <a href=\"https://profiles.wordpress.org/mujuonly/\">mujuonly</a>, <a href=\"https://profiles.wordpress.org/mukesh27/\">Mukesh Panchal</a>, <a href=\"https://profiles.wordpress.org/assassinateur/\">Nadir Seghir</a>, <a href=\"https://profiles.wordpress.org/nagoke/\">nagoke</a>, <a href=\"https://profiles.wordpress.org/nfmohit/\">Nahid Ferdous Mohit</a>, <a href=\"https://profiles.wordpress.org/finchps/\">Nate Finch</a>, <a href=\"https://profiles.wordpress.org/mukto90/\">Nazmul Ahsan</a>, <a href=\"https://profiles.wordpress.org/nekomajin/\">nekomajin</a>, <a href=\"https://profiles.wordpress.org/nextscripts/\">NextScripts</a>, <a href=\"https://profiles.wordpress.org/nickdaugherty/\">Nick Daugherty</a>, <a href=\"https://profiles.wordpress.org/celloexpressions/\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/nsundberg/\">Nicklas Sundberg</a>, <a href=\"https://profiles.wordpress.org/nickylimjj/\">Nicky Lim</a>, <a href=\"https://profiles.wordpress.org/vadimnicolai/\">nicolad</a>, <a href=\"https://profiles.wordpress.org/rahe/\">Nicolas Juen</a>, <a href=\"https://profiles.wordpress.org/nicole2292/\">nicole2292</a>, <a href=\"https://profiles.wordpress.org/nielslange/\">Niels Lange</a>, <a href=\"https://profiles.wordpress.org/nikhilgupte/\">nikhilgupte</a>, <a href=\"https://profiles.wordpress.org/nilamacharya/\">nilamacharya</a>, <a href=\"https://profiles.wordpress.org/noahtallen/\">noahtallen</a>, <a href=\"https://profiles.wordpress.org/noyle/\">noyle</a>, <a href=\"https://profiles.wordpress.org/nsubugak/\">nsubugak</a>, <a href=\"https://profiles.wordpress.org/oakesjosh/\">oakesjosh</a>, <a href=\"https://profiles.wordpress.org/oldenburg/\">oldenburg</a>, <a href=\"https://profiles.wordpress.org/alshakero/\">Omar Alshaker</a>, <a href=\"https://profiles.wordpress.org/ottok/\">Otto Kek&#228;l&#228;inen</a>, <a href=\"https://profiles.wordpress.org/ov3rfly/\">Ov3rfly</a>, <a href=\"https://profiles.wordpress.org/paaljoachim/\">Paal Joachim Romdahl</a>, <a href=\"https://profiles.wordpress.org/iaaxpage/\">page-carbajal</a>, <a href=\"https://profiles.wordpress.org/pagewidth/\">pagewidth</a>, <a href=\"https://profiles.wordpress.org/paragoninitiativeenterprises/\">Paragon Initiative Enterprises</a>, <a href=\"https://profiles.wordpress.org/swissspidy/\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/casiepa/\">Pascal Casier</a>, <a href=\"https://profiles.wordpress.org/pbearne/\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/pbiron/\">Paul Biron</a>, <a href=\"https://profiles.wordpress.org/rixeo/\">Paul Kevin</a>, <a href=\"https://profiles.wordpress.org/paulschreiber/\">Paul Schreiber</a>, <a href=\"https://profiles.wordpress.org/pcarvalho/\">pcarvalho</a>, <a href=\"https://profiles.wordpress.org/pedromendonca/\">Pedro Mendon&#231;a</a>, <a href=\"https://profiles.wordpress.org/perrywagle/\">perrywagle</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/philipmjackson/\">Philip Jackson</a>, <a href=\"https://profiles.wordpress.org/pierlo/\">Pierre Gordon</a>, <a href=\"https://profiles.wordpress.org/pierrelannoy/\">Pierre Lannoy</a>, <a href=\"https://profiles.wordpress.org/pikamander2/\">pikamander2</a>, <a href=\"https://profiles.wordpress.org/prashantvatsh/\">Prashant Singh</a>, <a href=\"https://profiles.wordpress.org/pratik-jain/\">Pratik Jain</a>, <a href=\"https://profiles.wordpress.org/presskopp/\">Presskopp</a>, <a href=\"https://profiles.wordpress.org/priyankabehera155/\">Priyanka Behera</a>, <a href=\"https://profiles.wordpress.org/raamdev/\">Raam Dev</a>, <a href=\"https://profiles.wordpress.org/bamadesigner/\">Rachel Cherry</a>, <a href=\"https://profiles.wordpress.org/larrach/\">Rachel Peter</a>, <a href=\"https://profiles.wordpress.org/ragnarokatz/\">ragnarokatz</a>, <a href=\"https://profiles.wordpress.org/ramiy/\">Rami Yushuvaev</a>, <a href=\"https://profiles.wordpress.org/raoulunger/\">raoulunger</a>, <a href=\"https://profiles.wordpress.org/razamalik/\">razamalik</a>, <a href=\"https://profiles.wordpress.org/remcotolsma/\">Remco Tolsma</a>, <a href=\"https://profiles.wordpress.org/rephotsirch/\">rephotsirch</a>, <a href=\"https://profiles.wordpress.org/rheinardkorf/\">rheinardkorf</a>, <a href=\"https://profiles.wordpress.org/youknowriad/\">Riad Benguella</a>, <a href=\"https://profiles.wordpress.org/quicoto/\">Ricard Torres</a>, <a href=\"https://profiles.wordpress.org/richtabor/\">Rich Tabor</a>, <a href=\"https://profiles.wordpress.org/rimadoshi/\">rimadoshi</a>, <a href=\"https://profiles.wordpress.org/rinkuyadav999/\">Rinku Y</a>, <a href=\"https://profiles.wordpress.org/rcutmore/\">Rob Cutmore</a>, <a href=\"https://profiles.wordpress.org/rob006/\">rob006</a>, <a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a>, <a href=\"https://profiles.wordpress.org/rconde/\">Roi Conde</a>, <a href=\"https://profiles.wordpress.org/murgroland/\">Roland Murg</a>, <a href=\"https://profiles.wordpress.org/costasovo/\">Rostislav Woln&#253;</a>, <a href=\"https://profiles.wordpress.org/roytanck/\">Roy Tanck</a>, <a href=\"https://profiles.wordpress.org/kingkool68/\">Russell Heimlich</a>, <a href=\"https://profiles.wordpress.org/rryyaanndd/\">Ryan</a>, <a href=\"https://profiles.wordpress.org/bookdude13/\">Ryan Fredlund</a>, <a href=\"https://profiles.wordpress.org/rmccue/\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/welcher/\">Ryan Welcher</a>, <a href=\"https://profiles.wordpress.org/looswebstudio/\">Ryo</a>, <a href=\"https://profiles.wordpress.org/sebastienserre/\">S&#233;bastien SERRE</a>, <a href=\"https://profiles.wordpress.org/sablednah/\">sablednah</a>, <a href=\"https://profiles.wordpress.org/viralsampat/\">Sampat Viral</a>, <a href=\"https://profiles.wordpress.org/otto42/\">Samuel Wood (Otto)</a>, <a href=\"https://profiles.wordpress.org/samuelfernandez/\">SamuelFernandez</a>, <a href=\"https://profiles.wordpress.org/zanderz/\">Sander</a>, <a href=\"https://profiles.wordpress.org/santilinwp/\">santilinwp</a>, <a href=\"https://profiles.wordpress.org/sathyapulse/\">Sathiyamoorthy V</a>, <a href=\"https://profiles.wordpress.org/tivus/\">Schuhwerk</a>, <a href=\"https://profiles.wordpress.org/coffee2code/\">Scott Reilly</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic/\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/scruffian/\">scruffian</a>, <a href=\"https://profiles.wordpress.org/scvleon/\">scvleon</a>, <a href=\"https://profiles.wordpress.org/sebastianpisula/\">Sebastian Pisula</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/sgr33n/\">Sergio de Falco</a>, <a href=\"https://profiles.wordpress.org/sergiomdgomes/\">sergiomdgomes</a>, <a href=\"https://profiles.wordpress.org/sgastard/\">sgastard</a>, <a href=\"https://profiles.wordpress.org/sgoen/\">sgoen</a>, <a href=\"https://profiles.wordpress.org/shahariaazam/\">Shaharia Azam</a>, <a href=\"https://profiles.wordpress.org/cafenoirdesign/\">Shannon Smith</a>, <a href=\"https://profiles.wordpress.org/shariqkhan2012/\">shariqkhan2012</a>, <a href=\"https://profiles.wordpress.org/sncoker/\">Shawntelle Coker</a>, <a href=\"https://profiles.wordpress.org/sheparddw/\">sheparddw</a>, <a href=\"https://profiles.wordpress.org/shital-patel/\">Shital Marakana</a>, <a href=\"https://profiles.wordpress.org/shizumi/\">Shizumi Yoshiaki</a>, <a href=\"https://profiles.wordpress.org/simonjanin/\">simonjanin</a>, <a href=\"https://profiles.wordpress.org/sinatrateam/\">sinatrateam</a>, <a href=\"https://profiles.wordpress.org/sirreal/\">sirreal</a>, <a href=\"https://profiles.wordpress.org/skorasaurus/\">skorasaurus</a>, <a href=\"https://profiles.wordpress.org/smerriman/\">smerriman</a>, <a href=\"https://profiles.wordpress.org/socalchristina/\">socalchristina</a>, <a href=\"https://profiles.wordpress.org/soean/\">Soren Wrede</a>, <a href=\"https://profiles.wordpress.org/spenserhale/\">spenserhale</a>, <a href=\"https://profiles.wordpress.org/sproutchris/\">sproutchris</a>, <a href=\"https://profiles.wordpress.org/squarecandy/\">squarecandy</a>, <a href=\"https://profiles.wordpress.org/starvoters1/\">starvoters1</a>, <a href=\"https://profiles.wordpress.org/steelwagstaff/\">SteelWagstaff</a>, <a href=\"https://profiles.wordpress.org/steevithak/\">steevithak</a>, <a href=\"https://profiles.wordpress.org/ryokuhi/\">Stefano Minoia</a>, <a href=\"https://profiles.wordpress.org/hypest/\">Stefanos Togoulidis</a>, <a href=\"https://profiles.wordpress.org/steffanhalv/\">steffanhalv</a>, <a href=\"https://profiles.wordpress.org/sabernhardt/\">Stephen Bernhardt</a>, <a href=\"https://profiles.wordpress.org/netweb/\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/dufresnesteven/\">Steve Dufresne</a>, <a href=\"https://profiles.wordpress.org/stevegrunwell/\">Steve Grunwell</a>, <a href=\"https://profiles.wordpress.org/stevenlinx/\">stevenlinx</a>, <a href=\"https://profiles.wordpress.org/stiofansisland/\">Stiofan</a>, <a href=\"https://profiles.wordpress.org/matthias-reuter/\">straightvisions GmbH</a>, <a href=\"https://profiles.wordpress.org/stroona/\">stroona.com</a>, <a href=\"https://profiles.wordpress.org/subratamal/\">Subrata Mal</a>, <a href=\"https://profiles.wordpress.org/subrataemfluence/\">Subrata Sarkar</a>, <a href=\"https://profiles.wordpress.org/manikmist09/\">Sultan Nasir Uddin</a>, <a href=\"https://profiles.wordpress.org/swapnild/\">swapnild</a>, <a href=\"https://profiles.wordpress.org/cybr/\">Sybre Waaijer</a>, <a href=\"https://profiles.wordpress.org/sergioestevao/\">Sérgio Estêvão</a>, <a href=\"https://profiles.wordpress.org/miyauchi/\">Takayuki Miyauchi</a>, <a href=\"https://profiles.wordpress.org/takeshifurusato/\">Takeshi Furusato</a>, <a href=\"https://profiles.wordpress.org/karmatosed/\">Tammie Lister</a>, <a href=\"https://profiles.wordpress.org/tanvirul/\">Tanvirul Haque</a>, <a href=\"https://profiles.wordpress.org/tbschen/\">TBschen</a>, <a href=\"https://profiles.wordpress.org/tdlewis77/\">tdlewis77</a>, <a href=\"https://profiles.wordpress.org/tellyworth/\">Tellyworth</a>, <a href=\"https://profiles.wordpress.org/thamaraiselvam/\">Thamaraiselvam</a>, <a href=\"https://profiles.wordpress.org/thefarlilacfield/\">thefarlilacfield</a>, <a href=\"https://profiles.wordpress.org/themezee/\">ThemeZee</a>, <a href=\"https://profiles.wordpress.org/timhavinga/\">Tim Havinga</a>, <a href=\"https://profiles.wordpress.org/hedgefield/\">Tim Hengeveld</a>, <a href=\"https://profiles.wordpress.org/timon33/\">timon33</a>, <a href=\"https://profiles.wordpress.org/spaceshipone/\">Timoth&#233;e Brosille</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs/\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/tkama/\">Tkama</a>, <a href=\"https://profiles.wordpress.org/tmanoilov/\">tmanoilov</a>, <a href=\"https://profiles.wordpress.org/tmatsuur/\">tmatsuur</a>, <a href=\"https://profiles.wordpress.org/tobifjellner/\">tobifjellner (Tor-Bjorn Fjellner)</a>, <a href=\"https://profiles.wordpress.org/tomgreer/\">Tom Greer</a>, <a href=\"https://profiles.wordpress.org/tjnowell/\">Tom J Nowell</a>, <a href=\"https://profiles.wordpress.org/tommix/\">tommix</a>, <a href=\"https://profiles.wordpress.org/skithund/\">Toni Viemer&#246;</a>, <a href=\"https://profiles.wordpress.org/toro_unit/\">Toro_Unit (Hiroshi Urabe)</a>, <a href=\"https://profiles.wordpress.org/torres126/\">torres126</a>, <a href=\"https://profiles.wordpress.org/zodiac1978/\">Torsten Landsiedel</a>, <a href=\"https://profiles.wordpress.org/itowhid06/\">Towhidul Islam</a>, <a href=\"https://profiles.wordpress.org/tristangemus/\">tristangemus</a>, <a href=\"https://profiles.wordpress.org/tristanleboss/\">tristanleboss</a>, <a href=\"https://profiles.wordpress.org/tsuyoring/\">tsuyoring</a>, <a href=\"https://profiles.wordpress.org/dinhtungdu/\">Tung Du</a>, <a href=\"https://profiles.wordpress.org/desaiuditd/\">Udit Desai</a>, <a href=\"https://profiles.wordpress.org/grapplerulrich/\">Ulrich</a>, <a href=\"https://profiles.wordpress.org/upadalavipul/\">upadalavipul</a>, <a href=\"https://profiles.wordpress.org/utsav72640/\">Utsav tilava</a>, <a href=\"https://profiles.wordpress.org/vaishalipanchal/\">Vaishali Panchal</a>, <a href=\"https://profiles.wordpress.org/valentinbora/\">Valentin Bora</a>, <a href=\"https://profiles.wordpress.org/varunshanbhag/\">Varun Shanbhag</a>, <a href=\"https://profiles.wordpress.org/veminom/\">Veminom</a>, <a href=\"https://profiles.wordpress.org/vinita29/\">Vinita Tandulkar</a>, <a href=\"https://profiles.wordpress.org/virgodesign/\">virgodesign</a>, <a href=\"https://profiles.wordpress.org/vsamoletov/\">Vlad. S.</a>, <a href=\"https://profiles.wordpress.org/vortfu/\">vortfu</a>, <a href=\"https://profiles.wordpress.org/waleedt93/\">waleedt93</a>, <a href=\"https://profiles.wordpress.org/webmandesign/\">WebMan Design &#124; Oliver Juhas</a>, <a href=\"https://profiles.wordpress.org/websupporter/\">websupporter</a>, <a href=\"https://profiles.wordpress.org/westonruter/\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/earnjam/\">William Earnhardt</a>, <a href=\"https://profiles.wordpress.org/williampatton/\">William Patton</a>, <a href=\"https://profiles.wordpress.org/wpgurudev/\">wpgurudev</a>, <a href=\"https://profiles.wordpress.org/alexandreb3/\">WPMarmite</a>, <a href=\"https://profiles.wordpress.org/wptoolsdev/\">wptoolsdev</a>, <a href=\"https://profiles.wordpress.org/xedinunknown-1/\">xedinunknown-1</a>, <a href=\"https://profiles.wordpress.org/yale01/\">yale01</a>, <a href=\"https://profiles.wordpress.org/collet/\">Yannicki</a>, <a href=\"https://profiles.wordpress.org/yordansoares/\">Yordan Soares</a>, <a href=\"https://profiles.wordpress.org/fierevere/\">Yui</a>, <a href=\"https://profiles.wordpress.org/zachflauaus/\">zachflauaus</a>, <a href=\"https://profiles.wordpress.org/tollmanz/\">Zack Tollman</a>, <a href=\"https://profiles.wordpress.org/zebulan/\">Zebulan Stanphill</a>, <a href=\"https://profiles.wordpress.org/zaffarn/\">Zee</a>, and <a href=\"https://profiles.wordpress.org/zsusag/\">zsusag</a>.\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p>Many thanks to all of the community volunteers who contribute in the&nbsp;<a href=\"https://wordpress.org/support/\">support forums</a>. They answer questions from people across the world, whether they are using WordPress for the first time or since the first release. These releases are more successful for their efforts!</p>\n\n\n\n<p>Finally, thanks to all the community translators who worked on WordPress 5.4. Their efforts bring WordPress fully translated to&nbsp;46 languages at release time, with more on the way.</p>\n\n\n\n<p>If you want to learn more about volunteering with WordPress, check out&nbsp;<a href=\"https://make.wordpress.org/\">Make WordPress</a>&nbsp;or the&nbsp;<a href=\"https://make.wordpress.org/core/\">core development blog</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8455\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"WordPress 5.4 RC5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2020/03/wordpress-5-4-rc5/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 28 Mar 2020 00:47:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8451\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:379:\"The fifth release candidate for WordPress 5.4 is live! WordPress 5.4 is currently scheduled to land on&#160;March 31 2020, and we need&#160;your&#160;help to get there—if you haven’t tried 5.4 yet, now is the time! You can test the WordPress 5.4 release candidate in two ways: Try the WordPress Beta Tester plugin (choose the “bleeding edge nightlies” option) [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Baumwald\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2181:\"\n<p><br>The fifth release candidate for WordPress 5.4 is live!</p>\n\n\n\n<p>WordPress 5.4 is currently scheduled to land on&nbsp;<strong><a href=\"https://make.wordpress.org/core/5-4/\">March 31 2020</a></strong>, and we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.4 yet, now is the time!</p>\n\n\n\n<p>You can test the WordPress 5.4 release candidate in two ways:</p>\n\n\n\n<ul><li>Try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (choose the “bleeding edge nightlies” option)</li><li>Or <a href=\"https://wordpress.org/wordpress-5.4-RC5.zip\">download the release candidate here</a> (zip).</li></ul>\n\n\n\n<p>For details about what to expect in WordPress 5.4, please see the&nbsp;<a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate post</a>.</p>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme to 5.4. The priority in testing is compatibility. If you find issues, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>&nbsp;so we can figure them out before the final release.</p>\n\n\n\n<p>The&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a>&nbsp;is also out! It’s your source for details on all the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language besides English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8451\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"WordPress 5.4 RC4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2020/03/wordpress-5-4-rc4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 24 Mar 2020 22:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8444\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:388:\"The fourth release candidate for WordPress 5.4 is live! WordPress 5.4 is currently scheduled to land on&#160;March 31 2020, and we need&#160;your&#160;help to get there—if you haven’t tried 5.4 yet, now is the time! You can test the WordPress 5.4 release candidate in two ways: Try the&#160;WordPress Beta Tester&#160;plugin (choose the “bleeding edge nightlies” option) [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Francesca Marano\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2395:\"\n<p>The fourth release candidate for WordPress 5.4 is live!</p>\n\n\n\n<p>WordPress 5.4 is currently scheduled to land on&nbsp;<strong><a href=\"https://make.wordpress.org/core/5-4/\">March 31 2020</a></strong>, and we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.4 yet, now is the time!</p>\n\n\n\n<p>You can test the WordPress 5.4 release candidate in two ways:</p>\n\n\n\n<ul><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.4-RC4.zip\">download the release candidate here</a>&nbsp;(zip).</li></ul>\n\n\n\n<p>For details about what to expect in WordPress 5.4, please see the&nbsp;<a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate post</a>.</p>\n\n\n\n<p>RC4 commits the new <a href=\"https://core.trac.wordpress.org/ticket/49295\">About page</a> and&nbsp;<a href=\"https://core.trac.wordpress.org/ticket/49688\">updates the editor packages</a>.</p>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme to 5.4. The priority in testing is compatibility. If you find issues, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>&nbsp;so we can figure them out before the final release.</p>\n\n\n\n<p>The&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a>&nbsp;is also out! It&#8217;s your source for details on all the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language besides English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8444\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"WordPress 5.4 RC3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2020/03/wordpress-5-4-rc3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Mar 2020 21:24:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8432\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:384:\"The third release candidate for WordPress 5.4 is now available! WordPress 5.4 is currently scheduled to be released on&#160;March 31 2020, and we need&#160;your&#160;help to get there—if you haven’t tried 5.4 yet, now is the time! There are two ways to test the WordPress 5.4 release candidate: Try the&#160;WordPress Beta Tester&#160;plugin (choose the “bleeding edge [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Baumwald\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4104:\"\n<p>The third release candidate for WordPress 5.4 is now available!</p>\n\n\n\n<p>WordPress 5.4 is currently scheduled to be released on&nbsp;<strong><a href=\"https://make.wordpress.org/core/5-4/\">March 31 2020</a></strong>, and we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.4 yet, now is the time!</p>\n\n\n\n<p>There are two ways to test the WordPress 5.4 release candidate:</p>\n\n\n\n<ul><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.4-RC3.zip\">download the release candidate here</a>&nbsp;(zip).</li></ul>\n\n\n\n<p>For details about what to expect in WordPress 5.4, please see the&nbsp;<a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate post</a>.</p>\n\n\n\n<p>RC3 addresses improvements to the new About page and&nbsp;<a href=\"https://core.trac.wordpress.org/query?id=49657%2C49621%2C48164%2C49577%2C47053%2C48303%2C49374%2C49619&amp;milestone=5.4&amp;group=component&amp;col=id&amp;col=summary&amp;col=milestone&amp;col=owner&amp;col=type&amp;col=status&amp;col=priority&amp;order=priority\">8 fixes</a>&nbsp;for the following bugs and regressions:</p>\n\n\n\n<ul><li><a href=\"https://core.trac.wordpress.org/ticket/49657\"></a><a href=\"https://core.trac.wordpress.org/ticket/49657\">49657</a> &#8211; <a href=\"https://core.trac.wordpress.org/ticket/49657\">Block Editor: Update WordPress Packages WordPress 5.4 RC 3</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49621\"></a><a href=\"https://core.trac.wordpress.org/ticket/49621\">49621</a> &#8211; <a href=\"https://core.trac.wordpress.org/ticket/49621\">Travis: Download Chromium for E2E Tests Only</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49164\"></a><a href=\"https://core.trac.wordpress.org/ticket/48164\">48164</a> &#8211; <a href=\"https://core.trac.wordpress.org/ticket/48164\">media_sideload_image Should Store Original URL and Optionally Check for Dupes</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49577\">49577 &#8211; Site Health Status Dashboard Provides Incorrect Items Count on Initial Load</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/47053\">47053 &#8211; Accessibility: Need to set proper &#8216;tabindex&#8217; in &#8216;Skip To Toolbar&#8217; HTML</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/48303\">48303 &#8211; Docblock Improvements for 5.4</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49374\">49374 &#8211; Use get_post_states to Denote Special Pages on the Added Menu Item Accordions</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49619\">49619 &#8211; Use &lt;hr /&gt; Instead of Margin on Freedoms Page</a></li></ul>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme to 5.4. If you find compatibility problems, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>&nbsp;so we can figure those out before the final release.</p>\n\n\n\n<p>The&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a>&nbsp;has also been published, which details the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8432\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"WordPress 5.4 RC2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2020/03/wordpress-5-4-rc2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Mar 2020 21:40:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8422\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:385:\"The second release candidate for WordPress 5.4 is now available! WordPress 5.4 is currently scheduled to be released on&#160;March 31 2020, and we need&#160;your&#160;help to get there—if you haven’t tried 5.4 yet, now is the time! There are two ways to test the WordPress 5.4 release candidate: Try the&#160;WordPress Beta Tester&#160;plugin (choose the “bleeding edge [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Francesca Marano\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3311:\"\n<p>The second release candidate for WordPress 5.4 is now available!</p>\n\n\n\n<p>WordPress 5.4 is currently scheduled to be released on&nbsp;<strong><a href=\"https://make.wordpress.org/core/5-4/\">March 31 2020</a></strong>, and we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.4 yet, now is the time!</p>\n\n\n\n<p>There are two ways to test the WordPress 5.4 release candidate:</p>\n\n\n\n<ul><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.4-RC2.zip\">download the release candidate here</a>&nbsp;(zip).</li></ul>\n\n\n\n<p>For details about what to expect in WordPress 5.4, please see the&nbsp;<a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate post</a>.</p>\n\n\n\n<p>RC2 addresses improvements to the new About page and <a href=\"https://core.trac.wordpress.org/query?id=49611%2C49318%2C49295%2C49585%2C49568%2C49549&amp;milestone=5.4&amp;group=component&amp;col=id&amp;col=summary&amp;col=milestone&amp;col=owner&amp;col=type&amp;col=status&amp;col=priority&amp;order=priority\">5 fixes</a> for the following bugs and regressions:</p>\n\n\n\n<ul><li><a href=\"https://core.trac.wordpress.org/ticket/49611\">49611</a> &#8211; Block Editor: Update WordPress Packages WordPress 5.4 RC 2</li><li><a href=\"https://core.trac.wordpress.org/ticket/49318\">49318</a> &#8211; Bundled Themes: Twenty Twenty content font CSS selector is too important</li><li><a href=\"https://core.trac.wordpress.org/ticket/49585\">49585</a> &#8211; REST API: Fix typo in disable-custom-gradients theme feature description</li><li><a href=\"https://core.trac.wordpress.org/ticket/49568\">49568</a> &#8211; Block Editor: Fix visual regression in editor&#8217;s color picker</li><li><a href=\"https://core.trac.wordpress.org/ticket/49549\">49549</a> &#8211; Bundled Themes: Calendar widget CSS fixes on various Bundled themes</li></ul>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme to 5.4. If you find compatibility problems, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>&nbsp;so we can figure those out before the final release.</p>\n\n\n\n<p>The&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a>&nbsp;has also been published, which details the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8422\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:79:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:6:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"People of WordPress: Mary Job\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/news/2020/03/people-of-wordpress-mary-job/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"https://wordpress.org/news/2020/03/people-of-wordpress-mary-job/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Mar 2020 16:30:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:9:\"heropress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:10:\"Interviews\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8406\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:189:\"In the March edition of our \"People of WordPress\" series, you\'ll find out how Mary Job grew from a timid, curious cat into a public speaker and organizer of WordPress Meetups and WordCamps.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Yvette Sonneveld\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9660:\"\n<p><em>You’ve probably heard that WordPress is open-source software, and may know that it’s created and run by volunteers. WordPress enthusiasts share many examples of how WordPress changed people’s lives for the better. This monthly series shares some of those lesser-known, amazing stories.&nbsp;</em></p>\n\n\n\n<h2>How it all began</h2>\n\n\n\n<figure class=\"wp-block-image size-large\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/02/At-WordCamp-Kampala-2020.jpeg?resize=632%2C844&#038;ssl=1\" alt=\"Mary Job at WordCamp Kampala 2020\" class=\"wp-image-8410\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2020/02/At-WordCamp-Kampala-2020.jpeg?resize=767%2C1024&amp;ssl=1 767w, https://i1.wp.com/wordpress.org/news/files/2020/02/At-WordCamp-Kampala-2020.jpeg?resize=225%2C300&amp;ssl=1 225w, https://i1.wp.com/wordpress.org/news/files/2020/02/At-WordCamp-Kampala-2020.jpeg?resize=768%2C1025&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2020/02/At-WordCamp-Kampala-2020.jpeg?w=809&amp;ssl=1 809w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /><figcaption>Mary Job at WordCamp Kampala 2020</figcaption></figure>\n\n\n\n<p>Mary remembers when cybercafés started trending in Nigeria. She had just finished high school and was awaiting her results for admission to university. She spent all of her time (10 hours a day) and all of her pocket money buying bulk time online at cafes. All the way through university that was true, until in 2008 she graduated with a degree in philosophy and bought her own computer and modem.</p>\n\n\n\n<p>She started blogging in 2009. Initially, she tried out Blogger, Hubpages, and WordPress—but found WordPress too complicated.&nbsp;</p>\n\n\n\n<h2>Growing up as a timid but curious cat</h2>\n\n\n\n<p>Mary is one of four kids, and the only girl among her siblings. Throughout her childhood she felt shy, even though others didn’t always see her that way. </p>\n\n\n\n<p>When she first started her personal blog, it was mostly an opportunity for her to speak her mind where she was comfortable. Blogging gave her a medium to express her thoughts and with every new post she became a better writer.</p>\n\n\n\n<h2>Rediscovering WordPress</h2>\n\n\n\n<p>After completing a postgraduate diploma in mass communication, Mary started a Masters degree in Information Management. This required a three month internship. She decided to volunteer in Ghana in 2015 at the headquarters of the Salesians of Don Bosco in West Africa (SDBAFW<strong>)</strong> where her uncle was based.</p>\n\n\n\n<p>While she was there, her uncle asked Mary why she was not blogging on WordPress, which also happened to be the software the organisation used. She explained how difficult and complicated it was so he shared a group of beginner-level tutorial videos with her.</p>\n\n\n\n<p>After two weeks of watching those videos, she started to realize she could have a full-time career doing this. So she immediately joined a number of online training groups so she could learn everything.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>I saw a lot of people earning an income from things I knew and did for the fun of it. I found myself asking why I had not turned my passion into a business.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<p>Not long after that, she was contacted by a website editor who was impressed by her blog. With the information available online for WordPress, she was able to learn everything she needed to improve and redesign a site for what turned into her first client.</p>\n\n\n\n<figure class=\"wp-block-image size-large\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/my-home-office-in-2016.jpeg?w=632&#038;ssl=1\" alt=\"\" class=\"wp-image-8412\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2020/03/my-home-office-in-2016.jpeg?w=512&amp;ssl=1 512w, https://i1.wp.com/wordpress.org/news/files/2020/03/my-home-office-in-2016.jpeg?resize=300%2C169&amp;ssl=1 300w\" sizes=\"(max-width: 512px) 100vw, 512px\" data-recalc-dims=\"1\" /><figcaption>Mary&#8217;s home office in 2016</figcaption></figure>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>I visited the <a href=\"https://wordpress.org/showcase/\">WordPress.org showcase</a> and was wowed with all the good things I could do with WordPress.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<p>In 2016 after a year of deep WordPress learning, she had fallen in love with the CMS and wanted to give back to the <a href=\"https://make.wordpress.org/\">WordPress open source project</a>.&nbsp;</p>\n\n\n\n<p>She volunteered to help the Community team. And when she moved to Lagos later that year, she discovered there was an active WordPress Meetup community. This started her journey toward becoming a WordPress Meetup Co-organizer and a Global Community Team Deputy.</p>\n\n\n\n<p>Today the Nigerian WordPress community continues to grow, as has the <a href=\"https://www.meetup.com/Lagos-WordPress-Meetup-Group\">Lagos WordPress Meetup</a> group. The first Nigerian WordCamp took place in Lagos in 2018 and a <a href=\"https://2020.lagos.wordcamp.org/\">2020 event is being planned</a>. A local WordPress community also developed in Mary’s hometown in Ijebu.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>I have made great friends and met co-organizers in the community who are dedicated to building and sharing their WordPress knowledge with the community like I am.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<h2>What did Mary gain from using and contributing to WordPress?</h2>\n\n\n\n<ul><li>She <strong>overcame her stage fright</strong> by getting up in front of an audience at her local Meetup to introduce speakers and to talk about the WordPress community.&nbsp;</li><li>She <strong>attended her first of many African WordCamps </strong>in Cape Town, South Africa. Coincidentally this was also her first time outside West Africa. Before that, she had not been in an aircraft for more than one hour.</li><li>She <strong>earned money</strong> from WordPress web design projects to sustain her during her learning period. Mary continues to use WordPress in her work and says she is still learning every day!</li><li>She got to <strong>jump off</strong> Signal Hill in Cape Town when visiting a WordCamp!&nbsp;</li></ul>\n\n\n\n<figure class=\"wp-block-image size-large\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Moderating-a-Panel-at-WCLOS2019.jpg?fit=632%2C422&amp;ssl=1\" alt=\"\" class=\"wp-image-8413\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Moderating-a-Panel-at-WCLOS2019.jpg?w=1683&amp;ssl=1 1683w, https://i1.wp.com/wordpress.org/news/files/2020/03/Moderating-a-Panel-at-WCLOS2019.jpg?resize=300%2C200&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2020/03/Moderating-a-Panel-at-WCLOS2019.jpg?resize=1024%2C683&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2020/03/Moderating-a-Panel-at-WCLOS2019.jpg?resize=768%2C512&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2020/03/Moderating-a-Panel-at-WCLOS2019.jpg?resize=1536%2C1024&amp;ssl=1 1536w, https://i1.wp.com/wordpress.org/news/files/2020/03/Moderating-a-Panel-at-WCLOS2019.jpg?w=1264&amp;ssl=1 1264w\" sizes=\"(max-width: 632px) 100vw, 632px\" /><figcaption>Mary moderating a panel at WordCamp Lagos in 2019</figcaption></figure>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>Essentially, the community has taught me to be a better communicator, and a better person. I’ve made friends across the world that have become like a family to me.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<p>She now runs a village hub in Ijebu,&nbsp; where she teaches girls digital skills and WordPress as a way of giving back to her town.</p>\n\n\n\n<p>Since she started on this journey, Mary has gotten a fulltime job supporting a WordPress plugin. She’s also become a Community Team Rep and continues to build and foster communities.</p>\n\n\n\n<h2>Mary’s advice to others</h2>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>Always seek to understand the basics of whatever knowledge you seek. Never jump in too fast, wanting to spiral to the top while ignoring the learning curve. You will likely crash down effortlessly if you do so, and would have learned nothing.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<h2>Contributors</h2>\n\n\n\n<p>Thanks to Alison Rothwell (<a href=\"https://profiles.wordpress.org/wpfiddlybits/\">@wpfiddlybits</a>), Yvette Sonneveld (<a href=\"https://profiles.wordpress.org/yvettesonneveld/\">@yvettesonneveld</a>), Abha Thakor (<a href=\"https://profiles.wordpress.org/webcommsat/\">@webcommsat</a>), Josepha Haden (<a href=\"https://profiles.wordpress.org/chanthaboune/\">@chanthaboune</a>), Topher DeRosia (<a href=\"https://profiles.wordpress.org/topher1kenobe/\">@topher1kenobe</a>). Thank you to Mary Job (<a href=\"https://profiles.wordpress.org/mariaojob/\">@maryojob</a>) for sharing her #ContributorStory.</p>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"alignleft size-large\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/heropress_logo_180.png?w=632&#038;ssl=1\" alt=\"\" class=\"wp-image-8409\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<p><em>This post is based on </em><a href=\"https://heropress.com/essays/wordpress-gave-perfect-identity/\"><em>an article originally published on HeroPress.com</em></a><em>, a community initiative created by </em><a href=\"https://profiles.wordpress.org/topher1kenobe/\"><em>Topher DeRosia</em></a><em>. HeroPress highlights people in the WordPress community who have overcome barriers and whose stories would otherwise go unheard.</em></p>\n\n\n\n<p><em>Meet more WordPress community members over at </em><a href=\"https://heropress.com/\"><em>HeroPress.com</em></a><em>!</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2020/03/people-of-wordpress-mary-job/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"16\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8406\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 5.4 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Mar 2020 21:59:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8399\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:360:\"The first release candidate for WordPress 5.4 is now available! This is an important milestone as we progress toward the WordPress 5.4 release date. “Release Candidate” means that the new version is ready for release, but with millions of users and thousands of plugins and themes, it’s possible something was missed. WordPress 5.4 is currently [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Baumwald\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2714:\"\n<p>The first release candidate for WordPress 5.4 is now available!</p>\n\n\n\n<p>This is an important milestone as we progress toward the WordPress 5.4 release date. “Release Candidate” means that the new version is ready for release, but with millions of users and thousands of plugins and themes, it’s possible something was missed. WordPress 5.4 is currently scheduled to be released on <strong>March 31, 2020</strong>, but we need <em>your</em> help to get there—if you haven’t tried 5.4 yet, <strong>now is the time</strong>!</p>\n\n\n\n<p>There are two ways to test the WordPress 5.4 release candidate:</p>\n\n\n\n<ul><li>Try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (choose the “bleeding edge nightlies” option)</li><li>Or <a href=\"https://wordpress.org/wordpress-5.4-RC1.zip\">download the release candidate here</a> (zip).</li></ul>\n\n\n\n<h2>What’s in WordPress 5.4?</h2>\n\n\n\n<p>WordPress 5.4 has lots of refinements to polish the developer experience. To keep up, subscribe to the&nbsp;<a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a>&nbsp;and pay special attention to the&nbsp;<a href=\"https://make.wordpress.org/core/tag/5-4+dev-notes/\">developer notes</a>&nbsp;tag for updates on those and other changes that could affect your products.</p>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the <em>Tested up to</em> version in the readme file to 5.4. If you find compatibility problems, please be sure to post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a> so we can figure those out before the final release.</p>\n\n\n\n<p>The WordPress 5.4 Field Guide will be published within the next 24 hours with a more detailed dive into the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a> This release also marks the <a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\">hard string freeze</a> point of the 5.4 release schedule.</p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8399\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"The Month in WordPress: February 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://wordpress.org/news/2020/03/the-month-in-wordpress-february-2020/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Mar 2020 09:15:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Month in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8393\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:337:\"February 2020 was a busy month in the WordPress project! Most notably, there was an outpouring of sentiment in response to the unfortunate cancellation of WordCamp Asia. However, the team continues to work hard in the hopes of making WordCamp Asia 2021 happen. In addition, there were a number of releases and some exciting new [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Hugh Lashbrooke\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9167:\"\n<p>February 2020 was a busy month in the WordPress project! Most notably, there was an outpouring of sentiment in response to the unfortunate cancellation of WordCamp Asia. However, the team continues to work hard in the hopes of making WordCamp Asia 2021 happen. In addition, there were a number of releases and some exciting new news during the month of February. Read on for more information!</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>WordCamp Asia 2020 Cancelled &amp; Pop-up Livestream</h2>\n\n\n\n<p>There was a ton of excitement around WordCamp Asia, not to mention all the effort from organizers, speakers, sponsors and volunteers. Unfortunately, on February 12th, <a href=\"https://wordpress.org/news/2020/02/wordcamp-asia-cancelled-due-to-covid-19/\">WordCamp Asia was cancelled</a> due to concern and uncertainty around COVID-19. Since then, the organizing team has worked to <a href=\"https://2020.asia.wordcamp.org/2020/02/12/cancellation/\">refund tickets and to support hotel and air refunds</a>. In addition, a <a href=\"https://wordpress.org/news/2020/02/pop-up-livestream-on-february-22/\">pop-up livestream</a> featuring some WordCamp Asia speakers and a Fireside Chat and Q&amp;A with Matt Mullenweg took place on February 22nd.</p>\n\n\n\n<p>For a personal take on the cancellation of WordCamp Asia, read <a href=\"https://naoko.blog/2020/02/13/wordcamp-asia-2020-recap/\">this post from Naoko Takano</a>, the global lead organizer. Many thanks to the volunteers who worked hard to deliver WordCamp Asia. They’ve not only handled logistics associated with cancellation but have also announced that they’ve started <a href=\"https://2020.asia.wordcamp.org/2020/02/18/wordcamp-asia-2021/\">working on WordCamp Asia 2021</a> with some January dates in mind! To get the latest on WordCamp Asia, subscribe to updates <a href=\"https://2021.asia.wordcamp.org/\">here</a>.&nbsp;</p>\n\n\n\n<h2>WordPress 5.4 Beta is Now Available</h2>\n\n\n\n<p><a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-1/\">WordPress 5.4 Beta 1</a> was released on February 11 and quickly followed by <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-2/\">Beta 2</a> on February 18 and <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-3/\">Beta 3</a> on February 25. These two releases get us closer to our primary goal for 2020: full-site editing with blocks. WordPress 5.4 will merge ten releases of the Gutenberg plugin and is scheduled to be released on March 31, 2020. It will come with many new features, such as two new blocks for social links and buttons, and easier navigation in the block breadcrumbs. There are also a number of accessibility improvements, such as easier multi-block selection and easier tabbing, one of the editor’s biggest accessibility issues. <a href=\"https://make.wordpress.org/core/tag/5-4/\">5.4 will also include</a> many developer-focused changes, such as improved favicon handling and many new hooks and filters.</p>\n\n\n\n<p>Want to get involved in building WordPress? There are a number of ways to help right now! If you speak a language other than English, <a href=\"https://translate.wordpress.org/projects/wp/dev/\">help us translate WordPress</a>. Found a bug? Post it to the<a href=\"https://wordpress.org/support/forum/alphabeta/\"> Alpha/Beta area</a> in the support forums. You can also help us test the current beta by installing <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">the WordPress Beta Tester plugin</a>. Just remember that the software is still in development, so we recommend against running it on a production site.&nbsp;</p>\n\n\n\n<h2>WordCamp Centroamérica is Looking for Speakers and Sponsors!</h2>\n\n\n\n<p><a href=\"https://2020.centroamerica.wordcamp.org/\">WordCamp Centroamérica</a> is the first regional WordCamp for Central America and will be held on September 17-19, 2020, in Managua, Nicaragua. The <a href=\"https://2020.centroamerica.wordcamp.org/2020/01/28/llamado-a-ponentes-call-for-speakers/#more-5\">Call for Speakers</a> and <a href=\"https://2020.centroamerica.wordcamp.org/2020/01/16/call-for-sponsors/\">Call for Sponsors</a> are now open, so if you’re interested in speaking at or sponsoring WordCamp Centroamérica, now is your chance! To learn more about the eent, visit and subscribe to updates on their <a href=\"https://2020.centroamerica.wordcamp.org/\">website</a>, or follow their <a href=\"https://www.facebook.com/WordCampCA\">Facebook</a>, <a href=\"https://twitter.com/WordCampCA\">Twitter</a>, and <a href=\"https://instagram.com/wccentroamerica\">Instagram</a> accounts.&nbsp;&nbsp;</p>\n\n\n\n<p>Want to get involved in the Community team and help make more amazing WordCamps happen? <a href=\"https://make.wordpress.org/community/\">Follow the blog</a> and join the #community-events channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>! You can also find out about other <a href=\"https://central.wordcamp.org/\">upcoming WordCamps here</a>.</p>\n\n\n\n<h2>Contribute to WordPress Core via GitHub</h2>\n\n\n\n<p>An experimental feature has been added to Trac to help improve collaboration between Trac and GitHub. This feature allows contributors to link GitHub pull requests opened against the official <a href=\"https://github.com/wordpress/wordpress-develop\">WordPress Develop Git mirror</a> to tickets, which will make GitHub contributions more visible in the related Trac ticket. To learn all the details and to see how it works, read <a href=\"https://make.wordpress.org/core/2020/02/21/working-on-trac-tickets-using-github-pull-requests/\">this post</a>.</p>\n\n\n\n<h2>Gutenberg Development Continues</h2>\n\n\n\n<p>There are many new exciting additions to Gutenberg! On February 5, <a href=\"https://make.wordpress.org/core/2020/02/05/whats-new-in-gutenberg-5-february/\">Gutenberg 7.4 saw two new features added</a>, including background color support to the Columns block and text color support for the Group block. Many enhancements were made, including a number of improvements to the Navigation Block.</p>\n\n\n\n<p>Gutenberg 7.5 was released on February 12, <a href=\"https://make.wordpress.org/core/2020/02/26/whats-new-in-gutenberg-26-february/\">with 7.6 following</a> on February 27. They introduced even more features, including the Social Links block as a stable block and a number of additional blocks for full-site editing, not to mention the many enhancements, new APIs, bug fixes, documentation, and updates.</p>\n\n\n\n<p>Want to get involved in building Gutenberg? Follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>, contribute to <a href=\"https://github.com/WordPress/gutenberg/\">Gutenberg on GitHub</a>, and join the #core-editor channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>Further Reading:</h2>\n\n\n\n<ul><li>Aside from WordCamp Asia, two other WordCamps have been postponed due to COVID-19: <a href=\"https://2020-soltau.retreat.wordcamp.org/2020/02/29/verschiebung-des-wordcamp-retreat-postponing-of-wordcamp-retreat/\">WordCamp Retreat Soltau</a> and <a href=\"https://2020.geneve.wordcamp.org/wordcamp-geneve-reporte/\">WordCamp Genève</a>. News about further postponements or cancellations will be posted on <a href=\"https://central.wordcamp.org/news/\">the WordCamp Central blog</a>.</li><li>Automatic updates for themes and plugins <a href=\"https://make.wordpress.org/core/2020/02/26/feature-plugin-wp-auto-updates/\">are being planned</a> for inclusion in WordPress 5.5.</li><li>Version 2.2.1 of the WordPress Coding Standards has been released.</li><li>The Community Team <a href=\"https://make.wordpress.org/community/2020/02/06/community-team-reps-for-2020-2/\">has selected new team representatives</a> for 2020.</li><li>The Core team <a href=\"https://make.wordpress.org/core/2020/02/09/what-does-it-mean-to-be-a-component-maintainer-a-refresher/\">published a useful refresher</a> on what it means to be a component maintainer, along with some tips and best practices.</li><li><a href=\"https://make.wordpress.org/support/2020/02/changes-to-the-support-guidelines-for-linking-to-off-site-resources/\">The Support Team has announced</a> some amendments to their guidelines for linking to external resources when using the support forums.</li><li>The WordPress Foundation <a href=\"https://wordpressfoundation.org/2020/wordpress-foundation-donates-to-black-girls-code-and-internet-archive/\">has published financial information</a> regarding their charitable donations from 2019.</li><li>The Core XML Sitemaps project kicked off with <a href=\"https://make.wordpress.org/core/2020/02/24/xml-sitemaps-meeting-february-25th-2020/\">their first meeting</a> this month.</li><li>The Gutenberg team have created <a href=\"https://make.wordpress.org/core/2020/02/28/new-wordpress-create-block-package-for-block-scaffolding/\">a new @wordpress/create-block package</a> for scaffolding new blocks.</li></ul>\n\n\n\n<p><em>Have a story that we should include in the next “Month in WordPress” post? Please </em><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><em>submit it here</em></a><em>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8393\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 5.4 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 25 Feb 2020 22:10:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8384\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:343:\"WordPress 5.4 Beta 3 is now available! This software is still in development,&#160;so we don’t recommend you run it on a production site. Consider setting up a test site to play with the new version. You can test the WordPress 5.4 beta in two ways: Try the WordPress Beta Tester plugin (choose &#8220;bleeding edge nightlies&#8221; [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Baumwald\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2869:\"\n<p>WordPress 5.4 Beta 3 is now available!</p>\n\n\n\n<p><strong>This software is still in development,</strong>&nbsp;so we don’t recommend you run it on a production site. Consider setting up a test site to play with the new version.</p>\n\n\n\n<p>You can test the WordPress 5.4 beta in two ways:</p>\n\n\n\n<ul><li>Try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (choose &#8220;bleeding edge nightlies&#8221; or &#8220;Beta/RC &#8211; Bleeding edge&#8221; option in version 2.2.0 or later of the plugin) * you must already have updated to your site to &#8220;bleeding edge nightlies&#8221; for the &#8220;Beta/RC &#8211; Bleeding edge&#8221; option to be available</li><li>Or <a href=\"https://wordpress.org/wordpress-5.4-beta3.zip\">download the beta here</a> (zip). </li></ul>\n\n\n\n<p>WordPress 5.4 is slated for release on&nbsp;<a href=\"https://make.wordpress.org/core/5-4/\">March 31st, 2020</a>, and we need your help to get there.</p>\n\n\n\n<p>Thanks to the testing and feedback from everyone who tested <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-2/\">beta 2</a> (and <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-1/\">beta 1</a>) over <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;changetime=02%2F18%2F2020..02%2F25%2F2020&amp;milestone=5.4&amp;col=id&amp;col=summary&amp;col=status&amp;col=milestone&amp;col=owner&amp;col=type&amp;col=priority&amp;order=priority\">24 tickets have been closed</a> in the past week. </p>\n\n\n\n<h2>Some highlights </h2>\n\n\n\n<ul><li><a href=\"https://github.com/WordPress/gutenberg/pull/20424\">Round-up of Gutenberg fixes</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/47606\">Display Site Health score on Dashboard</a></li></ul>\n\n\n\n<h2>Developer notes</h2>\n\n\n\n<p>WordPress 5.4 has lots of refinements to polish the developer experience. To keep up, subscribe to the&nbsp;<a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a>&nbsp;and pay special attention to the&nbsp;<a href=\"https://make.wordpress.org/core/tag/5-4+dev-notes/\">developer notes</a>&nbsp;tag for updates on those and other changes that could affect your products.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev/\">Help us translate WordPress into more than 100 languages</a>!</p>\n\n\n\n<p>If you think you’ve found a bug, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://core.trac.wordpress.org/newticket\">file one on WordPress Trac</a>&nbsp;where you can also find a list of&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">known bugs</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"8384\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:32:\"https://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:4:\"site\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"14607090\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 06 Apr 2020 23:26:10 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:25:\"strict-transport-security\";s:11:\"max-age=360\";s:6:\"x-olaf\";s:3:\"⛄\";s:13:\"last-modified\";s:29:\"Fri, 03 Apr 2020 12:01:00 GMT\";s:4:\"link\";s:63:\"<https://wordpress.org/news/wp-json/>; rel=\"https://api.w.org/\"\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:9:\"HIT ord 1\";}}s:5:\"build\";s:14:\"20130911040210\";}','no'),
	(138,'_transient_timeout_feed_mod_9bbd59226dc36b9b26cd43f15694c5c3','1586258771','no'),
	(139,'_transient_feed_mod_9bbd59226dc36b9b26cd43f15694c5c3','1586215571','no'),
	(140,'_transient_timeout_feed_d117b5738fbd35bd8c0391cda1f2b5d9','1586258773','no'),
	(141,'_transient_feed_d117b5738fbd35bd8c0391cda1f2b5d9','a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: Proposal to Move WordPress Theme Review Process to GitHub\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98312\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:179:\"https://wptavern.com/proposal-to-move-wordpress-theme-review-process-to-github?utm_source=rss&utm_medium=rss&utm_campaign=proposal-to-move-wordpress-theme-review-process-to-github\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5516:\"<p class=\"has-drop-cap\">Denis &#381;oljom, the automation representative for the WordPress theme review team, <a href=\"https://make.wordpress.org/themes/2020/04/03/proposal-github-theme-review/\">proposed moving much of the theme review system</a> over to GitHub. The idea is to move the interactive parts of the review away from the current system. The proposal claims such a move would streamline the process via automated tools and make the manual, reviewer-to-author interactions easier.</p>\n\n\n\n<p>Currently, the theme review process takes place on <a href=\"https://themes.trac.wordpress.org/\">Trac</a>. For many theme authors and reviewers, the software can feel archaic. It does not have the feature set that developers have become accustomed to with other solutions. With the move of major parts of WordPress, such as feature plugin development, to GitHub over the past few years, it might be time to reevaluate other areas of the core project.</p>\n\n\n\n<p>&#381;oljom noted in the proposal that reviews handled through Trac are cumbersome. As a former theme review team lead and reviewer, I know how many on the team feel. Right now, much of the review process is manual. It is handled via a lot of back-and-forth communication between the reviewer and author. There is no good way to leave a note or comment on a specific line of code when there is an issue. This ongoing <em>discussion</em> between reviewer and author is sometimes hindered by a language barrier. The experience of comparing changes between code updates is lackluster at best. Plus, the only automated check is handled by the <a href=\"https://wordpress.org/plugins/theme-check/\">Theme Check</a> plugin.</p>\n\n\n\n<p>Handling reviews on GitHub opens a new world of possibilities that could make reviews more efficient and provide a better experience on both ends of the process.</p>\n\n\n\n<p>From 2015 through 2019, I ran a side business with a partner where we performed code reviews on plugins and themes. The majority of that business was working with commercial theme shops. Around 90% of the reviews were handled on GitHub.</p>\n\n\n\n<p>At the same time, I was still volunteering with the WordPress theme review team. There was no comparison in terms of user experience. GitHub won hands down. This experience turned me away from wanting to perform reviews for the official directory. Nothing there was streamlined. It was tougher to point to specific code issues and check if a problem was corrected when an author sent in an update.</p>\n\n\n\n<p>&#381;oljom&rsquo;s initial proposal outlines a system where the theme author submits their theme through the WordPress <a href=\"https://wordpress.org/themes/getting-started/\">theme upload page</a>. If it passes the initial check, the system would automatically create a new GitHub repository with the theme. Theme authors can then fork this newly-created repository to work on code changes based on reviewer feedback. Theme updates would also work through GitHub.</p>\n\n\n\n<p>&ldquo;I think that forks are a good middle ground,&rdquo; said &#381;oljom. &ldquo;Authors have forks on their own GitHub accounts and can update those, and make updates that way even. That would definitely help us with people who are trying to trick the system by updating their themes once they go live with things that break the requirements.&rdquo;</p>\n\n\n\n<p>The proposal is merely an idea to explore at this stage. Much of the process could change if it is given the green light to proceed.</p>\n\n\n\n<p>&ldquo;In the end, I hope this initiative will go live and help us bring the review queue down,&rdquo; said &#381;oljom. He has hopes the team can integrate more automated checks such as the <a href=\"https://github.com/WordPress/WordPress-Coding-Standards\">WordPress Coding Standards</a>. With more automation, it could also mean the theme review team could focus on other projects it works on, such as preparing for the future of full-site editing and continuing education.</p>\n\n\n\n<h2>Beyond the Review Process</h2>\n\n\n\n<p class=\"has-drop-cap\">One of the primary issues the team has faced over the years is educating authors on writing cleaner and more secure code. Some issues like sanitizing data on input and escaping it on output are still prevalent during reviews. The team&rsquo;s history of communication via Trac has not seemed to help with education on the whole.</p>\n\n\n\n<p>&ldquo;The main point is the fact that many people can be involved in the review process, and then you have experienced reviewers who can show why some code is not good or needs improvement,&rdquo; said &#381;oljom. &ldquo;This provides a way for many people to see what is wrong with the code and how they can improve it. Plus the forked theme stays in their repo, so they can see the changes that they made and why.&rdquo;</p>\n\n\n\n<p>&#381;oljom has a few items in reserve for the long-term wish list. One possibility for the future may be setting up themes on Packagist for installation via Composer. He admits that it is a longshot at best.</p>\n\n\n\n<p>&ldquo;I see this as an opportunity to bring one aspect of WordPress up to par with other modern PHP frameworks like Laravel,&rdquo; he said. &ldquo;Plus, utilize automatic tools at our disposal. From PHP CodeSniffer, PHPStan, ES Lint, and a plethora of other tools, we could also show authors how they can set these tools on their projects and make their coding skills better. Maybe throw some automatic integration tests in the mix. The possibilities are really endless.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 06 Apr 2020 20:08:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: Proposal to Add a Consent API to WordPress, Feature Plugin Available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98269\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:199:\"https://wptavern.com/proposal-to-add-a-consent-api-to-wordpress-feature-plugin-available?utm_source=rss&utm_medium=rss&utm_campaign=proposal-to-add-a-consent-api-to-wordpress-feature-plugin-available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4432:\"<p class=\"has-drop-cap\">On Wednesday, Garret Hyder announced a <a href=\"https://make.wordpress.org/core/2020/04/01/feature-plugin-proposal-wp-consent-api/\">feature proposal for a WordPress Consent API.</a> The proposal is one step on the larger <a href=\"https://make.wordpress.org/core/roadmap/privacy/\">privacy roadmap</a> for core. If merged into WordPress, it would establish a standard method for core, plugins, and themes to obtain consent for various privacy-related features. The idea is to create a consistent experience for developers, site administrators, and site visitors.</p>\n\n\n\n<p>The <a href=\"https://wordpress.org/plugins/wp-consent-api/\">WP Consent API</a> plugin is available via the WordPress plugin directory. Development is currently happening on the plugin&rsquo;s <a href=\"https://github.com/rlankhorst/wp-consent-level-api/\">GitHub repository</a>.</p>\n\n\n\n<p>Hyder identified several areas in which an API for handling consent could help in bringing a site into compliance with various privacy laws:</p>\n\n\n\n<ul><li>Consent management plugins cannot prevent other plugins from placing a PHP cookie.</li><li>Plugins that integrate tracking code on the client-side could break the site if blocked by a consent management plugin.</li><li>Minified URLs in JavaScript files may not be detected by automatic blocking scripts.</li><li>Using a blocking approach to handle privacy requires a list of all types of URLs when dealing with cookies and other types of tracking.</li></ul>\n\n\n\n<p>&ldquo;Primarily this API is aimed at helping to achieve a compliant use of cookies or other means of tracking by WordPress websites,&rdquo; wrote Hyder in the proposal. &ldquo;If a plugin or custom code triggers, for example, Facebook, usage of this API will be of help to ensure consent. If a user manually embeds a Facebook iframe, a cookie blocker is needed that initially disables the iframe and or scripts.&rdquo;</p>\n\n\n\n<p>The goal is not to create functionality that would block third-party scripts, such as tracking from a site like Facebook. Because different jurisdictions have their own laws across the world, the actual management of blocking functionality would be best suited for a consent management plugin. This would be outside of the scope of what WordPress does out of the box. By providing an API directly in core, it would allow plugin developers to build consent management plugins that are needed in different locations. The API would merely be a means for all plugins to <em>talk the same language</em>. That standardization would allow consent management plugins to work as they should.</p>\n\n\n\n<p>Furthermore, adding a front-end user interface would place additional scripts, styles, and functionality on all WordPress sites. These types are things are best handled by plugin developers.</p>\n\n\n\n<p>The API proposes allowing the creation of consent categories. Such categories might be preferences, marketing, or statistics. They would be filterable by plugins. The API has two indicators to determine consent for a category: a region-based consent type, which can be opt-in or opt-out, and the visitor&rsquo;s choice.</p>\n\n\n\n<p>The team working on the project has put together a <a href=\"https://wpconsentapi.org/\">Consent API Demo</a> to see how this plugin would work along with consent management on a website&rsquo;s front end. The demo makes use of the <a href=\"https://complianz.io/\">Complianz plugin</a> and an <a href=\"https://github.com/rlankhorst/consent-api-example-plugin\">example plugin</a> for showcasing how the API works.</p>\n\n\n\n<p>Consent management is a tough area to handle in terms of web design and development. On the one hand, respecting the privacy laws of various jurisdictions is necessary for many people around the world. On the other hand, cookie notice popups on websites often create a poor user experience for site visitors, and that experience may only get worse before it gets better.</p>\n\n\n\n<p>However, a standard API is past due in core WordPress. This will at least provide plugin authors with a means of working with consent management plugins. In time, maybe we will find a front-end interface that creates a nice experience while maintaining privacy.</p>\n\n\n\n<p>The team is currently looking for feedback on the proposal and plugin. If the feature proposal is accepted, authors of consent management plugins should be prepared to begin integrating with the API.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 03 Apr 2020 19:25:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WordPress.org blog: The Month in WordPress: March 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8532\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2020/04/the-month-in-wordpress-march-2020/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8586:\"<p>The month of March was both a tough and exciting time for the WordPress open-source project. With COVID-19 declared a pandemic, in-person events have had to adapt quickly &#8211; a challenge for any community. March culminated with the release of WordPress 5.4, an exhilarating milestone only made possible by dedicated contributors. For all the latest, read on.&nbsp;</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>WordPress 5.4 “Adderley”</h2>\n\n\n\n<p>WordPress 5.4 “Adderley” <a href=\"https://wordpress.org/news/2020/03/adderley/\">was released on March 31</a> and includes a robust list of new blocks, enhancements, and new features for both users and developers. The primary focus areas of this release included the block editor, privacy, accessibility, and developer improvements, with the full list of enhancements covered in <a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">the 5.4 field guide</a>.</p>\n\n\n\n<p>Want to get involved in building WordPress Core? Follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>, and join the #core channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>Releases of Gutenberg 7.7 and 7.8</h2>\n\n\n\n<p>It’s been another busy month for Gutenberg, this time with the release of Gutenberg <a href=\"https://make.wordpress.org/core/2020/03/11/whats-new-in-gutenberg-11-march/\">7.7</a> and <a href=\"https://make.wordpress.org/core/2020/03/26/whats-new-in-gutenberg-25-march/\">7.8</a>. Gutenberg 7.7 introduced block patterns &#8211; predefined block layouts that are ready to use and tweak. This is an important step towards Full Site Editing, which is currently targeted for inclusion in WordPress 5.6. As a first iteration, you can pick and insert patterns from the Block Patterns UI, which has been added as a sidebar plugin.</p>\n\n\n\n<p>Gutenberg 7.7 also includes a refresh of the Block UI, which better responds to the ways users interact with the editor. For more information on the User UI and Block Patterns, read <a href=\"https://make.wordpress.org/themes/2020/03/18/block-based-themes-meeting-notes/\">this summary of the most recent Block-Based Themes meeting</a>. Gutenberg 7.8, introduced on March 25, further enhanced this Block UI redesign. Both releases also included a suite of improvements, bug fixes, new APIs, documentation, and more!</p>\n\n\n\n<p>Want to get involved in building Gutenberg? Follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>, contribute to <a href=\"https://github.com/WordPress/gutenberg/\">Gutenberg on GitHub</a>, and join the #core-editor channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>WordCamp cancellations and shift to online events</h2>\n\n\n\n<p>In early March, the Community team issued <a href=\"https://make.wordpress.org/community/2020/03/11/new-recommendations-for-event-organizers-in-light-of-covid-19/\">new recommendations for event organizers</a> in light of growing concerns around COVID-19. Following this guidance, and with COVID-19 declared a pandemic, WordPress community organizers reluctantly but responsibly <a href=\"https://make.wordpress.org/community/2020/03/12/latest-updates-on-changes-to-wordcamps/\">postponed or canceled their upcoming WordCamps</a> and meetups.</p>\n\n\n\n<p>As community events are an important part of the WordPress open-source project, the Community team made suggestions for <a href=\"https://make.wordpress.org/community/2020/03/20/taking-charity-hackathons-online/\">taking charity hackathons online</a>, <a href=\"https://make.wordpress.org/community/2020/03/24/community-events-in-the-time-of-covid-19/\">proposed interim adjustments</a> to existing community event guidelines, and provided <a href=\"https://make.wordpress.org/community/2020/03/13/online-conference-organizer-training/\">training for online conference organizing</a> with Crowdcast. The team is currently working on building a <a href=\"https://make.wordpress.org/community/handbook/virtual-events/\">Virtual Events Handbook</a> that will continue to support WordPress community organizers at this time.&nbsp;</p>\n\n\n\n<p>Want to get involved with the WordPress Community team, host your own virtual WordPress event, or help improve the documentation for all of this? Follow <a href=\"https://make.wordpress.org/community/\">the Community team blog</a>, learn more about <a href=\"https://make.wordpress.org/community/handbook/virtual-events/\">virtual events</a>, and join the #community-events channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<h2>Link your GitHub profile to WordPress.org</h2>\n\n\n\n<p>Last month, <a href=\"https://make.wordpress.org/core/2020/02/21/working-on-trac-tickets-using-github-pull-requests/\">an experimental feature</a> was added to Trac, WordPress Core’s bug-tracking system, to improve collaboration between Trac and GitHub. This month, to help make tracking contributions to the WordPress project across multiple locations easier, there is <a href=\"https://make.wordpress.org/core/2020/03/19/associating-github-accounts-with-wordpress-org-profiles/\">a new option</a> to connect your GitHub account to your WordPress.org profile. This connection allows for more accurate acknowledgement and recognition of contributors. You can connect your GitHub account to your WordPress.org account by editing your WordPress.org profile.</p>\n\n\n\n<p>For more information and instructions on how to connect your accounts, <a href=\"https://make.wordpress.org/core/2020/03/19/associating-github-accounts-with-wordpress-org-profiles/\">read the announcement post</a>.</p>\n\n\n\n<h2>Modernizing WordPress coding standards</h2>\n\n\n\n<p>Defined coding standards is an important step in creating the consistent codebase needed to prepare for requiring PHP 7.x for WordPress Core. As such, <a href=\"https://make.wordpress.org/core/2020/03/20/updating-the-coding-standards-for-modern-php/\">coding standards have been proposed</a> for implementation in WordPress Coding Standards 3.0.0. This includes new proposed standards for namespace declarations, import use statements, fully qualified names in inline code, traits and interfaces, type declarations, declare statements/strict typing, the ::class constant, operators, and more.&nbsp;</p>\n\n\n\n<p>Want to get involved or view the full list of currently proposed new coding standards? Visit and add your feedback to the post on <a href=\"https://make.wordpress.org/core/2020/03/20/updating-the-coding-standards-for-modern-php/\">updating the Coding standards for modern PHP</a> and follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>Further Reading:</h2>\n\n\n\n<ul><li>On March 16, <a href=\"https://make.wordpress.org/core/2020/03/18/auto-updates-feature-meeting-summary-march-17th-2020/\">Version 0.3 of the auto-updates feature was released</a>, including fixes to a number of issues and the introduction of email notifications.&nbsp;</li><li>WordCamp US announced that <a href=\"https://2020.us.wordcamp.org/2020/03/26/wcus-is-happening/\">the 2020 event will happen</a>, one way or another. But the team need your help to make sure that it’s another fantastic event. <a href=\"https://2020.us.wordcamp.org/2020/03/16/call-for-speakers-is-now-open/\">Consider applying to be a speaker</a>!</li><li>Speaking of WordCamp US, <a href=\"https://2020.us.wordcamp.org/2020/03/23/call-for-cities-for-wcus-2021-2022/\">the Call for Cities for WCUS 2021/2022</a> is now open. If your community is interested in being a future WCUS host, <a href=\"https://wordcampcentral.survey.fm/wcus-2021-2022\">apply today</a>!</li><li>With COVID-19 preventing in-person community events, the Diverse Speaker Training (#wpdiversity) Group encourages you to <a href=\"https://make.wordpress.org/community/2020/03/17/covid-19-and-the-diverse-speaker-training-wpdiversity-group/\">host a virtual Diverse Speaker Workshop</a> to prepare speakers for when we are able to meet in person again. To get started, <a href=\"https://tiny.cc/wpdiversity\">visit this page</a>.&nbsp;</li><li>An <a href=\"https://make.wordpress.org/updates/2020/03/06/update-progress-on-goals/\">update for progress on 2020 goals</a> has been posted, sharing some more defined targets and schedule.</li></ul>\n\n\n\n<p><em>Have a story that we should include in the next “Month in WordPress” post? Please </em><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><em>submit it here</em></a><em>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 03 Apr 2020 12:01:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Hugh Lashbrooke\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Gary: Bebo, Betty, and Jaco\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"https://pento.net/?p=5166\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://pento.net/2020/04/03/bebo-betty-and-jaco/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:643:\"<p><em>Wait, wasn&#8217;t <a href=\"https://wordpress.org/news/2020/03/adderley/\">WordPress 5.4</a> just released?</em></p>\n\n\n\n<p>It absolutely was, and congratulations to everyone involved! Inspired by the fine work done to get another release out, I finally completed the last step of co-leading WordPress 5.0, 5.1, and 5.2 (Bebo, Betty, and Jaco, respectively).</p>\n\n\n\n<img src=\"https://pento.net/wp-content/uploads/2020/04/IMG_20200403_121947-1024x768.jpg\" alt=\"\" class=\"wp-image-5165\" />\n\n\n\n<p>My study now has a bit more jazz in it. <img src=\"https://s.w.org/images/core/emoji/12.0.0-1/72x72/1f642.png\" alt=\"?\" class=\"wp-smiley\" /></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 03 Apr 2020 01:51:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Gary\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: Create Custom Patterns with the Block Pattern Builder Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98244\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:185:\"https://wptavern.com/create-custom-patterns-with-the-block-pattern-builder-plugin?utm_source=rss&utm_medium=rss&utm_campaign=create-custom-patterns-with-the-block-pattern-builder-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4597:\"<p class=\"has-drop-cap\">Have I mentioned how excited I am about the potential of <a href=\"https://wptavern.com/block-patterns-will-change-everything\">block patterns</a>? For regular Tavern readers, I may sound like a broken record at this point, but I am going to continue evangelizing this upcoming feature for WordPress.</p>\n\n\n\n<p>With no social plans or other important things requiring my attention this past weekend, it made for a good moment to dip my toes back into the development waters. I have not built a new plugin for public release since becoming a writer for WP Tavern six months ago. My excitement over block patterns was creating an itch that I needed to scratch. Combine that with the physical distancing we are all practicing during the current worldwide pandemic, it made for an opportune moment to throw together a plugin idea I had.</p>\n\n\n\n<p>Let me introduce you to Block Pattern Builder.</p>\n\n\n\n<p>When the initial API launched for <a href=\"https://wptavern.com/gutenberg-7-8-adds-patterns-api-and-continues-interface-cleanup\">block patterns in Gutenberg 7.8</a>, it was immediately apparent how easy registering custom patterns would be for theme and plugin authors. Building a pattern was as simple as creating a unique ID, giving it a title, and pasting in the code for the blocks that make up the pattern. There is almost no coding actually involved with building patterns.</p>\n\n\n\n<p>Because patterns are merely the HTML code from blocks, it meant that it was possible to utilize the block editor to create them. End-users could do this. They just need an easy way to publish their custom patterns. That&rsquo;s where the Block Pattern Builder plugin comes in.</p>\n\n\n\n<p>With the idea in mind, I knocked out a working prototype in an hour on Saturday afternoon. I have since cleaned the code a bit and packaged it for you all to use.</p>\n\n\n\n<p><strong>Download the plugin:</strong>  You can <a href=\"https://wordpress.org/plugins/block-pattern-builder\">grab the plugin</a> from the WordPress plugin directory or install it directly from the new plugin screen in your admin. It is also <a href=\"https://github.com/justintadlock/block-pattern-builder\">available via GitHub</a>.</p>\n\n\n\n<h2>How Block Pattern Builder Works</h2>\n\n\n\n<p class=\"has-drop-cap\">Block Pattern Builder requires version 7.8 or later of the <a href=\"https://wordpress.org/plugins/gutenberg\">Gutenberg plugin</a> to work. Eventually, perhaps in WordPress 5.5, the block pattern system will be merged directly into WordPress. For now, the latest version of the Gutenberg plugin is necessary.</p>\n\n\n\n<p>After installing and activating the plugin, it adds a new admin menu item titled &ldquo;Block Patterns.&rdquo; From that point, creating patterns works just like creating a post or page. You simply add a new pattern by clicking the &ldquo;Add New&rdquo; link. You can rearrange blocks to your heart&rsquo;s desire. When you have a pattern that you like, publish it.</p>\n\n\n\n<img />Creating a custom block pattern.\n\n\n\n<p>Once a pattern is published, it is available via the pattern sidebar in the block editor. Currently, this is a button in the top right corner of the editor. However, its location and interface are likely to change as the Gutenberg team continues developing the feature.</p>\n\n\n\n<img />Inserting a block pattern into the post editor.\n\n\n\n<p>That is all there is to it. It is a simple system, but it will provide an easy way to play around with the patterns feature in Gutenberg.</p>\n\n\n\n<h2>Notes and Ideas</h2>\n\n\n\n<p class=\"has-drop-cap\">Because block patterns are an evolving feature in the Gutenberg plugin, the system could break until things are a bit more settled down. The underlying API could change. However, that does not mean we cannot have a little fun in the meantime. Just keep in mind this is currently flagged as an experimental feature in Gutenberg.</p>\n\n\n\n<p>If you are a plugin or theme author who wants to register your patterns within your own plugins or themes, you can make use of this plugin too. Build your custom patterns within the provided editor. Then, switch over to the code view for the block editor. You can copy the block code and register it via the <a href=\"https://developer.wordpress.org/block-editor/developers/block-api/block-patterns/\">Patterns API</a>.</p>\n\n\n\n<p>If you need inspiration for patterns, Gutenberg Hub&rsquo;s <a href=\"https://templates.gutenberghub.com/\">template library</a> has over 100 ideas to choose from. You can copy and paste those directly into the editor and save them as custom patterns with Block Pattern Builder.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Apr 2020 20:03:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: BuddyPress 6.0 Beta Introduces Group and Member Blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98219\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:173:\"https://wptavern.com/buddypress-6-0-beta-introduces-group-and-member-blocks?utm_source=rss&utm_medium=rss&utm_campaign=buddypress-6-0-beta-introduces-group-and-member-blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5461:\"<p class=\"has-drop-cap\">The team behind <a href=\"https://wordpress.org/plugins/buddypress/\">BuddyPress</a> dropped the first <a href=\"https://buddypress.org/2020/03/buddypress-6-0-0-beta1/\">version 6.0 beta release</a> of the plugin yesterday. One of the most important features is the introduction of the new member and group blocks for the WordPress editor. The plugin now requires at least PHP 5.6 and WordPress 4.8 (5.0 to use the new blocks).</p>\n\n\n\n<p>&ldquo;I think it&rsquo;s exciting times,&rdquo; said John James Jacoby, lead developer of BuddyPress, on the addition of the new blocks. &ldquo;Having things as blocks means end-users gain a bit more freedom with where and how they integrate BuddyPress into their existing sites. Right now, BuddyPress blocks are mostly presentational &mdash; quick ways to output stuff from the community anywhere blocks are allowed. In a few years, when blocks have matured and are the de-facto way to interact with everything, I can imagine there being a single BuddyPress block that wraps the entire functionality of the community into a single block like its own little web applet.&rdquo;</p>\n\n\n\n<p>BuddyPress 6.0 is scheduled for launch at the end of April. End-users can test the latest version of the plugin via the <a href=\"https://wordpress.org/plugins/bp-beta-tester/\">BP Beta Tester</a> or by directly downloading the <a href=\"https://downloads.wordpress.org/plugin/buddypress.6.0.0-beta1.zip\">beta ZIP file</a>.</p>\n\n\n\n<p>Aside from the new blocks, the <a href=\"https://developer.buddypress.org/bp-rest-api/\">BP REST API</a> is now complete, which provides developers with a more robust tool to build apps. The user profile photo and cover image fields have also been moved to the Members component of the plugin. This change allows end-users to use the features without activating the BP Extended Profile component.</p>\n\n\n\n<h2>Introducing the Member and Group Blocks</h2>\n\n\n\n<p class=\"has-drop-cap\">Version 6.0 of BuddyPress will include only two blocks. However, there are plans to add more over time. The development of blocks takes place in the <a href=\"https://github.com/buddypress/bp-blocks\">BP Blocks repository</a> on GitHub.</p>\n\n\n\n<p>BuddyPress 6.0 will create a new &ldquo;BuddyPress&rdquo; category in the block inserter. This houses the current blocks and will contain those created in the future.</p>\n\n\n\n<p>The member block is a simple member profile box that displays the member avatar, cover image, display name, and username. At the bottom of the block, it adds a button to view the member&rsquo;s profile. Each of the fields can be enabled or disabled via the block settings.</p>\n\n\n\n<img />BuddyPress member block.\n\n\n\n<p>The group block works similarly to the member block. The group avatar, cover image, name, and description are all shown by default. Visibility options are also available via the block settings.</p>\n\n\n\n<img />BuddyPress group block.\n\n\n\n<p>The only trivial gripe I have with the new blocks is how the block settings are handled. Each setting is placed within its own tabbed section. It does not make sense to open or close four tabs to get to a single setting for each. The team may add extra settings under each tab in the future, but it currently feels like unnecessary mouse clicks.</p>\n\n\n\n<p>Overall, the team has put together a nice update and the blocks worked without issue.</p>\n\n\n\n<h2>Future BuddyPress Blocks</h2>\n\n\n\n<p class=\"has-drop-cap\">Development of BuddyPress blocks <a href=\"https://buddypress.org/2019/11/the-road-to-buddypress-blocks/\">began in November 2019</a>. The team garnered 161 votes in a poll on which blocks to build. The initial work started based on that feedback.</p>\n\n\n\n<p>&ldquo;We think working on blocks to highlight a single Group or a single Member is a good starting point,&rdquo; wrote Mathieu Viet, BuddyPress developer. It made sense to implement simpler blocks for the team&rsquo;s first foray into block development. It will be a large undertaking that will take many months of development hours to build into the block system.</p>\n\n\n\n<p>The team has plans for the future but is looking forward to hearing feedback. &ldquo;We are very open to ideas into this area,&rdquo; said Viet. &ldquo;So the obvious next blocks are transforming our existing widgets into blocks. We are also working on a new <a href=\"https://github.com/buddypress/bp-attachments\">Media component</a>, which should include a block to select user-generated media from the block editor.&rdquo;</p>\n\n\n\n<p>Viet said he had at least one &ldquo;crazy idea&rdquo; in mind but hasn&rsquo;t discussed it much with the team yet. &ldquo;Bring a light version of the block editor into the front end to replace the textarea we are using to post activities,&rdquo; he said. &ldquo;Some BP block types like the User Media one would then be available to post richer activity content using a simple property like <em>supports activity</em>.&rdquo;</p>\n\n\n\n<p>Launching the block editor on the front end, even a light version, could be interesting. It may be the future for plugins like BuddyPress that rely on solid front-end posting solutions.</p>\n\n\n\n<p>For the near-term future, Viet said the team is looking for contributors to the <a href=\"https://github.com/buddypress/bp-blocks\">BP Blocks repository</a>. &ldquo;We&rsquo;ll be very happy to include their work into BP Core if we believe our community members would be interested in these blocks,&rdquo; he said.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 01 Apr 2020 19:28:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"HeroPress: How WordPress enabled me to take care of my baby without compromising on my career goals\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=3083\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:250:\"https://heropress.com/essays/how-wordpress-enabled-me-to-take-care-of-my-baby-without-compromising-on-my-career-goals/#utm_source=rss&utm_medium=rss&utm_campaign=how-wordpress-enabled-me-to-take-care-of-my-baby-without-compromising-on-my-career-goals\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6080:\"<img width=\"960\" height=\"480\" src=\"https://s20094.pcdn.co/wp-content/uploads/2021/03/032720-min.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: Remote jobs seem to be very promising & advantageous for women, especially for moms.\" /><p>Hello everyone! <img class=\"emoji\" src=\"https://s.w.org/images/core/emoji/12.0.0-1/svg/1f44b.svg\" alt=\"&#x1f44b;\" /></p>\n<p>Since my <a href=\"https://heropress.com/essays/joy-giving-back/\">first essay </a>on HeroPress, there have been many changes in my life. But there are two things that remained constant – <a href=\"http://wordpress.org/\">WordPress</a> and <a href=\"https://rtcamp.com/\">rtCamp</a>. <img class=\"emoji\" src=\"https://s.w.org/images/core/emoji/12.0.0-1/svg/1f607.svg\" alt=\"&#x1f607;\" /></p>\n<h2><strong>Working Remotely</strong></h2>\n<p>Three years back, I got married and had to relocate to Delhi, from Pune. Thanks to WordPress and rtCamp’s remote work culture, I didn’t have to worry about looking for a new career.</p>\n<p>It’s been more than 3 years since I have been working remotely with rtCamp. And having a work-life balance would not have been possible without WordPress.</p>\n<p><a href=\"https://s20094.pcdn.co/wp-content/uploads/2020/03/juhi-with-kashvi.jpeg\"><img /></a></p>\n<h2><strong>Taking care of my little one without compromising career goals?</strong></h2>\n<p>A lot of surveys indicate that a high percentage of women quit their job after having a baby. Even the ones who continue to work, face a guilt of leaving their babies at home or at a daycare. Thanks to WordPress and my company rtCamp, I didn’t have to face this trauma. <img class=\"emoji\" src=\"https://s.w.org/images/core/emoji/12.0.0-1/svg/1f603.svg\" alt=\"&#x1f603;\" /></p>\n<p>The remote work culture turned out to be a blessing when I got pregnant. I could take care of myself by staying in my comfort zone (home).</p>\n<p>One may perceive that a remote job means a freelance job, which is not true. I have a full-time regular job and all the employment terms apply to this. Because of the flexible parental policy, offered by rtCamp, I got maternity leaves of 6 months.</p>\n<p>This perk made <a href=\"https://sevencoloursblog.wordpress.com/2019/04/07/happiness-is-having-your-baby-24x7-by-your-side-even-when-you-are-working/\">my motherhood journey much more beautiful </a><img class=\"emoji\" src=\"https://s.w.org/images/core/emoji/12.0.0-1/svg/1f618.svg\" alt=\"&#x1f618;\" /><img class=\"emoji\" src=\"https://s.w.org/images/core/emoji/12.0.0-1/svg/1f618.svg\" alt=\"&#x1f618;\" />. I can feed my baby girl whenever she is hungry, I can play with her whenever I want, I can see her growing every second. What else can a mother desire?</p>\n<p>Remote jobs seem to be very promising and advantageous for women, especially for moms. Mothers no longer need to worry about leaving their little ones at home. I, as a mother, am very thankful to WordPress</p>\n<p>BTW, rtCamp is always hiring! Head over to the <a href=\"https://rtcamp.com/careers/\">careers page</a> to check out the current openings! <img class=\"emoji\" src=\"https://s.w.org/images/core/emoji/12.0.0-1/svg/1f917.svg\" alt=\"&#x1f917;\" /></p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: How WordPress enabled me to take care of my baby without compromising on my career goals\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=How%20WordPress%20enabled%20me%20to%20take%20care%20of%20my%20baby%20without%20compromising%20on%20my%20career%20goals&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fhow-wordpress-enabled-me-to-take-care-of-my-baby-without-compromising-on-my-career-goals%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: How WordPress enabled me to take care of my baby without compromising on my career goals\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fhow-wordpress-enabled-me-to-take-care-of-my-baby-without-compromising-on-my-career-goals%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fhow-wordpress-enabled-me-to-take-care-of-my-baby-without-compromising-on-my-career-goals%2F&title=How+WordPress+enabled+me+to+take+care+of+my+baby+without+compromising+on+my+career+goals\" rel=\"nofollow\" target=\"_blank\" title=\"Share: How WordPress enabled me to take care of my baby without compromising on my career goals\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/how-wordpress-enabled-me-to-take-care-of-my-baby-without-compromising-on-my-career-goals/&media=https://heropress.com/wp-content/uploads/2021/03/032720-min-150x150.jpg&description=How WordPress enabled me to take care of my baby without compromising on my career goals\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: How WordPress enabled me to take care of my baby without compromising on my career goals\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/how-wordpress-enabled-me-to-take-care-of-my-baby-without-compromising-on-my-career-goals/\" title=\"How WordPress enabled me to take care of my baby without compromising on my career goals\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/how-wordpress-enabled-me-to-take-care-of-my-baby-without-compromising-on-my-career-goals/\">How WordPress enabled me to take care of my baby without compromising on my career goals</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 01 Apr 2020 08:00:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Juhi Saxena\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"BuddyPress: BuddyPress 6.0.0-beta1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=310710\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://buddypress.org/2020/03/buddypress-6-0-0-beta1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3990:\"<p><a href=\"https://downloads.wordpress.org/plugin/buddypress.6.0.0-beta1.zip\">BuddyPress 6.0.0-beta1</a> is now available for testing!</p>\n\n\n\n<p>Please note the plugin is <strong>still in development</strong>, so we recommend running this beta release on a <strong>testing site</strong>.</p>\n\n\n\n<p>You can test BuddyPress 6.0.0-beta1 in 4 ways :</p>\n\n\n\n<ul><li>Try the <a href=\"https://wordpress.org/plugins/bp-beta-tester/\">BP Beta Tester</a> plugin.</li><li><a href=\"https://downloads.wordpress.org/plugin/buddypress.6.0.0-beta1.zip\">Download the beta here (zip file)</a>.</li><li>Check out our SVN repository: <code>svn co https://buddypress.svn.wordpress.org/trunk/</code></li><li>Clone our read-only Git repository: <code>git clone git://buddypress.git.wordpress.org/</code></li></ul>\n\n\n\n<p>We&#8217;ve scheduled the 6.0.0 stable release to the end of April, and we&#8217;d love you to give us a hand to get there!</p>\n\n\n\n<p>Testing for bugs is an important part of polishing the release during the beta stage and a great way to contribute. Here are some of the big changes and features to pay close attention to while testing (Check out&nbsp;<a href=\"https://buddypress.trac.wordpress.org/query?status=closed&group=resolution&milestone=6.0.0\">this report</a>&nbsp;on Trac for the full list).</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2>User Profile Photo &amp; User Cover Image are now belonging to the BP Members component.</h2>\n\n\n\n<p>Since the very first version of BuddyPress, the local avatar management feature (renamed as <em>Profile Photo</em> in version 2.1) was depending on the BP Extended Profile component. When we introduced the Cover Image feature in version 2.4, we&#8217;ve also made it dependent of the BP Extended Profile component. <strong>In 6.0.0, both features has been moved to the BP Members component</strong>. It means they will always be available even if the BP Extended Profile component is not active on your setup. We recommend you to <a href=\"https://bpdevel.wordpress.com/2020/03/01/the-profile-photo-cover-image-features-belong-to-members/\">read this development note</a> to learn what this move changes for end users and for BuddyPress plugin/theme developers.</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2>The BP REST API is now completed!</h2>\n\n\n\n<p>In 5.0.0, we&#8217;ve introduced the first endpoints and a <a href=\"https://developer.buddypress.org/bp-rest-api/\">reference documentation about them</a>. In 6.0.0, we are adding the remaining ones so that you can build great BuddyPress full featured apps!</p>\n\n\n\n<p>PS:  we will update the reference documentation with these new endpoints during this beta stage.</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2>The first BuddyPress Blocks are arriving <img src=\"https://s.w.org/images/core/emoji/12.0.0-1/72x72/1f642.png\" alt=\"?\" class=\"wp-smiley\" /></h2>\n\n\n\n<p>In 6.0.0, you will be able to feature a specific member or a specific group of your community site into your posts or pages: discover more information about the BP Member Block and the BP Group Block reading <a href=\"https://bpdevel.wordpress.com/2020/03/30/welcome-to-the-first-buddypress-blocks/\">this development note</a>. </p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2>New PHP and WordPress required versions.</h2>\n\n\n\n<p>BuddyPress 6.0.0 is requiring <strong>PHP &gt;= 5.6</strong> and <strong>WordPress &gt;= 4.8</strong></p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2>How You Can Help</h2>\n\n\n\n<p>Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp-plugins/buddypress/dev/\">Help us translate BuddyPress into more than 100 languages</a>!</p>\n\n\n\n<p>If you think you’ve found a bug, you can post in&nbsp;<a href=\"https://buddypress.org/support\">the support forums</a>. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://buddypress.trac.wordpress.org/newticket\">file one on BuddyPress Trac</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 31 Mar 2020 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mathieu Viet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"WPTavern: WordPress 5.4 “Adderley” Includes Improved Editor, New Blocks, and Developer APIs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98192\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:237:\"https://wptavern.com/wordpress-5-4-adderley-released-includes-improved-editor-new-blocks-and-developer-apis?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-5-4-adderley-released-includes-improved-editor-new-blocks-and-developer-apis\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7819:\"<p class=\"has-drop-cap\">WordPress 5.4 &ldquo;Adderley&rdquo;, named in honor American jazz musician Nat Adderley, <a href=\"https://wordpress.org/news/2020/03/adderley/\">was released today</a> and is now available for download. The update includes new social icons and buttons blocks, usability improvements to the block editor, and new APIs for developers to use in plugins and themes.</p>\n\n\n\n<p>This release saw contributions from 168 new volunteers.  There were 552 contributors in total.</p>\n\n\n\n<p>The release was led by <a href=\"https://ma.tt/\">Matt Mullenweg</a>, <a href=\"https://profiles.wordpress.org/francina/\">Francesca Marano</a>, and <a href=\"https://profiles.wordpress.org/davidbaumwald\">David Baumwald</a>. They were joined by the following contributors in supporting roles in getting version 5.4 released:</p>\n\n\n\n<ul><li>Editor Tech &ndash; <a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Filipe Costa</a></li><li>Editor Design &ndash; <a href=\"https://profiles.wordpress.org/mapk/\">Mark Uraine</a></li><li>Core Tech &ndash; <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a></li><li>Design &ndash; <a href=\"https://profiles.wordpress.org/karmatosed/\">Tammie Lister</a></li><li>Docs Coordinator &ndash; <a href=\"https://profiles.wordpress.org/audrasjb/\">JB Audras</a></li><li>Docs and Comms Wrangler &ndash; <a href=\"https://profiles.wordpress.org/marybaum/\">Mary Baum</a></li></ul>\n\n\n\n<p>Users can update directly from their WordPress admin or grab a copy from the <a href=\"https://wordpress.org/download/\">download page</a>.  For more information on updating, view the <a href=\"https://wordpress.org/support/wordpress-version/version-5-4/\">WordPress 5.4 support guide</a>.</p>\n\n\n\n<h2>New Block Editor Features</h2>\n\n\n\n<img />Cover block with new gradient background and social icons block.\n\n\n\n<p class=\"has-drop-cap\">Users who have not been running the Gutenberg plugin, the project behind editor development, will enjoy an improved editor experience. A slew of features were developed in the past several months. This release will include features from Gutenberg 6.6 through 7.5. Bug fixes from more recent versions of the plugin are also included.</p>\n\n\n\n<p>The development team refined the user experience with updates such as making it easier to select multiple blocks and pinning the toolbar to the top of the screen on mobile devices. They introduced a Welcome Guide modal to familiarize end-users with the block editor. Block breadcrumbs are easier to navigate.</p>\n\n\n\n<p>The biggest user-facing change is that the <a href=\"https://wptavern.com/editor-will-default-to-fullscreen-mode-in-wordpress-5-4\">block editor now defaults to fullscreen mode</a>. Users who do not prefer fullscreen mode can revert this change by clicking the tools and options button (vertical ellipsis icon) and uncheck the &ldquo;Fullscreen mode&rdquo; option.</p>\n\n\n\n<p>WordPress has added a gradient background feature to the button and cover blocks. Users can change the color of individual bits of text within all rich text fields (e.g., paragraphs, lists). Plus, the featured image box supports dragging and dropping an image.</p>\n\n\n\n<p>The block editor has two new blocks: social icons and buttons. The social icons block allows users to add a group of linked icons to their social networks. This feature will become more useful once WordPress moves to full-site editing in the future. For now, usage may be limited by being able to place them only in post or page content. The buttons block lets end-users create a group of buttons. The existing button block is allowed only within the buttons block now.</p>\n\n\n\n<p>With a few exceptions, WP Tavern has covered every major release of the Gutenberg plugin that will be included in this WordPress update. You can catch up all the details of each update via the following links:</p>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2019/10/02/whats-new-in-gutenberg-2-october/\">Gutenberg 6.6 on Make Core Blog</a></li><li><a href=\"https://wptavern.com/gutenberg-6-7-introduces-storybook-and-gradient-backgrounds\">Gutenberg 6.7 Introduces Storybook and Gradient Backgrounds</a></li><li><a href=\"https://make.wordpress.org/core/2019/10/30/whats-new-in-gutenberg-30-october/\">Gutenberg 6.8 on Make Core Blog</a></li><li><a href=\"https://wptavern.com/gutenberg-6-9-introduces-image-titles-block-patterns-and-new-theme-features\">Gutenberg 6.9 Introduces Image Titles, Block Patterns, and New Theme Features</a></li><li><a href=\"https://wptavern.com/gutenberg-7-0-launches-stable-navigation-block-post-blocks-and-template-parts\">Gutenberg 7.0 Launches Stable Navigation Block, Post Blocks, and Template Parts</a></li><li><a href=\"https://wptavern.com/gutenberg-7-1-includes-welcome-modal-improves-multi-block-selection-and-adds-drag-and-drop-featured-images\">Gutenberg 7.1 Includes Welcome Modal, Improves Multi-Block Selection, and Adds Drag-and-Drop Featured Images</a></li><li><a href=\"https://wptavern.com/gutenberg-7-2-adds-long-awaited-multi-button-block-and-gallery-image-size-option\">Gutenberg 7.2 Adds Long-Awaited Multi-Button Block and Gallery Image Size Option</a></li><li><a href=\"https://wptavern.com/gutenberg-7-3-brings-navigation-block-colors-block-collections-api-and-dynamic-post-blocks\">Gutenberg 7.3 Brings Navigation Block Colors, Block Collections API, and Dynamic Post Blocks</a></li><li><a href=\"https://wptavern.com/gutenberg-7-4-adds-new-color-controls-link-ui-and-block-scaffolding-for-developers\">Gutenberg 7.4 Adds New Color Controls, Link UI, and Block Scaffolding for Developers</a></li><li><a href=\"https://make.wordpress.org/core/2020/02/12/whats-new-in-gutenberg-12-february/\">Gutenberg 7.5 on Make Core Blog</a></li></ul>\n\n\n\n<h2>Changes for Developers</h2>\n\n\n\n<p class=\"has-drop-cap\">WordPress 5.4 introduces several changes, some of which break backward compatibility, for plugin and theme authors. For a full overview, see our coverage of the most important code changes in our <a href=\"https://wptavern.com/preparing-for-wordpress-5-4-changes-theme-and-plugin-developers-should-know-about\">version 5.4 developer preparation post</a>.</p>\n\n\n\n<p>Theme authors now have access to the <a href=\"https://make.wordpress.org/core/2020/03/02/new-gradient-theme-apis/\">Gradients API</a> for the cover and button blocks. They should also make sure their theme block styles handle the new social icons and buttons blocks.</p>\n\n\n\n<p>There are some breaking changes that theme authors may need to account for. Several CSS classes have been <a href=\"https://make.wordpress.org/core/2020/03/02/markup-and-style-related-changes/\">renamed within the block editor</a>. The core team also rewrote the <a href=\"https://make.wordpress.org/core/2020/02/12/changes-related-to-calendar-widget-markup-in-wordpress-5-4/\">HTML markup for the calendar widget</a> and updated its classes.</p>\n\n\n\n<p>Block developers can now use the <a href=\"https://make.wordpress.org/core/2020/02/27/block-collections/\">Collections API</a> to group collections of blocks by namespace. The <a href=\"https://make.wordpress.org/core/2020/02/27/introduce-block-variations-api/\">Variations API</a> allows developers to create variations of an individual block. The new social icons block makes good use of this API to create variations for each of the social icons.</p>\n\n\n\n<p>Plugin and theme authors have new hooks for <a href=\"https://make.wordpress.org/core/2020/02/25/wordpress-5-4-introduces-new-hooks-to-add-custom-fields-to-menu-items/\">adding custom fields to nav menus</a>. WordPress 5.4 also <a href=\"https://make.wordpress.org/core/2020/02/13/wordpress-5-4-introduces-apply-shortcodes-as-an-alias-for-do-shortcode/\">introduces the <code>apply_shortcodes()</code> alias</a> for the former <code>do_shortcode()</code> function.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 31 Mar 2020 21:24:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress.org blog: WordPress 5.4 “Adderley”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8455\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"https://wordpress.org/news/2020/03/adderley/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47920:\"<p class=\"has-text-color has-very-dark-gray-color\">Here it is! Named “Adderley” in honor of Nat Adderley, the latest and greatest version of WordPress is available for&nbsp;<a href=\"https://wordpress.org/download/\">download</a>&nbsp;or update in your dashboard.</p>\n\n\n\n<img src=\"https://i0.wp.com/wordpress.org/news/files/2020/03/5-4_album-cover.png?resize=632%2C632&ssl=1\" alt=\"\" class=\"wp-image-8484\" />\n\n\n\n<div class=\"wp-block-cover has-background-dim\"><div class=\"wp-block-cover__inner-container\">\n<p class=\"has-text-align-center\"><strong>Say hello to more and better.</strong></p>\n\n\n\n<p class=\"has-text-align-center has-medium-font-size\">More ways to make your pages come alive. With easier ways to get it all done and looking better than ever—and boosts in speed you can feel.</p>\n</div></div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2 class=\"has-text-align-left\"><strong>Welcome to WordPress 5.4</strong></h2>\n\n\n\n<p class=\"has-text-align-left\"><strong>Every major release adds more to the block editor.</strong></p>\n\n\n\n<p>More ways to make posts and pages come alive with your best images. More ways to bring your visitors in, and keep them engaged, with the richness of embedded media from the web’s top services.</p>\n\n\n\n<p>More ways to make your vision real, and put blocks in the perfect place—even if a particular kind of block is new to you. More efficient processes.</p>\n\n\n\n<p>And more speed everywhere, so as you build sections or galleries, or just type in a line of prose, you can feel how much faster your work flows.</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-image\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Squares.jpg?resize=632%2C316&ssl=1\" alt=\"\" class=\"wp-image-8480\" /></div>\n\n\n\n<h3>Two new blocks. And better blocks overall.</h3>\n\n\n\n<ul><li>Two brand-new blocks: Social Icons and Buttons make adding interactive features fast and easy.</li><li>New ways with color: Gradients in the Buttons and Cover block, toolbar access to color options in Rich Text blocks, and for the first time, color options in the Group and Columns blocks.</li><li>Guess a whole lot less! Version 5.4 streamlines the whole process for placing and replacing multimedia in every block. Now it works the same way in almost every block!</li><li>And if you’ve ever thought your image in the Media+Text block should link to something else—perhaps a picture of a brochure should download that brochure as a document? Well, now it can.</li></ul>\n\n\n\n\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h3>Cleaner UI, clearer navigation—and easier tabbing!</h3>\n\n\n\n<ul><li>Clearer block navigation with block breadcrumbs. And easier selection once you get there.</li><li>For when you need to navigate with the keyboard, better tabbing and focus. Plus, you can tab over to the sidebar of nearly any block.</li><li>Speed! 14% faster loading of the editor, 51% faster time-to-type!</li><li>Tips are gone. In their place, a Welcome Guide window you can bring up when you need it—and only when you need it—again and again.</li><li>Know at a glance whether you’re in a block’s Edit or Navigation mode. Or, if you have restricted vision, your screen reader will tell you which mode you’re in.</li></ul>\n\n\n\n<p class=\"has-background\">Of course, if you want to work with the very latest tools and features, <strong><a href=\"https://wordpress.org/plugins/gutenberg/\">install the Gutenberg plugin</a></strong>. You’ll get to be the first to use new and exciting features in the block editor before anyone else has seen them!</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-image\"><img src=\"https://i0.wp.com/wordpress.org/news/files/2020/03/Rectangles-and-circles.jpg?resize=632%2C316&ssl=1\" alt=\"\" class=\"wp-image-8481\" /></div>\n\n\n\n<h3>Your fundamental right: privacy</h3>\n\n\n\n<p>5.4 helps with a variety of privacy issues around the world. So when users and stakeholders ask about regulatory compliance, or how your team handles user data, the answers should be a lot easier to get right.</p>\n\n\n\n<p>Take a look:</p>\n\n\n\n<ul><li>Now personal data exports include users session information and users location data from the community events widget. Plus, a table of contents!</li><li>See progress as you process export and erasure requests through the privacy tools.</li><li>Plus, little enhancements throughout give the privacy tools a little cleaner look. Your eyes will thank you!</li></ul>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Mixed.jpg?resize=632%2C316&ssl=1\" alt=\"\" class=\"wp-image-8482\" />\n\n\n\n<h2><strong>Just for developers</strong></h2>\n\n\n\n<h3>Add custom fields to menu items—natively</h3>\n\n\n\n<p>Two new actions let you add custom fields to menu items—without a plugin and without writing custom walkers.</p>\n\n\n\n<p>On the Menus admin screen, <code>wp_nav_menu_item_custom_fields</code> fires just before the move buttons of a nav menu item in the menu editor.</p>\n\n\n\n<p>In the Customizer, <code>wp_nav_menu_item_custom_fields_customize_template</code> fires at the end of the menu-items form-fields template.</p>\n\n\n\n<p>Check your code and see where these new actions can replace your custom code, and if you’re concerned about duplication, add a check for the WordPress version.</p>\n\n\n\n<h3>Blocks! Simpler styling, new APIs and embeds</h3>\n\n\n\n<ul><li>Radically simpler block styling. Negative margins and default padding are gone! Now you can style blocks the way you need them. And, a refactor got rid of four redundant wrapper divs.</li><li>If you build plugins, now you can register collections of your blocks by namespace across categories—a great way to get more brand visibility.</li><li>Let users do more with two new APIs: block variations and gradients.</li><li>In embeds, now the block editor supports TikTok—and CollegeHumor is gone.</li></ul>\n\n\n\n<p class=\"has-background\">There’s lots more for developers to love in WordPress 5.4. To discover more and learn how to make these changes shine on your sites, themes, plugins and more, check the <strong><a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a></strong>.</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2><strong>The Squad</strong></h2>\n\n\n\n<p>This release was led by&nbsp;<a href=\"http://ma.tt/\">Matt Mullenweg</a>,&nbsp;<a href=\"https://profiles.wordpress.org/francina\">Francesca Marano</a>, and&nbsp;<a href=\"https://dream-encode.com/blog/\">David Baumwald</a>. They were enthusiastically supported by a release squad:</p>\n\n\n\n<ul><li><strong>Editor Tech</strong>: Jorge Filipe Costa (<strong><a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">@jorgefelipecosta</a></strong>)</li><li><strong>Editor Design</strong>: Mark Uraine (<a rel=\"noreferrer noopener\" target=\"_blank\" href=\"https://profiles.wordpress.org/mapk/\"><strong>@mapk</strong></a>)</li><li><strong>Core Tech</strong>: Sergey Biryukov (<a href=\"https://profiles.wordpress.org/sergeybiryukov/\"><strong>@sergeybiryukov</strong></a>)</li><li><strong>Design</strong>: Tammie Lister (<strong><a href=\"https://profiles.wordpress.org/karmatosed/\">@karmatosed</a></strong>)</li><li><strong>Docs Coordinator</strong>:&nbsp;JB Audras (<a href=\"https://profiles.wordpress.org/audrasjb/\"><strong>@audrasjb</strong></a>)</li><li><strong>Docs &amp; Comms Wrangler</strong>: Mary Baum (<strong><a href=\"https://profiles.wordpress.org/marybaum/\">@marybaum</a></strong>)</li></ul>\n\n\n\n<p>The squad was joined throughout the release cycle by <strong>552 generous volunteer contributors</strong> who collectively worked on <strong><a href=\"https://core.trac.wordpress.org/milestone/5.4\">361</a> tickets on Trac</strong> and <strong>1226 pull requests on GitHub</strong>.</p>\n\n\n\n<p>Put on a Nat Adderley playlist, click that update button (or&nbsp;<a href=\"https://wordpress.org/download/\">download it directly</a>), and check the profiles of the fine folks that helped:</p>\n\n\n<a href=\"https://profiles.wordpress.org/0v3rth3d4wn/\">0v3rth3d4wn</a>, <a href=\"https://profiles.wordpress.org/123host/\">123host</a>, <a href=\"https://profiles.wordpress.org/1naveengiri/\">1naveengiri</a>, <a href=\"https://profiles.wordpress.org/jorbin/\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/abhijitrakas/\">Abhijit Rakas</a>, <a href=\"https://profiles.wordpress.org/abrightclearweb/\">abrightclearweb</a>, <a href=\"https://profiles.wordpress.org/acosmin/\">acosmin</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein/\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/adamboro/\">adamboro</a>, <a href=\"https://profiles.wordpress.org/addiestavlo/\">Addie</a>, <a href=\"https://profiles.wordpress.org/adnanlimdi/\">adnan.limdi</a>, <a href=\"https://profiles.wordpress.org/shaikhaezaz80/\">Aezaz Shaikh</a>, <a href=\"https://profiles.wordpress.org/aftabmuni/\">Aftab Ali Muni</a>, <a href=\"https://profiles.wordpress.org/akibjorklund/\">Aki Bj&#246;rklund</a>, <a href=\"https://profiles.wordpress.org/smallprogrammers/\">Akib</a>, <a href=\"https://profiles.wordpress.org/atachibana/\">Akira Tachibana</a>, <a href=\"https://profiles.wordpress.org/akshayar/\">akshayar</a>, <a href=\"https://profiles.wordpress.org/schlessera/\">Alain Schlesser</a>, <a href=\"https://profiles.wordpress.org/aljullu/\">Albert Juh&#233; Lluveras</a>, <a href=\"https://profiles.wordpress.org/xknown/\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/viper007bond/\">Alex Mills</a>, <a href=\"https://profiles.wordpress.org/alexholsgrove/\">AlexHolsgrove</a>, <a href=\"https://profiles.wordpress.org/alexischenal/\">alexischenal</a>, <a href=\"https://profiles.wordpress.org/alextran/\">alextran</a>, <a href=\"https://profiles.wordpress.org/alishankhan/\">alishankhan</a>, <a href=\"https://profiles.wordpress.org/allancole/\">allancole</a>, <a href=\"https://profiles.wordpress.org/allendav/\">Allen Snook</a>, <a href=\"https://profiles.wordpress.org/alpipego/\">alpipego</a>, <a href=\"https://profiles.wordpress.org/amirs17/\">Amir Seljubac</a>, <a href=\"https://profiles.wordpress.org/wpamitkumar/\">Amit Dudhat</a>, <a href=\"https://profiles.wordpress.org/amolv/\">Amol Vhankalas</a>, <a href=\"https://profiles.wordpress.org/agawish/\">Amr Gawish</a>, <a href=\"https://profiles.wordpress.org/amykamala/\">Amy Kamala</a>, <a href=\"https://profiles.wordpress.org/anantajitjg/\">Anantajit JG</a>, <a href=\"https://profiles.wordpress.org/anlino/\">Anders Nor&#233;n</a>, <a href=\"https://profiles.wordpress.org/nosolosw/\">Andr&#233;s</a>, <a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/dontdream/\">Andrea Tarantini</a>, <a href=\"https://profiles.wordpress.org/andreaitm/\">andreaitm</a>, <a href=\"https://profiles.wordpress.org/andraganescu/\">Andrei Draganescu</a>, <a href=\"https://profiles.wordpress.org/aandrewdixon/\">Andrew Dixon</a>, <a href=\"https://profiles.wordpress.org/aduth/\">Andrew Duthie</a>, <a href=\"https://profiles.wordpress.org/nacin/\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/andrewserong/\">Andrew Serong</a>, <a href=\"https://profiles.wordpress.org/eatingrules/\">Andrew Wilder</a>, <a href=\"https://profiles.wordpress.org/rarst/\">Andrey Savchenko</a>, <a href=\"https://profiles.wordpress.org/afragen/\">Andy Fragen</a>, <a href=\"https://profiles.wordpress.org/andizer/\">Andy Meerwaldt</a>, <a href=\"https://profiles.wordpress.org/apeatling/\">Andy Peatling</a>, <a href=\"https://profiles.wordpress.org/la-geek/\">Angelika Reisiger</a>, <a href=\"https://profiles.wordpress.org/ankitmaru/\">Ankit Panchal</a>, <a href=\"https://profiles.wordpress.org/antpb/\">Anthony Burchell</a>, <a href=\"https://profiles.wordpress.org/paranoia1906/\">Anthony Ledesma</a>, <a href=\"https://profiles.wordpress.org/apedog/\">apedog</a>, <a href=\"https://profiles.wordpress.org/apermo/\">Apermo</a>, <a href=\"https://profiles.wordpress.org/apieschel/\">apieschel</a>, <a href=\"https://profiles.wordpress.org/aravindajith/\">Aravind Ajith</a>, <a href=\"https://profiles.wordpress.org/archon810/\">archon810</a>, <a href=\"https://profiles.wordpress.org/arenddeboer/\">arenddeboer</a>, <a href=\"https://profiles.wordpress.org/aristath/\">Ari Stathopoulos</a>, <a href=\"https://profiles.wordpress.org/passoniate/\">Arslan Ahmed</a>, <a href=\"https://profiles.wordpress.org/ashokrd2013/\">ashokrd2013</a>, <a href=\"https://profiles.wordpress.org/ataurr/\">Ataur R</a>, <a href=\"https://profiles.wordpress.org/ate-up-with-motor/\">Ate Up With Motor</a>, <a href=\"https://profiles.wordpress.org/autotutorial/\">autotutorial</a>, <a href=\"https://profiles.wordpress.org/ayeshrajans/\">Ayesh Karunaratne</a>, <a href=\"https://profiles.wordpress.org/backups/\">BackuPs</a>, <a href=\"https://profiles.wordpress.org/bahia0019/\">bahia0019</a>, <a href=\"https://profiles.wordpress.org/b-07/\">Bappi</a>, <a href=\"https://profiles.wordpress.org/bartczyz/\">Bart Czyz</a>, <a href=\"https://profiles.wordpress.org/bengreeley/\">ben.greeley</a>, <a href=\"https://profiles.wordpress.org/benedictsinger/\">benedictsinger</a>, <a href=\"https://profiles.wordpress.org/bfintal/\">Benjamin Intal</a>, <a href=\"https://profiles.wordpress.org/bibliofille/\">bibliofille</a>, <a href=\"https://profiles.wordpress.org/bilgilabs/\">bilgilabs</a>, <a href=\"https://profiles.wordpress.org/birgire/\">Birgir Erlendsson</a>, <a href=\"https://profiles.wordpress.org/bph/\">Birgit Pauli-Haack</a>, <a href=\"https://profiles.wordpress.org/skypressatx/\">BMO</a>, <a href=\"https://profiles.wordpress.org/boga86/\">Boga86</a>, <a href=\"https://profiles.wordpress.org/boonebgorges/\">Boone Gorges</a>, <a href=\"https://profiles.wordpress.org/bwmarkle/\">Brad Markle</a>, <a href=\"https://profiles.wordpress.org/kraftbj/\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/brentswisher/\">Brent Swisher</a>, <a href=\"https://profiles.wordpress.org/cvoell/\">Cameron Voell</a>, <a href=\"https://profiles.wordpress.org/poena/\">Carolina Nymark</a>, <a href=\"https://profiles.wordpress.org/ceyhun0/\">ceyhun0</a>, <a href=\"https://profiles.wordpress.org/chetan200891/\">Chetan Prajapati</a>, <a href=\"https://profiles.wordpress.org/ketuchetan/\">Chetan Satasiya</a>, <a href=\"https://profiles.wordpress.org/chinteshprajapati/\">Chintesh Prajapati</a>, <a href=\"https://profiles.wordpress.org/chipsnyder/\">Chip Snyder</a>, <a href=\"https://profiles.wordpress.org/cklosows/\">Chris Klosowski</a>, <a href=\"https://profiles.wordpress.org/eclare/\">Chris Trynkiewicz (Sukces Strony)</a>, <a href=\"https://profiles.wordpress.org/chrisvanpatten/\">Chris Van Patten</a>, <a href=\"https://profiles.wordpress.org/pixelverbieger/\">Christian Sabo</a>, <a href=\"https://profiles.wordpress.org/christianamohr/\">Christiana Mohr</a>, <a href=\"https://profiles.wordpress.org/clayisland/\">clayisland</a>, <a href=\"https://profiles.wordpress.org/copons/\">Copons</a>, <a href=\"https://profiles.wordpress.org/coreymckrill/\">Corey McKrill</a>, <a href=\"https://profiles.wordpress.org/crdunst/\">crdunst</a>, <a href=\"https://profiles.wordpress.org/littlebigthing/\">Csaba (LittleBigThings)</a>, <a href=\"https://profiles.wordpress.org/xendo/\">Dademaru</a>, <a href=\"https://profiles.wordpress.org/retrofox/\">Damián Suárez</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber/\">Daniel Bachhuber</a>, <a href=\"https://profiles.wordpress.org/danieltj/\">Daniel James</a>, <a href=\"https://profiles.wordpress.org/diddledan/\">Daniel Llewellyn</a>, <a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>, <a href=\"https://profiles.wordpress.org/mte90/\">Daniele Scasciafratte</a>, <a href=\"https://profiles.wordpress.org/daniloercoli/\">daniloercoli</a>, <a href=\"https://profiles.wordpress.org/nerrad/\">Darren Ethier (nerrad)</a>, <a href=\"https://profiles.wordpress.org/darrenlambert/\">darrenlambert</a>, <a href=\"https://profiles.wordpress.org/davidshq/\">Dave Mackey</a>, <a href=\"https://profiles.wordpress.org/get_dave/\">Dave Smith</a>, <a href=\"https://profiles.wordpress.org/daveslaughter/\">daveslaughter</a>, <a href=\"https://profiles.wordpress.org/davewp196/\">DaveWP196</a>, <a href=\"https://profiles.wordpress.org/dartiss/\">David Artiss</a>, <a href=\"https://profiles.wordpress.org/davidbinda/\">David Binovec</a>, <a href=\"https://profiles.wordpress.org/dlh/\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dryanpress/\">David Ryan</a>, <a href=\"https://profiles.wordpress.org/dshanske/\">David Shanske</a>, <a href=\"https://profiles.wordpress.org/superdav42/\">David Stone</a>, <a href=\"https://profiles.wordpress.org/dkarfa/\">Debabrata Karfa</a>, <a href=\"https://profiles.wordpress.org/dekervit/\">dekervit</a>, <a href=\"https://profiles.wordpress.org/delowardev/\">Delowar Hossain</a>, <a href=\"https://profiles.wordpress.org/denisco/\">Denis Yanchevskiy</a>, <a href=\"https://profiles.wordpress.org/dhavalkasvala/\">Dhaval kasavala</a>, <a href=\"https://profiles.wordpress.org/dhurlburtusa/\">dhurlburtusa</a>, <a href=\"https://profiles.wordpress.org/dilipbheda/\">Dilip Bheda</a>, <a href=\"https://profiles.wordpress.org/dingo_d/\">dingo-d</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/dipeshkakadiya/\">dipeshkakadiya</a>, <a href=\"https://profiles.wordpress.org/djp424/\">djp424</a>, <a href=\"https://profiles.wordpress.org/dominic_ks/\">dominic_ks</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/dotancohen/\">Dotan Cohen</a>, <a href=\"https://profiles.wordpress.org/dphiffer/\">dphiffer</a>, <a href=\"https://profiles.wordpress.org/dragosh635/\">dragosh635</a>, <a href=\"https://profiles.wordpress.org/drewapicture/\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/eclev91/\">eclev91</a>, <a href=\"https://profiles.wordpress.org/seedsca/\">ecotechie</a>, <a href=\"https://profiles.wordpress.org/eden159/\">eden159</a>, <a href=\"https://profiles.wordpress.org/ediamin/\">Edi Amin</a>, <a href=\"https://profiles.wordpress.org/disillusia/\">edmundcwm</a>, <a href=\"https://profiles.wordpress.org/etoledom/\">Eduardo Toledo</a>, <a href=\"https://profiles.wordpress.org/ellatrix/\">Ella van Durpe</a>, <a href=\"https://profiles.wordpress.org/elmastudio/\">Ellen Bauer</a>, <a href=\"https://profiles.wordpress.org/aliveic/\">Emil E</a>, <a href=\"https://profiles.wordpress.org/epiqueras/\">Enrique Piqueras</a>, <a href=\"https://profiles.wordpress.org/nrqsnchz/\">Enrique Sánchez</a>, <a href=\"https://profiles.wordpress.org/equin0x80/\">equin0x80</a>, <a href=\"https://profiles.wordpress.org/erikkroes/\">erikkroes</a>, <a href=\"https://profiles.wordpress.org/estelaris/\">Estela Rueda</a>, <a href=\"https://profiles.wordpress.org/fabifott/\">Fabian</a>, <a href=\"https://profiles.wordpress.org/fabiankaegy/\">Fabian K&#228;gy</a>, <a href=\"https://profiles.wordpress.org/fahimmurshed/\">Fahim Murshed</a>, <a href=\"https://profiles.wordpress.org/faisal03/\">Faisal Alvi</a>, <a href=\"https://profiles.wordpress.org/felipeelia/\">Felipe Elia</a>, <a href=\"https://profiles.wordpress.org/felipeloureirosantos/\">Felipe Santos</a>, <a href=\"https://profiles.wordpress.org/flixos90/\">Felix Arntz</a>, <a href=\"https://profiles.wordpress.org/fernandovbsouza/\">Fernando Souza</a>, <a href=\"https://profiles.wordpress.org/fervillz/\">fervillz</a>, <a href=\"https://profiles.wordpress.org/fgiannar/\">fgiannar</a>, <a href=\"https://profiles.wordpress.org/flaviozavan/\">flaviozavan</a>, <a href=\"https://profiles.wordpress.org/mista-flo/\">Florian TIAR</a>, <a href=\"https://profiles.wordpress.org/fotisps/\">Fotis Pastrakis</a>, <a href=\"https://profiles.wordpress.org/efarem/\">Frank Martin</a>, <a href=\"https://profiles.wordpress.org/galbaras/\">Gal Baras</a>, <a href=\"https://profiles.wordpress.org/garrett-eclipse/\">Garrett Hyder</a>, <a href=\"https://profiles.wordpress.org/garyj/\">Gary Jones</a>, <a href=\"https://profiles.wordpress.org/pento/\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/guddu1315/\">Gaurang Dabhi</a>, <a href=\"https://profiles.wordpress.org/georgestephanis/\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/geriux/\">geriux</a>, <a href=\"https://profiles.wordpress.org/girishpanchal/\">Girish Panchal</a>, <a href=\"https://profiles.wordpress.org/glebkema/\">Gleb Kemarsky</a>, <a href=\"https://profiles.wordpress.org/hometowntrailers/\">Glenn</a>, <a href=\"https://profiles.wordpress.org/gh640/\">Goto Hayato</a>, <a href=\"https://profiles.wordpress.org/grafruessel/\">grafruessel</a>, <a href=\"https://profiles.wordpress.org/gregrickaby/\">Greg Rickaby</a>, <a href=\"https://profiles.wordpress.org/gziolo/\">Grzegorz Ziółkowski</a>, <a href=\"https://profiles.wordpress.org/grzegorzjanoszka/\">Grzegorz.Janoszka</a>, <a href=\"https://profiles.wordpress.org/bordoni/\">Gustavo Bordoni</a>, <a href=\"https://profiles.wordpress.org/gwwar/\">gwwar</a>, <a href=\"https://profiles.wordpress.org/hamedmoodi/\">hamedmoodi</a>, <a href=\"https://profiles.wordpress.org/hampzter/\">hAmpzter</a>, <a href=\"https://profiles.wordpress.org/happiryu/\">happiryu</a>, <a href=\"https://profiles.wordpress.org/hareesh-pillai/\">Hareesh Pillai</a>, <a href=\"https://profiles.wordpress.org/harry-milatz/\">Harry Milatz</a>, <a href=\"https://profiles.wordpress.org/hazdiego/\">Haz</a>, <a href=\"https://profiles.wordpress.org/helgatheviking/\">helgatheviking</a>, <a href=\"https://profiles.wordpress.org/henryholtgeerts/\">Henry Holtgeerts</a>, <a href=\"https://profiles.wordpress.org/imani3011/\">Himani Lotia</a>, <a href=\"https://profiles.wordpress.org/krynes/\">Hubert Kubiak</a>, <a href=\"https://profiles.wordpress.org/i3anaan/\">i3anaan</a>, <a href=\"https://profiles.wordpress.org/ianbelanger/\">Ian Belanger</a>, <a href=\"https://profiles.wordpress.org/iandunn/\">Ian Dunn</a>, <a href=\"https://profiles.wordpress.org/ianatkins/\">ianatkins</a>, <a href=\"https://profiles.wordpress.org/ianmjones/\">ianmjones</a>, <a href=\"https://profiles.wordpress.org/ideaboxcreations/\">IdeaBox Creations</a>, <a href=\"https://profiles.wordpress.org/shaampk1/\">Ihtisham Zahoor</a>, <a href=\"https://profiles.wordpress.org/intimez/\">intimez</a>, <a href=\"https://profiles.wordpress.org/ipstenu/\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/isabel_brison/\">Isabel Brison</a>, <a href=\"https://profiles.wordpress.org/ispreview/\">ispreview</a>, <a href=\"https://profiles.wordpress.org/whyisjake/\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/jbinda/\">Jakub Binda</a>, <a href=\"https://profiles.wordpress.org/macmanx/\">James Huff</a>, <a href=\"https://profiles.wordpress.org/jameskoster/\">James Koster</a>, <a href=\"https://profiles.wordpress.org/jnylen0/\">James Nylen</a>, <a href=\"https://profiles.wordpress.org/jameslnewell/\">jameslnewell</a>, <a href=\"https://profiles.wordpress.org/jankimoradiya/\">Janki Moradiya</a>, <a href=\"https://profiles.wordpress.org/jarretc/\">Jarret</a>, <a href=\"https://profiles.wordpress.org/studiotwee/\">Jasper van der Meer</a>, <a href=\"https://profiles.wordpress.org/jaydeep23290/\">jaydeep23290</a>, <a href=\"https://profiles.wordpress.org/jdy68/\">jdy68</a>, <a href=\"https://profiles.wordpress.org/audrasjb/\">Jean-Baptiste Audras</a>, <a href=\"https://profiles.wordpress.org/jean-david/\">Jean-David Daviet</a>, <a href=\"https://profiles.wordpress.org/jblz/\">Jeff Bowen</a>, <a href=\"https://profiles.wordpress.org/jffng/\">Jeff Ong</a>, <a href=\"https://profiles.wordpress.org/jeffpaul/\">Jeff Paul</a>, <a href=\"https://profiles.wordpress.org/phpbits/\">Jeffrey Carandang</a>, <a href=\"https://profiles.wordpress.org/jeichorn/\">jeichorn</a>, <a href=\"https://profiles.wordpress.org/jenilk/\">Jenil Kanani</a>, <a href=\"https://profiles.wordpress.org/miss_jwo/\">Jenny Wong</a>, <a href=\"https://profiles.wordpress.org/jepperask/\">jepperask</a>, <a href=\"https://profiles.wordpress.org/jeremyclarke/\">Jer Clarke</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt/\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jeherve/\">Jeremy Herve</a>, <a href=\"https://profiles.wordpress.org/jeroenrotty/\">Jeroen Rotty</a>, <a href=\"https://profiles.wordpress.org/jeryj/\">Jerry Jones</a>, <a href=\"https://profiles.wordpress.org/luminuu/\">Jessica Lyschik</a>, <a href=\"https://profiles.wordpress.org/jipmoors/\">Jip Moors</a>, <a href=\"https://profiles.wordpress.org/joedolson/\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joehoyle/\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/joemcgill/\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/joen/\">Joen Asmussen</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/johnwatkins0/\">johnwatkins0</a>, <a href=\"https://profiles.wordpress.org/jon81/\">Jon</a>, <a href=\"https://profiles.wordpress.org/itsjonq/\">Jon Quach</a>, <a href=\"https://profiles.wordpress.org/jonsurrell/\">Jon Surrell</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/jg-visual/\">Jonathan Goldford</a>, <a href=\"https://profiles.wordpress.org/spacedmonkey/\">Jonny Harris</a>, <a href=\"https://profiles.wordpress.org/jonoaldersonwp/\">Jono Alderson</a>, <a href=\"https://profiles.wordpress.org/joonasvanhatapio/\">Joonas Vanhatapio</a>, <a href=\"https://profiles.wordpress.org/joostdevalk/\">Joost de Valk</a>, <a href=\"https://profiles.wordpress.org/koke/\">Jorge Bernal</a>, <a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Costa</a>, <a href=\"https://profiles.wordpress.org/chanthaboune/\">Josepha Haden</a>, <a href=\"https://profiles.wordpress.org/joshuawold/\">JoshuaWold</a>, <a href=\"https://profiles.wordpress.org/joyously/\">Joy</a>, <a href=\"https://profiles.wordpress.org/jqz/\">jqz</a>, <a href=\"https://profiles.wordpress.org/jsnajdr/\">jsnajdr</a>, <a href=\"https://profiles.wordpress.org/juanfra/\">Juanfra Aldasoro</a>, <a href=\"https://profiles.wordpress.org/derweili/\">Julian Weiland</a>, <a href=\"https://profiles.wordpress.org/juliankimmig/\">julian.kimmig</a>, <a href=\"https://profiles.wordpress.org/jrf/\">Juliette Reinders Folmer</a>, <a href=\"https://profiles.wordpress.org/juliobox/\">Julio Potier</a>, <a href=\"https://profiles.wordpress.org/nukaga/\">Junko Nukaga</a>, <a href=\"https://profiles.wordpress.org/jurgen/\">jurgen</a>, <a href=\"https://profiles.wordpress.org/justdaiv/\">justdaiv</a>, <a href=\"https://profiles.wordpress.org/justinahinon/\">Justin Ahinon</a>, <a href=\"https://profiles.wordpress.org/kadamwhite/\">K. Adam White</a>, <a href=\"https://profiles.wordpress.org/kaggdesign/\">kaggdesign</a>, <a href=\"https://profiles.wordpress.org/kalpshit/\">KalpShit Akabari</a>, <a href=\"https://profiles.wordpress.org/leprincenoir/\">Kantari Samy</a>, <a href=\"https://profiles.wordpress.org/kasparsd/\">Kaspars</a>, <a href=\"https://profiles.wordpress.org/ryelle/\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/kennithnichol/\">Kennith Nichol</a>, <a href=\"https://profiles.wordpress.org/khag7/\">Kevin Hagerty</a>, <a href=\"https://profiles.wordpress.org/kharisblank/\">Kharis Sulistiyono</a>, <a href=\"https://profiles.wordpress.org/khushbu19/\">Khushbu Modi</a>, <a href=\"https://profiles.wordpress.org/killerbishop/\">killerbishop</a>, <a href=\"https://profiles.wordpress.org/kinjaldalwadi/\">kinjaldalwadi</a>, <a href=\"https://profiles.wordpress.org/kitchin/\">kitchin</a>, <a href=\"https://profiles.wordpress.org/ixkaito/\">Kite</a>, <a href=\"https://profiles.wordpress.org/kjellr/\">Kjell Reigstad</a>, <a href=\"https://profiles.wordpress.org/kkarpieszuk/\">kkarpieszuk</a>, <a href=\"https://profiles.wordpress.org/knutsp/\">Knut Sparhell</a>, <a href=\"https://profiles.wordpress.org/kokkieh/\">KokkieH</a>, <a href=\"https://profiles.wordpress.org/obenland/\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/xkon/\">Konstantinos Xenos</a>, <a href=\"https://profiles.wordpress.org/klopez8/\">Krystyna</a>, <a href=\"https://profiles.wordpress.org/kubiq/\">kubiq</a>, <a href=\"https://profiles.wordpress.org/wpkuf/\">kuflievskiy</a>, <a href=\"https://profiles.wordpress.org/sainthkh/\">Kukhyeon Heo</a>, <a href=\"https://profiles.wordpress.org/kyliesabra/\">kyliesabra</a>, <a href=\"https://profiles.wordpress.org/lakenh/\">Laken Hafner</a>, <a href=\"https://profiles.wordpress.org/leandroalonso/\">leandroalonso</a>, <a href=\"https://profiles.wordpress.org/leogermani/\">leogermani</a>, <a href=\"https://profiles.wordpress.org/lgrev01/\">lgrev01</a>, <a href=\"https://profiles.wordpress.org/linuxologos/\">linuxologos</a>, <a href=\"https://profiles.wordpress.org/lisota/\">lisota</a>, <a href=\"https://profiles.wordpress.org/lorenzof/\">Lorenzo Fracassi</a>, <a href=\"https://profiles.wordpress.org/luisherranz/\">luisherranz</a>, <a href=\"https://profiles.wordpress.org/luisrivera/\">luisrivera</a>, <a href=\"https://profiles.wordpress.org/lukaswaudentio/\">lukaswaudentio</a>, <a href=\"https://profiles.wordpress.org/ljasinskipl/\">Lukasz Jasinski</a>, <a href=\"https://profiles.wordpress.org/lukecavanagh/\">Luke Cavanagh</a>, <a href=\"https://profiles.wordpress.org/wodarekly/\">Lydia Wodarek</a>, <a href=\"https://profiles.wordpress.org/vinoth06/\">M A Vinoth Kumar</a>, <a href=\"https://profiles.wordpress.org/maciejmackowiak/\">maciejmackowiak</a>, <a href=\"https://profiles.wordpress.org/mahesh901122/\">Mahesh Waghmare</a>, <a href=\"https://profiles.wordpress.org/manzoorwanijk/\">Manzoor Wani</a>, <a href=\"https://profiles.wordpress.org/marcelo2605/\">marcelo2605</a>, <a href=\"https://profiles.wordpress.org/marcio-zebedeu/\">Marcio Zebedeu</a>, <a href=\"https://profiles.wordpress.org/marcoz/\">MarcoZ</a>, <a href=\"https://profiles.wordpress.org/mkaz/\">Marcus Kazmierczak</a>, <a href=\"https://profiles.wordpress.org/marekdedic/\">Marek Dědič</a>, <a href=\"https://profiles.wordpress.org/clorith/\">Marius Jensen</a>, <a href=\"https://profiles.wordpress.org/marius84/\">Marius84</a>, <a href=\"https://profiles.wordpress.org/markjaquith/\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/mmarzeotti/\">Mark Marzeotti</a>, <a href=\"https://profiles.wordpress.org/mapk/\">Mark Uraine</a>, <a href=\"https://profiles.wordpress.org/hinjiriyo/\">Martin Stehle</a>, <a href=\"https://profiles.wordpress.org/m-e-h/\">Marty Helmick</a>, <a href=\"https://profiles.wordpress.org/marybaum/\">Mary Baum</a>, <a href=\"https://profiles.wordpress.org/matstars/\">Mat Gargano</a>, <a href=\"https://profiles.wordpress.org/mat-lipe/\">Mat Lipe</a>, <a href=\"https://profiles.wordpress.org/imath/\">Mathieu Viet</a>, <a href=\"https://profiles.wordpress.org/matveb/\">Matias Ventura</a>, <a href=\"https://profiles.wordpress.org/mattkeys/\">Matt Keys</a>, <a href=\"https://profiles.wordpress.org/veraxus/\">Matt van Andel</a>, <a href=\"https://profiles.wordpress.org/mattchowning/\">mattchowning</a>, <a href=\"https://profiles.wordpress.org/snapfractalpop/\">Matthew Kevins</a>, <a href=\"https://profiles.wordpress.org/mattnyeus/\">mattnyeus</a>, <a href=\"https://profiles.wordpress.org/maxme/\">maxme</a>, <a href=\"https://profiles.wordpress.org/mayanksonawat/\">mayanksonawat</a>, <a href=\"https://profiles.wordpress.org/mbrailer/\">mbrailer</a>, <a href=\"https://profiles.wordpress.org/mehidi258/\">Mehidi Hassan</a>, <a href=\"https://profiles.wordpress.org/melchoyce/\">Mel Choyce-Dwan</a>, <a href=\"https://profiles.wordpress.org/mensmaximus/\">mensmaximus</a>, <a href=\"https://profiles.wordpress.org/michael-arestad/\">Michael Arestad</a>, <a href=\"https://profiles.wordpress.org/michaelecklund/\">Michael Ecklund</a>, <a href=\"https://profiles.wordpress.org/donmhico/\">Michael Panaga</a>, <a href=\"https://profiles.wordpress.org/marktimemedia/\">Michelle Schulp</a>, <a href=\"https://profiles.wordpress.org/miette49/\">miette49</a>, <a href=\"https://profiles.wordpress.org/mcsf/\">Miguel Fonseca</a>, <a href=\"https://profiles.wordpress.org/mmtr86/\">Miguel Torres</a>, <a href=\"https://profiles.wordpress.org/mihdan/\">mihdan</a>, <a href=\"https://profiles.wordpress.org/miinasikk/\">Miina Sikk</a>, <a href=\"https://profiles.wordpress.org/simison/\">Mikael Korpela</a>, <a href=\"https://profiles.wordpress.org/mauteri/\">Mike Auteri</a>, <a href=\"https://profiles.wordpress.org/mikehansenme/\">Mike Hansen</a>, <a href=\"https://profiles.wordpress.org/mikeschinkel/\">Mike Schinkel [WPLib Box project lead]</a>, <a href=\"https://profiles.wordpress.org/mikeschroder/\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/mikejdent/\">mikejdent</a>, <a href=\"https://profiles.wordpress.org/msaari/\">Mikko Saari</a>, <a href=\"https://profiles.wordpress.org/iihglobal/\">Milan Patel</a>, <a href=\"https://profiles.wordpress.org/gdragon/\">Milan Petrovic</a>, <a href=\"https://profiles.wordpress.org/mimitips/\">mimi</a>, <a href=\"https://profiles.wordpress.org/mircoraffinetti/\">mircoraffinetti</a>, <a href=\"https://profiles.wordpress.org/mjnewman/\">mjnewman</a>, <a href=\"https://profiles.wordpress.org/mlbrgl/\">mlbrgl</a>, <a href=\"https://profiles.wordpress.org/morganestes/\">Morgan Estes</a>, <a href=\"https://profiles.wordpress.org/man4toman/\">Morteza Geransayeh</a>, <a href=\"https://profiles.wordpress.org/mppfeiffer/\">mppfeiffer</a>, <a href=\"https://profiles.wordpress.org/mryoga/\">mryoga</a>, <a href=\"https://profiles.wordpress.org/musamamasood/\">Muhammad Usama Masood</a>, <a href=\"https://profiles.wordpress.org/mujuonly/\">mujuonly</a>, <a href=\"https://profiles.wordpress.org/mukesh27/\">Mukesh Panchal</a>, <a href=\"https://profiles.wordpress.org/assassinateur/\">Nadir Seghir</a>, <a href=\"https://profiles.wordpress.org/nagoke/\">nagoke</a>, <a href=\"https://profiles.wordpress.org/nfmohit/\">Nahid Ferdous Mohit</a>, <a href=\"https://profiles.wordpress.org/finchps/\">Nate Finch</a>, <a href=\"https://profiles.wordpress.org/mukto90/\">Nazmul Ahsan</a>, <a href=\"https://profiles.wordpress.org/nekomajin/\">nekomajin</a>, <a href=\"https://profiles.wordpress.org/nextscripts/\">NextScripts</a>, <a href=\"https://profiles.wordpress.org/nickdaugherty/\">Nick Daugherty</a>, <a href=\"https://profiles.wordpress.org/celloexpressions/\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/nsundberg/\">Nicklas Sundberg</a>, <a href=\"https://profiles.wordpress.org/nickylimjj/\">Nicky Lim</a>, <a href=\"https://profiles.wordpress.org/vadimnicolai/\">nicolad</a>, <a href=\"https://profiles.wordpress.org/rahe/\">Nicolas Juen</a>, <a href=\"https://profiles.wordpress.org/nicole2292/\">nicole2292</a>, <a href=\"https://profiles.wordpress.org/nielslange/\">Niels Lange</a>, <a href=\"https://profiles.wordpress.org/nikhilgupte/\">nikhilgupte</a>, <a href=\"https://profiles.wordpress.org/nilamacharya/\">nilamacharya</a>, <a href=\"https://profiles.wordpress.org/noahtallen/\">noahtallen</a>, <a href=\"https://profiles.wordpress.org/noyle/\">noyle</a>, <a href=\"https://profiles.wordpress.org/nsubugak/\">nsubugak</a>, <a href=\"https://profiles.wordpress.org/oakesjosh/\">oakesjosh</a>, <a href=\"https://profiles.wordpress.org/oldenburg/\">oldenburg</a>, <a href=\"https://profiles.wordpress.org/alshakero/\">Omar Alshaker</a>, <a href=\"https://profiles.wordpress.org/ottok/\">Otto Kek&#228;l&#228;inen</a>, <a href=\"https://profiles.wordpress.org/ov3rfly/\">Ov3rfly</a>, <a href=\"https://profiles.wordpress.org/paaljoachim/\">Paal Joachim Romdahl</a>, <a href=\"https://profiles.wordpress.org/iaaxpage/\">page-carbajal</a>, <a href=\"https://profiles.wordpress.org/pagewidth/\">pagewidth</a>, <a href=\"https://profiles.wordpress.org/paragoninitiativeenterprises/\">Paragon Initiative Enterprises</a>, <a href=\"https://profiles.wordpress.org/swissspidy/\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/casiepa/\">Pascal Casier</a>, <a href=\"https://profiles.wordpress.org/pbearne/\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/pbiron/\">Paul Biron</a>, <a href=\"https://profiles.wordpress.org/rixeo/\">Paul Kevin</a>, <a href=\"https://profiles.wordpress.org/paulschreiber/\">Paul Schreiber</a>, <a href=\"https://profiles.wordpress.org/pcarvalho/\">pcarvalho</a>, <a href=\"https://profiles.wordpress.org/pedromendonca/\">Pedro Mendon&#231;a</a>, <a href=\"https://profiles.wordpress.org/perrywagle/\">perrywagle</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/philipmjackson/\">Philip Jackson</a>, <a href=\"https://profiles.wordpress.org/pierlo/\">Pierre Gordon</a>, <a href=\"https://profiles.wordpress.org/pierrelannoy/\">Pierre Lannoy</a>, <a href=\"https://profiles.wordpress.org/pikamander2/\">pikamander2</a>, <a href=\"https://profiles.wordpress.org/prashantvatsh/\">Prashant Singh</a>, <a href=\"https://profiles.wordpress.org/pratik-jain/\">Pratik Jain</a>, <a href=\"https://profiles.wordpress.org/presskopp/\">Presskopp</a>, <a href=\"https://profiles.wordpress.org/priyankabehera155/\">Priyanka Behera</a>, <a href=\"https://profiles.wordpress.org/raamdev/\">Raam Dev</a>, <a href=\"https://profiles.wordpress.org/bamadesigner/\">Rachel Cherry</a>, <a href=\"https://profiles.wordpress.org/larrach/\">Rachel Peter</a>, <a href=\"https://profiles.wordpress.org/ragnarokatz/\">ragnarokatz</a>, <a href=\"https://profiles.wordpress.org/ramiy/\">Rami Yushuvaev</a>, <a href=\"https://profiles.wordpress.org/raoulunger/\">raoulunger</a>, <a href=\"https://profiles.wordpress.org/razamalik/\">razamalik</a>, <a href=\"https://profiles.wordpress.org/remcotolsma/\">Remco Tolsma</a>, <a href=\"https://profiles.wordpress.org/rephotsirch/\">rephotsirch</a>, <a href=\"https://profiles.wordpress.org/rheinardkorf/\">rheinardkorf</a>, <a href=\"https://profiles.wordpress.org/youknowriad/\">Riad Benguella</a>, <a href=\"https://profiles.wordpress.org/quicoto/\">Ricard Torres</a>, <a href=\"https://profiles.wordpress.org/richtabor/\">Rich Tabor</a>, <a href=\"https://profiles.wordpress.org/rimadoshi/\">rimadoshi</a>, <a href=\"https://profiles.wordpress.org/rinkuyadav999/\">Rinku Y</a>, <a href=\"https://profiles.wordpress.org/rcutmore/\">Rob Cutmore</a>, <a href=\"https://profiles.wordpress.org/rob006/\">rob006</a>, <a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a>, <a href=\"https://profiles.wordpress.org/rconde/\">Roi Conde</a>, <a href=\"https://profiles.wordpress.org/murgroland/\">Roland Murg</a>, <a href=\"https://profiles.wordpress.org/costasovo/\">Rostislav Woln&#253;</a>, <a href=\"https://profiles.wordpress.org/roytanck/\">Roy Tanck</a>, <a href=\"https://profiles.wordpress.org/kingkool68/\">Russell Heimlich</a>, <a href=\"https://profiles.wordpress.org/rryyaanndd/\">Ryan</a>, <a href=\"https://profiles.wordpress.org/bookdude13/\">Ryan Fredlund</a>, <a href=\"https://profiles.wordpress.org/rmccue/\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/welcher/\">Ryan Welcher</a>, <a href=\"https://profiles.wordpress.org/looswebstudio/\">Ryo</a>, <a href=\"https://profiles.wordpress.org/sebastienserre/\">S&#233;bastien SERRE</a>, <a href=\"https://profiles.wordpress.org/sablednah/\">sablednah</a>, <a href=\"https://profiles.wordpress.org/viralsampat/\">Sampat Viral</a>, <a href=\"https://profiles.wordpress.org/otto42/\">Samuel Wood (Otto)</a>, <a href=\"https://profiles.wordpress.org/samuelfernandez/\">SamuelFernandez</a>, <a href=\"https://profiles.wordpress.org/zanderz/\">Sander</a>, <a href=\"https://profiles.wordpress.org/santilinwp/\">santilinwp</a>, <a href=\"https://profiles.wordpress.org/sathyapulse/\">Sathiyamoorthy V</a>, <a href=\"https://profiles.wordpress.org/tivus/\">Schuhwerk</a>, <a href=\"https://profiles.wordpress.org/coffee2code/\">Scott Reilly</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic/\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/scruffian/\">scruffian</a>, <a href=\"https://profiles.wordpress.org/scvleon/\">scvleon</a>, <a href=\"https://profiles.wordpress.org/sebastianpisula/\">Sebastian Pisula</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/sgr33n/\">Sergio de Falco</a>, <a href=\"https://profiles.wordpress.org/sergiomdgomes/\">sergiomdgomes</a>, <a href=\"https://profiles.wordpress.org/sgastard/\">sgastard</a>, <a href=\"https://profiles.wordpress.org/sgoen/\">sgoen</a>, <a href=\"https://profiles.wordpress.org/shahariaazam/\">Shaharia Azam</a>, <a href=\"https://profiles.wordpress.org/cafenoirdesign/\">Shannon Smith</a>, <a href=\"https://profiles.wordpress.org/shariqkhan2012/\">shariqkhan2012</a>, <a href=\"https://profiles.wordpress.org/sncoker/\">Shawntelle Coker</a>, <a href=\"https://profiles.wordpress.org/sheparddw/\">sheparddw</a>, <a href=\"https://profiles.wordpress.org/shital-patel/\">Shital Marakana</a>, <a href=\"https://profiles.wordpress.org/shizumi/\">Shizumi Yoshiaki</a>, <a href=\"https://profiles.wordpress.org/simonjanin/\">simonjanin</a>, <a href=\"https://profiles.wordpress.org/sinatrateam/\">sinatrateam</a>, <a href=\"https://profiles.wordpress.org/sirreal/\">sirreal</a>, <a href=\"https://profiles.wordpress.org/skorasaurus/\">skorasaurus</a>, <a href=\"https://profiles.wordpress.org/smerriman/\">smerriman</a>, <a href=\"https://profiles.wordpress.org/socalchristina/\">socalchristina</a>, <a href=\"https://profiles.wordpress.org/soean/\">Soren Wrede</a>, <a href=\"https://profiles.wordpress.org/spenserhale/\">spenserhale</a>, <a href=\"https://profiles.wordpress.org/sproutchris/\">sproutchris</a>, <a href=\"https://profiles.wordpress.org/squarecandy/\">squarecandy</a>, <a href=\"https://profiles.wordpress.org/starvoters1/\">starvoters1</a>, <a href=\"https://profiles.wordpress.org/steelwagstaff/\">SteelWagstaff</a>, <a href=\"https://profiles.wordpress.org/steevithak/\">steevithak</a>, <a href=\"https://profiles.wordpress.org/ryokuhi/\">Stefano Minoia</a>, <a href=\"https://profiles.wordpress.org/hypest/\">Stefanos Togoulidis</a>, <a href=\"https://profiles.wordpress.org/steffanhalv/\">steffanhalv</a>, <a href=\"https://profiles.wordpress.org/sabernhardt/\">Stephen Bernhardt</a>, <a href=\"https://profiles.wordpress.org/netweb/\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/dufresnesteven/\">Steve Dufresne</a>, <a href=\"https://profiles.wordpress.org/stevegrunwell/\">Steve Grunwell</a>, <a href=\"https://profiles.wordpress.org/stevenlinx/\">stevenlinx</a>, <a href=\"https://profiles.wordpress.org/stiofansisland/\">Stiofan</a>, <a href=\"https://profiles.wordpress.org/matthias-reuter/\">straightvisions GmbH</a>, <a href=\"https://profiles.wordpress.org/stroona/\">stroona.com</a>, <a href=\"https://profiles.wordpress.org/subratamal/\">Subrata Mal</a>, <a href=\"https://profiles.wordpress.org/subrataemfluence/\">Subrata Sarkar</a>, <a href=\"https://profiles.wordpress.org/manikmist09/\">Sultan Nasir Uddin</a>, <a href=\"https://profiles.wordpress.org/swapnild/\">swapnild</a>, <a href=\"https://profiles.wordpress.org/cybr/\">Sybre Waaijer</a>, <a href=\"https://profiles.wordpress.org/sergioestevao/\">Sérgio Estêvão</a>, <a href=\"https://profiles.wordpress.org/miyauchi/\">Takayuki Miyauchi</a>, <a href=\"https://profiles.wordpress.org/takeshifurusato/\">Takeshi Furusato</a>, <a href=\"https://profiles.wordpress.org/karmatosed/\">Tammie Lister</a>, <a href=\"https://profiles.wordpress.org/tanvirul/\">Tanvirul Haque</a>, <a href=\"https://profiles.wordpress.org/tbschen/\">TBschen</a>, <a href=\"https://profiles.wordpress.org/tdlewis77/\">tdlewis77</a>, <a href=\"https://profiles.wordpress.org/tellyworth/\">Tellyworth</a>, <a href=\"https://profiles.wordpress.org/thamaraiselvam/\">Thamaraiselvam</a>, <a href=\"https://profiles.wordpress.org/thefarlilacfield/\">thefarlilacfield</a>, <a href=\"https://profiles.wordpress.org/themezee/\">ThemeZee</a>, <a href=\"https://profiles.wordpress.org/timhavinga/\">Tim Havinga</a>, <a href=\"https://profiles.wordpress.org/hedgefield/\">Tim Hengeveld</a>, <a href=\"https://profiles.wordpress.org/timon33/\">timon33</a>, <a href=\"https://profiles.wordpress.org/spaceshipone/\">Timoth&#233;e Brosille</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs/\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/tkama/\">Tkama</a>, <a href=\"https://profiles.wordpress.org/tmanoilov/\">tmanoilov</a>, <a href=\"https://profiles.wordpress.org/tmatsuur/\">tmatsuur</a>, <a href=\"https://profiles.wordpress.org/tobifjellner/\">tobifjellner (Tor-Bjorn Fjellner)</a>, <a href=\"https://profiles.wordpress.org/tomgreer/\">Tom Greer</a>, <a href=\"https://profiles.wordpress.org/tjnowell/\">Tom J Nowell</a>, <a href=\"https://profiles.wordpress.org/tommix/\">tommix</a>, <a href=\"https://profiles.wordpress.org/skithund/\">Toni Viemer&#246;</a>, <a href=\"https://profiles.wordpress.org/toro_unit/\">Toro_Unit (Hiroshi Urabe)</a>, <a href=\"https://profiles.wordpress.org/torres126/\">torres126</a>, <a href=\"https://profiles.wordpress.org/zodiac1978/\">Torsten Landsiedel</a>, <a href=\"https://profiles.wordpress.org/itowhid06/\">Towhidul Islam</a>, <a href=\"https://profiles.wordpress.org/tristangemus/\">tristangemus</a>, <a href=\"https://profiles.wordpress.org/tristanleboss/\">tristanleboss</a>, <a href=\"https://profiles.wordpress.org/tsuyoring/\">tsuyoring</a>, <a href=\"https://profiles.wordpress.org/dinhtungdu/\">Tung Du</a>, <a href=\"https://profiles.wordpress.org/desaiuditd/\">Udit Desai</a>, <a href=\"https://profiles.wordpress.org/grapplerulrich/\">Ulrich</a>, <a href=\"https://profiles.wordpress.org/upadalavipul/\">upadalavipul</a>, <a href=\"https://profiles.wordpress.org/utsav72640/\">Utsav tilava</a>, <a href=\"https://profiles.wordpress.org/vaishalipanchal/\">Vaishali Panchal</a>, <a href=\"https://profiles.wordpress.org/valentinbora/\">Valentin Bora</a>, <a href=\"https://profiles.wordpress.org/varunshanbhag/\">Varun Shanbhag</a>, <a href=\"https://profiles.wordpress.org/veminom/\">Veminom</a>, <a href=\"https://profiles.wordpress.org/vinita29/\">Vinita Tandulkar</a>, <a href=\"https://profiles.wordpress.org/virgodesign/\">virgodesign</a>, <a href=\"https://profiles.wordpress.org/vsamoletov/\">Vlad. S.</a>, <a href=\"https://profiles.wordpress.org/vortfu/\">vortfu</a>, <a href=\"https://profiles.wordpress.org/waleedt93/\">waleedt93</a>, <a href=\"https://profiles.wordpress.org/webmandesign/\">WebMan Design &#124; Oliver Juhas</a>, <a href=\"https://profiles.wordpress.org/websupporter/\">websupporter</a>, <a href=\"https://profiles.wordpress.org/westonruter/\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/earnjam/\">William Earnhardt</a>, <a href=\"https://profiles.wordpress.org/williampatton/\">William Patton</a>, <a href=\"https://profiles.wordpress.org/wpgurudev/\">wpgurudev</a>, <a href=\"https://profiles.wordpress.org/alexandreb3/\">WPMarmite</a>, <a href=\"https://profiles.wordpress.org/wptoolsdev/\">wptoolsdev</a>, <a href=\"https://profiles.wordpress.org/xedinunknown-1/\">xedinunknown-1</a>, <a href=\"https://profiles.wordpress.org/yale01/\">yale01</a>, <a href=\"https://profiles.wordpress.org/collet/\">Yannicki</a>, <a href=\"https://profiles.wordpress.org/yordansoares/\">Yordan Soares</a>, <a href=\"https://profiles.wordpress.org/fierevere/\">Yui</a>, <a href=\"https://profiles.wordpress.org/zachflauaus/\">zachflauaus</a>, <a href=\"https://profiles.wordpress.org/tollmanz/\">Zack Tollman</a>, <a href=\"https://profiles.wordpress.org/zebulan/\">Zebulan Stanphill</a>, <a href=\"https://profiles.wordpress.org/zaffarn/\">Zee</a>, and <a href=\"https://profiles.wordpress.org/zsusag/\">zsusag</a>.\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<p>Many thanks to all of the community volunteers who contribute in the&nbsp;<a href=\"https://wordpress.org/support/\">support forums</a>. They answer questions from people across the world, whether they are using WordPress for the first time or since the first release. These releases are more successful for their efforts!</p>\n\n\n\n<p>Finally, thanks to all the community translators who worked on WordPress 5.4. Their efforts bring WordPress fully translated to&nbsp;46 languages at release time, with more on the way.</p>\n\n\n\n<p>If you want to learn more about volunteering with WordPress, check out&nbsp;<a href=\"https://make.wordpress.org/\">Make WordPress</a>&nbsp;or the&nbsp;<a href=\"https://make.wordpress.org/core/\">core development blog</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 31 Mar 2020 19:04:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: Proposal to Update the WordPress Coding Standards for Modern PHP\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98172\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:193:\"https://wptavern.com/proposal-to-update-the-wordpress-coding-standards-for-modern-php?utm_source=rss&utm_medium=rss&utm_campaign=proposal-to-update-the-wordpress-coding-standards-for-modern-php\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5010:\"<p class=\"has-drop-cap\">WordPress is a dinosaur. If you are a PHP programmer and have had the <a href=\"https://wptavern.com/lessons-learned-by-stepping-outside-wordpress-comfort-zone\">opportunity to work outside of WordPress</a> in the past 10 years, there are likely one or two or a few dozen things that frustrate you when diving back into the project&rsquo;s 16-year-old codebase. At a time when WordPress is gifting JavaScript programmers with the latest and greatest goodies, those doing PHP work can feel left behind.</p>\n\n\n\n<p>There is a good reason for the legacy code in WordPress: it is backward compatible with over a decade of third-party extensions. Plus, <em>old</em> code does not necessarily equate to <em>bad</em> code. <em>If it ain&rsquo;t broke</em> &mdash; well, you know how the rest goes.</p>\n\n\n\n<p>Last year, WordPress <a href=\"https://wptavern.com/wordpress-ends-support-for-php-5-2-5-5-bumps-minimum-required-php-version-to-5-6\">bumped the minimum requirement</a> for running the software to PHP 5.6 or newer. Many developers cheered in support of features such as short array syntax, namespacing, and the spread operator. Others wanted to jump to PHP 7+, but PHP 5.6 was a good stepping stone to more modern PHP code.</p>\n\n\n\n<p>This change opened some new questions. <em>When will core WordPress begin using new features? What coding standards should the project follow?</em></p>\n\n\n\n<p>WordPress 5.3 made use of the new <a href=\"https://wptavern.com/coming-in-wordpress-5-3-what-is-the-php-spread-operator\">spread operator</a>, which cleaned up and simplified several functions. It showed a willingness of the core leads to update some outdated code while avoiding backward-compatible issues.</p>\n\n\n\n<h2>An Updated Set of Standards</h2>\n\n\n\n<p class=\"has-drop-cap\">To begin using modern PHP features in WordPress, the platform&rsquo;s coding standards must evolve. On March 20, Juliette Reinders Folmer <a href=\"https://make.wordpress.org/core/2020/03/20/updating-the-coding-standards-for-modern-php/\">proposed an extensive set of guidelines</a>. The proposal is a draft and will need to be fine-tuned based on feedback from developers and core contributors.</p>\n\n\n\n<p>&ldquo;While it may still be a while before some of these features will actually be adopted for use in WordPress Core,&rdquo; wrote Folmer, &ldquo;defining the coding standards in advance will allow for a consistent code base when they do get adopted and will allow for plugins and themes, which are not necessarily bound to the PHP 5.6 minimum, to safeguard their code consistency when they start using more modern PHP already.&rdquo;</p>\n\n\n\n<p>The proposed standards are broken down into the following topics:</p>\n\n\n\n<ul><li>Namespace declarations</li><li>Import <code>use</code> statements</li><li>Traits and interfaces</li><li>Type declarations</li><li>Declare statements / strict typing</li><li>The <code>::class</code> constant</li><li>Operators</li><li>Additional new rules covering various items</li></ul>\n\n\n\n<p>Any code that goes directly into WordPress must follow the project&rsquo;s coding standards. It is strongly recommended that plugin and theme developers adopt the same standards, but it is not a requirement for inclusion in the official plugin and theme directories. Coding standards across an ecosystem make it easier for one developer to pick up code from other developers without having to learn unique styles between extensions.</p>\n\n\n\n<p>On the whole, the update look solid. There is a lot to like about this proposal, and it would be a welcome addition to a <a href=\"https://make.wordpress.org/core/handbook/best-practices/coding-standards/php/\">set of guidelines</a> that sorely needed a refresh.</p>\n\n\n\n<p>One of my biggest gripes is around file naming. The WordPress project should drop the use of <code>class-</code>, <code>interface-</code>, and <code>trait-</code> prefixes from PHP filenames. Instead, we should use this opportunity to adopt the <a href=\"https://www.php-fig.org/psr/psr-4/\">PSR-4 autoloading standard&rsquo;s</a> naming convention. In that standard, the filename matches the class, interface, or trait&rsquo;s name exactly. At the very least, the prefixed filenames should not be a recommendation that goes out to WordPress developers everywhere. Keep it for core if necessary for tradition, but don&rsquo;t recommend widespread usage of a system that is years out of touch with modern PHP.</p>\n\n\n\n<p>I would also like to see WordPress adopt the use of Pascal case (i.e., <code>ExampleProject</code>) over camel caps (i.e., <code>Example_Project</code>) for namespaces. However, given the tradition of camel caps for class names, I do not see this changing. This is a bit nit-picky, but it feels out of place in comparison to other, more modern PHP projects.</p>\n\n\n\n<p>The biggest thing the WordPress developer community can do right now is to discuss the proposal and offer feedback. Most of the work is done. It is up to the community to help push it forward.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 30 Mar 2020 19:48:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"WordPress.org blog: WordPress 5.4 RC5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8451\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2020/03/wordpress-5-4-rc5/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2181:\"<p><br />The fifth release candidate for WordPress 5.4 is live!</p>\n\n\n\n<p>WordPress 5.4 is currently scheduled to land on&nbsp;<strong><a href=\"https://make.wordpress.org/core/5-4/\">March 31 2020</a></strong>, and we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.4 yet, now is the time!</p>\n\n\n\n<p>You can test the WordPress 5.4 release candidate in two ways:</p>\n\n\n\n<ul><li>Try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (choose the “bleeding edge nightlies” option)</li><li>Or <a href=\"https://wordpress.org/wordpress-5.4-RC5.zip\">download the release candidate here</a> (zip).</li></ul>\n\n\n\n<p>For details about what to expect in WordPress 5.4, please see the&nbsp;<a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate post</a>.</p>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme to 5.4. The priority in testing is compatibility. If you find issues, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>&nbsp;so we can figure them out before the final release.</p>\n\n\n\n<p>The&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a>&nbsp;is also out! It’s your source for details on all the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language besides English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 28 Mar 2020 00:47:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Baumwald\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: Font Awesome Releases New COVID-19 Awareness Icons\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:165:\"https://wptavern.com/font-awesome-releases-new-covid-19-awareness-icons?utm_source=rss&utm_medium=rss&utm_campaign=font-awesome-releases-new-covid-19-awareness-icons\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2733:\"<img />COVID-19 awareness icons added to Font Awesome.\n\n\n\n<p class=\"has-drop-cap\">On Monday, the Font Awesome team <a href=\"https://blog.fontawesome.com/covid-19-awareness-icons/\">launched a new set of icons</a> to promote awareness around COVID-19. The solid icons available in the Font Awesome 5.13 update are all available for free and are open-source. The regular, light, and duotone versions of the icons are a part of the pro package.</p>\n\n\n\n<p>The goal of the new icons is to help websites and apps boost awareness around the global pandemic. The latest update adds 47 new icons that range from medical use to promoting hygienic practices such as hand washing. Some icons represent viruses and social/physical distancing. There is even a couple of toilet paper icons thrown in for good measure. <em>Apparently, those are necessary in today&rsquo;s world of mass panic buying.</em></p>\n\n\n\n<p>&ldquo;Based on recommendations from The World Health Organization and others, you&rsquo;ll find symbols to communicate good hygiene and social distancing,&rdquo; wrote Jory Raphael, Icon Design Lead at Font Awesome. &ldquo;While we can&rsquo;t be on the front lines like brave medical professionals across the globe, we hope these icons aid in communicating some of the most important things people can do to protect themselves and their communities.&rdquo;</p>\n\n\n\n<p>The icons were <a href=\"https://github.com/FortAwesome/Font-Awesome/issues/16315\">originally requested</a> two weeks ago on the Font Awesome GitHub repository. The design team moved quickly to make them available. There are additional icon tickets for <a href=\"https://github.com/FortAwesome/Font-Awesome/issues/13931\">liquid soap</a> and a <a href=\"https://github.com/FortAwesome/Font-Awesome/issues/15855\">bar of soap</a> open.</p>\n\n\n\n<p>Like all Font Awesome icons, the new icons are available as part of the font package or for download as individual SVG files.</p>\n\n\n\n<p>The fonts may come in handy for website owners, designers, and developers who are building sites or pages with content related to COVID-19. Icons can add context to content or focus attention where needed.</p>\n\n\n\n<p>Users of the <a href=\"https://wordpress.org/plugins/font-awesome/\">Font Awesome WordPress plugin</a> should have immediate access to the new icons if needed. The plugin relies on the external Font Awesome CDN or Font Awesome kits. Users can also choose which version of the library of icons they wish to use, which includes the latest release.</p>\n\n\n\n<p class=\"has-background has-gray-100-background-color is-style-highlight bg-gray-100\">If you know of any other icon sets or resources for designers and developers related to COVID-19, please share them in the comments.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 27 Mar 2020 20:00:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WPTavern: Gutenberg 7.8 Adds Patterns API and Continues Interface Cleanup\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98109\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:191:\"https://wptavern.com/gutenberg-7-8-adds-patterns-api-and-continues-interface-cleanup?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-7-8-adds-patterns-api-and-continues-interface-cleanup\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5936:\"<p class=\"has-drop-cap\">Version 7.8 of the Gutenberg plugin <a href=\"https://make.wordpress.org/core/2020/03/26/whats-new-in-gutenberg-25-march/\">landed yesterday</a>. The team continues to improve the editor with the refreshed interface work that began in <a href=\"https://wptavern.com/gutenberg-7-7-ships-refreshed-ui-and-first-iteration-of-block-patterns\">version 7.7</a>. The most useful feature with this update of the plugin is the inclusion of the Patterns API for plugin and theme developers.</p>\n\n\n\n<p>This release is not the massive feature release that we experienced with some earlier versions. It is the culmination of many smaller improvements, particularly with improving the user interface and experience. The update includes over 20 bug fixes, some continued work on experimental features like the site editor, and several improvements in code quality.</p>\n\n\n\n<p><a href=\"https://github.com/WordPress/gutenberg/pull/12009\">Editing a post permalink</a> without requiring a save should work correctly, which has been an outstanding issue for over a year. Users can now <a href=\"https://github.com/WordPress/gutenberg/pull/20781\">select multiple categories</a> for the latest posts block as opposed to a single category. And, the experimental full-site editing feature now <a href=\"https://github.com/WordPress/gutenberg/pull/20691\">supports fullscreen mode</a>.</p>\n\n\n\n<h2>UI Continues Improving</h2>\n\n\n\n<img />Gutenberg 7.8 editor with updated preview button.\n\n\n\n<p class=\"has-drop-cap\">The team began a massive refresh of the user interface in Gutenberg 7.7. With this release, they continued building upon that initial work. Designers have <a href=\"https://github.com/WordPress/gutenberg/pull/20980\">fine-tuned several of the icons</a> for the editor toolbar, which includes the bold, italic, strikethrough, indent, outdent, and spacer icons.</p>\n\n\n\n<p>One of the most notable differences is an update to the user-facing text for the post preview button. In the previous version, there was a button that simply read &ldquo;Desktop.&rdquo; Once clicked, it would open a drop-down list to preview the post in desktop, tablet, or mobile mode. I had initially thought the team had removed the post preview option until I clicked on it. In version 7.8, that button&rsquo;s text now reads &ldquo;Preview,&rdquo; which is a much-needed change that is no longer confusing.</p>\n\n\n\n<p>Overall, the polishing work done on the editor looks good. At this point, I have become so accustomed to it that I have no desire to go back to a regular WordPress install without the Gutenberg plugin installed.</p>\n\n\n\n<h2>Building Custom Block Patterns</h2>\n\n\n\n<img />Custom block pattern registered and in use.\n\n\n\n<p class=\"has-drop-cap\">I have said it before, but it bears repeating: I am <a href=\"https://wptavern.com/block-patterns-will-change-everything\">excited about block patterns</a>. I am even more excited about the ability for plugin and theme authors to begin testing this feature by building custom patterns of their own. I foresee an explosion of creativity over the next several months and beyond.</p>\n\n\n\n<p>Patterns are a registration of the HTML for one or more blocks. Plugin and theme authors can further define the settings for those blocks. The Gutenberg team included a simple PHP function for developers to <a href=\"https://github.com/WordPress/gutenberg/pull/21074\">register custom patterns</a> called <code>register_pattern()</code>.</p>\n\n\n\n<p>I have tinkered with numerous pattern ideas since I updated yesterday evening. The simplest way to build a pattern is to do so visually. Open the editor and create a unique group of blocks that you like. Then, switch to the code editor and copy the code. From that point, you can register the pattern via PHP and paste the copied code. There is not really much actual coding involved in the process. Even advanced users with enough DIY grit could register them within their theme&rsquo;s <code>functions.php</code> file.</p>\n\n\n\n<p>The following is a simple &ldquo;hero&rdquo; pattern as shown in the above screenshot that uses the cover block, a heading, a paragraph, and a buttons group (I formatted the code a little after copying and pasting for readability):</p>\n\n\n\n<pre class=\"wp-block-code\"><code>add_action( \'init\', function() {\n\n	register_pattern( \'tavern/hero-1\', [\n		\'title\'   =&gt; __( \'Hero 1\' ),\n		\'content\' =&gt;\n			\'&lt;!-- wp:cover {\"customOverlayColor\":\"#273f60\",\"align\":\"full\"} --&gt;\n			&lt;div class=\"wp-block-cover alignfull has-background-dim\" style=\"background-color:#273f60\"&gt;\n				&lt;div class=\"wp-block-cover__inner-container\"&gt;\n					&lt;!-- wp:heading {\"align\":\"center\"} --&gt;\n					&lt;h2 class=\"has-text-align-center\"&gt;Heading Title Here&lt;/h2&gt;\n					&lt;!-- /wp:heading --&gt;\n\n					&lt;!-- wp:paragraph {\"align\":\"center\"} --&gt;\n					&lt;p class=\"has-text-align-center\"&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit.&lt;/p&gt;\n					&lt;!-- /wp:paragraph --&gt;\n\n					&lt;!-- wp:buttons {\"align\":\"center\"} --&gt;\n					&lt;div class=\"wp-block-buttons aligncenter\"&gt;\n						&lt;!-- wp:button {\"className\":\"is-style-outline\"} --&gt;\n						&lt;div class=\"wp-block-button is-style-outline\"&gt;&lt;a class=\"wp-block-button__link\"&gt;Button A&lt;/a&gt;&lt;/div&gt;\n						&lt;!-- /wp:button --&gt;\n						&lt;!-- wp:button {\"className\":\"is-style-outline\"} --&gt;\n						&lt;div class=\"wp-block-button is-style-outline\"&gt;&lt;a class=\"wp-block-button__link\"&gt;Button B&lt;/a&gt;&lt;/div&gt;\n						&lt;!-- /wp:button --&gt;\n					&lt;/div&gt;\n					&lt;!-- /wp:buttons --&gt;\n				&lt;/div&gt;\n			&lt;/div&gt;\n			&lt;!-- /wp:cover --&gt;\'\n	] );\n} );</code></pre>\n\n\n\n<p class=\"has-background has-gray-100-background-color bg-gray-100\"><strong>Disclaimer:</strong> The preceding code is for an experimental feature and could change in later versions of the Gutenberg plugin or before the API is officially added to core WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Mar 2020 20:06:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: Finding Balance in These Uncertain Times: Remote Work and Sharing Our Struggles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98079\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:221:\"https://wptavern.com/finding-balance-in-these-uncertain-times-remote-work-and-sharing-our-struggles?utm_source=rss&utm_medium=rss&utm_campaign=finding-balance-in-these-uncertain-times-remote-work-and-sharing-our-struggles\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5811:\"<p class=\"has-drop-cap\">There is a popular saying, which has been used in several memes, among my developer and remote-working friend groups. It goes something like the following:</p>\n\n\n\n<p><strong>Government and Doctors:</strong> <em>Practice physical distancing during this pandemic.</em></p>\n\n\n\n<p><strong>Remote Workers:</strong> <em>I&rsquo;ve been preparing my whole life for this moment. I got this.</em></p>\n\n\n\n<p>The truth is that we don&rsquo;t &ldquo;got this,&rdquo; at least I know I don&rsquo;t.</p>\n\n\n\n<p>While practicing physical distancing during the COVID-19 pandemic, it is those little moments that you do not think you will miss that suddenly become important.</p>\n\n\n\n<p>Every Saturday, I awake around 6 or 6:30 a.m. I go through my normal routine and get dressed for a morning drive into the city. My home is in a quiet area in rural Alabama. I am a Millennial living within a neighborhood of mostly Baby Boomers. For the most part, it is an ideal place for remote work. Few people bother me, and I can tend to my animals and get my work done in peace. However, it is not exactly the most socially invigorating place in the world.</p>\n\n\n\n<p>Those Saturday mornings are important. Assuming I have no other social plans for the week, it is my one chance to get out into the world. I stop by the local Co-Op, pick up any feed or seed I need, and chat with the people there about the farming season or the weather &mdash; mostly the weather. I drop into Hidden Treasures, a flea market, and talk with a seller who shares an interest in finding old DVDs, VHS tapes, and Laserdiscs. I grab a sandwich at Subway and am greeted by the Indian-American manager who learned my name on my first visit years ago. He asks about my family. I ask how his family is doing.</p>\n\n\n\n<p>These fleeting moments are almost forgettable. They are routine. Run-of-the-mill. When they are happening, you do not think about them. However, when they are gone, there is a void remaining that is hard to fill.</p>\n\n\n\n<p>Yes, I have been practicing physical distancing for over a decade, at least to some degree. That makes those small moments where I interact with others in person crucial to my mental health.</p>\n\n\n\n<p>This Saturday, I will once again head into the city after a hiatus. However, my trip will be different. This time, I will be gathering necessities for myself and some of my elderly neighbors who want to avoid the public for a while. The trip will be quick. Some of the places I normally visit are closed. My Subway meal will be carryout.</p>\n\n\n\n<p>Even after a couple of weeks, and feeling like I was prepared for this moment, I am still coming to grips with the world as it is now.</p>\n\n\n\n<h2>Staying Strong as a Community</h2>\n\n\n\n<p class=\"has-drop-cap\">The WordPress community, the people, have put up a strong front. Bloggers have written <a href=\"https://wptavern.com/advice-for-newcomers-to-remote-work-lessons-learned\">posts on remote work</a>. Developers, designers, and others have willingly shared their knowledge with others. Companies are offering discounts to help ease the burden for those looking to begin a shop or blog online. Yes, our community will get through this, and we will be stronger for it.</p>\n\n\n\n<p>However, it is OK for us to share our vulnerabilities during these uncertain times.</p>\n\n\n\n<p>Ultimately, this community is not about software. It is about people. The software is the way we connect. It is a tool that we program, design, and evangelize. We do it for ourselves. We do it for millions of others to have a voice online. But, it is always about people.</p>\n\n\n\n<p>Sometimes, people need to know that others in our community are struggling. This is a collective pain that we are working through. Remote work does not always mean physical distancing from everything and every one of the outside world. Many of us may have a bit of a head-start on staying put at home for hours on end, but we are also dealing with a new reality every day. Showing strength is good, but sharing our stories of struggle is just as important.</p>\n\n\n\n<p>For some of us, that weekly trip into the city plays a vital role in our well-being. Others are dealing with children who would normally be in school or daycare. Kids can be disruptive, even when you have the best-laid plans and every hour of their day mapped out. Even for us remote workers, life is a little out of balance now. It is OK to admit that. If you are running a WordPress business, it is OK for you to provide a little more flexibility for your workers who are at home. Many of them will need it.</p>\n\n\n\n<p>It is not time to break down. It is time to find a new balance in our current environments. That may mean starting up a family board game night. It may mean making sure that you set up a video chat with those loved ones you have been too busy to call in several months. Maybe you will start taking a daily walk for better health. It might also be time to <a href=\"https://twitter.com/jemjabella/status/1240283538596999170\">set up WordPress blogs for your children</a> as part of their education. Some of these new things may and probably should become routine, <em>especially that last one</em>.</p>\n\n\n\n<p>Do not become overwhelmed if you feel like you should be handling this situation better because you have practice at remote work.</p>\n\n\n\n<p>Hop over to your personal WordPress blog. You may have to dust that thing off; some of you have not used it in a while. Write about the things you are struggling with. Share them with the community and find support among others. Post about your experiences. Tell us about your tough days and those small wins that are helping you get through this.</p>\n\n\n\n<p>For me, it is having my dad call to check in for the third time this week, and it is only Wednesday.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 25 Mar 2020 18:45:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"Matt: Don’t Mute, Get a Better Headset\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=51030\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://ma.tt/2020/03/dont-mute-get-a-better-headset/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11250:\"<p>One heterodox recommendation I have for audio and video calls when you&#8217;re working in a distributed fashion is <strong>not to mute</strong>, if you can help it. When you&#8217;re speaking to a muted room, it&#8217;s eerie and unnatural —&nbsp;you feel alone even if you can see other people&#8217;s faces. You lose all of those spontaneous reactions that keep a conversation flowing. If you ask someone a question, or they want to jump in, they have to wait to unmute. I also don&#8217;t love the &#8220;unmute to raise your hand&#8221; behavior, as it lends itself to meetings where people are just waiting their turn to speak instead of truly listening. I&#8217;m always hesitant <a href=\"https://seths.blog/2018/09/how-to-be-on-a-zoom-or-skype-call-the-secrets-of-video-conferences/\">to disagree with Seth Godin</a>, but that&#8217;s been my experience.</p>\n\n\n\n<p>So what should you do? Use the latest and greatest hardware and software to have the best of both worlds, a fantastic auditory experience for you and your interlocutors and little to no background noise.</p>\n\n\n\n<p>To summarize, <a href=\"https://www.amazon.com/s?k=sennheiser+usb-c+headset&tag=photomatt08-20\">I recommend a wired, USB headset with a mic that stays a constant distant from your mouth and has a noise-canceling microphone</a>. Save mute for coughs and sips of drinks.</p>\n\n\n\n<p>The rest of this post I&#8217;m going to try out eleven different microphones and headsets, ranging from $35 to $1,000+, and record a short file on each, and intersperse some software tips for people on MacOS.        You may want to listen to these samples with good headphones on to really hear the differences. I apologize some are louder than others, I didn&#8217;t edit to even out the levels, which Zoom or Skype would do automatically.</p>\n\n\n\n<p>My previous top recommendation was the <a href=\"https://www.amazon.com/gp/product/B00D4LBOV6/?tag=photomatt08-20\">trusty Sennheiser SC 30</a>, in <a href=\"https://ma.tt/2018/10/whats-in-my-bag-2018-edition/\">my previous bag posts</a>. It&#8217;s cheap and effective, but the cord was too long and it was USB-A. If you read no further, get this one and revolutionize how you sound on Zoom calls. Here&#8217;s how it sounds:</p>\n\n\n\n<div class=\"wp-block-columns are-vertically-aligned-top\">\n<div class=\"wp-block-column is-vertically-aligned-top\">\n\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-top\">\n<img />\n</div>\n</div>\n\n\n\n<p><a href=\"https://www.amazon.com/dp/B07P68C7Y7/?tag=photomatt08-20\">Sennheiser has upgraded to a USB-C version, with a much shorter cord, the SC 130</a>. It feels and looks much better, you don&#8217;t need a USB-C dongle, and the sound quality of the earphones is quite bearable. The cost is about twice as much (~$70).</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>You can plug the USB-C into your iPad or Android phone as well and it works great, though the headphones can be a bit quiet on Android. Either of the above will spoil you for making calls, and you won&#8217;t want to go back to the old low-fi way of doing things.</p>\n\n\n\n<p>In order to have a bit more flexibility I tried out the much more expensive ($134) <a href=\"https://www.amazon.com/dp/B00MPX2P0I/?tag=photomatt08-20\">Sennheiser MB Pro 1</a>. I liked the freedom of wireless Bluetooth, but you can hear that the sound is much worse. Connecting over Bluetooth lowers the quality a ton, and also occasionally means you need to disconnect, reconnect, etc.</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>All three of the Sennheisers above come in two-ear versions, which I prefer if I&#8217;m in a noisy environment, but at home I find the one-ear a bit more comfortable. I got excited about this $70 <a href=\"https://www.amazon.com/gp/product/B081Q5RCMV/?tag=photomatt08-20\">TaoTronics &#8220;Trucker Bluetooth&#8221; headset because it had Bluetooth 5.0</a> so I foolishly assumed it would have better quality, but it sounds really terrible:</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>But does wireless have to mean terrible quality? The <a href=\"https://www.amazon.com/dp/B07ZPC9QD4/?tag=photomatt08-20\">Apple Airpods Pro ($249) are actually pretty decent</a>, and you can easily switch them between your phone and your computer in the audio menu. If you haven&#8217;t tried the Pro version, the noise canceling is actually pretty amazing for something so small and light —&nbsp;I jog with them.</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>And one of the best sounding mics in this entire roundup was the wireless $119 <a href=\"https://www.amazon.com/dp/B07KQF165L?tag=photomatt08-20\">Antlion Audio ModMic Wireless</a>, which sound amazing, but you have to provide your own headphones to attach it to, and the entire thing ends up being fairly bulky and has its own wireless adapter. On the plus side, you can bring your own super-fancy headphones and get amazing audio quality. With certain headphones it did cause a buzz in the ear of the headphone I attached it to.</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>But hot dang that sounds good. If they made an over-the-ear USB-C version with an earbud, and had the mic be a little smaller, it would be work-from-home nirvana.</p>\n\n\n\n<p>I ventured into the gaming headset territory for this <a href=\"https://www.amazon.com/dp/B07HSC3WWL/?tag=photomatt08-20\">SteelSeries Arctis Pro Wireless Gaming Headset</a>, which at first felt totally ridiculous with its own connector box, a million cables, etc, but goshdarnit grew on me. It has this really cool boom mic   that extends out, and I think it&#8217;s the most comfortable headset I&#8217;ve worn for an extended amount of time. I tried it out via its proprietary 2.4ghz wireless connection + USB, and Bluetooth, and unfortunately the results weren&#8217;t great, including the Bluetooth being a little garbled. I hope Steelseries does another iteration because they&#8217;re <a href=\"https://twitter.com/photomatt/status/1242668323466350592\">so close</a>, it just needs to be USB-C on the headphones, the cables, the everything, and super high quality recording.</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n\n\n\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>One final entrant —&nbsp;how about just your laptop? Normally I would say this sounds terrible and judge people who didn&#8217;t use a headset, but <a href=\"https://daringfireball.net/2019/11/16-inch_macbook_pro_first_impressions\">John Gruber&#8217;s review of the new Macbook 16 had some really impressive audio files that intrigued me</a>, so here it is, the Macbook Pro 16&#8243;, which starts at about $2,400. It&#8217;s a little boomy, but not bad.</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>Okay now let&#8217;s get a little crazy. Here&#8217;s a <a href=\"https://www.amazon.com/gp/product/B00KCXMBES/?tag=photomatt08-20\">Zoom H5</a> with the <a href=\"https://www.amazon.com/gp/product/B00GXMTZE6/?tag=photomatt08-20\">SGH6 shotgun mic attachment</a>. (The other Zoom! $410 total.)</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>Next up is the <a href=\"https://www.amazon.com/gp/product/B0002E4Z8M/?tag=photomatt08-20\">Shure SM7B Cardioid Dynamic</a>, which is what I usually use to record the <a href=\"http://distributed.blog\">Distributed</a> podcast, and costs about $400. This is milky and smooth. (I accidentally called it a Sennheiser in the recording.)</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>A favorite <a href=\"https://tomdheere.com/voiceovers-and-my-sennheiser-416-the-not-silent-blog-52416/\">of voiceover artists everywhere</a> is the <a href=\"https://www.amazon.com/gp/product/B00030679K/?tag=photomatt08-20\">Sennheiser MKH416 Super-Cardioid Shotgun Tube Condenser ($1,000)</a>, which I like the sound of and I also use for if I&#8217;m doing a fancy video setup and want super-good sound that&#8217;s not in the frame of the camera.</p>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<img />\n</div>\n</div>\n\n\n\n<p>It&#8217;s a great sound, but the part of the house where I recorded all of these is pretty noisy with an AC unit on the other side of the wall, and there&#8217;s a ton of background noise in this.</p>\n\n\n\n<h3>Software eats the audio world</h3>\n\n\n\n<p>Just like photography has been completely transformed by software enhancing images to the point where the top-of-the-line Apple or Samsung smartphone camera is better than all but the very top pro SLR cameras, I think the same thing is going to happen for audio. </p>\n\n\n\n<p>None of these clips are processed, which is why some of the volume levels are different, but I thought it would be fun to demo a tool I&#8217;ve been recommending to a lot of people.</p>\n\n\n\n<p>There&#8217;s a <a href=\"https://krisp.ai/\">$40/year program called Krisp.ai</a>, which I first learned about in 2018 from this awesome post on the <a href=\"https://devblogs.nvidia.com/nvidia-real-time-noise-suppression-deep-learning/\">Nvidia developer blog, Real-Time Noise Suppression Using Deep Learning</a>. What it does is create a virtual microphone, like a filter that exists between one of your physical inputs and what the software on your computer &#8220;hears.&#8221; For fun I re-recorded the MKH416 in the exact same place, but filtered through Krisp.ai:</p>\n\n\n\n<div class=\"wp-block-columns are-vertically-aligned-top\">\n<div class=\"wp-block-column is-vertically-aligned-top\">\n\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-top\">\n<img />\n</div>\n</div>\n\n\n\n<p>Now the audio quality is not as good, it sounds a bit clipped, but throughout there is no more distracting background hums or noise. Krisp can be a little awkward to use but they&#8217;ve made it a lot more user friendly. You could mix Krisp with almost any option here and it would make it sound much better, in fact when I&#8217;m in a pinch my favorite go-to is Airpods Pro + Krisp.</p>\n\n\n\n<p>With everything, a pro tip on MacOS is to hold Option when you click on the sound icon in your upper right taskbar, and it will let you select both input and output devices. Sound Preferences, linked at the bottom of that menu, are your friend. If a mic is too soft you can boost the input volume in the preferences. To choose a camera or mic in Zoom, click the arrow next to the mute button in the bottom left. In Zoom audio settings, under Advanced, they are starting to expose a number of new options for real-time audio processing.</p>\n\n\n\n<img />\n\n\n\n<p>The future sounds good.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 25 Mar 2020 06:04:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"WordPress.org blog: WordPress 5.4 RC4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8444\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2020/03/wordpress-5-4-rc4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2393:\"<p>The fourth release candidate for WordPress 5.4 is live!</p>\n\n\n\n<p>WordPress 5.4 is currently scheduled to land on&nbsp;<strong><a href=\"https://make.wordpress.org/core/5-4/\">March 31 2020</a></strong>, and we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.4 yet, now is the time!</p>\n\n\n\n<p>You can test the WordPress 5.4 release candidate in two ways:</p>\n\n\n\n<ul><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.4-RC4.zip\">download the release candidate here</a>&nbsp;(zip).</li></ul>\n\n\n\n<p>For details about what to expect in WordPress 5.4, please see the&nbsp;<a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate post</a>.</p>\n\n\n\n<p>RC4 commits the new <a href=\"https://core.trac.wordpress.org/ticket/49295\">About page</a> and&nbsp;<a href=\"https://core.trac.wordpress.org/ticket/49688\">updates the editor packages</a>.</p>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme to 5.4. The priority in testing is compatibility. If you find issues, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>&nbsp;so we can figure them out before the final release.</p>\n\n\n\n<p>The&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a>&nbsp;is also out! It&#8217;s your source for details on all the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language besides English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 24 Mar 2020 22:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Francesca Marano\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: Yoast Publishes Free Online Training Course for the Block Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98052\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:193:\"https://wptavern.com/yoast-publishes-free-online-training-course-for-the-block-editor?utm_source=rss&utm_medium=rss&utm_campaign=yoast-publishes-free-online-training-course-for-the-block-editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5162:\"<p class=\"has-drop-cap\">Yoast, the company behind the popular Yoast SEO plugin, launched its free <a href=\"https://academy.yoast.com/courses/block-editor-training/\">block editor training course</a> today. The course is available to anyone by signing up for Yoast Academy, which also includes multiple other free and paid courses. Users can learn everything from SEO and copy writing to basic WordPress skills. The Academy team&rsquo;s latest course promises to get first-time users up to speed on using the block editor.</p>\n\n\n\n<p>&ldquo;At Yoast, we are huge fans of the block editor,&rdquo; wrote Marieke van de Rakt, CEO of Yoast in the <a href=\"https://yoast.com/new-free-online-training-block-editor-training/\">training course announcement</a>. &ldquo;Admittedly -not right from the start-, but we&rsquo;re now block-editor fanboys and fangirls. That&rsquo;s why we created an awesome free block editor course! We hope it will help everybody to use the block editor to the fullest!&rdquo;</p>\n\n\n\n<p>Currently, the course on block editor training has at least two or three hours of content to work through, depending on how quickly users digest the content. The course offers three major sections:</p>\n\n\n\n<ul><li>What is the block editor?</li><li>Using the block editor</li><li>Extras</li></ul>\n\n\n\n<p>Each of these is further broken down between one and three sub-sections. At the moment, there are seven lessons in total, which range between 7 and 49 minutes based on Yoast&rsquo;s estimated time.</p>\n\n\n\n<p>The courses are similar to taking a school class. The Academy team provides short videos that cover individual topics around the block editor. The team also provides a PDF version of the lesson for those who prefer text over video format. At the end of the lesson, users take a quiz and move on to the next lesson. A score of 80% or more is considered a passing grade.</p>\n\n\n\n<p>The team keeps each lesson digestible enough to complete in a short bout. Even if watching the videos, the PDF version of the lessons, which are high quality and have loads of useful information with links to third-party resources, are recommended reading.</p>\n\n\n\n<p>The team has provided a preview of the block editor course via YouTube:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n\n</div>\n\n\n\n<h2>Moving to the Block Editor and Building Training Courses</h2>\n\n\n\n<p class=\"has-drop-cap\">Joost de Valk, founder and CPO of Yoast, said the team would continue building on the training course over time as new features are added to the block editor. There are no plans to update it on a strict schedule, but the team wants to keep it current.</p>\n\n\n\n<p>Yoast, as a company, focuses on SEO. Therefore, some of the advice offered through the course puts focus on creating content that is useful for people and friendly for search engines. One of the primary topics the course touches on is publishing &ldquo;resources&rdquo; and how this is made better by the block editor. &ldquo;Resources are larger articles, evergreen content or in our SEO terminology &lsquo;cornerstone content&rsquo;: the stuff you want to rank within the search results,&rdquo; said de Valk. &ldquo;You can&rsquo;t just throw some words on a page and expect to rank anymore.  You&rsquo;ll have to try a bit harder.  Gutenberg makes that extremely easy.&rdquo;</p>\n\n\n\n<p>The Yoast team has been moving its massive site to the block editor over time. &ldquo;The post types I deal with regularly are all written with the block editor, but we might have some areas of the site that aren&rsquo;t there yet,&rdquo; said de Valk. &ldquo;It&rsquo;s a rather large site, with e-commerce, training, jobs, etc. all built into one giant WordPress multi-site install, so that was a bit of an undertaking. We always try to dog-food stuff though, so we moved everything over quite quickly.&rdquo;</p>\n\n\n\n<p>Getting the 11 million users who are using Yoast&rsquo;s products to make the switch is not quite as easy. Not everyone has embraced the block editor. &ldquo;The usage of the block editor is definitely improving, but it&rsquo;s not going as fast as we&rsquo;d like to see,&rdquo; said de Valk. &ldquo;We honestly think a lot of people don&rsquo;t understand the chances the block editor brings yet, one of the reasons for releasing this course and trying to help more people to start using it.&rdquo;</p>\n\n\n\n<p>The team&rsquo;s latest SEO course had over 10,000 signups within a week. While that number is a drop in the bucket in comparison to their full user count, it is promising. With a similar turnout for the block editor training course, it may convert more users from the older classic editor.</p>\n\n\n\n<p>Putting together full training courses is a large undertaking, but these are the types of resources the WordPress community needs moving forward. &ldquo;It&rsquo;s a lot of work,&rdquo; said de Valk. &ldquo;We have four people in our Academy team, a crew that records our videos, and our design team designs all the PDFs and slides within the videos. It&rsquo;s a non-trivial investment, but we&rsquo;re happy to make that if it helps make more people enthusiastic for the block editor.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 24 Mar 2020 19:47:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WPTavern: Block Patterns Will Change Everything\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=98017\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:139:\"https://wptavern.com/block-patterns-will-change-everything?utm_source=rss&utm_medium=rss&utm_campaign=block-patterns-will-change-everything\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6877:\"<img />Book sales section from a custom theme.\n\n\n\n<p class=\"has-drop-cap\">It was about a year ago. I was happily designing a theme for aspiring novelists. I wanted to get ahead of the competition and market a theme specifically to writers who would be attempting the National Novel Writing Month 2019 challenge.</p>\n\n\n\n<p>NaNoWriMo, for short, is a whirlwind of a month where 1,000s of people from around the world clatter away on their keyboards to pen a 50,000-word novel manuscript. One month of sheer willpower, coffee by the gallon, and sleepless nights in exchange for glory. There are no grand prizes or guaranteed publishing contracts at the end of the journey. You nab a certificate, a few coupons, and bragging rights. I completed the challenge in 2018.</p>\n\n\n\n<p>Inspired by my win just months before, I built a theme for those who would be taking the journey the following year. I also wanted to broaden its appeal to anyone who might be an aspiring novelist but not necessarily participating in the challenge. Or, maybe even to someone who just published their first book. Perhaps this would be an opportunity to bring a few new WordPress users into our community.</p>\n\n\n\n<p>I outlined a homepage layout to show how users could feature their latest book with a purchase button. Then, it dawned on me.</p>\n\n\n\n<p><em>How could someone build this book sales page without solid experience with the block editor?</em></p>\n\n\n\n<p>I had been using the Gutenberg plugin for months upon months before it landed in WordPress 5.0. I knew the ins and outs of the system.</p>\n\n\n\n<p>The design was simple. Using the core media &amp; text block, a heading, a couple of paragraphs, and a button, I had created something that may have been too complex for the average user. I had not even gotten into the custom color, font-size, and block-style options that accented the layout.</p>\n\n\n\n<p>This simple combination of blocks had the potential to be overly complicated for some. I had other plans for more complex layouts. Other theme authors had taken on bigger combinations of blocks. For end-users, they were likely stepping into a world that did not make sense. They would see beautiful theme demos and grow frustrated when they could not make things work. The block editor was not, and is still not, intuitive enough for the least-knowledgeable users to build layouts beyond the basics.</p>\n\n\n\n<p>I opted for a step-by-step tutorial to guide my users into building this <em>simple</em> book-selling section. However, documentation is not always the best answer. Even when users find and read it, the results are not always accurate. It would have been far simpler to have a button that, when clicked, inserted this section directly into the editor. The user could then customize it to fit their content.</p>\n\n\n\n<p>That is where <a href=\"https://github.com/WordPress/gutenberg/issues/17335\">block patterns</a> come in.</p>\n\n\n\n<p>Theme authors should be able to build unique and complex combinations of blocks with custom styles. Users should be able to just <em>make it look like the demo</em>.</p>\n\n\n\n<p>Since &ldquo;building&rdquo; (I use this term loosely) my first WordPress theme in 2005, I have either seen or attempted every manner of solution to this problem. Page templates. Theme options. Shortcodes. Widgets. You name it. They have all been tried before. Each method provided major hurdles for users. Some (<em>ahem, shortcodes</em>) left users&rsquo; content in shambles and created a lock-in effect where they ended up tied down to their theme.</p>\n\n\n\n<p>It is long past time for something new.</p>\n\n\n\n<h2>What Are Block Patterns and How Will They Improve User Experience?</h2>\n\n\n\n<img />Custom pricing columns section.\n\n\n\n<p class=\"has-drop-cap\">What happens when a user wants to build a layout with multiple columns of pricing options as shown in the above screenshot? Good luck. Most could not produce it with the block system. Even without block patterns, the theme would need some custom block styles to make it possible. Plugins will likely fill in the void for such complex output and have been tackling pricing tables in various ways over the years. What if we could produce layouts like this within themes or in much simpler plugins?</p>\n\n\n\n<p>It is possible with block patterns.</p>\n\n\n\n<p>Put simply, a block pattern is a group of blocks. Core WordPress, themes, and plugins will be able to register patterns with predefined settings attached to them.</p>\n\n\n\n<p>From the average user&rsquo;s point of view, block patterns are predefined sections they can use to create layouts. These layouts can be something as simple as the book section from earlier in this article to the more complex pricing columns. With these patterns available, users will be able to create complex layouts at the click of a button.</p>\n\n\n\n<p>The block system laid the foundation for a much different and forward-compatible future than what we have experienced over the years. At the end of the day, most blocks are just plain old HTML. Block patterns will be nothing more than the registration of a group of these blocks. When a user switches themes, their content remains intact, even when their new theme does not register the same patterns.</p>\n\n\n\n<p><a href=\"https://wptavern.com/gutenberg-7-7-ships-refreshed-ui-and-first-iteration-of-block-patterns\">Version 7.7 of the Gutenberg plugin</a> shipped the first iteration of an interface for patterns. It is basic and will undergo several more iterations before it is ready for use in production. Eventually, there will be a fully-integrated interface for selecting from multiple patterns. The user sees something they want to use. They click on that pattern. It gets inserted into the post.</p>\n\n\n\n<p>No more complicated theme options. No more shortcode soup. No more hours of frustration wondering why you cannot build that custom front page shown in that carefully-crafted theme demo.</p>\n\n\n\n<p>I may be a tad optimistic. Block patterns will require massive buy-in from the theme and plugin developer community. While core WordPress will ship several popular patterns by default, they will in no way cover the breadth of design that is possible when theme authors put their artistic skills to work.</p>\n\n\n\n<p>I have always been excited about the block editor. However, it has always felt like I was more excited about the <em>potential</em> than the end product. I was in a constant state of waiting for it to become the thing I thought it could be. Yes, I am still waiting. However, tinkering with an early version of the pattern system feels like we are getting to the point where we can do those awesome things the editor was supposed to allow us to accomplish. It has been a long wait, and we still have a bit to go. But, I have a renewed passion for the project after experiencing the work that has been done thus far.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Mar 2020 20:12:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WPTavern: Still No Wood Grain: WP Tavern Design Update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97987\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:151:\"https://wptavern.com/still-no-wood-grain-wp-tavern-design-update?utm_source=rss&utm_medium=rss&utm_campaign=still-no-wood-grain-wp-tavern-design-update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2924:\"<img />WP Tavern homepage design.\n\n\n\n<p class=\"has-drop-cap\">It has been a bit of a slow news week in the land of WordPress with the COVID-19 pandemic reaching across the globe. Most people are hunkering down or getting accustomed to a change in their daily lives. For some people, that has meant figuring out a way to work with children at home. For others, it has meant they cannot take their daily lunch with colleagues or friends.</p>\n\n\n\n<p>With far less WordPress-specific news going on, it made for an ideal time to put some work into the WP Tavern website. Most weeks, I am far too busy sifting through stories to put the amount of work I want into updating the design, but I am trying to treat this week as a little bit of a blessing and look at the upside.</p>\n\n\n\n<p>Not much has changed with the overall layout of the site, but I was able to tackle a couple of issues that you, our readers, have been asking for.</p>\n\n\n\n<p>The biggest change that you will notice is a new header design. On mobile devices, it will look the same. However, on larger screens, the header expands to reveal a search form with a navigation menu below. The header colors have been updated. With more horizontal space, the menu also has extra links pointing to our primary categories, which has also been an oft-requested change.</p>\n\n\n\n<p>While these changes may seem minor, I wanted to address some of the bigger user-experience issues that you all have messaged about. There is still more work to do, but I want you to know that we are listening to your feedback.</p>\n\n\n\n<p>The major roadblock with this design iteration was related to the block editor&rsquo;s markup changes. These changes will <a href=\"https://wptavern.com/preparing-for-wordpress-5-4-changes-theme-and-plugin-developers-should-know-about\">land in WordPress 5.4</a>, so theme authors need to make sure they are prepared.</p>\n\n\n\n<p>I wanted to spend more time working on front-end updates, but correcting editor issues took precedence. It has not been a great experience writing on the site for the past week without theme styles being properly applied. The block editor&rsquo;s default font size is far too small for my poor eyesight, so backend work moved to the top of the to-do list.</p>\n\n\n\n<p>Aside from those changes, I cleaned up several trivial issues that have been bugging me but would go unnoticed by visitors. Work on a website design is never finished, and I look forward to continuing molding things to better serve our readers.</p>\n\n\n\n<p>One of the things I want to tackle next is featuring comments from you all in better ways. We have done a little of this with our <a href=\"https://wptavern.com/category/from-the-comments\">From the Comments</a> series, but that is just the first step toward building more of a community atmosphere. As always, feedback is welcome.</p>\n\n\n\n<p>Everyone stay safe during this rough patch the world is going through.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 20 Mar 2020 20:09:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: Block-Based Themes and the Problem with Dynamic Data in HTML Templates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97955\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:205:\"https://wptavern.com/block-based-themes-and-the-problem-with-dynamic-data-in-html-templates?utm_source=rss&utm_medium=rss&utm_campaign=block-based-themes-and-the-problem-with-dynamic-data-in-html-templates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6431:\"<p class=\"has-drop-cap\">The Gutenberg project and its eventual full-site editing feature is coming upon a major issue that will need to be solved. <a href=\"https://wptavern.com/initial-documentation-for-block-based-wordpress-themes-proposed\">Block-based themes</a> of the future are currently on a path toward a template system that will comprise of plain HTML files. While that will work for the majority of a theme&rsquo;s output, the trouble is figuring out how the project will handle dynamic values.</p>\n\n\n\n<p>Most of the discussion has centered on handling URLs, which are probably the most common use case. Currently, theme templates have all sorts of dynamic content. Much of that will be replaced with blocks as we continue moving toward full-site editing. However, not all dynamic data will have a block equivalent.</p>\n\n\n\n<p>A good example is that theme authors cannot currently add the <a href=\"https://github.com/WordPress/gutenberg/issues/20542\">homepage URL to the navigation block</a>. Some experimental block-based themes are using a simple <code>/</code> character, which points to the wrong location on many WordPress installs.</p>\n\n\n\n<p>Solving this issue sooner rather than later is important for the progression of theme development in a block world. However, such a solution needs to be carefully crafted so that the theming community is not bogged down by a decade or more with a poor templating implementation.</p>\n\n\n\n<h2>The Current Proposals</h2>\n\n\n\n<p>The Gutenberg repository currently has an <a href=\"https://github.com/WordPress/gutenberg/issues/20966\">open ticket for discussion</a> on handling dynamic values in templates. At the moment, there are four proposals on how to address the issue.</p>\n\n\n\n<h3>On-the-Fly String Replacement</h3>\n\n\n\n<p>One solution would be to use PHP to parse each HTML file and replace strings representing dynamic data on the fly. This would require parsing all of a theme&rsquo;s templates on every page load. The downside is that it would slow down the page load. We would need real unit tests to see how much of a spike in loading time this method creates.</p>\n\n\n\n<p>Assuming a <a href=\"https://mustache.github.io/\">Mustache</a>-like syntax, templates would have values such as the following image output:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>&lt;img src=\"{{ theme_image_example }}\" /&gt;</code></pre>\n\n\n\n<p>One added benefit of adopting such a solution is that WordPress could automatically escape these dynamic values by default. This would be a boon to theme security, which is one of the <a href=\"https://wptavern.com/data-from-theme-reviews-shows-authors-need-more-education-on-developing-secure-wordpress-themes\">biggest issues faced by the theme review team</a>.</p>\n\n\n\n<h3>One-Time String Replacement</h3>\n\n\n\n<p>The second solution proposes using the same method but parsing the HTML files once, upon theme activation, and replacing dynamic values with proper values. The largest benefit of this method is that the parsing would not affect front-end loading speed.</p>\n\n\n\n<p>This method is problematic because it does not account for changes to templates after the initial parsing. It also does not handle scenarios when a value changes via user input. For example, a user may decide to change the location of their blog posts page. Therefore, a parsed URL that becomes static would point to the wrong location.</p>\n\n\n\n<h3>Templates as JSON</h3>\n\n\n\n<p>A third solution proposes the idea of turning theme files into JSON. It is far easier to parse and extract data from a JSON file than and HTML file. However, theme designers do not write JSON to build template output. HTML exists for a reason.</p>\n\n\n\n<p>This solution would raise the barrier so high for new theme authors that it would be rare for those who just learned basic CSS and HTML to get into WordPress theme development. This idea is so foreign to the idea of template design, that it should not be a serious consideration.</p>\n\n\n\n<h3>Templates That Return Blocks via PHP</h3>\n\n\n\n<p>The fourth and final proposal is to use PHP files with a function that returns a block template. This method would be straightforward and could be picked up easily for existing theme authors who have a familiarity with PHP.</p>\n\n\n\n<p>A template would look something like the following:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>function my_theme_front_page() {\n	return \'&lt;!-- wp:cover {\"url\":\"\' . get_template_directory_uri() .\'/block-background-image.png\",\"id\":273,\"dimRatio\":0,\"minHeight\":647,\"align\":\"wide\"} --&gt;\';\n}</code></pre>\n\n\n\n<p>This idea puts more focus on PHP than HTML. It would be the easiest-to-implement solution for the Gutenberg development team. However, like the JSON method, it would raise the barrier to entry for first-time theme authors. It will mean making sure quote and double-quote characters do not get mixed up. The method would be prone to bugs and looks alien to modern-day templating.</p>\n\n\n\n<h2>Templating Should Focus on HTML</h2>\n\n\n\n<p>Templating should always be HTML-first. Even in our current theme system, theme authors can build beautiful, safe, and functional themes by simply knowing HTML and CSS. PHP is secondary, especially when it comes to the templating aspect. Our templating system relies on knowing HTML and plugging in a few <em>template tags</em>, which are PHP functions that WordPress provides for dropping in between HTML tags. This simplicity is, in part, what made WordPress theme development so easy to learn for anyone willing to put in a little time.</p>\n\n\n\n<p>Block-based themes have the potential to drop the barrier even lower than our current templating system. However, templates as JSON or PHP functions runs counter to that. Any solution that pushes us farther away from the basic building blocks of the web, HTML, should not be on the table for discussion.</p>\n\n\n\n<p>It may be time to adopt a proper PHP templating engine. There are plenty of examples out there. <a href=\"https://twig.symfony.com/\">Twig</a>, <a href=\"https://laravel.com/docs/5.7/blade\">Blade</a>, <a href=\"https://www.smarty.net/\">Smarty</a>, and others have existed for years. Those also have some barrier to entry in the form of new syntax, but this should be no tougher than learning to plug template tags into the current system.</p>\n\n\n\n<p>At the very least, we will need to figure out a solution for handling dynamic data in what is essentially static HTML files.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 19 Mar 2020 20:37:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Matt: Physical Distancing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=51063\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"https://ma.tt/2020/03/physical-distancing/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1303:\"<blockquote class=\"wp-block-quote\"><p>I&#8217;ve really had enough of this term &#8220;social distancing.&#8221; That is not at all what we are looking for, is it? It should be &#8220;physical distancing.&#8221; In these times of rampant loneliness (especially for seniors), disconnection, and lack of empathy and compassion, we need the opposite — social connecting. And we need it under these circumstances more than ever. Let&#8217;s be creative in finding new ways to come together.</p><cite><a href=\"https://gazzaley.com/\">Adam Gazzaley</a>, M. D., Ph. D, University of California, San Francisco</cite></blockquote>\n\n\n\n<p>Update: On March 20th, the World Health Organization has officially updated it&#8217;s recommendation to &#8220;physical distancing.&#8221;</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">WHO is changing the phrase \'social distancing\' to recommend \'physical distancing,\' encouraging people to stay connected via social media. Live updates: <a href=\"https://t.co/cEBwkonfeh\">https://t.co/cEBwkonfeh</a> <a href=\"https://t.co/csWTpViUQh\">pic.twitter.com/csWTpViUQh</a></p>&mdash; Reuters (@Reuters) <a href=\"https://twitter.com/Reuters/status/1241058736501858304?ref_src=twsrc%5Etfw\">March 20, 2020</a></blockquote>\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 19 Mar 2020 03:26:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"Post Status: Taking care of your mental health in uncertain times, with Dr. Sherry Walling\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=78135\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://poststatus.com/mental-health-dr-sherry-walling/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:57908:\"<p>Dr. Sherry Walling is a psychologist and entrepreneur adept at &#8220;helping smart people do hard things.&#8221; She was gracious with her time in this Post Status Webinar with Cory Miller, where Dr. Walling explained how to navigate life in uncertain times.</p>\n\n\n\n<p>Here\'s the audio episode:</p>\n\n\n\n\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<div class=\"embed-vimeo\"></div>\n</div>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h3><strong>Topics discussed </strong></h3>\n\n\n\n<ul><li>Managing fear, worry, and anxiety.</li><li>The coronavirus (COVID-19), and how to handle it.</li><li>Isolation, social distancing, remote work, and mental health.</li><li>Q&A; on work boundaries, stress, and more.</li></ul>\n\n\n\n<h3>Cory\'s Takeaways</h3>\n\n\n\n<ul><li><strong>Take some big deep breaths: </strong>Do Dr. Walling\'s 4&#215;4 breathing exercise: four slow seconds in, four slow seconds out. </li><li><strong>Refocus on gratitude: </strong> Make a list of what are you thankful for.</li><li><strong>Have the worry voice inside you make an appointment: </strong>Put it on a schedule that\'s not 24/7. Listen to it for a set time; it’s there to protect you, but once its time is up, move on.  </li><li><strong>Connect with others daily:</strong> Social distancing doesn’t mean losing connection. Use FaceTime, Zoom, etc, and schedule a virtual Lunch or Snack. </li><li><strong>Have playtime: </strong>Whether that’s playing with Legos, cooking, or pulling our your old musical instruments. </li><li><strong>Get your heart rate up with exercise:</strong> Have a family dancing competition, do yoga or pushups.</li><li><strong>Limit your news consumption to 15 minutes a day.</strong></li><li><strong>For single people living alone and missing physical touch:</strong> Find a soft, comfortable, and perhaps a heavy blanket, or take a hot bath. </li><li><strong>For entrepreneurs:</strong> Remember, you can’t do everything yourself and you can’t fix everything by yourself. We’re all in this together, especially your team: &#8220;Leadership means you\'re hosting the conversation. You\'re listening. you\'re engaging, it doesn\'t mean that you are the ultimate decider.&#8221; </li></ul>\n\n\n\n<h3>Links</h3>\n\n\n\n<ul><li><a href=\"https://mastermindjam.com/\">Zen Founder</a></li><li><a href=\"https://sherrywalling.com\">Dr. Sherry Walling\'s website</a></li><li><a href=\"https://twitter.com/zenfounder\">@zenfounder</a> — Dr. Walling\'s Twitter</li><li><a href=\"https://zenfounder.com/episodes/episode-235-calm-stability-in-the-crisis-of-coronavirus/\">Calm Stability in the Crisis of Coronavirus</a> (ZenFounder podcast)</li></ul>\n\n\n\n<h3>Episode Partner: <a href=\"https://poststat.us/sandhills\">WordFence</a></h3>\n\n\n\n<p>If your website is mission-critical you can\'t afford the downtime, reputation challenges or SEO impact of getting hacked. That\'s why so many sites rely on the real-time protection provided by&nbsp;<a href=\"https://poststat.us/wordfence\">Wordfence&nbsp;Premium</a>.</p>\n\n\n\n<p><a href=\"https://poststat.us/wordfence\">Wordfence</a>&nbsp;protects your websites with the best WordPress security available and offers a powerful and efficient way to manage security for multiple sites in one place with&nbsp;Wordfence&nbsp;Central.</p>\n\n\n\n<h3>Full Transcript:</h3>\n\n\n\n<div class=\"transcript\">\n\n<p><strong>Cory:</strong> Hey, everybody, my name is Cory Miller and I am pumped to have my good friend Dr. Sherry walling. Here Today she is an experienced psychologist has worked with all types of people across the spectrum in particular how we got to know each other is her work with entrepreneurs. She is an entrepreneur, she happens to be married to a serial entrepreneur, but I love the breadth and depth of her experience, particularly with trauma. And so, amidst the circumstances, we find ourselves today, I texted Sherry and said, Would you do a q&#038;a? Would you just have a conversation with me? And she said, &#8220;Absolutely.&#8221; Sherry, thank you for the time today. This is vital that we keep this conversation on and I appreciate you be willing to share your experience and expertise with whoever\'s on the webinar today.\n\n<p><strong>Sherry:</strong> Yeah, thanks so much for asking. Cory and I had — we\'ve had — lots of conversations related to mental health and the need for an open conversation about mental health in entrepreneur communities that we kind of live and work and breathe in. So I\'m always grateful for the way that you are hosting conversations where people get to be honest about what they\'re needing and what part and also share what\'s helpful.\n\n<p><strong>Cory:</strong> Absolutely. Well, just if you join And you can help me help others as they join the webinar late perhaps, and I\'m talking to our attendees, that little button that says q&#038;a on the bottom zoom, hit that and ask a question along the way, but Jerry and I are just going to geek out and have a conversation. And so I\'m glad you can join us for it. Okay, Doctor,\n\n<p><strong>Sherry:</strong> —this is also what it\'s like to have a coffee with Cory and me, by the way.\n\n<p><strong>Cory:</strong> Exactly. Okay, doctor. The world is a little bit chaotic right now.\n\n<p><strong>Sherry:</strong> Yeah, I noticed.\n\n<p><strong>Cory:</strong> Um, I feel like this. This conversation is pertinent because right now, if we just kind of stay, here\'s where I\'m going at what I\'m going through. I\'ve got two kids and now you\'ve got three. Were quarantined. No school for the foreseeable future. They\'re talking about in Kansas, for instance, I think shutting down school for the end of the year. End of the school year. There\'s, I don\'t even want to look at my stock market equities stuff. Um, what are you feeling?\n\n<p><strong>Sherry:</strong> You know, I think I go up and down probably like everybody else. So the pain point just for me personally right now is that I am continuing to work my husband is continuing to work because thankfully both of us still have work to do. And both of us have jobs that are fairly possible to do from home. But now we have all three of our children home off the road children who go to three different schools who are now trying to throw together online education over a weekend and you know, all of us who do work on the internet can appreciate that that\'s not very easy to do. So all my kids are like, how do I like it? How do I do this, how to do that, like nobody, none of the systems are flowing and that is, of course unnecessary. In where the best case scenario you\'ve got two parents who are used to working from home and are flexible and things like that. So the bottom line is that there is no normal anymore for a while for anyone. And so there\'s a great deal of as you know, just anxiety and the need to be able to be extraordinarily flexible in a way that none of us are used to doing because especially those of us that run businesses we plan we look at spreadsheets, we think we\'re strategic, and all of those bands are not relevant right now for the foreseeable future, which is extraordinary—\n\n<p><strong>Cory:</strong> So the one emotion I guess, that comes to mind in all of this and I\'m speaking from personal experience here is fear. I think it was the first word I mentioned to you — so much fear — some of it just fear on fear, you know, just accounting fear. You can\'t go online or watch TV without being just bombarded about it. So if you had a microphone right now and the entire world could hear it and all their native languages and stuff, when we talk about fear, and fear produces anxiety, all this stuff. We can\'t we can get frozen in it. What? What\'s something you would say?\n\n<p><strong>Sherry:</strong> I mean, in a way, I think we\'re all feeling it in our bodies. Like when even you say the word fear, like your la just kind of gets tight. Your chest gets heavy, it\'s hard to breathe. And on one hand, it feels really disingenuous to say don\'t be afraid. But on the other hand, we are all in the same boat and we will all All survived one way or another together. So I think the extent to which we can slow down that fear response and breathe and look around to see what is directly controllable which, you know for many of us is our bodies you know have gone on a walk today joining me to lay down for a nap What does my body need at this moment? Do I need just a really big glass of water, like the really, really simple things that are directly controllable help to counterbalance this sense of fear which comes from being out of control? And so getting really specific, slowing down, keeping life as simple as possible. They sound so simple, but of course, when we actually try to put them into practice, they\'re profound and somewhat difficult. But the, you know, the fear is in and of itself, its own problem. So turning down that fear even if it\'s well-grounded fear I\'m I mean, I\'m under No, no delusion that everything is fine. Everything is not fine, but the fear doesn\'t help.\n\n<p><strong>Cory:</strong> Yeah, there\'s so much in there I want to impact. So when I think it was like a couple of days ago kids were home because of spring break here in Oklahoma. And we\'re looking at Oh, man, will they go back to school? markets, all that stuff. And I remember walking out that night and just looking at the beautiful sunset and going, the sun is still setting in the next morning when I woke up is still rose again. It\'s this weird thing. I guess we haven\'t told the son that there\'s a chaotic thing happening right now. But some of those things. One I think you just give us freedom and permission to know that fear is a human experience. But I like the words you said there — &#8220;what are the things we can control?&#8221; And I\'m probably an admitted control freak. What are some of the prompts you ask yourself or your clients or others about that I want to get to? &#8220;Walk&#8221; and &#8220;sunshine&#8221; and all that because I know there\'s a big word called &#8220;play&#8221; that you love, you\'ve helped introduce back to me. But, you know, for me, it\'s fun. It feels like okay, what can I control? You know, our responses potentially to freeze in the fear, let it compound and just suffocate us. And I go, what are the things I can\'t control? What are the things I know are fact like, you know, the sun setting and rising the next day?\n\n<p><strong>Sherry:</strong> Yeah, I mean, I do think we can, we can control our body, sleep, food movement, we control our breasts, the ability to take slow deep breaths, we can control our thoughts. To some extent, and we can go back to breath in a minute, you want to talk more about that. But like, we can control our thoughts to some extent. And that\'s, that is the thing that I think feels really difficult right now. Because I know like you like my instinct is like, every time I pick up this magical device to be like, how many more? How many more cases are there? What\'s the market doing? Like, you know which borders are closed, which is open. You know, there\'s so much and I think some of the control that we all want to exert right now is to really limit the amount of factoids and information that we\'re, we\'re accessing right now. Like, obviously, it is an important time to have good healthy information on which to make decisions, but the amount of information is, is really not helpful. So 15 minutes in the morning, 15 minutes a night should probably do, yeah, you don\'t need to have your newsfeed buzzing all day. So controlling titrating turning up and down the volume around which you\'re exposed to information is helpful, that helps control your thoughts. Even specifically skewing your thoughts one way or another. I mean, his is the best time in the world for our gratitude practice, again, not because we need to walk around pretending it\'s all sunshine and roses, but because right now we\'re on this call and we\'re all breathing. And we\'re all okay so far. And that, in and of itself is I think going to become profoundly important to remember the things that are going well the things that are intact, the things that we can be grateful for. That helps to put some parameters around the power of fear to begin to sort of control our minds.\n\n<p><strong>Cory:</strong> Yeah, I love that. The things you just mentioned are all just so simple. I think we have a tendency to &#8230; skim over them, but the fact that we can just take a breath and gratitude. I hadn\'t had that on the list before we talked, but gratitude those are things we absolutely control. In the past groups you and I have done together, you\'ve really led. You really talk about the breath. And I know, yoga is a deep part of your life. I know. And that is not all about the breath. But you know, I know this is something we all have at our disposal right now, as you just said. Can you share some practices, some thoughts about that?\n\n<p><strong>Sherry:</strong> So the super-fast version of the science is that there\'s this thing called the vagus nerve, which is based in our brainstem and then goes all the way throughout our bodies and after these tendrils of connection and all of our major organs, and that\'s a part of their bodies that declares all as well. So after we have that anxiety response, it\'s the vagus nerve that signals Okay, we\'re good now, like the tiger is not going to eat us today. And that is the part of the body that in a way we kind of want to hack those of you who coders here, do you want to hack to be able to say, Okay, I need to take my body into palm because my body\'s been living in fear. Anxiety too long. So the breath is this strategy that we use to help signal the all-clear sign to end the emergency response. You think about, it\'s almost impossible to be really upset and breathe really slowly there. There\'s kind of antithetical physical realities. So when we can engage our vagus nerve through deep, slow breath, we\'re essentially sort of pushing the dominoes to fall toward calm both in our mind and in our physiological reality. So the simplest practice, like the Easy, easy way to do this, is I call it it\'s just four by four breaths. So it\'s four seconds in, four seconds out, for birth should begin to turn the tide. It doesn\'t have to be this deep, 30-minute sort of meditation where you go into some existential Zen Nirvana place. Just really, that was a terrible cultural statement, I\'m sorry, but four deep breaths. And the breath should be low and slow, which means we\'re pulling the breath all the way down into our belly or diaphragm and slowing it down. So lots of like apps and YouTube things about this. We can end with a breath practice if we have time. But it\'s beyond yoga and meditation. It\'s just really, really great concrete science to help counteract that anxiety response.\n\n<p><strong>Cory:</strong> Well, this is something you know, I\'ve read navy seals and combat. They control their breath. They weren\'t maybe before but you know, they weren\'t. So think about that in crisis. That first instinct is to take a big deep breath, but I love the former for practice, Southern by—\n\n<p><strong>Sherry:</strong> I didn\'t learn that in yoga, I learned it working in with the military. Oh, that\'s right. That\'s right.\n\n<p><strong>Cory:</strong> Well, I\'d invite everybody right now and your own while we\'re talking. Let\'s do that the four by four, four slow, deep breaths in, slip four out. We\'re going to continue your conversations because I\'ve got a lot to talk this year about, by the way, and I\'m glad you\'re eavesdropping on our conversation. gratitude. It\'s that one that it\'s like, I know the science the studies are there. And it\'s that one that man, I just — my mind just wants to focus on all the junk, all the chaos. But it\'s kind of like that you\'re the former for deep breath is telling you. I love your statement there. It\'s hard to do both of these negative and positive things at the same time. So it is to pick feels that way was gratitude too, though. Yeah.\n\n<p><strong>Sherry:</strong> I think when you\'re when you\'re acknowledging, making a list three to five things that you\'re grateful for. And that can be the fact that hey, I don\'t have to go to the doctor today. Or, you know, my kids are able to relate lead. So worst-case scenario can give him a book and we can call that school I mean there it can be really, really simple things it\'s pretty impossible to feel like everything is horrible when you can find those five things to be grateful for. So even you know, those of you who live with other people this is a great practice for the dinner table. When I was growing up, we would begin our meal with a prayer my family doesn\'t practice that tradition anymore, but we do begin our meal with a gratitude, and so each of our children will go around and just say one or two things that that are they\'re thankful are happening right now.\n\n<p><strong>Cory:</strong> And what a great pair with the breathing you know, finding yourself going down the anxiety true deep, getting lost into feeling suffocated, whatever those sensations are, but then going back to the breath and gratitude. I think you\'re just really fantastic. You know, worry. So one thing that comes to mind for me is when something happens, I go catastrophe mode. And another fancy phrase, phrase for this is cognitive distortion, I believe cognitive bias traffic—\n\n<p><strong>Sherry:</strong> —traffic thinking, yeah.\n\n<p><strong>Cory:</strong> And I would bet you money that a lot of people go cash-free to, like the markets crashing, my 401k is screwed. Like, I\'m not going to be rich, I\'m going to be working until I\'m 110 I live that low kind of thing. And that feels like something when we talk about worry is that our mind can it can work against us, too. What are some thoughts about that? My mind goes racing, I got a contest free I got a Yeah, you know, there is no I mean, the world is, you know, ending in my mind. I can see it all — all the bad things that could potentially happen. And how do I, how do I reset? I mean, we\'ve just talked about breath for sure and gratitude, but how do we combat some of the — I call it my inner jerk.\n\n<p><strong>Sherry:</strong> So I have maybe a little bit of a different take on that, especially right now, which is to like, let your inner jerk have his moment. So, you know, it\'s to sort of maybe sit down with Lindsey or meet with my husband, Rob, sort of say like, what is the worst-case scenario? Like? If we haven\'t, you know, to basically put it on your calendar, we\'re going to have two hours of catastrophe planning. And we\'re going to talk about all of the things that are going to fall for us it meant we like updated our will, you know, like, hey, both of us died from this virus who\'s going to watch our kids who haven\'t done in a while. We bought a hand-crank radio. So I don\'t know how the power is going to go out from coronavirus but like, you know, we have one in the basement now. So it\'s basically acknowledgment that you call it the jerk but like the sort of paranoid voice. So it lives in your head, is there as an attempt to protect you? Like, he\'s not really a jerk? He\'s just like, hey, Cory, are you paying attention? And so when we give them a moment and sort of say, Okay, what do you need to tell me? You know, and what can I possibly do with what is within my control my power to prepare for the end of the world? There might be some things, right you know, we have a really stupid radio thing, we have more batteries that we need, canned food &#8230; So I would say make an appointment with your, the crisis manager that lives in your head and give he or she a couple of hours of your focused attention and follow whatever recommendations are reasonable and you can reasonably do and then when that voice resurfaces, you can say &#8220;it\'s cool, dude, I got the hand-crank radio in the basement, like we did that, yeah, we have a water filter, you know? Or, you know, we\'ve got some gold or you know&#8230;&#8221; Certainly, lots of these scenarios we can\'t perfectly plan for. But I think when we give that alarmist voice a little bit of airtime and make a plan accordingly, it helps to sue that more than just sort of push it down and say, Stop, stop, stop, stop, stop. You\'re a jerk because I don\'t know I don\'t think he\'s a jerk or I think he\'s just trying to help you out.\n\n<p><strong>Cory:</strong> Yes, a jerk voice though sometimes, but yeah, we\'ll get no I love that because I think there\'s this sense insane, like, make an appointment, bro. And then just my counselor a couple weeks ago, I was stressing about something like catastrophe. It wasn\'t related to this. Because Okay, tell me what you\'re gonna do. Keep going down the cash-free room. Okay. And I went dark and I went deep, and I started the video. Kind of laughing because I could hear myself say things and go do I really think this catastrophe is gonna happen? But I love your advice is that I mean there is some there\'s probably some sense of safety. I\'m just thinking like, I want to go by hand-cranked radio, you know, but like I think there\'s some sense of like you\'ve acknowledged it like you said, but also go in your head. There\'s a hand-crank radio, by the way. Hey, remember, I did listen to you. He may not be perfect for FEMA executive director, but you\'re helping me and I think what you\'re saying to Sherry is acknowledging that that also is natural that that inner the prey maybe not so jerk. She\'s there for good reason too.\n\n<p><strong>Sherry:</strong> The alarm is protection has a role. We don\'t let it go crazy, but it doesn\'t also help to sort of shove it in the closet.\n\n<p><strong>Cory:</strong> Yeah, then just pulls up even probably worse, when when you don\'t, you know, let these human things part of being human, kind of acknowledge them and, you know, thousands of years ago were in us biologically to help us survive and I think that\'s good. Okay, so we\'ve talked about fear worry, there\'s some in that I think some of the uncertainty and some really good ways to tackle that. So let\'s switch gears just a tad in the situation we find ourselves in we just acknowledge like, you\'ve got three kiddos. I\'ve got two kiddos were sequestered at home, you know? Yeah. So it\'s, it\'s crazy. You know, Sherry have talked so long about that, trying to provide resources into the world that says I\'m not alone. Yet this phenomenon that\'s trending which is a good reason for this particular this pandemic is social distancing. But we\'re sequestered in our house. You know? So this the situation we\'re in, I want to talk about parenting to and spouse, significant other roommates, all that. But, yeah, isolation. I mean, we have to oscillate in order to flatten that curve and do the right things and everything but there\'s a real phenomenon that we\'re pushing deeper into, which is isolation, social distancing, which is good for maybe a virus but not for our emotional high.\n\n<p><strong>Sherry:</strong> Yeah.\n\n<p><strong>Cory:</strong> What are your thoughts about we\'re in our bunkers, right? We\'re in right we\'re told don\'t high five and hug. Yeah. Don\'t go Yeah, middle of groups, whether it be churches or groups for instance, or, you know, our workplaces. were told to go isolate like&#8230;\n\n<p><strong>Sherry:</strong> — and that is where, you know, again, this magical device in my hand becomes really powerful because I can still FaceTime my mom in California. And, you know, I\'m having, you know, a zoom snack later with my friend Anna. Like, I think that register zooms back. We\'re not drinking right now. So we\'re having Zoom snacks instead of Zoom drinks. But I think that, you know, the danger is that we mistake Facebook feed or twitter feed for connection. And there\'s a utility there, but it\'s not the kind of connection that we\'re craving. But if we get on the phone, get face to face, over the devices, with friends with people, we love that that\'s still a way to have a really meaningful connection that we all desperately need. Even the kids need, you know, my kids are facetiming a lot more people than normal. So, so Social distancing is about, you know, spreading germs. It\'s not about our hearts and our minds. social connection is as important if not more important than it\'s ever been before. And that\'s where technology is suddenly really, really helpful for all of us. But the thing that I want to stress is that it\'s intentional. It\'s connected, it\'s heart to heart. It\'s not just like reading the highlight reel on Facebook. Like that\'s not the kind of connection that we all necessarily need. It\'s the appointment. Let\'s sit down and talk. Tell me how you\'re feeling. What\'s driving you crazy. What are you grateful for? What\'s bringing you joy right now?\n\n<p><strong>Cory:</strong> Those are great questions, like, just phone a friend or having a zoom snack. What\'s bringing you joy right now? What do you mean? You just, I see your Taekwondo here. You\'re a ninja. You\'re like, okay, ask the question. Maybe it\'s a conversation with someone who is a dear friend. Some of you haven\'t talked to a loved one. Back to the gratitude. Hey, can we have a deep breath together? I love that. Someone and by the way, let me just take a moment to say if you have a question, hit the Q&#038;A button at the bottom of the Zoom window. And you can ask an anonymous question. A couple have come in. I\'ll take those in just a minute. But one of them said, Sherry, I really liked this distinction. Any thoughts on tape, changing the term social distancing to physical distancing? You can still be social. But yeah, it\'s there. There\'s a physical distance — \n\n<p><strong>Sherry:</strong> —allotted for it. Yeah. \n\n<p><strong>Cory:</strong> Yeah. I like that distinction. So maybe, I mean, I tend to think share a —  try to think — take problems and see the opportunity in it. And you know, there\'s probably some kind of sunshine quote, I should figure that out. You know, like, every Rain, Rain is the rainbow or something. But there are opportunities were sequestered. It might be an opportunity where we\'re not in a busy office or having to run around like, you know, take kids to school and practice that we\'ve got a little bit more time to And can use that to reach out to somebody we haven\'t. And, and I really, really, really like that and using technology, not trying to replace it. But right now it\'s a, it\'s an opportunity we have FaceTime is free soon, I\'ll have your zoom snack thing. So&#8230;\n\n<p><strong>Sherry:</strong> Yeah, it\'s a good time to make a list of a couple of people who you haven\'t talked to in a while or who might be having a rough time of it. You know, I, I know my mom is quarantined all by herself in her big house in California. And she\'s, you know, when can come and no one can go and that\'s, so we\'re talking every day and we don\'t normally talk every day. And like, my yoga teachers and my kids, music instructors, like people who are really woven into the fabric of our lives, who have no income, all of a sudden, I\'m sending them notes. So I think you know, we can again, we can change our frame of mind to say who needs a virtual high five, who needs a little reach out, who\'s going to be lonely? And I think that also helps our own mental health when we realize there\'s a lot I can do to be helpful. It doesn\'t involve maybe even finances or even just involve some fullness. So that\'s good for everybody.\n\n<p><strong>Cory:</strong> So we\'ve talked about just now about the forward, you know, pushing forward and reaching out. I want to switch in real quick and say, how do we ask for help? And you know, man sure this is hard. This is tough. I like to keep things bottled up. I like to try to be Superman, and do everything myself. But there is a very real-time this one, this is every single day, not just in the pain demo. Right now. It\'s heightened for even more of the population, I think, reaching out and saying I do need help. I do need support and how to do that.\n\n<p><strong>Sherry:</strong> Yeah, I, I think this is really a tough one, especially for, again, our entrepreneur, brothers and sisters, because we\'re really used to being pretty autonomous and pretty capable of handling things ourselves. And all kinds of help is going to be needed, right? financial help, just emotional sanity help. Addiction help, parenting help. Like, I feel like there\'s really a pretty nightmare scenario where we\'re, we\'re stuck in the house, it\'s easy to start drinking more, it\'s easy to be a little more abrasive or rougher with your kids because they\'re going crazy and you\'re going crazy. You know, I just think there are lots of dominoes that could fall in a bad way and to be able to call someone and just say like, Okay, can you just talk to me for 10 minutes like I need a break from what\'s happening right now. Maybe you don\'t even have to use the H-word. Maybe you can say like, hey, &#8220;Just tell me a story from your day?&#8221; or &#8220;What are you reading right now,&#8221; you know, just get connected in a way that gets you out of the cycle that you\'re in. And there also may be times where you just really do need help to say, I can\'t pay my rent right now, or I have no work. Do you have, you know, reach out to some people? Do you have any extra projects or things that I can help you with? Or that it? I think the thing is that everyone is going to need help, you know, there\'s not going to be a family that\'s sort of untouched by all of this. And so we as leaders, as entrepreneurs, as people who are aware can now begin to set a new trend where now is just part of the vernacular to ask for an offer to help.\n\n<p><strong>Cory:</strong> Yep. And I think we said examples about that, too, is I mean, I think many of us — I won\'t say most — many of us, and I\'ll just say myself, I\'m good at offering help. I\'m terrible at asking for help, you know, and I let it go too far and it gets, it gets tough. And I think you\'ve hit a resonating thing, which is, this is not the time for social isolations in the sense of not the physical, we get to watch that with the virus, but that this is the time to lean in on connection and doing those to this amazing technology. We have the internet to do so free resources to do so. So I appreciate that. Okay, Sherry, I want to talk about things that I know you have put like squarely on my plate for so long. And if you follow Sherry on Instagram, you know, she does aerial yoga, I believe is the name of it.\n\n<p><strong>Sherry:</strong> That\'s all my Instagram is.\n\n<p><strong>Cory:</strong> It\'s all she told me a couple like a week ago she was she said she was two weeks ago. She was in Vegas and she was going to the circus on site. I remember the circus and that wasn\'t actually the circus. It was aerial yoga. The Circus I remember. But the word that I\'m coming to share is the one that you\'ve really helped introduced to me, which is called play, like most of us think play was when I was a kid. It\'s what my kids do. But you\'ve been very intentional about talking about play. And its necessity and I think it might tie into, I\'m gonna approach it again, exercise the things that we could do. You know, we talked about the breath, we talked about gratitude, there\'s play this component that I would love for you to tell me more about us about and then exercise too, and how to dance really.\n\n<p><strong>Sherry:</strong> It\'s really counterintuitive, because I think we need play more than ever, but the world feels so very serious. And especially those of us who are grownups with lots of grand responsibilities. We can feel a lot of pressure to live in that seriousness all the time and our bodies and our minds really need play, which is essentially a word that It describes being part of an activity purely for the joy of it for a sense of getting lost in it for a sense of you know, flow is another word. Because it sort of stimulates your curiosity and your sense of joy not because it leads to a certain kind of outcome. So people play in lots of ways I happen to have fallen in love with play related to circus, which is very physical, but, you know, playing music, playing by cooking by, you know, working through a cookbook, so I think, you know, if anything, I would love to challenge each of us to find a quarantine play activity. Maybe that\'s building a new york Lego set, or maybe it\'s, you know, mastering handstands or something that is a break from the heaviness of life and just lets you be joyful and light-hearted Again, it\'s a counterbalance, we have all of this heaviness. So we need to introduce some more lightness, we have all of this sadness and fear, we need to introduce more joy. We have all of this like deep, difficult intellectual problem solving to do we need to introduce more sort of nonlinear, playful, less structured ways of thinking and ways of using our brains. So play the engages the body is like doubly helpful because you have all the benefits of play and then all of the benefits of movement. But play doesn\'t. It doesn\'t have to be physical. It\'s just, you know, it\'s nice if it is you just want to be able to lose yourself in something.\n\n<p><strong>Cory:</strong> Yeah, by the way, if you\'re not following Sherry on Twitter, you need to. I\'ve stolen her ideas that she tweets&#8230;. Please keep doing this. One of them was talking about Legos and I was like, you know, Calloway my son that\'s got a roomful of Legos, man. Maybe we could reconstruct the things. He\'s completely obliterated. Going back to that joyful time like, it could be, you know, doodling what thinking back as a kid and going What? What brought you joy that you\'d like lost yourself in video games, whatever. I know you even mentioned to Netflix and chill like, you brought up one on Twitter By the way, she\'s at Zen founder. And I\'ll give you her website address, which is Sherry walling calm too, as well. But you mentioned the West Wing on the classics that we bought. And so, we\'ve been just a couple things. But I love this it could be what is that art, like breaking out the instrument, you know, the musical instrument, you know, that\'s dusty in the closet or, you know, something and I love that you continually and you follow you know, Sherry scream, you will see that she loves the play aspect, and I think that\'s such a great reminder for me every time I see it, I\'m like, I don\'t know if I could do the aerobatic stuff, but—\n\n<p><strong>Sherry:</strong>—you could if you made it your ambition.\n\n<p><strong>Cory:</strong> That\'s true. I can make it—\n\n<p><strong>Sherry:</strong>—into your quarantine project, you could.\n\n<p><strong>Cory:</strong> Yeah. And I love you how you\'ve paired also, it doesn\'t have to but me, you know, exercise being kind of the wonder drug, getting your heart rate up doing something which we can all maybe do a push up or sit up for something, even in our confined space to do that, and, you know, I can remember the book offhand but you know, he says that wonder drug so finding something within your, you know, physical space to do YouTubing some things I think is great just getting that body, you know, what do you call that? pulse, the heart —\n\n<p><strong>Sherry:</strong> &#8230;heart rate elevator getting some adrenaline, some endorphins flowing. I mean, it\'s also good old fashioned catharsis, right, for he talked about this the sense of like, just moving big emotion, through and out of the body. And we know that the longer that emotions are sitting stagnant in us, especially stress, it causes a lot of chemical changes within our body. So if we can engage in whether it\'s playful or just deeply physical activities that help, like, shift around to that chemistry, it\'s much better for us in the long run. So things like dancing are both like neurologically stimulating because you\'re like, what? Which left foot which one is left and where does it go? But also take you they require you to think about something that\'s not the coronavirus or your you know, your business spreadsheets. So something that engages your mind, as well as your body, is really, really helpful.\n\n<p><strong>Cory:</strong> Yeah, like that. So, you know, Sherry Lindsey is listening and I don\'t like to dance. First thing, you know, she\'s gonna say is like, let\'s do it. Let\'s dance.\n\n[laughing] Cory.\n\n<p><strong>Cory:</strong> Well, I want to, I want to make sure we have some time and space for questions and there\'s a couple that have come in Sherry and again, by the way, hit that Q&#038;A button right there, and you can do it anonymously. I will be the only one that sees the actual questions and but it also says anonymous when you click anonymous. So please hit that. There are a couple of questions. So you just hit on stress, or you know, use the word stress in your sentence. And so one of the questions was, my spouse is in a complete state of denial, running a manufacturing plant, and when the shade the state has shut down all the essential stuff. So what if, what if you have people in your life that are in a sense of like, denial? And I\'ve honestly, I\'ll tell you, some people that don\'t really take the measures that the CDC and government officials that know way more about these things than me have suggested don\'t take it. Don\'t take it very seriously. So, thoughts on thoughts on how to handle the denial or you know, lack of seriousness about the issues at hand?\n\n<p><strong>Sherry:</strong> Yeah, that\'s a tough one in a family for sure. I mean, I think it\'s helpful that those conversations happen very intentionally. So as opposed to, like, you know, in this scenario, it\'s partners that live together. Like, you\'re not doing dishes or sort of running from one thing to another or like, you\'re not distracted, but you sit down and you say to your significant other, like, I, I appreciate that you see this way. I see it in a different way. And I am quite concerned and I would like your help in implementing some of these measures for our family. And you just make it a very personal conversation. You don\'t try to go, you know, toe to toe or head to head about like which news sources which and you know, how many people die of the flu versus how many I mean, don\'t just don\'t engage in the kind of infowar and just say &#8220;hi&#8221; to me It\'s gonna help my heart. Yep. If you just stay home for two weeks, like just as a favor to me, like let\'s just bunker up together. And I think not try to, you know, sort of went over someone\'s mind as much as you just asked for their heart can be a little bit more compelling than trying to debate them into submission, which you know, never works.\n\n<p><strong>Cory:</strong> Well and I didn\'t get to this but it brings up the topic and there are two questions on this kind of thing, which is now we\'re isolated with our family that we don\'t spend 24 hours a day with basically, yeah, and now we look on potentially weeks of doing this. There\'s going to be inevitable conflict arguments. It\'s, you know, it can feel like in the isolation &#8230; with people. And I know I\'m not the best to always get along but Okay, so here\'s, here\'s a couple of thoughts here that came in through anonymous questions if your employer wants you to work 100% but you can\'t because of kids, not having a workspace, etc. How do you maintain that boundary without pushing yourself too hard?\n\n<p><strong>Sherry:</strong> Yeah, I mean, I think everybody is, is sort of having a lot more attuned to what they need. So, you know, talking with your significant other unit. So for example, today I have a monster day I\'ve just scheduled from nine to six straight just the day that it is for me today. Friday, much more flexible. So I sat down with Rob and I said, Look, you\'re on duty on Wednesday, because I\'m really busy. But I\'m Friday, I\'ll be on duty, we got to sort of trade back and forth. So talking with the people in your house about what they need what you need. I\'ve also sat down with each of my kids individually and said, Hey, guys, here\'s the reality like all of us are home. The house cleaner is not common. Nobody can leave. Your mom and your dad were both more stressed than normal. So and I know You\'re more stressed than normal. So here are some of the things that I need from you. What do you need from me? So I mean, my youngest is nine. But so we\'re having some really open dialogue about stress and emotion and how that affects our household and how our household runs. I think it\'s also an open conversation with your employer. I mean, many, many people are now home with their children, and again, minor nine to nine-year-olds and a 13-year-old but they can like make their own breakfast and like do things. But if I was home with a three-year-old, like, I couldn\'t be doing, you know, you can\'t work in a focused way. So that\'s a conversation with the employer to say, I need a scale my hours back or maybe I can just add six hours on Saturday so that I\'m working shorter days or I\'m mixing up my hours so I can do it when my kids are sleeping, like sit down and think about what you need to help your life kind of work and begin To ask people for that, there might be some negotiation, but there has to be flexibility from other people too. So don\'t sit here assuming I have to work full time, I have to watch my kids full time I have to, you know, like that\'s, that\'s not realistic, this is not going to be just this week, this is going to be for a while. So you have to proactively protect your energy and ask for what you need from other people, including your clients, including your employer.\n\n<p><strong>Cory:</strong> We were having this conversation and some similar, you know, stock market, all that kind of stuff work. And my thought was, you know, there\'s, let\'s say there\'s a natural disaster that happens that come through, and then there are people affected, but not everyone is affected. This particular thing, everyone, the globe, essentially, is the stock market. Everybody\'s in our place, work. Most everyone is in our place. Whether it\'s worrying about a job worrying about if you know selling We\'re going to continue. And but I think going back to what you said, just reiterating the boundaries. I mean, what a great thought there and scheduling out, this is what I\'m dealing with. It\'s what we\'re dealing with. We did that this morning talking to that now, it\'s not perfect, like you said, and that\'s the other thing is, it\'s never going to be perfect, but we\'re going to make the best of it. Okay, so we\'ve talked about parenting a little bit, and I said, You\'re not parenting, but really having people in the house. And there\'s a flip to our conversation, which is the single people that might be at home having to, you know, quarantine, and you\'ve talked about the connection there. But again, so for our single friends on the call, too, we got kind of that specific advice about searching in place alone. But what other issues or concerns and having no one to touch or runaway thoughts, for example, someone asked, you know, compelling the isolation when we\'ve talked about it parents like we\'re not I\'m going to be alone. There are people here physically with us. But you can still feel alone for sure. But for our single friends out there,\n\n<p><strong>Sherry:</strong> Yeah, I think this is a time to, to, again, get a couple of people on your list that you\'re just going to say, hey, you\'re my person for the quarantine. Let\'s check-in every day. Let\'s just make sure we\'re both Well, yeah, and I, you mentioned it may be a little in passing, but the idea of touches are a really big deal for for this sort of quarantine process. And it\'s imperfect, but like things like a really warm, fuzzy blanket things where you can sort of feel pressure on your skin, if you have a pet, that\'s great, but realizing that your body is is also going to sort of need some sense of comfort in sort of on the cellular level. So if you\'re living alone, you know, extra, like nurture on your body so you know, warm baths. lotion, things that sort of help take care of your skin or even your sort of touching your own skin. Skin sort of stimulates this sense of calm within our bodies that is pretty physiologically hardwired, warm blankets, you know, things that are heavy. And then having your list of people who are you\'re checking people, so every day, you\'re talking with someone or you\'re seeing someone\'s face, even if it\'s virtually to just be really proactive.\n\n<p><strong>Cory:</strong>  Single buddy, I like that single buddies being there for each other leaning on each other. \n\n<p><strong>Sherry:</strong> Or even, you know, you don\'t have to be single like my, you know, my friend Anna, who we\'re having the Zoom snack, she lives by herself. I don\'t live by myself, but I certainly would like to talk to somebody that\'s not my husband or children today. She needs a break from quiet, I need a break from them. It\'ll work.\n\n<p><strong>Cory:</strong> But I love in the absence of being able to physically touch another human being a fiver a hug. The warm blanket the heavy heavy blankets. I know if they have pets, of course, I love that specific tip. That\'s this seemed like it just resonates so deeply. Thank you for saving for your skin. Yeah, suit the suit to your skin. Yeah, absolutely. And there\'s that my daughter loves these little soft blankets and every time I touch she\'s just — and I\'m like, man, I should steal that for an hour. Hey, everybody, we have like 14 minutes. Thanks for eavesdropping on our conversation together. Sherry\'s always just I love talking to her Do you can just tell in her voice and she\'s got such a true calling and all of this and spent most of her life either in education or with clients helping people. So thank you again. Sure. It\'s been so good. Okay, so let me look through some questions real quick. Yes, this will be recorded by the way. We\'ll post it. Post it right after this or shortly after. I think We got some of that&#8230;I\'m just looking to the questions real quick. &#8220;To compound the stress, we\'re older parents one child is a senior in high school, given a stress that he wants to go out. We\'re financially strapped, scared that we will not financially make it through this. I\'m a type A personality. So this has really affected me. And again, I want to give the disclaimer for my dear friend Sherry, she\'s not doing therapy. One-on-one therapy is private. It\'s with a professional license. Sherry has just made herself available to answer questions and offer tips. But thank you, Sherry, any thoughts on you know, a situation like this where Okay, I can imagine my kids are too young, they want to go out but there\'s rain stuff. It\'s not like they can drive away. And then there\'s mention of the financial stress which is the thing that most of us, all of us are looming You know, economic crisis, for instance.\n\n<p><strong>Sherry:</strong> It kind of comes back to control what you can control. With financial stuff, you know, there are ways that we can all probably tighten up well, we\'ll have to because nobody\'s going out to eat. So, sort of planning for the worst as much as possible. But also, again, realizing everyone\'s in the same boat, like, I don\'t know what the government\'s gonna do. I don\'t know how they\'re gonna. I don\'t know how we\'re all going to put it back together. But we all will have to work together to put it back together. Because all of us are feeling it and will continue to feel it. And I know that that\'s deeply comforting, but I think it is important to realize you don\'t have to solve this on your own. And that sense of, you know, how do I work it out. Other people will feel as well. Man with the kiddo though who is like, just doing their own thing or teenager? I have a 13-year-old. He\'s like the best and worst human that I know. And Peston worse. Um, and I think you know, again, you can try to do the logic and then you just got to do the love and just say like, Hey, man, my heart won\'t let you go out. I\'m gonna hide your keys if I have to. Or, you know, if you go out like you\'re putting your whole family at risk, and maybe you don\'t care about that right now, but like I do know, it\'s a tough conversation.\n\n<p><strong>Cory:</strong> Yeah, absolutely. \n\n<p><strong>Sherry:</strong> There\'s enough social pressure on everyone to help reinforce it\'s not just like, mom\'s word or dad\'s word. It\'s universal.\n\n<p><strong>Cory:</strong> So I want to ask this one to a question for entrepreneurs specifically because you are one you live with one. Rob is a tremendous human being is like you are and also brilliant entrepreneur, but you know, for someone that\'s responsible for, you know, other people\'s livelihood, potentially, yeah, as an entrepreneur, I mean, uncertainty. It\'s, we call it the roller coaster for a good reason. And this one just starting to go, you know, it\'s, it\'s going downhill and thinking, Okay, well, I know some people that potentially have restaurants or service companies or everybody feeling some sense of like, what happens if nobody can move and do anything. And then they\'re, you know, this ripple effect. Thoughts for entrepreneurs on this? This is a down this is a downward swing potentially for the roller coaster of entrepreneurship, thoughts about how we, as entrepreneurs, you know, we\'re also leading other people and how we do that. Well.\n\n<p><strong>Sherry:</strong> You know, I think, as always, there\'s an invitation for very calm, intentional communication, which is to say, Hey, this is a situation right now. I, you know, I know I\'ve got runway for\nhowever long. And then there may be a time when we need to adjust what we\'re doing. I think, again, everybody gets it. You as an entrepreneur, as a business owner with employees, you don\'t have a magic wand, you\'re doing the math like everybody else. And the more that you can just constantly communicate and do your best to keep people calm, but also give them a realistic picture so they can sort of make their choices as best they can too. You know, it\'s not easy, but don\'t put yourself in the superhero position like you can\'t save your self, your family, the whole world, all your employees like you are not responsible if you need to, like lay people off or make some different choices like there is a massive virus and that\'s what is causing this I think people sometimes take a little bit too much ownership, which is not to say be, I don\'t know, all of this is a balancing act, right? Be careful, be wise, be strategic, communicate, treat others the way that you will want to be treated. And at the end of the day, I realize that there are just really significant limits to what is within your power to do.\n\n<p><strong>Cory:</strong> That is such a dear message for my brothers and sisters that are entrepreneurs. You can\'t control everything, obviously. And you\'re not Superman they can magically or I don\'t know, some magical wizard that\'s gonna make everything better. And I like what you just said there\'s a limit there\'s to what we can do, and we\'ll try our best and communicate. So here\'s another thing too, on this kind of topic, cheery, trying to balance this Brian for his team calm and confidence but also not ignoring reality that as a lot of full unknown. And I and I would feel disingenuous, not admitting that any tips on how to walk those lines. You know, you know, you\'ve, you\'ve seen, we\'ve talked about this as being vulnerable and open with people, but not scaring the crap out of them to making the situation and that\'s a balanced two.\n\n<p><strong>Sherry:</strong> And I in a way, you know, when all else fails, you tell the truth, which is to say, Hey, I\'m working hard to keep us all employed, you know, these are the steps that I\'m taking, these are the things that I\'m trying. But I am worried if this goes on for two months or three months. So, you know, let\'s, let\'s all think together about what we might be able to contribute in order to solve this problem, in order to stay to stay fresh. So again, everyone is in the same boat. So tell the truth about that. I think people find that comforting.\n\n<p><strong>Cory:</strong> Why going back to something you said I think applies here too Sherry is like, this is what I know. I know, that I want you to have I want us to keep going. Yeah, I don\'t know what the financial future looks like for the entire world. We just don\'t know those things and coming back to those trees. And also like the message of like, it\'s hard to say this because we can\'t physically be together. But this is our time to rally as humans and the team. Like, I don\'t know what the feature is that what I do know is I love you, I care about you. I care about your family. You know, I think those things are really good, really good words too.\n\n\n<p><strong>Sherry:</strong> You, I think, again, depending on your context, because these are very context-dependent kind of questions. But it\'s also you know, I wouldn\'t save this for every team, but it\'s okay as a leader to sort of put it back to the team and say, here are the numbers. Here\'s the work. Here\'s the timeline, like what do we want to do? Maybe people are going to say, hey, let\'s just take 25% off. Across the board will help reduce our salaries will, you know bank that money? Hopefully or, I mean, I think you can think creatively together. And again, not feel the pressure of I have to solve this for everyone. That\'s not what leadership means. Leadership means you\'re hosting the conversation. You\'re listening. you\'re engaging, it doesn\'t mean that you are the ultimate decider. You\'re not the wizard to use your term. Yeah.\n\n<p><strong>Cory:</strong> Yeah. I love that. We don\'t have to have the answer. We\'re not gonna have the answer. \n\n<p><strong>Sherry:</strong> We can\'t. You don\'t. You can\'t. It\'s not a choice.\n\n<p><strong>Cory:</strong> We can put her my partner used to say the open hand approached open palm is like how do we? That\'s a great question. How do we figure this out? That goes for family situations too, right here. How to, hey, we\'re in this together. This is you know, if we find this rainbow in the storm cloud kind of thing is, this is forced our human race to go. We\'re in this together, even the ones that maybe don\'t even have a quote case. Have the virus, especially as to say like we are all in this together. And it\'s an opportunity for Philly, all of us to come together at this time. Che just a couple more minutes. I want people to know how to get ahold of you or resources. And before I let you say that I want to say, Sherry, thank you again, everybody. Thank her please, chat online if you feel do so on Twitter. She\'s ads and founder. But I want to mention one thing, too. She\'s got a prolific podcast. And the last podcast episode she did is called calm stability. Can you hear that in her voice, by the way, should be calm stability, calm by Sherry Wallace. But go do that she\'s got a ton of resources there particularly for entrepreneurs. Sure, how can people learn more about you and the different pieces of content? Ah, I forgot to do this Sherry. She\'s got a great book called How to keep your sh t together and I\'ll put a link to do that in the chat or somebody can put a link to that in chat, by the way, it\'s 399 on Kindle. It\'s a great resource that Sherry and her husband Rob put together just for these times. I don\'t want to miss that. But how else can we kind of keep on the Sherry? Sherry fan? Fan bank bandwagon?\n\n<p><strong>Sherry:</strong> Yeah, you know, I think, and I\'m just really happy to do it, Cory, anything, like, like all of you, if I can find a little space of where I can offer something helpful, what an honor for me to be able to offer something helpful. And I think all of us are sort of asking, How can I be helpful. So you know, I\'m right alongside you and the rest of your team and ask him that question. I mean, the podcast, I hope is a great resource in terms of just, you know, freely available. It\'s not always perfect, but you know, we try to provide some thoughtful content that helps people navigate the storms that sort of safe all of our mental health. But yeah, if people want to reach out to me, I\'m at Sherry wall. dot com or Zen founder, comm z and founder calm so yeah,\n\n<p><strong>Cory:</strong> I\'ll put the link in the recording. But also Lindsay\'s put the link to her book, fantastic book, a couple of recaps, I just want to say from what I heard from Sherry, from what I heard from you, my friend. We\'re in this together, a big four by four, deep, low breath, for in four seconds in four seconds out, gratitude. Find a way to play. Still, your kids like this, break out a board game, do something, find a way to play to this element of childlike joy. Exercise is a great antidote. Find a way to get your heartbeat up. Stay connected. Have your list of people that you\'re going to connect with every day, or frequently to do that as a kind of an antidote to the time that we\'re in. Sherry Thank you, please. Say hi to Rob and the kiddos. And thank you so so so much for your time. Today sharing I think this was a big deep breath for everyone and you\'re calm presence and you\'re just sharing your tips and things have helped a lot of people that I hope will keep you going and you can share these things. Practice these things actually be an example for others and reach out when we need help. So any less than this year, thanks. \n\n<p><strong>Sherry:</strong> Thanks so much and thanks for having the conversation. We\'ll have the conversation as many times as we need to tell this is a little bit better.\n\n<p><strong>Cory:</strong> Yes ma\'am. Thank you, everybody. Stay safe and healthy. mentally and physically. See you</div>\n\n<p><a href=\"https://otter.ai/s/yMpkP8vNRy-5Ildi4Ec82Q\">Transcription via Otter</a>.</p>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 19 Mar 2020 01:42:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: Build Custom Templates with the MB Views Add-On for Meta Box\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97940\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:185:\"https://wptavern.com/build-custom-templates-with-the-mb-views-add-on-for-meta-box?utm_source=rss&utm_medium=rss&utm_campaign=build-custom-templates-with-the-mb-views-add-on-for-meta-box\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8296:\"<p class=\"has-drop-cap\">Meta Box released its <a href=\"https://metabox.io/plugins/mb-views/\">MB Views add-on plugin</a> last week. The new extension allows developers to build custom templates from the comfort of their WordPress admin. The goal is to provide an easy-to-use interface for outputting custom fields without editing theme files, but its flexibility pushes the boundaries of full-site editing.</p>\n\n\n\n<p><strong>Quick take:</strong> MB Views offers a solid developer experience but falls a little short of being friendly for those unfamiliar with code.</p>\n\n\n\n<p>I have long been a fan of what the <a href=\"https://wordpress.org/plugins/meta-box/\">Meta Box</a> team has done with its core plugin and extensions. The project&rsquo;s developers have created a well-documented code base, written solid documentation, and have generally paid attention to details where others have failed. MB Views is no different. In minutes after activating the extension, I had custom views set up and rolled out on the front end of my test site.</p>\n\n\n\n<p>The interface is simple enough to pick up almost immediately with enough flexibility to build nearly anything from the WordPress admin.</p>\n\n\n\n<p>On the whole, the team&rsquo;s new add-on is well worth the price of one of the available <a href=\"https://metabox.io/pricing/\">premium bundles</a>, which range between $79 and $349. It is not without a few minor issues, but that is to be expected with a version 1.0 release.</p>\n\n\n\n<h2>A Powerful Tool for Front End Editing</h2>\n\n\n\n<img />Creating a custom view with the plugin&rsquo;s view editor.\n\n\n\n<p class=\"has-drop-cap\">My experience working with the view-editing screen felt natural. The code editor uses <a href=\"https://codemirror.net/\">Code Mirror</a> and its Oceanic Next theme. It has auto-tabbing and auto-complete built in, so it feels like most offline editors. Developers should feel at home quickly building a custom view.</p>\n\n\n\n<p>Because I mostly use Tailwind CSS these days, I was able to build a <em>faux</em> email signup form in a couple of minutes and display it directly beneath my posts using the available view settings.</p>\n\n\n\n<img />Custom-built email signup form with MB Views.\n\n\n\n<p>The code editor has a &ldquo;New Field&rdquo; button that opens a slide-out box on the right side of the screen. It allows users to insert post, site, user, and query fields. The options also include custom fields created via the Meta Box plugin.</p>\n\n\n\n<p>Besides editing the template, users can also add custom CSS and JavaScript directly from the view code editor.</p>\n\n\n\n<p>The output of these fields are all handled through <a href=\"https://twig.symfony.com/\">Twig</a>, a modern PHP templating engine. Many PHP developers will already be familiar with Twig and will feel comfortable with its syntax. Through this system, plugin users are not limited to HTML. They can use conditionals and loops to customize the output of their view content.</p>\n\n\n\n<p>For a better developer experience, it would be nice to see an auto-complete option for inserting new fields instead of clicking the &ldquo;New Field&rdquo; button and then clicking on a particular field. Most likely, developers will begin memorizing the fields over time and simply type them out. Auto-complete would be a nice touch for custom fields.</p>\n\n\n\n<img />View settings and conditionals.\n\n\n\n<p>Where MB Views really shines is its view settings. The plugin allows views to take over the entire page between the theme header and footer or just the content area. It allows users to choose between displaying a view on singular posts, archive pages, or something custom using its built-in shortcode. Users can further break down where a view appears based on conditions that can be grouped in various ways. It can be as simple or complex as needed. It is not completely on par with what&rsquo;s possible with custom PHP conditionals, but it is close enough to cover the majority of use cases.</p>\n\n\n\n<p>If someone wanted to try their hand at it, they could use MB Views as an entire site editor. The only real requirement would be to build their theme with a header and footer. At some point, maybe the plugin will allow users to take over the entire page layout, effectively making a theme unnecessary.</p>\n\n\n\n<h2>Issues and Future Enhancements</h2>\n\n\n\n<p class=\"has-drop-cap\">Version 1.0 is about shipping something into the hands of users. It is a time when developers get some of their most useful feedback, so I expect the following to be addressed as the developers continue to build upon the plugin in the future. I did not hit any major roadblocks, but I did come across some minor issues and had some ideas for improvement.</p>\n\n\n\n<p>The first issue I hit made me initially believe the plugin did not work at all. I had chosen to display my custom view on singular posts. This is easy to do via the view settings. You select the &ldquo;Singular&rdquo; type. Then, select &ldquo;Post&rdquo; in the first drop-down select. I had assumed this would make the template appear on all posts. However, nothing happened after saving. None of my custom content appeared on the front end. The problem was there was a second drop-down select, which had not been populated with a value by default. There was an &ldquo;All Posts&rdquo; option I needed to select. It was a quick issue to address, but this is why good defaults are so important in plugin development.</p>\n\n\n\n<p>There is no revision support. For a code editor in the WordPress admin, it makes sense that users could revert their code to an earlier version. If users only ever create views with minor bits of code, this will be a non-issue. However, the plugin goes as far as allowing users to create an entire page layout between the theme&rsquo;s header and footer. That will sometimes mean a lot of code and the need to backpedal changes.</p>\n\n\n\n<p>MB Views offers an <code>[mbv]</code> shortcode for outputting a view within shortcode-ready areas, such as post content. However, there is no block equivalent for use in the block editor. At this point, having a shortcode but no block seems like a major oversight. Shortcodes need to die a slow and painful death.</p>\n\n\n\n<p>The view management screen could use a little love too. It would be nice to see at least a column for the view type. As the list of custom views grows, it may get hard to figure out where each view is used at a glance.</p>\n\n\n\n<h2>User Friendliness and the Future</h2>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>You want to get values of Meta Box fields and put them on your front-end templates, but you&rsquo;re not too familiar with coding and don&rsquo;t want to touch theme files?</p></blockquote>\n\n\n\n<p>MB Views&rsquo; opening description claims the plugin is geared toward users who are not familiar with coding. I am unsure if the average user could take advantage of it without picking up some coding knowledge along the way. The interface is primarily geared toward developers. Quite literally, the view editor is a code editor. It does have an easy-to-click field inserter, but those fields will often be useless without some familiarity with HTML and CSS.</p>\n\n\n\n<p>The tool is good at what it does, but it almost feels like a stop-gap measure in the era of the block editor.</p>\n\n\n\n<p>For MB Views to be a more useful end-user tool, it will need to transition to more of a visual, point-and-click interface with design options. Otherwise, it will mostly stay in the land of developers who can customize view output to perfection.</p>\n\n\n\n<p>I don&rsquo;t necessarily think MB Views must go in that direction if the team wants to focus on a great developer experience. However, it does not currently live up to its claim of friendliness for those less familiar with code.</p>\n\n\n\n<p>We are still likely at least a year out from a full-site editing experience via the block system. Efforts by the Meta Box team may be best spent integrating view editing within that system. The MB Views add-on is a useful and necessary tool for many Meta Box plugin users today, but it may not have time to gain traction before full-site editing lands in core. At that point, the plugin team will need to already be transitioning into a much different world of user experience with WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 18 Mar 2020 20:35:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"HeroPress: Finding My Way With WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=3076\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"https://heropress.com/essays/finding-my-way-with-wordpress/#utm_source=rss&utm_medium=rss&utm_campaign=finding-my-way-with-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8398:\"<img width=\"960\" height=\"480\" src=\"https://s20094.pcdn.co/wp-content/uploads/2021/03/031620-min.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"WordPress Changed My Life\" /><p>Wow, HeroPress! How did I even get here? Why am I even here? I&#8217;m hardly a hero after reading so many inspiring stories.</p>\n<p>Let me tell you mine. I do this with my usual reluctance which I will explain in a bit.</p>\n<h3>The Beginning</h3>\n<p>I got started with WordPress about 10 years ago. I was having lunch with a friend (formerly a client) in Grand Central Station in New York. He, being much wiser than I, said, &#8220;Hey Bud, you ought to learn WordPress.&#8221;</p>\n<p>&#8220;No way,&#8221; I objected. &#8220;I&#8217;m a code guy. I&#8217;m a &#8216;Rage Against The Machine Guy.&#8217; I&#8217;ll never use anything like that.&#8221;</p>\n<p>He pleaded with me to re-consider. &#8220;You don&#8217;t know what you&#8217;re talking about. Things are changing. I&#8217;ll give you my username and password. Just login and have a look. My guy installed a bunch of plugins that you can use.&#8221;</p>\n<p>What the heck was a plugin?</p>\n<p>And so it began. I logged in. Looking back, it was WordPress 2.6. I didn&#8217;t really know what that meant.</p>\n<p>I signed up with Bluehost. I played around with lots of themes but kept coming back to Kubrick (aka TwentyTen). I religiously installed all the plugins used in my friend&#8217;s site, holding on to his railings as I began to learn WP. Then came Thematic and its &#8220;easy&#8221; introduction to what a child theme was. Once I saw that you could edit anything and make it yours, I was hooked. The endorphins were freely coursing through my veins.</p>\n<h3>Spreading The Word</h3>\n<p>Now soon after &#8211; being an instructor &#8211; I thought, &#8220;I could teach this&#8221; and so I did at the Fashion Institute of Technology in New York City. That first class was totally by the seat of my pants. Hardly my usual MO. The syllabus was completely in my head. I pulled it off and that was a lot of fun.</p>\n<p>The classrooms were packed those first few years of teaching. WP was exploding. If you were the first kid on the block using or teaching it, you were gold.</p>\n<p>Then two big things were about to happen that were really going to change my life. They would show me the way to the WordPress community &#8211; not that I even knew what that was.</p>\n<h3>Finding Community</h3>\n<p>A student advised that I should go to the monthly WordPress MeetUp in New York City. That was in 2014. He&#8217;s long gone but I&#8217;m a regular. I have presented talks many times where we usually got about 40 people to attend. Other types of WordPress MeetUps started to take hold and I became a regular there as well.</p>\n<p>At the same time, I started going to WordCamps in NYC. Those were eye openers. This WordPress thing was getting big and there were people connected to it and each other. They were all so nice and smart and I felt at home &#8211; not that I&#8217;m always so nice and smart. In 2016 I was accepted to speak at WordCamp NYC. (It still is the only WordCamp ever held at the United Nations.) I didn&#8217;t know a soul but one of the organizers loved my presentation, &#8220;Lessons Learned: Considerations For Teaching Your Clients WordPress.&#8221; He and I became good friends as he ushered me into the New York City WordPress community.</p>\n<p>From there it was on to WordCamp US in Philadelphia and the following year in Nashville. I started meeting WordPress Royalty like <a href=\"https://heropress.com/essays/its-never-too-late-even-in-the-tech-community/\">BobWP</a> (aka Bob Dunn). WordCamps were starting to feel like high school reunions. In 2019 I spoke at WordCamps Boston, Montclair, and Philadelphia. Speaker wrangling became my thing. I&#8217;ll be doing it for the third and final time this year for WordCamp NYC. (That&#8217;s if all goes well given how many WordCamps have been cancelled because of COVID-19.)</p>\n<p>Somewhere in the middle of it all, I was listening to a WordPress Weekly podcast and a host, Marcus Couch, just got a gig with Smashing Magazine as their WordPress guy. He put out a call for anyone to submit an article for publication. I sent in &#8220;The Golden Age Of Web Design&#8221; and, after a few back and forths, it got turned down. Then I came up with an idea that I didn&#8217;t think they&#8217;d turn away, but I did not want to write about.</p>\n<p>I figured why not write about something that is very personal and something I was reluctant to discuss publicly. I am legally blind.</p>\n<h3>Freedom From Blindness</h3>\n<p>So &#8220;<a href=\"https://www.smashingmagazine.com/2018/05/using-low-vision-teach-wordpress/\">Using Low Vision As My Tool To Help Me Teach WordPress</a>&#8221; was written. There was no way Smashing Mag would turn me down now, and they didn&#8217;t. In a year or so I turned that article into &#8220;My Way With WordPress,&#8221; a WordCamp talk. While I was not really interested in the subject, it seemed as if others were.</p>\n<p>But the funniest &#8211; I suppose &#8211; story was when I spoke at the first ever WordCamp Montclair in 2019. It was a presentation on Gutenberg plugins. Since I couldn&#8217;t do this from a notebook screen (the screen is too small and the keyboard is hard for me to manipulate), it was decided that I would bring (I am about to embarrass myself) my 27&#8243; iMac to a WordCamp. I&#8217;m probably the first person to ever have done this. It was good thing I only lived a few miles away.</p>\n<p>After lunch on Day One, it was my turn to present. The guys (it was a crew) spent a few minutes hooking me up to all the equipment. I sat behind my computer, did my thing, and every once in awhile peered out to make sure people were still there. While there doesn&#8217;t seem to be any pictures of this ever happening, I don&#8217;t need visual proof to remind me of this. I hear about it all the time!</p>\n<p>And that&#8217;s fine with me.</p>\n<p>WordPress changed my life. It’s not just about the community but through it the sense of accomplishment I get whenever I launch a new or re-designed site. It’s also given me a great feeling to know that many people have learned WordPress around the world because of my 2 free online classes. This might just be the most gratifying thing of all.</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Finding My Way With WordPress\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Finding%20My%20Way%20With%20WordPress&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Ffinding-my-way-with-wordpress%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Finding My Way With WordPress\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Ffinding-my-way-with-wordpress%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Ffinding-my-way-with-wordpress%2F&title=Finding+My+Way+With+WordPress\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Finding My Way With WordPress\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/finding-my-way-with-wordpress/&media=https://heropress.com/wp-content/uploads/2021/03/031620-min-150x150.jpg&description=Finding My Way With WordPress\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Finding My Way With WordPress\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/finding-my-way-with-wordpress/\" title=\"Finding My Way With WordPress\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/finding-my-way-with-wordpress/\">Finding My Way With WordPress</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 18 Mar 2020 08:00:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Bud Kraus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"WordPress.org blog: WordPress 5.4 RC3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8432\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2020/03/wordpress-5-4-rc3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4062:\"<p>The third release candidate for WordPress 5.4 is now available!</p>\n\n\n\n<p>WordPress 5.4 is currently scheduled to be released on&nbsp;<strong><a href=\"https://make.wordpress.org/core/5-4/\">March 31 2020</a></strong>, and we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.4 yet, now is the time!</p>\n\n\n\n<p>There are two ways to test the WordPress 5.4 release candidate:</p>\n\n\n\n<ul><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.4-RC3.zip\">download the release candidate here</a>&nbsp;(zip).</li></ul>\n\n\n\n<p>For details about what to expect in WordPress 5.4, please see the&nbsp;<a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate post</a>.</p>\n\n\n\n<p>RC3 addresses improvements to the new About page and&nbsp;<a href=\"https://core.trac.wordpress.org/query?id=49657%2C49621%2C48164%2C49577%2C47053%2C48303%2C49374%2C49619&milestone=5.4&group=component&col=id&col=summary&col=milestone&col=owner&col=type&col=status&col=priority&order=priority\">8 fixes</a>&nbsp;for the following bugs and regressions:</p>\n\n\n\n<ul><li><a href=\"https://core.trac.wordpress.org/ticket/49657\"></a><a href=\"https://core.trac.wordpress.org/ticket/49657\">49657</a> &#8211; <a href=\"https://core.trac.wordpress.org/ticket/49657\">Block Editor: Update WordPress Packages WordPress 5.4 RC 3</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49621\"></a><a href=\"https://core.trac.wordpress.org/ticket/49621\">49621</a> &#8211; <a href=\"https://core.trac.wordpress.org/ticket/49621\">Travis: Download Chromium for E2E Tests Only</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49164\"></a><a href=\"https://core.trac.wordpress.org/ticket/48164\">48164</a> &#8211; <a href=\"https://core.trac.wordpress.org/ticket/48164\">media_sideload_image Should Store Original URL and Optionally Check for Dupes</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49577\">49577 &#8211; Site Health Status Dashboard Provides Incorrect Items Count on Initial Load</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/47053\">47053 &#8211; Accessibility: Need to set proper &#8216;tabindex&#8217; in &#8216;Skip To Toolbar&#8217; HTML</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/48303\">48303 &#8211; Docblock Improvements for 5.4</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49374\">49374 &#8211; Use get_post_states to Denote Special Pages on the Added Menu Item Accordions</a></li><li><a href=\"https://core.trac.wordpress.org/ticket/49619\">49619 &#8211; Use &lt;hr /&gt; Instead of Margin on Freedoms Page</a></li></ul>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme to 5.4. If you find compatibility problems, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>&nbsp;so we can figure those out before the final release.</p>\n\n\n\n<p>The&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a>&nbsp;has also been published, which details the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Mar 2020 21:24:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Baumwald\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Akismet: Version 4.1.4 of the Akismet WordPress Plugin is Now Available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=2065\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://blog.akismet.com/2020/03/17/akismet-4-1-4-for-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:971:\"<p>Version 4.1.4 of <a href=\"http://wordpress.org/plugins/akismet/\">the Akismet plugin for WordPress</a> is now available. It contains the following changes:</p>\n\n\n\n<ul>\n<li>The plugin will now only redirect to the Akismet setup screen upon plugin activation if the plugin was activated manually from within the plugin-related screens, to help users with non-standard install workflows (like WP-CLI).</li>\n<li>We&#8217;ve updated the layout of the initial setup screen to be more readable on small screens.</li>\n<li>We&#8217;ve reduced the amount of code that runs when no API key has been entered yet.</li>\n<li>We&#8217;ve improved the readability of the comment history entries.</li>\n</ul>\n\n\n\n<p>To upgrade, visit the Updates page of your WordPress dashboard and follow the instructions. If you need to download the plugin zip file directly, links to all versions are available in <a href=\"http://wordpress.org/plugins/akismet/\">the WordPress plugins directory</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Mar 2020 20:53:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Christopher Finke\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: GitHub Acquires npm, Plans to Improve Infrastructure and Experience\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97921\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:197:\"https://wptavern.com/github-acquires-npm-plans-to-improve-infrastructure-and-experience?utm_source=rss&utm_medium=rss&utm_campaign=github-acquires-npm-plans-to-improve-infrastructure-and-experience\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3988:\"<p class=\"has-drop-cap\">GitHub announced yesterday that it had <a href=\"https://github.blog/2020-03-16-npm-is-joining-github/\">acquired the popular JavaScript package service</a> npm for an undisclosed amount. npm, Inc. was the company behind the Node package manager, npm Registry, and npm CLI. The company is shuttering its doors, but the future of the npm service looks bright with this acquisition.</p>\n\n\n\n<p>Currently, npm serves over 1.3 million packages with 75 billion downloads every month. Over the past decade, the service has solidified itself as a vital part of the modern web. At least 12 million developers use npm to manage JavaScript dependencies.</p>\n\n\n\n<p>In recent years, it has become a necessary piece of core WordPress, plugin, and theme development. The WordPress software currently has <a href=\"https://www.npmjs.com/org/wordpress\">71 packages</a> available through the public npm registry. As the platform continues relying on JavaScript in the coming years, the number of packages should continue increasing.</p>\n\n\n\n<p>&ldquo;There are few unmitigated successes or failures in the real world,&rdquo; wrote Isaac Schlueter in a <a href=\"http://blog.npmjs.org/post/612764866888007680/next-phase-montage\">post on the npm blog</a>. &ldquo;But this is a win, and a good one, for me and the team and the entire JavaScript community.&rdquo;</p>\n\n\n\n<p>The merging of npm and GitHub will make sense for many developers. Because the two services are used in conjunction so often, it can be hard to tell where one ends and the other begins to the uninitiated. GitHub is an online service built to make it easier to collaborate and work on top of the Git version control system. It is social-coding on a massive scale. Many JavaScript repositories hosted on GitHub are then submitted to the npm registry. Other developers can then use npm to manage their dependencies on a per-project level.</p>\n\n\n\n<p>Nat Friedman, CEO of GitHub, said npm will always remain available and free of charge in the company&rsquo;s announcement. GitHub plans to invest in the registry infrastructure and improve the core experience, particularly with work that has already gone into version 7 of the npm CLI. He also stressed the company will garner feedback from the JavaScript community to mold npm&rsquo;s future.</p>\n\n\n\n<p>&ldquo;Looking further ahead, we&rsquo;ll integrate GitHub and npm to improve the security of the open source software supply chain, and enable you to trace a change from a GitHub pull request to the npm package version that fixed it,&rdquo; wrote Friedman. &ldquo;Open source security is an important global issue, and with the recent launch of the GitHub Security Lab and GitHub&rsquo;s built-in security advisories, we are well-positioned to make a difference.&rdquo;</p>\n\n\n\n<p>Schlueter expressed that he feels like this is an ideal move for npm, largely in part to GitHub&rsquo;s commitment to open source. &ldquo;As we dug into the technical and strategic plans for how npm would fit into the vision of GitHub moving forward, it became clear that this isn&rsquo;t just a good option for the JavaScript community &ndash; it&rsquo;s significantly better than what npm, Inc., can provide on its own,&rdquo; he said. &ldquo;I&rsquo;ve said countless times before that I wouldn&rsquo;t let the registry go someplace that won&rsquo;t take care of it.&rdquo;</p>\n\n\n\n<p>For JavaScript programmers, this change should not cause any issues. It should be <em>business as usual</em>. With a company as large as GitHub and the infrastructure it can provide, developers will likely be looking for new features and improved tools.</p>\n\n\n\n<p>&ldquo;There are some awesome opportunities for improvement in the npm experience, to meaningfully improve life for JS devs in countless large and small ways,&rdquo; said Schlueter. &ldquo;We&rsquo;ll be making things more reliable, convenient, and connected for everyone across our vast interdependent JavaScript ecosystem.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Mar 2020 20:05:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Matt: Business as Usual in The Information\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=51051\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://ma.tt/2020/03/business-as-usual-in-the-information/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2394:\"<p><a href=\"https://www.theinformation.com/articles/business-as-usual-remotely\">The Information wrote Business as Usual — Remotely</a>, which includes &#8220;85% of its 900 employees working from their homes&#8221; Hashicorp, which just raised $175M at a $5.1B valuation today. (I have to get them on <a href=\"https://distributed.blog/\">Distributed</a>.) Here&#8217;s my part:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>A survey of American workers by the polling firm Gallup found that in 2016 43% of employees worked remotely at least some of the time, up from 39% in 2012. Of those remote workers, almost a third spent 80% or more of their time working remotely in 2016, compared to 24% in 2012. In computer-related professions, 57% did some remote work in 2016, according to Gallup. </p><p>That includes tech companies like Automattic, which makes WordPress and other software products and has been almost entirely remote since it was founded in 2005. At one point, it opened a large office in San Francisco for employees who preferred a more traditional work environment, but it got rid of that space in 2016 because of how little people used it.  </p><p>“We had this 15,000-square-foot place with only five people coming into it,” said Matt Mullenweg, CEO of Automattic, which acquired Tumblr last year. </p><p>Now Automattic rents only one small co-working space in a WeWork suite in New York  and uses another small office in San Francisco exclusively for board meetings. It manages its remote workforce using Slack and Zoom and gives new employees $2,000 so they can purchase home office equipment. </p><p>Employees can also get up to $250 per month for access to a co-working space or for daily coffees at a local coffee shop. But Mullenweg says only about 300 of the company’s 1,200 employees chose to work somewhere other than a home office.</p><p>“I hope there can be a silver lining to this crisis, which we all hope is over as soon as possible, that enables people to reexamine how they work and how they interact with things and improve it,” said Mullenweg. “I’m happy to spread the gospel wherever possible for distributed work. I think it’s better for companies, employees, the environment and the world. There are very few downsides.” </p></blockquote>\n\n\n\n<p>The Information is a worthwhile subscription if you&#8217;re in the tech business.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Mar 2020 03:21:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: Gutenberg 7.7 Ships Refreshed UI and First Iteration of Block Patterns\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97905\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:205:\"https://wptavern.com/gutenberg-7-7-ships-refreshed-ui-and-first-iteration-of-block-patterns?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-7-7-ships-refreshed-ui-and-first-iteration-of-block-patterns\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6734:\"<p class=\"has-drop-cap\">Last week, <a href=\"https://make.wordpress.org/core/2020/03/11/whats-new-in-gutenberg-11-march/\">version 7.7 of the Gutenberg plugin</a> shipped to users. In what is one of the more visually-striking updates in a while, the design team presented a refreshed UI. Users will also get their first chance to test the upcoming block patterns feature.</p>\n\n\n\n<p>Some users may get a surprise. Gutenberg 7.7 is the first version of the plugin to ship the editor in fullscreen mode out of the box. This change will <a href=\"https://wptavern.com/editor-will-default-to-fullscreen-mode-in-wordpress-5-4\">land in WordPress 5.4</a>. Now is a good opportunity to see how it works before upgrading later this month.</p>\n\n\n\n<p>Block developers can rejoice for the ability to <a href=\"https://github.com/WordPress/gutenberg/pull/19701\">create their own block wrappers</a>. This is part of a change for creating a faster DOM. Inner blocks also produce a <a href=\"https://github.com/WordPress/gutenberg/pull/19910\">lighter DOM output</a>, so the element tree in the editor now matches the front end. These changes make it easier for theme designers to style blocks without a convoluted mess of nested <code>&lt;div&gt;</code> elements.</p>\n\n\n\n<p>Version 7.7 includes over two dozen bug fixes. It also includes a fix for the &ldquo;View Posts&rdquo; back button at the top of the editor while in fullscreen mode. Instead of an arrow button, which was confusing for users who thought it might return them to the regular editing mode, the team replaced it with the WordPress &ldquo;W&rdquo; icon.</p>\n\n\n\n<h2>A Fresh and Clean Editor UI</h2>\n\n\n\n<img />Refreshed UI in Gutenberg 7.7.\n\n\n\n<p class=\"has-drop-cap\">It took a few days to grow on me after more than a year getting accustomed to the old UI. The basics are the same. The layout has not changed. However, the buttons and related elements have received a nice refresh.</p>\n\n\n\n<p>The editor feels more professional. The block toolbar is simpler and cleaner. The Gutenberg team redesigned the icons. The color contrast makes everything crisper.</p>\n\n\n\n<p>The block inserter now uses the full height of the editor. This is a large improvement over earlier iterations. It means less scrolling to find the right block, which has been one of my pet-peeves (<em>I have fewer and fewer of these with each release</em>).</p>\n\n\n\n<p>This is a first pass over the new interface, and there is still more work for the Gutenberg design team to tackle. Work on the sidebar, dropdowns, and other elements is currently in progress and should land in upcoming plugin updates.</p>\n\n\n\n<p>Overall, the UI is much more polished. The average WordPress user will not experience it until WordPress 5.5, but it is well worth installing and activating the Gutenberg plugin to give it a spin.</p>\n\n\n\n<h2>Early Work Toward Block Patterns</h2>\n\n\n\n<img />Inserting a pattern into the block editor.\n\n\n\n<p class=\"has-drop-cap\">Perhaps one of the most-anticipated Gutenberg features is the inclusion of a pattern library. A pattern is a collection of blocks in a predefined arrangement. For example, a common pattern is a large hero image with text and a couple of buttons laid over the top. Another common pattern is a set of three or four boxes aligned next to each other, each with a title, image, and text.</p>\n\n\n\n<p>The more complex a particular layout, the harder it is to create from the editor without the know-how. That&rsquo;s where patterns come in. They are a sort of &ldquo;template&rdquo; that allows end-users to quickly build out sections of content without the requirement of inserting the individual blocks.</p>\n\n\n\n<p>Patterns will be a game-changer.</p>\n\n\n\n<p>Some projects have already made solid attempts at something akin to patterns. <a href=\"https://wptavern.com/creator-of-editorskit-launches-community-block-sharing-site\">ShareABlock&rsquo;s community-based shared blocks</a> and <a href=\"https://wptavern.com/gutenberg-hub-launches-collection-of-100-block-templates\">Gutenberg Hub&rsquo;s copy-and-paste templates</a> are good options for people who know about those projects. Users are even turning the reusable block system into <em>faux</em> patterns. However, few solutions will be able to compete with having a true Block Patterns API and exposing those patterns in the UI to end-users.</p>\n\n\n\n<p>The new patterns feature in Gutenberg 7.7 is meant as a minimum viable product and not representative of what the feature will look like by the time it ships in core WordPress. At the moment, the UI is a new sidebar with a small sampling of patterns to choose from. However, patterns will likely be a part of the block inserter or exposed differently down the road. The goal is to ship something that works and iterate.</p>\n\n\n\n<p>Currently, the team has bundled only four patterns:</p>\n\n\n\n<ul><li>Two Columns of Text</li><li>Two Buttons</li><li>Cover</li><li>Two Images Side by Side</li></ul>\n\n\n\n<p>While these particular patterns are not exciting, they are simple examples to begin testing the feature. The big question: <em>what patterns should Gutenberg include by default?</em> There is currently an <a href=\"https://github.com/WordPress/gutenberg/issues/20345\">open GitHub ticket</a> to discuss and implement the possibilities. There are several proposals for commonly-seen patterns around the web. The ideal people to be involved with this discussion would be theme authors because they have been working closely and directly with users for years. With enough solid patterns in core, it would mean less code work in themes. Instead of building dozens of patterns to achieve modern layouts, theme authors could focus more on the design aspect of theme development.</p>\n\n\n\n<p>In testing, the feature worked without issue. After selecting the patterns sidebar, you simply select the pattern you want, which is inserted directly in the content area of the editor. From that point, you can edit like any other block.</p>\n\n\n\n<p>Patterns will certainly make the block editor far more <a href=\"https://wptavern.com/will-page-builders-remain-competitive-in-the-block-era\">competitive with page building plugins</a>. More than anything, they will allow users to more quickly build layouts that often make for an overly complex and frustrating experience.</p>\n\n\n\n<p>Right now, the pattern library is not included in the most recent <a href=\"https://make.wordpress.org/updates/2020/03/06/update-progress-on-goals/\">roadmap update</a> for 2020. However, I could see it making an official appearance in WordPress this year if work continues at its current pace. That is merely speculation, and perhaps a little hope, but this is one of the most exciting Gutenberg features in the works.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Mar 2020 20:13:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Women in Tech Salary Transparency Project: Addressing the Gender Pay Gap\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97782\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:207:\"https://wptavern.com/women-in-tech-salary-transparency-project-addressing-the-gender-pay-gap?utm_source=rss&utm_medium=rss&utm_campaign=women-in-tech-salary-transparency-project-addressing-the-gender-pay-gap\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:12827:\"<p class=\"has-drop-cap\">Lizzie Kardon, Head of Content and Engagement at Pagely, was featured in a nationwide segment on NBC&rsquo;s TODAY show last month.  On the show, <a href=\"https://www.today.com/video/women-tackle-the-wage-gap-by-sharing-their-salaries-78161989798\">women talked about the wage gap</a> and the issues faced by women in the workforce.  Kardon is a part of a growing movement of women who are supporting other women in negotiating a fairer paycheck.</p>\n\n\n\n<p>NBC caught wind of Kardon&rsquo;s <a href=\"http://salarytransparencyproject.com/\">Women in Tech Salary Transparency Project</a>, an open spreadsheet where women share salaries. The next step was bringing her on the show and featuring the work she is doing. &ldquo;Today I went on national television to represent over 500 women in tech because it&rsquo;s time to close the pay gap and start paying people what they&rsquo;re worth,&rdquo; she wrote in an <a href=\"https://pagely.com/blog/pagely-today-show/\">article about the show and project</a>.</p>\n\n\n\n<p>The inspiration for the project came after reading a piece by the New York Times on <a href=\"https://www.nytimes.com/2020/01/09/style/women-salary-transparency.html\">salary transparency</a>. Kardon wanted to put theory into practice. It was an experiment to see if others would be willing to share.</p>\n\n\n\n<p>&ldquo;I honestly never expected it to turn into what it is today,&rdquo; said Kardon. &ldquo;When I started this, the day after that NYT piece went out, it was slow to get traction. After I took the plunge to be the first one to share, others gained the confidence to do the same and it snowballed from there.&rdquo;</p>\n\n\n\n<h2>The Salary Transparency Project</h2>\n\n\n\n<p class=\"has-drop-cap\">Currently, the project is a <a href=\"http://salarytransparencyproject.com/\">simple spreadsheet</a> where women in tech can anonymously share their salaries. It has grown since the initial 500 entries when Kardon was on national television. Today, over 1,900 women have transparently shared their job title, wages, location, benefits, and years of experience.</p>\n\n\n\n<p>The goal is to provide concrete data for other women to use in salary and raise negotiations.</p>\n\n\n\n<p>Kardon expressed a desire to do more with the data than having it sitting around in a spreadsheet. One of the goals is to convert it into an ongoing open-source project. She is looking for partners to kick-start such a project with the development skills to compliment her growth and marketing experience.</p>\n\n\n\n<p>She also just kicked off the <a href=\"https://nogendergap.substack.com/p/no-gender-gap-issue-1\">first issue</a> of a new Substack newsletter, <a href=\"https://nogendergap.substack.com/\">No Gender Gap</a>. The first email went to 209 subscribers. The newsletter is a more immediate-term solution toward larger goals.</p>\n\n\n\n<p>&ldquo;[The newsletter] examines everything from getting fairly compensated for your work and negotiating a higher salary to being inspired by women in leadership and finding progressive companies with the best people practices,&rdquo; Kardon said. &ldquo;I have a bachelor&rsquo;s in mathematics, so I&rsquo;m also stretching those muscles and providing data insights inside of the newsletter. One of the added benefits for paid subscribers is that they can ask me their specific questions on the data, which I will then analyze and answer.&rdquo;</p>\n\n\n\n<p>After shipping the first issue, <em>No Gender Gap</em> has surpassed 300 subscribers.</p>\n\n\n\n<p>&ldquo;It&rsquo;s just amazing how many people are in need of this information and support, and I guess I&rsquo;ve just taken it upon myself to provide that right now,&rdquo; said Kardon. After her guest spot on nationwide news, she has suddenly become an advocate for working women over a few weeks. &ldquo;It&rsquo;s a bit surreal, and I can&rsquo;t stop now.&rdquo;</p>\n\n\n\n<h2>Camaraderie and Being Vocal</h2>\n\n\n\n<p class=\"has-drop-cap\">For men in tech and elsewhere, there exists a sort of <em>bro culture</em> where men are supportive of other men. This culture is not necessarily anti-woman. However, this camaraderie sets men up for success when it comes to negotiating salaries. Men are often open and push their male colleagues and friends to pursue a better wage.</p>\n\n\n\n<p>&ldquo;More and more we as women are learning how to replicate the positive aspects of that culture, inside of our own cohort,&rdquo; she said. &ldquo;The most obvious example is my recent salary transparency project. I think it&rsquo;s fair to say that efforts like this are a somewhat new movement within the women in tech community. In part, it&rsquo;s as a response to the ways our male counterparts have already established similar systems of support (and sources to boost self-confidence) in terms of their worth. I suppose that out of necessity we&rsquo;ve begun to rally around each other in hopes to help close the gender pay gap. There&rsquo;s strength in numbers, and women have realized it&rsquo;s time to light that fire.&rdquo;</p>\n\n\n\n<p>The first step toward closing the gender pay gap is talking about it. Kardon said the best help women can provide others is to be vocal about helping one another.</p>\n\n\n\n<p>&ldquo;Talking about salary <em>doesn&rsquo;t have to be</em> taboo anymore,&rdquo; she said. &ldquo;The more we share, the better we position each other to know our worth.&rdquo;</p>\n\n\n\n<p>She stresses that the movement cannot stop with data on salaries. Women must be vocal about their interview experiences and their work environments. They must share both the good and the bad experiences while keeping companies accountable for maintaining inclusive practices.</p>\n\n\n\n<p>&ldquo;For some reason, professional society evolved to support companies more than individuals, in the sense that we are inclined to feel uncomfortable sharing our salary, our benefits, how much stock we get, etc.,&rdquo; she said. &ldquo;We get scared that if we share, it might somehow negatively affect our position within the companies we work for. Guess what? That <em>only</em> supports companies because it lets <em>them</em> control the narrative. In order to support ourselves as individuals, and hold companies accountable, we should switch that practice to being open about our experiences.&rdquo;</p>\n\n\n\n<p>Kardon described taking those first steps toward normalizing these conversations as scary.</p>\n\n\n\n<p>&ldquo;In my personal experience, sharing the success of this project within Pagely felt like a little bit of a risk, but my higher-ups have been supportive,&rdquo; she said. &ldquo;They&rsquo;ve published my successes across their social platforms, the Pagely newsletter, etc., which is great and has helped the initiative grow even more. I did feel like I might be stirring some sort of pot at first, but it&rsquo;s lead to some more open conversations that I hadn&rsquo;t previously had with employers. I needed to take that risk to continue advocating for working women, and I&rsquo;m glad I did.&rdquo;</p>\n\n\n\n<h2>Roadblocks and Systemic Issues</h2>\n\n\n\n<p class=\"has-drop-cap\">Kardon explains that some of the roadblocks to higher salaries are often self-inflicted because many women lack the confidence of their male counterparts in negotiations. Part of the solution is knowing what they are worth going in.</p>\n\n\n\n<p>&ldquo;The process many organizations implement today is that you, as the talent, go into an interview and are asked what your ideal salary band is,&rdquo; she said. &ldquo;This means you set the bar for how much the company needs to offer you. Let&rsquo;s say they were planning on allocating $100K to this salary, but you only indicate $80K as your ideal number. Do you know any companies that would come back and say, &lsquo;well, we think you&rsquo;re worth more&rsquo;? I don&rsquo;t think that&rsquo;s standard practice anywhere. To put it in plain terms, if a woman is more inclined to low ball herself to that $80K number, her male counterpart might have the built-in confidence to go ahead and aim higher at $100K and have his demands met.&rdquo;</p>\n\n\n\n<p>The larger roadblock stemming from this is that starting salaries will determine future earnings with a company. Raises are often based on a percentage of that starting salary rather than value to the company.</p>\n\n\n\n<p>&ldquo;After a handful of years, you gain a <em>lot</em> of skill and knowledge in your current position,&rdquo; Kardon said. &ldquo;But, you&rsquo;re still tied to that initial number which oftentimes ends up low compared to the expertise you&rsquo;ve developed. In that sense, the only way forward is to find another job. For women, we&rsquo;re more likely to be undervalued over time because we didn&rsquo;t understand how much we were worth in that initial salary negotiation.&rdquo;</p>\n\n\n\n<p>Kardon does not want to dismiss systemic issues such as gender discrimination, which are not self-inflicted roadblocks. &ldquo;I think, luckily, there is a trend towards less of that in tech today &mdash; though it still exists, don&rsquo;t get me wrong,&rdquo; she said. &ldquo;The best thing I can offer here, in terms of simple solutions that companies can implement to help address these issues, are organization-wide salary transparency and better people practices.&rdquo;</p>\n\n\n\n<p>One solution is for companies to follow the lead of Buffer with its <a href=\"https://buffer.com/salary/senior-data-engineer/average\">publicly viewable salary calculator</a>. This helps level the field in salary negotiations for all genders.</p>\n\n\n\n<p>Another important aspect is taking care of people&rsquo;s needs. Pagely, the company Kardon works for, provides three months of paid parental leave for both parents. &ldquo;Yes, this is great for male parents, but benefits like this also make it possible for birthing (and working) women to get the support they need from their partners,&rdquo; she said. &ldquo;There&rsquo;s nothing more isolating than being scared and alone at home with a newborn when your partner goes back to work two weeks later. People practices like this make sure women don&rsquo;t bear that responsibility all on their own. It&rsquo;s a small start, but a wonderful move in the right direction of equality and shared responsibilities in the home.&rdquo;</p>\n\n\n\n<p>However, more can be done. &ldquo;Other women-led people practices to consider are reimbursement for fertility treatments and lactation consultations, professional female networking, women&rsquo;s leadership development programs, and so much more,&rdquo; said Kardon.</p>\n\n\n\n<h2>The WordPress Ecosystem and Women</h2>\n\n\n\n<p class=\"has-drop-cap\">While Kardon does not have data specific to WordPress companies, the data she has collected thus far is clear. Women make up to 10%, on average, less than their male counterparts in the tech industry. Most of this data comes from women who are developers and engineers, jobs that are in abundance in the WordPress ecosystem.</p>\n\n\n\n<p>&ldquo;Overall, on a positive note, I think the WordPress community is inherently inclusive,&rdquo; said Kardon. &ldquo;At WordCamps, we see a high number of female organizers and speakers, and there are a bunch of female-founded companies in the ecosystem and women being recognized for the work they do in our community.&rdquo;</p>\n\n\n\n<p>&ldquo;A few examples of some of the most respected people in WordPress, who happen to be female, are Lisa-Sabin Wilson, co-owner of WebDevStudios; Tracy Apps of Tracy Apps Design; Rian Kinney of The Kinney Firm; Helen Hou-Sand&iacute;, director of open source initiatives at 10up and WordPress lead developer; Rachel Cherry; Andrea Middleton; Josepha Haden; and of course Sally Strebel, co-founder and COO of Pagely,&rdquo; she said.</p>\n\n\n\n<h2>Available Tools and Resources</h2>\n\n\n\n<p class=\"has-drop-cap\">Kardon describes this movement as new-<em>ish</em> with more resources being created every day. As more women become vocal and begin supporting each other, the more progress our society will make.</p>\n\n\n\n<p>The following links are to sites and resources where women, not those just in tech, can help each other and find more information (links provided by Kardon):</p>\n\n\n\n<ul><li><a href=\"https://www.ellevest.com/magazine\">Ellevest</a>, an online magazine that tackles money, career, and relevant topics.</li><li><a href=\"https://www.linkedin.com/in/salliekrawcheck/\">Videos on LinkedIn</a> from Ellevest CEO, Sallie Krawcheck.</li><li><a href=\"https://elpha.com/\">Elpha</a>, a community for women in tech to speak candidly.</li><li><a href=\"https://theriveter.co/\">The Riveter</a>, a group for women and allies fighting for equality.</li><li><a href=\"https://www.femalefoundercollective.com/\">The Female Founder Collective</a>, a network of businesses led by women, supporting women.</li></ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Mar 2020 19:58:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: The Wacky World of Sorta Brilliant’s Sorta Fun Block Plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97824\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:183:\"https://wptavern.com/the-wacky-world-of-sorta-brilliants-sorta-fun-block-plugins?utm_source=rss&utm_medium=rss&utm_campaign=the-wacky-world-of-sorta-brilliants-sorta-fun-block-plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9731:\"<div class=\"wp-block-cover alignfull has-background-dim has-cool-to-warm-spectrum-gradient-background\"><div class=\"wp-block-cover__inner-container\">\n<h1 class=\"has-text-align-center is-style-ghostwriter text-center\">The Wacky World of Sorta Brilliant&rsquo;s Sorta Fun Block Plugins</h1>\n</div></div>\n\n\n\n<div class=\"wp-block-group alignwide ticss-8eeb9a7e\"><div class=\"wp-block-group__inner-container\">\n<p class=\"has-drop-cap my-8\">You could say that I am a bit of a fanboy of the late 1990s and early 2000s web. I loved the funkiness of GeoCities. I enjoyed the random midi file that began playing when a new web page opened. I am <a href=\"https://wptavern.com/rebirth-of-creativity-gutenberg-and-the-future-of-wordpress-themes\">nostalgic about an early web</a> that felt like an explosion of weird creativity that was driven by the passion of the people who were using this newfangled toy and were not quite sure what to do with it. Visiting a web page was like diving into a shameless, bottomless pit of geekdom.</p>\n\n\n\n<p>When I see a new block editor plugin pushed out by Nick Hamze, I perk up. It is sure to be something interesting.</p>\n\n\n\n<p>Hamze is the mind behind <a href=\"https://sortabrilliant.com/\">Sorta Brillian</a>t, a website that is dedicated to sharing unique blocks mostly for the fun of it. In a web development world that is seemingly pushing another business or eCommerce tool every day, it is easy to sit back with blinders on. <em>Yawn.</em> Hamze is asking, <em>where has all the creativity gone?</em> He is putting his ideas and cash behind the development of features that harken to those early, fun days of the web. His projects will not be everyone&rsquo;s cup of tea, but he is filling in a particular void that has been widening for years. And he&rsquo;s doing it in style.</p>\n\n\n\n<p>&ldquo;I have at least 10 new block ideas a day,&rdquo; said Hamze. &ldquo;They just pop in there, and I have them made as fast as I can.&rdquo;</p>\n\n\n\n<p>Part of the problem is finding enough developers to help push out these projects at the pace that he can draw them up. Hamze is the creative force behind the projects, but he is not a programmer.</p>\n\n\n\n<p>Discoverability of these plugins can be also an issue. They are not exactly the types of plugins that are in fashion at the moment and can fly under the radar. &ldquo;I waffle back and forth between wanting to make stuff to make WordPress fun and get lots of installs,&rdquo; he said. &ldquo;Every time I ask someone how to get more installs, they tell me to make more boring stuff, but I don&rsquo;t want to do that.&rdquo; Hamze is speaking about the ecosystem&rsquo;s drive toward more minimalist and business-oriented trends.</p>\n\n\n\n<p>Hamze said many of his plugin ideas come from building his Zune fansite, <a href=\"https://hellofromseattle.com/\">Hello From Seattle</a>. It is a passion project for a long-dead MP3 player, but it fuels his brand of creativity.</p>\n\n\n\n<p>&ldquo;I see zero passion, especially in the WordPress space,&rdquo; Hamze said. &ldquo;It seems like everyone is just going through the motions lately. I&rsquo;m trying my best but I don&rsquo;t see anyone else who wants to bring back the old days. <em>Fun</em> doesn&rsquo;t seem like something WordPress is supposed to be used for. It makes me kind of sad. <em>WordPress is supposed to be used for large corporations and business; it shouldn&rsquo;t be used for silly things like I&rsquo;m doing.</em>&ldquo;</p>\n\n\n\n<p>He has at least one fan. <em>Hello.</em> I am just here to bring the rest of you along for the revival of the weird and wacky web experienced during the golden age of website creation.</p>\n\n\n\n<p>One such throwback plugin is his <a href=\"https://wordpress.org/plugins/peculiar-pointers/\">Peculiar Pointers</a> block. It is a container that allows users to upload an image to use as a custom cursor while moving the mouse over anything within the block. May the modern web development gods strike me down, but custom cursor images were really fun back in the day. I said it. No shame here.</p>\n\n\n\n<p>For users who do not have a custom cursor image in mind, Hamze provides some inspiration via his new <a href=\"https://weirdpress.club/\">WeirdPress website</a>, an early venture into his <em>weirder</em> WordPress ideas. &ldquo;I love making things but also really want to get people to actually use them,&rdquo; he said. &ldquo;With <a href=\"https://block.garden/\">Block Garden</a> and Sorta Brilliant, I try to stay a bit between fun and business because of this. With WeirdPress, I just wanted to make things that were really dumb but made me happy. Plugins, that if I&rsquo;m the only user, it&rsquo;s OK. People don&rsquo;t do things for fun anymore.&rdquo;</p>\n\n\n\n<p>Hamze wants more plugin developers to use their skills to be creative with block development. &ldquo;I&rsquo;ve asked all my ex-coworkers or people that I know in the WP world, <em>if you have the ability to make blocks, why don&rsquo;t you?</em> I can&rsquo;t code, so I end up paying a ton of money every month to developers. If I had the ability, I&rsquo;d be coding fun plugins all day long. But, to most people, WordPress is a business, a job, not something they do for fun.&rdquo;</p>\n\n\n\n<h2>A Collection of Block Editor Plugins</h2>\n\n\n\n<img />VHS filter from the Altered Reality plugin.\n\n\n\n<p class=\"has-drop-cap\">Last week, Hamze released the <a href=\"https://wordpress.org/plugins/altered-reality/\">Altered Reality</a> plugin, which allows users to select from over two dozen filters to apply over images. Aside from simply having a cool name for a plugin, end-users can enjoy everything from the funky Acid Trip filter to something more professional like the cool, blue tones of the Brooklyn filter. Most of the filters come from the <a href=\"https://una.im/CSSgram/\">CSS Gram</a> project, but there are a few extras thrown in for fun, such as the throwback VHS style.</p>\n\n\n\n<p>Hamze laments about the shortage of unique designs in the WordPress theme design world. &ldquo;It&rsquo;s like an afterthought,&rdquo; he said. &ldquo;All the themes look basically the same. They are minimalist and boring and have no personality. One of the main things I want to do is introduce fun design to WordPress. I can&rsquo;t do anything about boring themes, but I can make them a bit more fun.&rdquo;</p>\n\n\n\n<p>Because of the complexities of building out a fully-fledged WordPress theme, it is not cost-effective to fund such development at the moment. Hamze is sticking with smaller, one-off plugins that bring something unique to the block editor.</p>\n\n\n\n<img />\n\n\n\n<p>Last month, Hamze released <a href=\"https://wordpress.org/plugins/meme-me/\">Meme Me</a>, a plugin that allows users to generate a meme-style image directly via the block editor. The plugin is simple. It creates a custom image block style. When chosen, the image caption becomes the meme text. The plugin also offers a few design settings, such as the location of the text. A useful feature for the future would be to make the entire meme downloadable for sharing on social media. <em>That&rsquo;s what half of Facebook and Instagram are these days, right?</em></p>\n\n\n\n<p>It is not all fun and games. Hamze, through his Sorta Brilliant brand, has several block-related plugins that fit into the more <em>sensible</em> side of the web. <a href=\"https://wordpress.org/plugins/block-shots/\">Blockshots</a> allows end-users to snap a screenshot of individual blocks from the editor. <a href=\"https://wordpress.org/plugins/lazy-lists/\">Lazy Lists</a> is ideal for people who need to sort their list block alphabetically or numerically at the click of the button. <a href=\"https://wordpress.org/plugins/dapper-desktop/\">Dapper Desktop</a> is useful for turning large images into multiple, downloadable image sizes for visitors to use as wallpapers.</p>\n\n\n\n<p>On the wackier side of things, Hamze released a plugin called <a href=\"https://wordpress.org/plugins/vital-information/\">Vital Information</a> yesterday. It displays messages from a segment titled <em>Vital Information for Your Everyday Life</em> from the 1990s sketch-comedy <em>All That</em> across the top of the block editor. It is the modern-day Hello Dolly plugin with useful information like, &ldquo;If you&rsquo;re drinking apple juice, and it feels warm, odds are that ain&rsquo;t apple juice.&rdquo;</p>\n\n\n\n<p>We are barreling toward the point where there is truly a plugin for everything.</p>\n\n\n\n<p>Hamze said he does not plan far in advance when it comes to plugin ideas. &ldquo;Most of my projects go like this,&rdquo; he began. &ldquo;I think of an idea in the morning and two days later it&rsquo;s launched.&rdquo; He is currently working on a plugin that will <em>blockify</em> the WordPress dashboard. He also has a budding project for fun button styles. Followers of the <a href=\"https://github.com/sortabrilliant\">Sorta Brilliant GitHub account</a> can keep track of his projects as they are born.</p>\n\n\n\n<p>Recently, Hamze has felt discouraged by the seeming lack of interest from leaders within the core and inner WordPress community. He feels like there is not enough of a push to bring unique flavors to design in general to the WordPress ecosystem. &ldquo;One thing that I really believe is that we need fresh blood in the WordPress world,&rdquo; he said. &ldquo;There are some amazing designers out there that could make WordPress fun if we just made them feel welcome.&rdquo;</p>\n\n\n\n<p>I, for one, am ready see a scrolling-text block plugin.  Because the old <code>&lt;marquee&gt;</code> HTML tag is obsolete, we need a replacement to bring back some of the fun from those long-lost days of my early foray into the web.</p>\n</div></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Mar 2020 20:47:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WPTavern: WooCommerce 4.0 Lands with New Admin Interface and Updated Onboarding Experience\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97797\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:225:\"https://wptavern.com/woocommerce-4-0-lands-with-new-admin-interface-and-updated-onboarding-experience?utm_source=rss&utm_medium=rss&utm_campaign=woocommerce-4-0-lands-with-new-admin-interface-and-updated-onboarding-experience\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5219:\"<p class=\"has-drop-cap\">Yesterday, Automattic <a href=\"https://woocommerce.wordpress.com/2020/03/10/woocommerce-4-0-is-here/\">launched version 4.0</a> of its WooCommerce plugin.  Except for the new admin interface, which has been in testing for over a year, the development of this update began in January 2020.  The update also includes an updated onboarding experience for new users.</p>\n\n\n\n<p>Version 4.0 is a major release of the plugin.  Users should create a database backup before upgrading.  The WooCommerce team suggests testing on a staging site before upgrading on a live site to make sure everything runs smoothly.</p>\n\n\n\n<p>The new version is not completely backward compatible with previous versions of WooCommerce.  Reading the <a href=\"https://docs.woocommerce.com/document/how-to-update-woocommerce/\">How to Update WooCommerce</a> documentation before clicking the update button is recommended.</p>\n\n\n\n<p>Developers and end-users should take note of the <a href=\"https://woocommerce.wordpress.com/2020/01/08/action-scheduler-3-0/\">changes to the Action Scheduler library</a>, which is the background job runner bundled in WooCommerce.  In the past, it stored data as a custom post type, which has now been switched to a custom database table.  The change should make background processes more performant with large amounts of data.  It also has the potential to break custom code that does not interface directly with the API, but this should not be an issue for most users.</p>\n\n\n\n<h2>WooCommerce Admin Project Merged into the Core Plugin</h2>\n\n\n\n<img />Customizable dashboard stats and charts.\n\n\n\n<p class=\"has-drop-cap\">With well over a year of developer and user feedback,  the WooCommerce team decided it was time to merge its new admin interface into the core plugin.  Originally, the interface was developed as a separate plugin named <a href=\"https://wordpress.org/support/plugin/woocommerce-admin/\">WooCommerce Admin</a>.  The project began <a href=\"https://woocommerce.wordpress.com/2018/10/18/wc-admin/\">alpha testing in October 2018</a> and was later released publicly in February 2019. </p>\n\n\n\n<p>WooCommerce Admin is a JavaScript-driven experience, which allows loading certain data while remaining on the same screen.  It is indicative of the direction we will likely see more of in the future.  The plugin currently has over one million active installs and a three-star rating.  For many reviewers, they either loved or hated the plugin version, with most of the ratings either coming in one or five stars.</p>\n\n\n\n<p>The new admin interface features a customizable dashboard.  End-users can choose which stats to display in the performance section, select the charts they want to appear, and customize their leaderboard output.</p>\n\n\n\n<p>Reports are much improved over previous iterations.  The updated interface allows better filtering and comparisons.  It should provide merchants with more useful insights into how well their shop is performing.</p>\n\n\n\n<p>Plugin developers should take note that admin notices may not appear on all WooCommerce screens.  This seems to be limited to custom screens created by WooCommerce.  Notices appear on WordPress-generated pages (e.g., products, orders, coupons).  While this may be a welcome sight for third-party notices that are sometimes plastered across the admin, it could present an issue for plugins that are specifically attempting to display a notice related to WooCommerce.</p>\n\n\n\n<p>My biggest dislike is the inclusion of a sticky header and menu on all WooCommerce admin screens.  I have been vocal in the past about my dislike of sticky headers while viewing sites from my laptop.  If their height is small enough, it is a non-issue.  However, when a sticky header uses enough screen real estate, it triggers a gut-wrenching claustrophobia that is hard for me to shake.  WooCommerce&rsquo;s new sticky header would be enough for me to look elsewhere if starting a shop, or at least push me to write some custom code to change it.  I know this is a personal hangup, but I hope it is something that gets dropped from a future release.</p>\n\n\n\n<h2>Updated Onboarding Process</h2>\n\n\n\n<img />Selecting a theme during the final onboarding step.\n\n\n\n<p class=\"has-drop-cap\">The onboarding process was spot on.  For someone who rarely sets up online shops, each step was easy and helped me get off the ground running.  This type of experience for larger plugins should be the standard rather than the exception.  Far too often with these types of plugins, users can feel like they have been tossed into the wilderness with no compass after plugin activation.  This was one of the nicer onboarding experiences I have had with a WordPress plugin.</p>\n\n\n\n<p>Users have the option of selecting the old setup wizard if they are already familiar with it.  The new one is worth a spin.</p>\n\n\n\n<p>The first step primarily points users to Jetpack and other Automattic services, but many of those will be useful for shop owners.  There are also options for connecting with Facebook and Mailchimp.  The final step of the wizard offers a selection of free and paid themes, which is a useful part of setting up a shop for many first-time store owners.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Mar 2020 20:46:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"WordPress.org blog: WordPress 5.4 RC2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8422\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2020/03/wordpress-5-4-rc2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3269:\"<p>The second release candidate for WordPress 5.4 is now available!</p>\n\n\n\n<p>WordPress 5.4 is currently scheduled to be released on&nbsp;<strong><a href=\"https://make.wordpress.org/core/5-4/\">March 31 2020</a></strong>, and we need&nbsp;<em>your</em>&nbsp;help to get there—if you haven’t tried 5.4 yet, now is the time!</p>\n\n\n\n<p>There are two ways to test the WordPress 5.4 release candidate:</p>\n\n\n\n<ul><li>Try the&nbsp;<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a>&nbsp;plugin (choose the “bleeding edge nightlies” option)</li><li>Or&nbsp;<a href=\"https://wordpress.org/wordpress-5.4-RC2.zip\">download the release candidate here</a>&nbsp;(zip).</li></ul>\n\n\n\n<p>For details about what to expect in WordPress 5.4, please see the&nbsp;<a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate post</a>.</p>\n\n\n\n<p>RC2 addresses improvements to the new About page and <a href=\"https://core.trac.wordpress.org/query?id=49611%2C49318%2C49295%2C49585%2C49568%2C49549&milestone=5.4&group=component&col=id&col=summary&col=milestone&col=owner&col=type&col=status&col=priority&order=priority\">5 fixes</a> for the following bugs and regressions:</p>\n\n\n\n<ul><li><a href=\"https://core.trac.wordpress.org/ticket/49611\">49611</a> &#8211; Block Editor: Update WordPress Packages WordPress 5.4 RC 2</li><li><a href=\"https://core.trac.wordpress.org/ticket/49318\">49318</a> &#8211; Bundled Themes: Twenty Twenty content font CSS selector is too important</li><li><a href=\"https://core.trac.wordpress.org/ticket/49585\">49585</a> &#8211; REST API: Fix typo in disable-custom-gradients theme feature description</li><li><a href=\"https://core.trac.wordpress.org/ticket/49568\">49568</a> &#8211; Block Editor: Fix visual regression in editor&#8217;s color picker</li><li><a href=\"https://core.trac.wordpress.org/ticket/49549\">49549</a> &#8211; Bundled Themes: Calendar widget CSS fixes on various Bundled themes</li></ul>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the&nbsp;<em>Tested up to</em>&nbsp;version in the readme to 5.4. If you find compatibility problems, please be sure to post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>&nbsp;so we can figure those out before the final release.</p>\n\n\n\n<p>The&nbsp;<a href=\"https://make.wordpress.org/core/2020/03/03/wordpress-5-4-field-guide/\">WordPress 5.4 Field Guide</a>&nbsp;has also been published, which details the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English?&nbsp;<a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Mar 2020 21:40:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Francesca Marano\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: Advice for Newcomers to Remote Work: Lessons Learned\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97784\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:167:\"https://wptavern.com/advice-for-newcomers-to-remote-work-lessons-learned?utm_source=rss&utm_medium=rss&utm_campaign=advice-for-newcomers-to-remote-work-lessons-learned\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7835:\"<p>&ldquo;What did you do today?&rdquo; asked my aunt.  &ldquo;Take a nap?  Watch TV?&rdquo;</p>\n\n\n\n<p>&ldquo;You know, I work a real job, Auntie?  They pay me and everything.&rdquo;</p>\n\n\n\n<p>Making some of my family and friends understand what I <em>actually</em> do from home is tough.  If it is a family member I don&rsquo;t really like, I sometimes respond, &ldquo;I work &mdash; probably harder than you.&rdquo;  In all seriousness, over time, you learn to roll with it.  In 2020, more people are accustomed to the concept of remote work than ever before, so the conversations have become easier, even with family and friends.</p>\n\n\n\n<p>With the latest coronavirus strain (COVID-19) becoming widespread, many companies and people are looking at remote work options.  I am not sure if the world is ready, but it is a part of our new reality.  Those of us within the WordPress community can lead the charge by sharing our experiences and advice.</p>\n\n\n\n<p>I am in my twelfth year of working from home.  It is hard to believe that there was ever a time when I went into an office or commuted to a watermelon field in the middle of an Alabama summer.  I was the first person in my family to work from home.  Now I have siblings who do much of their work remotely, a nephew who is using the internet to jump-start his career before leaving high school, and a cousin who is &ldquo;exploring some options&rdquo; (he really just doesn&rsquo;t like wearing shoes).  Still, the overwhelming majority of the people I know are required to work in a physical location.  For many, working from home is not an option.  However, others are now facing a wild swing in how they will work for the next few weeks, months, and perhaps beyond.</p>\n\n\n\n<p>What follows is my advice for newcomers to remote work.  I have spent nearly my entire professional career behind a laptop at home and have had to learn some important lessons the hard way.</p>\n\n\n\n<p>Before diving in, my top tip is to get a comfortable chair and work from the front porch if possible.  Enjoy nature.  Watch the birds.  Breathe fresh air.  Don&rsquo;t trade one stuffy office for another.</p>\n\n\n\n<h2>Organization and Structure</h2>\n\n\n\n<p class=\"has-drop-cap\">I have worked remotely ever since I returned home from a teaching stint in South Korea.  I had spent a over a year teaching English as a second language, mostly to kids who would have rather been out playing.  Teaching is tough work.  You enjoy imparting knowledge upon young minds.  However, you must be part caregiver; part administrator; and part judge, jury, and detention-giver for the kid cussing you out in a foreign language (tip: always learn the bad words when teaching in another country).  At the end of the day, you are exhausted, but you get up the next morning because you&rsquo;re passionate about what you are doing.  </p>\n\n\n\n<p>For me, one of the best parts of going to the office was the structure.  To that point, I had spent my entire life within rigidly-defined systems.  From age 5 to 23, I was in school.  Nearly everything I did or anywhere I went was decided by someone else, whether that was my parents, teachers, coaches, or boss at a part-time job.  Moving into a job that was likewise structured seemed natural.</p>\n\n\n\n<p>My days felt like they had a purpose because of this structure.</p>\n\n\n\n<p>In the month before I moved back home to the States, I launched my business around WordPress.  I was excited to work from home.  I was unsure what that actually meant, but I was going to do it.  I would no longer be constrained by administrators or bosses.  I could set my own schedule.</p>\n\n\n\n<p>The idea sounded great&hellip;<em>in theory</em>.</p>\n\n\n\n<p>While I had successfully launched a business that I would continue for over a decade, there was an essential missing piece of the puzzle.  I had no structure.  In some ways, this was exciting.  I never knew what a new day would bring.  I could choose my own adventure each morning.</p>\n\n\n\n<p>However, that disarray eventually took its toll.  It took a toll on my health as my waistline continued to expand.  It took a toll on me mentally as I slept and worked at random hours.  I knew I could not continue along the same path.</p>\n\n\n\n<p>Before setting out on my own, all structure in my life was determined by others.  I had not learned the basic skills necessary for organizing my daily routine.  I thrive when I know exactly what I am going to do.  A little spontaneity is not bad, and my schedule does not need to broken down by the hour or minute.  However, a little planning and outlining goes a long way toward kick-starting my day.</p>\n\n\n\n<p>When talking with people who are setting out on their first journey into working from home, I always stress the need for structure.  This becomes even more important for people who are married or have children.  Not everyone needs to be rigid with their organization and map out each hour of the day.  However, it is good practice when first starting out to have some basic outline in place, at least until you get a feel for what works for you.</p>\n\n\n\n<p>For me, this means having daily goals.  In my current work setting, this is about having the next day&rsquo;s story lined up plus a couple of backup stories in case the first falls through.  It means knowing who I need to contact for an interview and touching base with sources.  In the past, as a developer, I would set up daily feature development or bug fix goals.  This system leaves me wiggle room while still setting me up for success.  I also play with the formula a bit when I feel like I need more or less structure.</p>\n\n\n\n<p>Everyone will be a little different, but jumping into remote work is a massive work and lifestyle change.  Having some level of organization and structure can set you up for easy wins early on.</p>\n\n\n\n<h2>Social Health and Relationships</h2>\n\n\n\n<p class=\"has-drop-cap\">The worst thing about working from home can be the loss of social structure.  More often than not, co-workers become part of our inner groups.  You find someone to be your gym spotter from your department.  You start a weekly poker game with folks from the office breakroom.  Often, where we work defines a part or all of our social circle.</p>\n\n\n\n<p>It is also easy to get too caught up in your work when no longer commuting to the office.  It becomes easier to skip a night out to the theater when you have been working on your latest project for 16 hours.  It is easy to forgo family dinner because you want to wrap up a few emails.  Your spouse suddenly becomes the only one reading the kids their bedtime story as you do a final check-in for the night.</p>\n\n\n\n<p>The biggest regret I have about working from home over the years is missing opportunities to spend with family and friends.  Far too often, I was working on my next &ldquo;big&rdquo; project.  I had to build out that feature that was going to revolutionize whatever I was working on.</p>\n\n\n\n<p>There is rarely something so important that it cannot wait until the morning.  While we all have to put food on the table, our social well-being is just as important as financial stability.</p>\n\n\n\n<p>Even those of us who prefer to be alone most of the time still need other people in our lives.  This connection with others is part of what makes us human.  It is not something we can afford to sacrifice.  You do not need to say <em>yes</em> to every social invite, but make sure you do not miss out on all human-to-human interaction.</p>\n\n\n\n<p>If nothing else, at least get a few furry, feathery, or scaly companions.  My cats, chickens, and ducks certainly keep life entertaining when I am not out in the world.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p>For those of you who work from home, what are your tips?  Share your experiences, lessons, and advice.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Mar 2020 19:55:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"Post Status: The benefits of Masterminds\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=78070\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://poststatus.com/masterminds/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1729:\"<p>Ken Wallace runs <a href=\"https://mastermindjam.com/\">Mastermind Jam</a>, which according to the website, &#8220;gives you everything you need to join, create, and manage your mastermind group, all without having to waste time cobbling together a bunch of different software, forms, and shared documents, even if you don\'t have a large personal network.&#8221;</p>\n\n\n\n<p>Here\'s the episode:</p>\n\n\n\n\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p><strong>Some of the topics discussed about Masterminds</strong></p>\n\n\n\n<ul><li>Defining what a mastermind is</li><li>The difference between a mastermind and other community channels</li><li>Why masterminds are important to hold with peers outside of your company</li><li>Learning to trust your mastermind</li><li>The importance of consistency, and setting up a regular cadence</li><li>How to structure conversations</li><li>How to find people for a mastermind </li></ul>\n\n\n\n<h3>Links</h3>\n\n\n\n<ul><li><a href=\"https://mastermindjam.com/\">Mastermind Jam</a>: find your mastermind</li><li>Ken <a href=\"https://twitter.com/boaticus\">on Twitter</a></li></ul>\n\n\n\n<h3>Episode Parter: <a href=\"https://poststat.us/sandhills\">Sandhills Development</a></h3>\n\n\n\n<p>No matter what you\'re working on with your WordPress website, <a href=\"https://poststat.us/sandhills\">Sandhills Development</a> probably has a tool that can help you. </p>\n\n\n\n<ul><li>Easy Digital Downloads – Sell digital products with WordPress</li><li>AffiliateWP – A full-featured affiliate marketing solution</li><li>Restrict Content Pro – A powerful membership plugin for WordPress</li><li>Sugar Calendar – WordPress event management made simple</li><li>WP Simple Pay – A lightweight Stripe payments plugin</li></ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Mar 2020 16:39:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: Editor Will Default to Fullscreen Mode in WordPress 5.4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97751\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:175:\"https://wptavern.com/editor-will-default-to-fullscreen-mode-in-wordpress-5-4?utm_source=rss&utm_medium=rss&utm_campaign=editor-will-default-to-fullscreen-mode-in-wordpress-5-4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5068:\"<img />WordPress editor in fullscreen mode.\n\n\n\n<p class=\"has-drop-cap\">Riad Benguella announced on the core development blog last week the editor in <a href=\"https://make.wordpress.org/core/2020/03/03/fullscreen-mode-enabled-by-default-in-the-editor/\">WordPress 5.4 will ship in fullscreen mode</a> by default.  While some form of fullscreen or distraction-free writing has existed for years in the core platform, this marks the first time WordPress will make it the default experience.</p>\n\n\n\n<p>Not all installations will see the fullscreen editor upon upgrading.  The editor will be in fullscreen mode the first time a user opens the editor in a new installation, on a new device, or whenever WordPress resets a user&rsquo;s preferences.</p>\n\n\n\n<p>Some people were not happy with the timing of the <a href=\"https://github.com/WordPress/gutenberg/pull/20611\">code change</a>, regardless of their feelings about whether it was a good decision to switch to a fullscreen experience by default.  The change was slipped in three weeks after a feature and enhancements freeze for the WordPress 5.4 development cycle.  This was also the same day that the first <a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">WordPress 5.4 release candidate</a> was released.  Some argued that the development cycle should remain sacred, that last-minute changes should be punted to the next cycle.  Doing so would provide an appropriate level of testing and preparation.  The shock-factor would also be lessened when more people are aware that a change is coming.</p>\n\n\n\n<p>&ldquo;I would have expected this to sit in the plugin for a cycle or two, and dropping an alteration to the editor&rsquo;s behavior this major into core several hours before 5.4 was promoted to Release Candidate is very confusing to me,&rdquo; said software engineer K. Adam White.  &ldquo;What about this change made it have to happen today, rather than following our release process and bundling this enhancement with 5.5?&rdquo;</p>\n\n\n\n<p>Matt Mullenweg, WordPress co-founder and 5.4 release lead, chimed in and accepted responsibility.  &ldquo;This is on me as release lead &mdash; I&rsquo;ve been meaning to get this in for a while but it got lost in the shuffle,&rdquo; he said.  &ldquo;I&rsquo;m very comfortable with the decision to have fullscreen by default given the user testing we&rsquo;ve seen and other qualitative feedback, which I&rsquo;ve also heard is similar to what folks like GoDaddy have found in their testing. The code change is minimal so if during the month of March we need to revert it, shouldn&rsquo;t be a problem.&rdquo;</p>\n\n\n\n<p>Late changes can catch people who provide support or manage client websites off guard.  Joost de Valk, founder and CPO of Yoast, noted that such changes also force extra work on people who maintain courses and other materials around the editor.</p>\n\n\n\n<h2>The Fullscreen Experience</h2>\n\n\n\n<p class=\"has-drop-cap\">Admittedly, I have never used fullscreen mode since the block editor landed.  I tested the earlier iteration when the classic editor was still the norm.  I did not care for it then, but I also did not care for the classic editor.  Instead, I always wrote in an offline editor.  I was not the ideal test candidate for the feature.  Since then, I have not given it much thought.</p>\n\n\n\n<p>When testing the fullscreen mode in WordPress 5.4, I was a little shocked by the change.  It felt like I stepped outside of my WordPress admin panel.  However, that shock quickly wore off.  The experience was not much different from working within the normal editor.</p>\n\n\n\n<p>The only thing that was a poor user experience for me was clicking the arrow button at the top left of the editor.  I had wrongly assumed the button would open the WordPress admin menu.  Instead, it took me back to the posts management screen.  The button does have a &ldquo;View Posts&rdquo; tooltip that appears when you hover it, but I tend to move fast and clicked it before I understood its purpose.  </p>\n\n\n\n<img />Top left button in editor returns users to posts management screen.\n\n\n\n<p>I was prepared to open a ticket to address this problem.  However, the Gutenberg team was <a href=\"https://github.com/WordPress/gutenberg/issues/20579\">already on top of the issue</a> and have <a href=\"https://github.com/WordPress/gutenberg/pull/20603\">merged a fix</a> within the plugin that uses the WordPress &ldquo;W&rdquo; icon.  It is unclear if this change will make it into WordPress 5.4.  It would be ideal to avoid the same issue I ran into.</p>\n\n\n\n<p>Finding these types of problems and addressing them is one of the primary reasons that we should avoid major changes to user interfaces late in the development cycle.  If we are lucky, this is the worst problem that arises this time around.</p>\n\n\n\n<p>The fullscreen experience would also be nicer if there was a button or keyboard shortcut to quickly switch modes.  Currently, users must click the &ldquo;&#8942;&rdquo; button for tools and options.  Then, select the editing mode. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 09 Mar 2020 19:44:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"Matt: Sonny Rollins Interview\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=50983\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://ma.tt/2020/03/sonny-rollins-interview/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:186:\"<p><a href=\"https://www.nytimes.com/interactive/2020/02/24/magazine/sonny-rollins-interview.html\">David Marchese at the  NY Times has a beautiful interview with Sonny Rollins up</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 08 Mar 2020 21:27:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: BracketSpace Releases Library of Reusable Code for Plugin and Theme Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97228\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:223:\"https://wptavern.com/bracketspace-releases-library-of-reusable-code-for-plugin-and-theme-development?utm_source=rss&utm_medium=rss&utm_campaign=bracketspace-releases-library-of-reusable-code-for-plugin-and-theme-development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4476:\"<p class=\"has-drop-cap\">BracketSpace, a WordPress-centric software development company based, released <a href=\"https://github.com/micropackage/\">Micropackage</a> a few weeks ago.  The project is a collection of open-source repositories with reusable code for inclusion in WordPress plugins and themes.  The library currently has 13 packages, including a filesystem wrapper, a template system, an Advanced Custom Fields block creator, and more.</p>\n\n\n\n<p>The company out of Poland specializes in project outsourcing and plugin development.  Some of their more popular plugins include <a href=\"https://bracketspace.com/downloads/advanced-cron-manager-pro/\">Advanced Cron Manager Pro</a> and <a href=\"https://wordpress.org/plugins/notification/\">Notification</a>, a custom notification plugin in which the BracketSpace sells pro extensions for various services.</p>\n\n\n\n<p>The Micropackage project was driven by the needs of the team and its projects.  &ldquo;We started the Micropackage project to scratch our own itch,&rdquo; said Jakub Mikita, CEO of BracketSpace.  &ldquo;During the past few years of active plugin and website development, we noticed that keeping the code standard was very important for maintainability.&rdquo;  The BracketSpace team had been copying and pasting code between projects.  Eventually, the team asked themselves the inevitable question that most development teams come to &mdash; <em>why not break all of this code up into small packages and maintain them in a single place?</em>  Thus, the Micropackage project was born.</p>\n\n\n\n<p>BracketSpace is using all of the packages in many of its current plugins and themes because the code was originally taken from those projects.  &ldquo;We are now rewriting one of our flagship plugins, Notification, using the micropackages and intend to create every new plugin and theme using them,&rdquo; said Mikita.  &ldquo;And, because they are loosely coupled, there can be a lot of configuration variations.</p>\n\n\n\n<p>Package and dependency management is a standard part of development within the larger PHP development world.  The use of packages has become more and more standard as WordPress has begun using modern JavaScript tooling.  However, the ecosystem mostly falls short when dealing with PHP packages.  While many plugin developers make use of such dependencies, the practice is not common.  WordPress also has no built-in method of handling dependencies.  The situation makes it hard for projects such as Micropackage to gain any real traction within the overall WordPress developer community.</p>\n\n\n\n<h2>The Available Packages</h2>\n\n\n\n<p class=\"has-drop-cap\">The project includes 13 repositories that can be included in WordPress plugins or themes via Composer.  Most of the packages are currently available on the <a href=\"https://packagist.org/packages/micropackage/\">Micropackage page on Packagist</a>.  Several of the packages are essentially wrappers for various WordPress APIs for simpler usage.  However, some of the packages offer new developer features.</p>\n\n\n\n<p>Mikita said the following are the most important packages for the team:</p>\n\n\n\n<ul><li><a href=\"https://github.com/micropackage/dochooks\">DocHooks</a> &ndash; PHP comment annotations repo that supports filters, actions, and shortcodes.</li><li><a href=\"https://github.com/micropackage/requirements\">Requirements</a> &ndash; Environment requirement checker for plugins.</li><li><a href=\"https://github.com/micropackage/filesystem\">Filesystem</a> &ndash; Simplified wrapper around the WordPress Filesystem API.</li><li><a href=\"https://github.com/micropackage/templates\">Templates</a> &ndash; Basic PHP templating solution that supports passing data to templates.</li><li><a href=\"https://github.com/micropackage/responsive-embeds\">Responsive Embeds</a> &ndash; JavaScript package for automatically making any embed responsive.</li></ul>\n\n\n\n<p>The repositories don&rsquo;t stop there.  They have built other wrappers for WordPress APIs, such as caching, scripts, and internationalization.  The team also has a block creator for ACF that allows developers to create blocks from templates.</p>\n\n\n\n<p>BracketSpace has at least five more packages planned for the project.  At the moment, the packages have primarily targeted WordPress developers.  However, Mikita said the team will also create platform-agnostic repositories whenever possible.  That way, they will be useful for developers beyond the WordPress ecosystem.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Mar 2020 20:07:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"WordPress.org blog: People of WordPress: Mary Job\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8406\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/news/2020/03/people-of-wordpress-mary-job/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7791:\"<p><em>You’ve probably heard that WordPress is open-source software, and may know that it’s created and run by volunteers. WordPress enthusiasts share many examples of how WordPress changed people’s lives for the better. This monthly series shares some of those lesser-known, amazing stories.&nbsp;</em></p>\n\n\n\n<h2>How it all began</h2>\n\n\n\n<img src=\"https://i1.wp.com/wordpress.org/news/files/2020/02/At-WordCamp-Kampala-2020.jpeg?resize=632%2C844&ssl=1\" alt=\"Mary Job at WordCamp Kampala 2020\" class=\"wp-image-8410\" />Mary Job at WordCamp Kampala 2020\n\n\n\n<p>Mary remembers when cybercafés started trending in Nigeria. She had just finished high school and was awaiting her results for admission to university. She spent all of her time (10 hours a day) and all of her pocket money buying bulk time online at cafes. All the way through university that was true, until in 2008 she graduated with a degree in philosophy and bought her own computer and modem.</p>\n\n\n\n<p>She started blogging in 2009. Initially, she tried out Blogger, Hubpages, and WordPress—but found WordPress too complicated.&nbsp;</p>\n\n\n\n<h2>Growing up as a timid but curious cat</h2>\n\n\n\n<p>Mary is one of four kids, and the only girl among her siblings. Throughout her childhood she felt shy, even though others didn’t always see her that way. </p>\n\n\n\n<p>When she first started her personal blog, it was mostly an opportunity for her to speak her mind where she was comfortable. Blogging gave her a medium to express her thoughts and with every new post she became a better writer.</p>\n\n\n\n<h2>Rediscovering WordPress</h2>\n\n\n\n<p>After completing a postgraduate diploma in mass communication, Mary started a Masters degree in Information Management. This required a three month internship. She decided to volunteer in Ghana in 2015 at the headquarters of the Salesians of Don Bosco in West Africa (SDBAFW<strong>)</strong> where her uncle was based.</p>\n\n\n\n<p>While she was there, her uncle asked Mary why she was not blogging on WordPress, which also happened to be the software the organisation used. She explained how difficult and complicated it was so he shared a group of beginner-level tutorial videos with her.</p>\n\n\n\n<p>After two weeks of watching those videos, she started to realize she could have a full-time career doing this. So she immediately joined a number of online training groups so she could learn everything.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>I saw a lot of people earning an income from things I knew and did for the fun of it. I found myself asking why I had not turned my passion into a business.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<p>Not long after that, she was contacted by a website editor who was impressed by her blog. With the information available online for WordPress, she was able to learn everything she needed to improve and redesign a site for what turned into her first client.</p>\n\n\n\n<img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/my-home-office-in-2016.jpeg?w=632&ssl=1\" alt=\"\" class=\"wp-image-8412\" />Mary&#8217;s home office in 2016\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>I visited the <a href=\"https://wordpress.org/showcase/\">WordPress.org showcase</a> and was wowed with all the good things I could do with WordPress.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<p>In 2016 after a year of deep WordPress learning, she had fallen in love with the CMS and wanted to give back to the <a href=\"https://make.wordpress.org/\">WordPress open source project</a>.&nbsp;</p>\n\n\n\n<p>She volunteered to help the Community team. And when she moved to Lagos later that year, she discovered there was an active WordPress Meetup community. This started her journey toward becoming a WordPress Meetup Co-organizer and a Global Community Team Deputy.</p>\n\n\n\n<p>Today the Nigerian WordPress community continues to grow, as has the <a href=\"https://www.meetup.com/Lagos-WordPress-Meetup-Group\">Lagos WordPress Meetup</a> group. The first Nigerian WordCamp took place in Lagos in 2018 and a <a href=\"https://2020.lagos.wordcamp.org/\">2020 event is being planned</a>. A local WordPress community also developed in Mary’s hometown in Ijebu.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>I have made great friends and met co-organizers in the community who are dedicated to building and sharing their WordPress knowledge with the community like I am.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<h2>What did Mary gain from using and contributing to WordPress?</h2>\n\n\n\n<ul><li>She <strong>overcame her stage fright</strong> by getting up in front of an audience at her local Meetup to introduce speakers and to talk about the WordPress community.&nbsp;</li><li>She <strong>attended her first of many African WordCamps </strong>in Cape Town, South Africa. Coincidentally this was also her first time outside West Africa. Before that, she had not been in an aircraft for more than one hour.</li><li>She <strong>earned money</strong> from WordPress web design projects to sustain her during her learning period. Mary continues to use WordPress in her work and says she is still learning every day!</li><li>She got to <strong>jump off</strong> Signal Hill in Cape Town when visiting a WordCamp!&nbsp;</li></ul>\n\n\n\n<img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/Moderating-a-Panel-at-WCLOS2019.jpg?fit=632%2C422&ssl=1\" alt=\"\" class=\"wp-image-8413\" />Mary moderating a panel at WordCamp Lagos in 2019\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>Essentially, the community has taught me to be a better communicator, and a better person. I’ve made friends across the world that have become like a family to me.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<p>She now runs a village hub in Ijebu,&nbsp; where she teaches girls digital skills and WordPress as a way of giving back to her town.</p>\n\n\n\n<p>Since she started on this journey, Mary has gotten a fulltime job supporting a WordPress plugin. She’s also become a Community Team Rep and continues to build and foster communities.</p>\n\n\n\n<h2>Mary’s advice to others</h2>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><em>Always seek to understand the basics of whatever knowledge you seek. Never jump in too fast, wanting to spiral to the top while ignoring the learning curve. You will likely crash down effortlessly if you do so, and would have learned nothing.</em></p><cite>Mary Job</cite></blockquote>\n\n\n\n<h2>Contributors</h2>\n\n\n\n<p>Thanks to Alison Rothwell (<a href=\"https://profiles.wordpress.org/wpfiddlybits/\">@wpfiddlybits</a>), Yvette Sonneveld (<a href=\"https://profiles.wordpress.org/yvettesonneveld/\">@yvettesonneveld</a>), Abha Thakor (<a href=\"https://profiles.wordpress.org/webcommsat/\">@webcommsat</a>), Josepha Haden (<a href=\"https://profiles.wordpress.org/chanthaboune/\">@chanthaboune</a>), Topher DeRosia (<a href=\"https://profiles.wordpress.org/topher1kenobe/\">@topher1kenobe</a>). Thank you to Mary Job (<a href=\"https://profiles.wordpress.org/mariaojob/\">@maryojob</a>) for sharing her #ContributorStory.</p>\n\n\n\n<div class=\"wp-block-image\"><img src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/heropress_logo_180.png?w=632&ssl=1\" alt=\"\" class=\"wp-image-8409\" /></div>\n\n\n\n<p><em>This post is based on </em><a href=\"https://heropress.com/essays/wordpress-gave-perfect-identity/\"><em>an article originally published on HeroPress.com</em></a><em>, a community initiative created by </em><a href=\"https://profiles.wordpress.org/topher1kenobe/\"><em>Topher DeRosia</em></a><em>. HeroPress highlights people in the WordPress community who have overcome barriers and whose stories would otherwise go unheard.</em></p>\n\n\n\n<p><em>Meet more WordPress community members over at </em><a href=\"https://heropress.com/\"><em>HeroPress.com</em></a><em>!</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Mar 2020 16:30:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Yvette Sonneveld\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"Matt: Coronavirus and the Remote Work Experiment No One Asked For\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"https://ma.tt/?p=50999\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://ma.tt/2020/03/coronavirus-remote-work/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5196:\"<blockquote class=\"wp-block-quote is-style-large\"><p><em>“We’ll never probably be the same. People who were reticent to work remotely will find that they really thrive that way. Managers who didn’t think they could manage teams that were remote will have a different perspective. I do think we won’t go back.”</em></p><cite><em>Jennifer Christie, Twitter’s head of human resources,</em> in <em><a href=\"https://www.buzzfeednews.com/article/alexkantrowitz/the-coronavirus-is-forcing-techies-to-work-from-home-some\">BuzzFeed News</a></em></cite></blockquote>\n\n\n\n<p>This is not how I envisioned the <a href=\"https://distributed.blog/\">distributed work revolution</a> taking hold.</p>\n\n\n\n<p>It has been a challenging time around the world—from how we live our daily lives to how we keep our kids safe in schools and our family members healthy in assisted living communities and hospitals.&nbsp;</p>\n\n\n\n<p>And then there’s how we work. Seattle (and all of King County in Washington State) is encouraging <a href=\"https://www.seattletimes.com/seattle-news/health/as-coronavirus-spreads-king-county-recommends-avoiding-large-groups-working-remotely-when-possible/\">companies to have their employees work from home</a>. Given that <a href=\"https://automattic.com/\">Automattic</a> is already distributed, we’re receiving requests from the press and other companies about how to navigate what is turning into a massive global work-from-home experiment.&nbsp;</p>\n\n\n\n<p>It’s not ideal on any level. Even at a remote-friendly company like Automattic, we rely on <a href=\"https://ma.tt/2018/10/the-importance-of-meeting-in-person/\">in-person team meetups</a> and conferences to strengthen our connections and get work done. For now, we’ve canceled all work-related travel.</p>\n\n\n\n<p>But as the BuzzFeed story notes, this might also offer an opportunity for many companies to finally build a culture that allows long-overdue work flexibility. Millions of people will get the chance to experience days without long commutes, or the harsh inflexibility of not being able to stay close to home when a family member is sick.&nbsp;</p>\n\n\n\n<p>Or even when you’re sick yourself. How many people in America go into an office even when they’re feeling under the weather, because of pressure from the company or managers, or because their sick days come out of their vacation days? This might be a chance for a great reset in terms of how we work.&nbsp;</p>\n\n\n\n<p>For those asking for tips, my <a href=\"https://distributed.blog/podcast/\">Distributed Podcast</a> has a wealth of advice and stories about how we operate. But here are four good ones to start with:&nbsp;</p>\n\n\n\n<ol><li>Operate as if everyone works from different time zones, because one day they might. This means more communication, likely written, that is accessible to people even if they can’t attend a specific meeting or be in a specific place. If you can minimize the number of real-time meetings, do so. Embrace asynchronous communication.</li><li>If you <em>are</em> hosting a real-time meeting, improve the audio (and video) quality. Don’t use conference call lines with grainy phone audio. Sign up for <a href=\"https://zoom.us/\">Zoom</a>, which allows for crystal clear audio calls or videoconference chats. Make video participation optional unless it’s planned well in advance. Record these calls so folks who can’t attend can catch up on what they missed. Everyone must use good headphones with mics (<a href=\"https://www.amazon.com/Sennheiser-Culture-Wideband-Headset-SC30-USB-ML/dp/B00E67S6ZY/\">I love Sennheiser</a>) to minimize external noise. <a href=\"https://krisp.ai/\">Krisp.ai is also cool</a>. Need a quiet place without distractions? Try a parked car or a closet.</li><li>We use our own WordPress blogs, <a href=\"https://p2theme.com/\">called P2</a>, instead of email as our central hub of communication so people throughout the company can access every team’s long-form notes, documents, and priorities. We’re bloggers by heart, so we blog a lot. There are other similar tools, like <a href=\"https://basecamp.com/\">Basecamp</a>. Make it your new office.  </li><li>We also use <a href=\"https://slack.com/\">Slack</a> for real-time chat, social connection, and urgent conversations. <a href=\"https://matrix.org/\">Check out Matrix</a> for an open-source, distributed version. Use it to chat and connect with your colleagues, but don’t let it replace your long-form planning notes in No. 3. Also create an etiquette that doesn’t force people to become chained to it all day and all night. When you ask a question in DM, do not expect that person to respond immediately, and ask your question upfront. Never write “got a sec?” and let it hang there. <img src=\"https://s.w.org/images/core/emoji/12.0.0-1/72x72/1f601.png\" alt=\"?\" class=\"wp-smiley\" /></li></ol>\n\n\n\n<p>The truth is, there are a thousand ways to do remote work, but it starts with committing to it at all levels of the company. If you assume positive intent and place trust in your coworkers and employees—knowing that if they do great work in an office they can do great work anywhere—then you will all succeed.&nbsp;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Mar 2020 04:35:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Gutenberg Hub Launches Collection of 100 Block Templates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97693\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:177:\"https://wptavern.com/gutenberg-hub-launches-collection-of-100-block-templates?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-hub-launches-collection-of-100-block-templates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6080:\"<img />\n\n\n\n<p class=\"has-drop-cap\">Gutenberg Hub <a href=\"https://gutenberghub.com/introducing-gutenberg-templates-library/\">launched its collection of block templates</a> yesterday.  The project, which kicked off with <a href=\"https://templates.gutenberghub.com/\">100 free templates</a>, aims to help users create complex layouts by simply copying and pasting block code into the editor.</p>\n\n\n\n<p>Munir Kamal, the founder of CakeWP, created Gutenberg Hub in 2017 after he heard about the initial Gutenberg project announcement.  &ldquo;It excited me from the early days, and that pushed me to set up a blog where I can share Gutenberg related stuff,&rdquo; he said.  &ldquo;It all started with curating the latest updates going on to the Gutenberg project and what others are working on related to Gutenberg.  Later on, I started writing some tutorials on the blog to help beginner users get started with Gutenberg.&rdquo;</p>\n\n\n\n<p>He then built out a block directory before following it up with the templates directory.  &ldquo;The goal is to make Gutenberg Hub an excellent resource for Gutenberg users,&rdquo; he said.  He also has other big goals with the site, including a potential theme directory alongside the existing tutorials, templates, and blocks.</p>\n\n\n\n<p>Currently, Kamal has a team of five people working on his various CakeWP projects.  Some of the team contributed to the template library.  One member built the template library system on top of <a href=\"https://wptavern.com/gatsby-raises-15m-plans-to-invest-more-heavily-in-wordpress-and-cms-integrations\">Gatsby</a>, a framework based on React that can pull data from a CMS such as WordPress.</p>\n\n\n\n<p>The idea for the template library came to Kamal while he was trying to replicate homepages from WordPress page builders in Gutenberg.  &ldquo;I was able to recreate popular page builders in Gutenberg without any extra plugin,&rdquo; he said.  &ldquo;But that took me a lot of effort, and I realized a lot could be achieved with core Gutenberg.&rdquo;  He began thinking in terms of how section templates could help him build out pages more quickly.  &ldquo;So, I started creating sections and eventually that grew up into a template library idea.&rdquo;</p>\n\n\n\n<p>With the help of a team member, the two knocked out 100 custom templates in a month.  &ldquo;Honestly, it took a lot of time,&rdquo; said Kamal.  &ldquo;I will be adding more templates myself for sure. But, what I wish to happen is that other designers, developers, and users contribute and add templates to this library.&rdquo;</p>\n\n\n\n<p>Kamal is currently building a system so that others can add their custom templates.  Ultimately, he wants the project to be primarily run by the community.  The idea is similar in scope to the <a href=\"https://wptavern.com/creator-of-editorskit-launches-community-block-sharing-site\">ShareABlock community site</a> but with a focus on templates.</p>\n\n\n\n<p>With the Gutenberg project&rsquo;s focus on <a href=\"https://wptavern.com/gutenberg-6-9-introduces-image-titles-block-patterns-and-new-theme-features\">block patterns</a> this year, it will be interesting to see how projects such as this one will fit into that paradigm.  At the very least, the template library will provide useful ideas for the Gutenberg team, providing a sort of roadmap of patterns that may be worth adopting in core WordPress.</p>\n\n\n\n<p>&ldquo;Technically, what I am doing with this library is kind of similar to <em>block patterns</em>,&rdquo; said Kamal.  &ldquo;I am looking forward to how the block pattern system works and will try my best to make this library work with that.&rdquo;</p>\n\n\n\n<h2>A Collection of Templates</h2>\n\n\n\n<img />Testing the <a href=\"https://templates.gutenberghub.com/section/hero/rec1kqlXHezoe0Imb\">Hero 3 template</a> from the Gutenberg Hub library.\n\n\n\n<p>The templates in the library are essentially sections of a page.  Users can import multiple sections to create a range of complex layouts.</p>\n\n\n\n<p>Unlike other libraries where users may need to import a JSON file, Gutenberg Hub&rsquo;s templates are completely copy and paste.  The site provides a simple &ldquo;Copy Code&rdquo; button.  Once clicked, the block code is copied to your clipboard, which can be pasted directly into the block editor.</p>\n\n\n\n<p>Some of the blocks have custom CSS to handle certain design aspects, which is also copy and paste.  Kamal recommends the <a href=\"https://wordpress.org/plugins/blocks-css/\">Blocks CSS plugin</a> by ThemeIsle, which allows users to add CSS directly to the block editor.  The other option is for users to add the CSS code via the WordPress customizer.  In my experience with some of the templates, the extra CSS was unnecessary to achieve some nice layouts.</p>\n\n\n\n<p>With 100 templates and counting, Kamal broke the collection down into 12 categories:</p>\n\n\n\n<ul><li>Hero</li><li>Testimonial</li><li>Team</li><li>Stats</li><li>Pricing</li><li>Logos</li><li>Gallery</li><li>Features</li><li>FAQ</li><li>Content</li><li>Contact</li><li>Card</li></ul>\n\n\n\n<p>There is a little something for everyone.  The library covers many of the most popular patterns currently found around the web.  I am having fun testing out the various templates.  Some work better within my theme than others.  On the whole, Gutenberg Hub has crafted a solid project.</p>\n\n\n\n<p>The contact form templates require the use of the <a href=\"https://wordpress.org/plugins/forms-gutenberg/\">Gutenberg Forms plugin</a>, which is developed and maintained by Kamal.  This requirement is because WordPress does not have a built-in form system, so an external plugin was necessary.  None of the other templates require a plugin at the moment.</p>\n\n\n\n<p>Kamal does not have a favorite template from the collection.  He stressed that he was not a designer.  &ldquo;I have tried my best to put together templates that are good and useful in multiple use cases,&rdquo; he said.  &ldquo;I hope others like the templates as well, and it can be a good starting point for creating a beautiful layout in Gutenberg.&rdquo;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Mar 2020 20:48:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WPTavern: Preparing for WordPress 5.4: Changes Theme and Plugin Developers Should Know About\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97655\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:227:\"https://wptavern.com/preparing-for-wordpress-5-4-changes-theme-and-plugin-developers-should-know-about?utm_source=rss&utm_medium=rss&utm_campaign=preparing-for-wordpress-5-4-changes-theme-and-plugin-developers-should-know-about\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8936:\"<p class=\"has-drop-cap\">With the release of WordPress 5.4 looming, it is time for plugin and theme developers to begin testing their extensions and making sure there are no issues.  There are also new APIs for upcoming features.  Yesterday, the core team released the <a href=\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\">first release candidate for 5.4</a>.  The official release is planned for March 31.</p>\n\n\n\n<p>This post will serve as a quick guide with links to several important changes that developers need to keep in mind in the coming weeks.  Be sure to test your plugins and themes.</p>\n\n\n\n<h2>Theme Developers</h2>\n\n\n\n<img />New social icons block.\n\n\n\n<p>There are several changes that theme authors will want to test against.  WordPress 5.4 has a few extra theme features.  It also has several markup-related changes that could break theme designs on the front end and in the block editor.  Unfortunately, for theme authors who want to support multiple versions of WordPress, some of these changes may mean a little extra CSS bloat.</p>\n\n\n\n<h3>Social Icons and Buttons Blocks</h3>\n\n\n\n<p>WordPress 5.4 <a href=\"https://make.wordpress.org/core/2020/02/27/new-or-updated-blocks-in-wordpress-5-4/\">introduces two new blocks</a>:  social icons and buttons.  The social icons block allows users to insert icons/links for up to 40 different social networks.  The buttons block lets users group multiple button blocks together.  Theme authors who are rolling out custom block editor styles need to account for these new blocks to make sure they are output correctly.</p>\n\n\n\n<h3>Create Custom Gradient Presets</h3>\n\n\n\n<p>The new <a href=\"https://make.wordpress.org/core/2020/03/02/new-gradient-theme-apis/\">Gradients API</a> allows theme authors to define custom gradient presets for users to use with either the group or button blocks.  Theme authors will need to do some legwork to improve on the eyesore that is the default gradient presets.  With a little work, gradients can be a useful tool at the user&rsquo;s disposal.  Theme authors can also disable gradients altogether if they prefer not to support them.</p>\n\n\n\n<h3>Block Editor Markup and Style Changes</h3>\n\n\n\n<p>Theme authors who have directly <a href=\"https://make.wordpress.org/core/2020/03/02/markup-and-style-related-changes/\">targeted specific editor classes</a>, will need to check their block editor styles.  Many classes with the <code>editor-</code> prefix have been changed to use the <code>block-editor-</code> prefix.  The wrapper element with the <code>.edit-post-layout__content</code> class has been removed altogether.  Several wrapper elements were removed from blocks and the rich text component.  Core&rsquo;s built-in padding and negative margins on blocks have been refactored, which is a welcome addition.  Perhaps theme authors will no longer have to fight against multiple nested selectors to provide a basic, working layout that matches the front end.</p>\n\n\n\n<p>These changes have already broken several themes I have seen.  There is a good chance many theme authors will need to update their block editor styles.</p>\n\n\n\n<p>At a time when the Theme Review Team is asking for more theme authors to submit themes with custom editor styles, these types of changes to classes and markup are not a boost of confidence.  Theme developers can easily feel like they are fighting a losing battle.  However, work is moving forward to make the editor markup closer to a one-to-one match with the front end.  At some point, theme authors can only hope they will no longer need to deal with these kinds of changes while supporting users across multiple versions of WordPress.  For now, they are in a somewhat messy transitional phase.</p>\n\n\n\n<h3>Calendar Markup and Class Changes</h3>\n\n\n\n<p>The core team <a href=\"https://make.wordpress.org/core/2020/02/12/changes-related-to-calendar-widget-markup-in-wordpress-5-4/\">changed the markup</a> of the <code>get_calendar()</code> function, which also affects the Calendar widget.  The calendar output no longer has a <code>&lt;tfoot&gt;</code> element.  Instead, the previous and next month links were moved to a <code>&lt;nav&gt;</code> element below the <code>&lt;table&gt;</code> element.</p>\n\n\n\n<p>The calendar output also adds or changes multiple IDs and classes:</p>\n\n\n\n<ul><li><code>.wp-calendar-table</code> added to the wrapper element.</li><li><code>.wp-calendar-nav</code> added to the navigation wrapper element.</li><li><code>.wp-calendar-nav-next</code> replaces the <code>#next</code> ID on the next month link. </li><li><code>.wp-calendar-nav-prev</code> replaces the <code>#prev</code> ID on the previous month link. </li></ul>\n\n\n\n<p>These are breaking changes.  Any custom CSS that targeted the old HTML or IDs will need to be updated.</p>\n\n\n\n<h2>Block Developers</h2>\n\n\n\n<img /> Initial JavaScript file created by the block scaffolding script.\n\n\n\n<p>For plugin developers who are creating custom blocks, WordPress 5.4 introduces several new APIs and tools for working with the block system.</p>\n\n\n\n<h3>Block Scaffolding</h3>\n\n\n\n<p>Developers have a new <a href=\"https://www.npmjs.com/package/@wordpress/create-block\">NPM package</a> for quickly creating a block plugin.  With a single command of <code>npm init @wordpress/block &lt;plugin-name&gt;</code> the script will create a new directory and build out the appropriate PHP, CSS, and JavaScript files necessary for building a block plugin.  Developers can use modern JavaScript tooling by default or optionally choose to use an ES5 version.</p>\n\n\n\n<p>The intention of the block scaffolding package is for plugin authors to build single-block plugins that will eventually make their way into the official block directory.</p>\n\n\n\n<h3>Block Collections API</h3>\n\n\n\n<p>The <a href=\"https://make.wordpress.org/core/2020/02/27/block-collections/\">Block Collections API</a> works similarly to categories.  However, they are based on namespace.  When a plugin developer registers a custom collection, any blocks that share the collection namespace will appear under a custom section in the block inserter.  This seems to be a smarter way to organize blocks.  It will certainly come in handy for plugins that create libraries of blocks, providing an automatic way to group them together.</p>\n\n\n\n<h3>Block Variations API</h3>\n\n\n\n<p>The new <a href=\"https://make.wordpress.org/core/2020/02/27/introduce-block-variations-api/\">Block Variations API</a> allows block developers to essentially create copies of block with a variation.  Each registered variation will appear as a separate block in the block inserter for users to choose from.  </p>\n\n\n\n<p>A good example of this feature is the new social icons block.  It is a single block with 40 variations for the various social networks.</p>\n\n\n\n<h2>Other Developer-Related Changes</h2>\n\n\n\n<p>There are a couple of other changes of note that cross into both plugin and theme development territory.</p>\n\n\n\n<h3>New Nav Menu Hooks</h3>\n\n\n\n<p>After waiting and waiting and waiting, developers are <a href=\"https://make.wordpress.org/core/2020/02/25/wordpress-5-4-introduces-new-hooks-to-add-custom-fields-to-menu-items/\">finally getting some oft-requested hooks</a> for adding custom fields to the nav menu admin screen and customizer.  At least one ticket goes back <a href=\"https://core.trac.wordpress.org/ticket/18584\">9 years</a>, but it is better late than never.  In the past, developers would need to use a custom walker class to make some of the necessary customizations.  However, only a single walker class could be used at a time, which meant that multiple plugins that made changes would not work together.</p>\n\n\n\n<p>The core team added the new <code>wp_nav_menu_item_custom_fields</code> hook on the nav menus admin screen, which appears before the &ldquo;move&rdquo; buttons for individual menu items.  For parity with the admin, nav menu items have a new <code>wp_nav_menu_item_custom_fields_customize_template</code> in the customizer.  These hooks will allow developers to add custom form fields necessary for adding custom data to nav menu items.</p>\n\n\n\n<h3>apply_shortcodes() Alias Function</h3>\n\n\n\n<p>WordPress 5.4 introduces a new <code>apply_shortcodes()</code> function.  It is an alias for the <code>do_shortcode()</code> function.  The <a href=\"https://make.wordpress.org/core/2020/02/13/wordpress-5-4-introduces-apply-shortcodes-as-an-alias-for-do-shortcode/\">new function</a> provides a more semantically-correct function name.  Generally, functions with a prefix of <code>do_</code> expect output or some type of action.  Functions with a prefix of <code>apply_</code> expect data to be returned.</p>\n\n\n\n<p>If you are creating a theme or plugin with shortcode-aware areas, you will want to make the switch to the new function.  While the <code>do_shortcode()</code> function is not currently marked for deprecation, that should be the eventual goal.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Mar 2020 21:38:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WordPress.org blog: WordPress 5.4 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8399\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2020/03/wordpress-5-4-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2712:\"<p>The first release candidate for WordPress 5.4 is now available!</p>\n\n\n\n<p>This is an important milestone as we progress toward the WordPress 5.4 release date. “Release Candidate” means that the new version is ready for release, but with millions of users and thousands of plugins and themes, it’s possible something was missed. WordPress 5.4 is currently scheduled to be released on <strong>March 31, 2020</strong>, but we need <em>your</em> help to get there—if you haven’t tried 5.4 yet, <strong>now is the time</strong>!</p>\n\n\n\n<p>There are two ways to test the WordPress 5.4 release candidate:</p>\n\n\n\n<ul><li>Try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (choose the “bleeding edge nightlies” option)</li><li>Or <a href=\"https://wordpress.org/wordpress-5.4-RC1.zip\">download the release candidate here</a> (zip).</li></ul>\n\n\n\n<h2>What’s in WordPress 5.4?</h2>\n\n\n\n<p>WordPress 5.4 has lots of refinements to polish the developer experience. To keep up, subscribe to the&nbsp;<a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a>&nbsp;and pay special attention to the&nbsp;<a href=\"https://make.wordpress.org/core/tag/5-4+dev-notes/\">developer notes</a>&nbsp;tag for updates on those and other changes that could affect your products.</p>\n\n\n\n<h2>Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.4 and update the <em>Tested up to</em> version in the readme file to 5.4. If you find compatibility problems, please be sure to post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a> so we can figure those out before the final release.</p>\n\n\n\n<p>The WordPress 5.4 Field Guide will be published within the next 24 hours with a more detailed dive into the major changes.</p>\n\n\n\n<h2>How to Help</h2>\n\n\n\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a> This release also marks the <a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\">hard string freeze</a> point of the 5.4 release schedule.</p>\n\n\n\n<p><em><strong>If you think you’ve found a bug</strong>, you can post to the&nbsp;<a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a>&nbsp;in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report,&nbsp;<a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find&nbsp;<a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Mar 2020 21:59:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Baumwald\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: Will Page Builders Remain Competitive in the Block Era?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97623\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:173:\"https://wptavern.com/will-page-builders-remain-competitive-in-the-block-era?utm_source=rss&utm_medium=rss&utm_campaign=will-page-builders-remain-competitive-in-the-block-era\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6337:\"<img />Screenshot courtesy of the Elementor plugin.\n\n\n\n<p class=\"has-drop-cap\">As Elementor, the most-used WordPress page builder, celebrated its <a href=\"https://wptavern.com/elementor-raises-15-million-plans-to-invest-in-the-team-product-and-community\">first round of funding at $15 million</a>, some of our readers questioned whether this was a sound investment.  With movement in the Gutenberg plugin toward a full-site editing solution, which will eventually make its way into core WordPress, it is a valid concern.  Will page builders remain competitive once WordPress begins taking over this role, likely sometime in 2021?</p>\n\n\n\n<p>While Elementor has seemingly pulled far ahead of the competition with over 4 million installations, there is a much wider market of page-building solutions that end-users are installing.  The free version of <a href=\"https://wordpress.org/plugins/beaver-builder-lite-version/\">Beaver Builder</a> has over 400,000 installs and <a href=\"https://wordpress.org/plugins/visualcomposer/\">Visual Composer</a> has over 70,000.  In the commercial space, Divi has over 600,000 customers and WP Bakery has seen 388,000 sales.  These numbers don&rsquo;t include the numerous other page-building plugins and custom solutions that developers build with libraries like Advanced Custom Fields and Meta Box.  Some themes also offer some form of a page builder but typically not as robust as plugins.</p>\n\n\n\n<p>All of this is to say that there is a huge market right now.  Based on current trends, growth for page builders is accelerating rather than slowing down.  My educated guess is that we are nowhere near the ceiling.</p>\n\n\n\n<p>From the comments on our recent coverage of Elementor&rsquo;s investment round, one of our readers named Anto <a href=\"https://wptavern.com/elementor-raises-15-million-plans-to-invest-in-the-team-product-and-community#comment-320236\">had a few thoughts on the future</a>.  &ldquo;I&rsquo;m happy that WordPress is getting more external investment, but I find it hard to imagine how Elementor has a long-term future in WordPress with their thinking,&rdquo; he said.  &ldquo;Sure, it has a place now, and will for at least a few more years, but as Gutenberg matures why would anyone want the added bloat? Once you abstract the window dressing, all page builders (including Gutenberg) are fairly similar. The remaining differences are a matter of workflow and taste because moving blocks/sections around isn&rsquo;t unique.&rdquo;</p>\n\n\n\n<p>Yoni Luksenberg, CEO and co-founder of Elementor believes the future is bright.  &ldquo;We believe in democratizing the editor so different WordPress users and different personas will have their editor of choice,&rdquo; he said in an interview.  &ldquo;This way, they can pick the editor that best fits their unique needs and preferences. This is the beauty of open source. There are endless ways to build a contact form: Contact Form 7, Gravity Forms, Jetpack Forms. Similarly, there are endless ways to build and design a web page. The users should have the option to choose their preferred method.&rdquo;</p>\n\n\n\n<p>Anto believes the choice between contact forms is not comparable to the choice between editors or builders.  Because the block editor is a part of the core platform, it would provide stiffer competition for a builder plugin.  &ldquo;Will people have different preferences that the ecosystem will fill?&rdquo; he asked.  &ldquo;Of course, these will be the block plugins, style/feature plugins, and additional layers of complexity that will evolve as Gutenberg matures, but they will all be built on core WordPress (Gutenberg) because doing anything else is just duplicative bloat.&rdquo;</p>\n\n\n\n<p>It is not clear what users will do in a year or two down the road.  However, there is a significant portion of end-users who are not currently satisfied with what WordPress is offering.  WordPress fell behind the market and plugin developers filled the void with solutions to meet demand.  It is now playing catch-up with these page builders.  Even with all the resources being thrown toward the block system and eventual full-site editing, we are miles away from a baseline working solution beyond content editing.</p>\n\n\n\n<p>&ldquo;At some point of time Gutenberg is going to be at least as powerful as the free version of the Elementor plugin,&rdquo; said <a href=\"https://wptavern.com/elementor-raises-15-million-plans-to-invest-in-the-team-product-and-community#comment-320356\">Richard Ginn in the comments</a>.  &ldquo;Gutenberg to me is getting more powerful at a faster rate than Elementor is.&rdquo;</p>\n\n\n\n<p>One thing page builders have going for them is their current user base.  It is human nature to stick with tools that are familiar and comfortable.  I do not imagine most page builders will lose large user numbers as long as they are offering the solutions that users want or need.  Even if WordPress offers a more robust solution within the next couple of years, user trust will be with existing plugins, and that is a hard thing to win back once it has been lost.</p>\n\n\n\n<p>With its recent funding round, Elementor is planning on growing its team and speeding up feature development.  Other page builders will need to keep up and continue finding ways to remain competitive.  Right now, page builder usage numbers are on the rise in the early block editor era.  We could see a lot more innovation in this space in the next couple of years.  Elementor&rsquo;s investment round validates a maturing market that is a direct competitor to core&rsquo;s block system.</p>\n\n\n\n<p>This level of competition is healthy for the ecosystem.  The rise of page builders will undoubtedly push Gutenberg and WordPress development to new heights.  There is a multi-million dollar market for third-party builders that is hard to ignore.  I don&rsquo;t see it going anywhere anytime soon.</p>\n\n\n\n<p class=\"has-text-color has-background has-white-color has-blue-700-background-color is-style-highlight text-white bg-blue-700\">This post is part of a new <a href=\"https://wptavern.com/category/from-the-comments\">From the Comments</a> series where we highlight interesting points of discussion from comments on WP Tavern articles. The hope is to give these comments, which can sometimes get lost, the attention they deserve. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Mar 2020 19:34:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: The International WordPress Community and WordCamps Amid COVID-19\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97595\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:195:\"https://wptavern.com/the-international-wordpress-community-and-wordcamps-amid-covid-19?utm_source=rss&utm_medium=rss&utm_campaign=the-international-wordpress-community-and-wordcamps-amid-covid-19\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7238:\"<p class=\"has-drop-cap\">With the rising numbers of people who have contracted COVID-19, a disease caused by SARS-CoV-2 (severe acute respiratory syndrome coronavirus 2), it is time for the WordPress community to begin evaluating what the remainder of 2020 may look like.  It is not a time for panic.  However, some serious discussions will need to happen and decisions made on an ongoing basis.</p>\n\n\n\n<p>Last month, WordCamp Asia made the tough decision to <a href=\"https://wptavern.com/wordcamp-asia-2020-canceled-over-covid-19-concerns\">cancel its inaugural event</a> in Bangkok, Thailand.  Given the spread of the coronavirus strain in the East Asian region and many unknowns at that point, it was a safe decision to protect our international community.</p>\n\n\n\n<p><a href=\"https://www.wordfence.com/blog/2020/02/wordcamp-asia-cancellation-fee-assistance-package-from-wordfence/\">Wordfence spearheaded the effort</a> to aid people with financial losses due to WordCamp Asia&rsquo;s late cancellation.  The company covered $10,000 of lost funds for attendees.  Yoast and GoDaddy are equally splitting costs beyond the initial $10,000 through the same WordCamp Asia Cancellation Fund.  To date, 117 applications have been verified and approved for a total of $19,860.  There are still eight pending applications for an additional $1,409.</p>\n\n\n\n<p>Mark Maunder, CEO of Defiant (the company behind Wordfence), seemed proud of how the community came together to make this happen.  He said that people acted with integrity during the process and many often made sure to only ask for smaller amounts of money to cover their lost expenses.</p>\n\n\n\n<p>Yesterday, Maunder authored a detailed post titled <a href=\"https://www.wordfence.com/blog/2020/03/covid-19-and-wordpress-community-engagement-in-2020/\">COVID-19 and WordPress Community Engagement in 2020</a>.  In it, he announced that his team would not be traveling globally to WordCamps until COVID-19 has run its course.  He also urges organizers to cancel WordCamp Europe this summer, to cancel WordCamps globally for the time being, and for WordCamp US to be put on hold.  Instead, the community can focus on doing remote events and providing an example to the world in how we can organize and collaborate online.  By taking a proactive approach and dealing with the issue sooner rather than later, it can save organizers headaches down the road and save attendees money by canceling early.</p>\n\n\n\n<p>&ldquo;It is my experience that people react to bad situations too slowly,&rdquo; wrote Maunder.  &ldquo;Whether it is a choking victim, a storm or a national emergency, there is the awkward pause that happens as life-as-usual transforms into a realization of reality requiring fast action.  Often, that reality only sets in after the event.&rdquo;</p>\n\n\n\n<p>Maunder said he desired to take a data-driven approach to determine whether camps and conferences should cancel.  It is not about raising panic or unnecessary alarm.  He wants people to make sure they think about how we deal with this as a community and not in terms of our potential health risks as individuals.  A healthy 30-year-old is at low risk of mortality, for example.  However, that same healthy adult can transfer the virus to the elderly and immune-compromised people who are at higher risks.  Bringing together large groups who are traveling internationally may help spread the virus because it de-localizes the problem.  This is particularly true for larger WordCamps that have a global list of attendees.</p>\n\n\n\n<h2>Current WordCamp Updates and Cancellations</h2>\n\n\n\n<p class=\"has-drop-cap\">WordCamp Europe organizers announced earlier today that the annual event will continue as planned.  The conference will take place on June 4-6 in Porto, Portugal.  The team said they were in contact with the national health authority, DGS, in Portugal.  They are monitoring the situation.  Currently, there is at least one confirmed case of COVID-19 in Portugal, but the government has not shut down its borders.  Those planning to attend WordCamp Europe should keep an eye on the camp&rsquo;s <a href=\"https://2020.europe.wordcamp.org/coronavirus-update/\">Coronavirus Updates page</a>.  Plans could change.</p>\n\n\n\n<p>Smaller, more regional WordCamps will want to keep a careful eye on what is going on locally.  This means following local news sources and staying informed by local government officials.</p>\n\n\n\n<p>WordCamp Geneva organizers have <a href=\"https://2020.geneve.wordcamp.org/wordcamp-geneve-reporte/\">postponed their event</a>, which was set for March 21.  At the moment, they are planning to set it back about six months, pending an improvement in the COVID-19 situation.  Otherwise, they will make the decision to cancel the event completely for the year.  The announcement came after the Swiss government banned large-scale events with over 1,000 people.  The organizers worried that such a ban would eventually extend to smaller events.</p>\n\n\n\n<p>The WordCamp Retreat, held annually in Soltau, Germany, <a href=\"https://2020-soltau.retreat.wordcamp.org/2020/02/29/verschiebung-des-wordcamp-retreat-postponing-of-wordcamp-retreat\">has also been canceled for 2020</a>.  The event was scheduled to run from April 30 through May 3.  The organizers plan to revive the retreat in May 2021.  Organizers said because of the unusual format in comparison to a normal WordCamp, the costs of waiting until later before deciding to cancel would have been financially irresponsible.  The format of the retreat has higher costs associated with how it is run.  February 29 was the last day to make a decision to cancel while breaking even financially.</p>\n\n\n\n<h2>Staying Informed</h2>\n\n\n\n<p class=\"has-drop-cap\">Aside from WordCamps, agencies and other companies with a physical location should prepare for having their employees do their work remotely.  This means setting up channels for communication, if they are already not in place, for continuing their work efficiently.  While we should all hope for the best outcome, preparedness is key for when things go awry.</p>\n\n\n\n<p>The most important thing for the global WordPress community to do right now is to continue communicating and sharing data from official sources.  Organizers, employers, and travelers will sometimes have to make tough calls.  Safety is always more important than whether we can network in person.  </p>\n\n\n\n<p>The following are links to resources from the World Health Organization.  Everyone should also keep track of national, state, and other local resources.</p>\n\n\n\n<ul><li><a href=\"https://www.who.int/emergencies/diseases/novel-coronavirus-2019\">WHO: COVID-19 Updates</a></li><li><a href=\"https://www.who.int/news-room/q-a-detail/q-a-coronaviruses\">WHO: Q&amp;A on Coronaviruses (COVID-19)</a></li><li><a href=\"https://www.who.int/emergencies/diseases/novel-coronavirus-2019/travel-advice\">WHO: Travel Advice</a></li></ul>\n\n\n\n<p class=\"has-background has-gray-100-background-color is-style-highlight bg-gray-100\"><strong>Update:</strong> Josepha Haden posted an official announcement with advice on <a href=\"https://make.wordpress.org/updates/2020/03/04/wordcamp-travel-and-covid-19/\">WordCamp Travel and COVID-19</a> on March 4.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Mar 2020 21:27:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WordPress.org blog: The Month in WordPress: February 2020\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=8393\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://wordpress.org/news/2020/03/the-month-in-wordpress-february-2020/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9165:\"<p>February 2020 was a busy month in the WordPress project! Most notably, there was an outpouring of sentiment in response to the unfortunate cancellation of WordCamp Asia. However, the team continues to work hard in the hopes of making WordCamp Asia 2021 happen. In addition, there were a number of releases and some exciting new news during the month of February. Read on for more information!</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>WordCamp Asia 2020 Cancelled &amp; Pop-up Livestream</h2>\n\n\n\n<p>There was a ton of excitement around WordCamp Asia, not to mention all the effort from organizers, speakers, sponsors and volunteers. Unfortunately, on February 12th, <a href=\"https://wordpress.org/news/2020/02/wordcamp-asia-cancelled-due-to-covid-19/\">WordCamp Asia was cancelled</a> due to concern and uncertainty around COVID-19. Since then, the organizing team has worked to <a href=\"https://2020.asia.wordcamp.org/2020/02/12/cancellation/\">refund tickets and to support hotel and air refunds</a>. In addition, a <a href=\"https://wordpress.org/news/2020/02/pop-up-livestream-on-february-22/\">pop-up livestream</a> featuring some WordCamp Asia speakers and a Fireside Chat and Q&amp;A with Matt Mullenweg took place on February 22nd.</p>\n\n\n\n<p>For a personal take on the cancellation of WordCamp Asia, read <a href=\"https://naoko.blog/2020/02/13/wordcamp-asia-2020-recap/\">this post from Naoko Takano</a>, the global lead organizer. Many thanks to the volunteers who worked hard to deliver WordCamp Asia. They’ve not only handled logistics associated with cancellation but have also announced that they’ve started <a href=\"https://2020.asia.wordcamp.org/2020/02/18/wordcamp-asia-2021/\">working on WordCamp Asia 2021</a> with some January dates in mind! To get the latest on WordCamp Asia, subscribe to updates <a href=\"https://2021.asia.wordcamp.org/\">here</a>.&nbsp;</p>\n\n\n\n<h2>WordPress 5.4 Beta is Now Available</h2>\n\n\n\n<p><a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-1/\">WordPress 5.4 Beta 1</a> was released on February 11 and quickly followed by <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-2/\">Beta 2</a> on February 18 and <a href=\"https://wordpress.org/news/2020/02/wordpress-5-4-beta-3/\">Beta 3</a> on February 25. These two releases get us closer to our primary goal for 2020: full-site editing with blocks. WordPress 5.4 will merge ten releases of the Gutenberg plugin and is scheduled to be released on March 31, 2020. It will come with many new features, such as two new blocks for social links and buttons, and easier navigation in the block breadcrumbs. There are also a number of accessibility improvements, such as easier multi-block selection and easier tabbing, one of the editor’s biggest accessibility issues. <a href=\"https://make.wordpress.org/core/tag/5-4/\">5.4 will also include</a> many developer-focused changes, such as improved favicon handling and many new hooks and filters.</p>\n\n\n\n<p>Want to get involved in building WordPress? There are a number of ways to help right now! If you speak a language other than English, <a href=\"https://translate.wordpress.org/projects/wp/dev/\">help us translate WordPress</a>. Found a bug? Post it to the<a href=\"https://wordpress.org/support/forum/alphabeta/\"> Alpha/Beta area</a> in the support forums. You can also help us test the current beta by installing <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">the WordPress Beta Tester plugin</a>. Just remember that the software is still in development, so we recommend against running it on a production site.&nbsp;</p>\n\n\n\n<h2>WordCamp Centroamérica is Looking for Speakers and Sponsors!</h2>\n\n\n\n<p><a href=\"https://2020.centroamerica.wordcamp.org/\">WordCamp Centroamérica</a> is the first regional WordCamp for Central America and will be held on September 17-19, 2020, in Managua, Nicaragua. The <a href=\"https://2020.centroamerica.wordcamp.org/2020/01/28/llamado-a-ponentes-call-for-speakers/#more-5\">Call for Speakers</a> and <a href=\"https://2020.centroamerica.wordcamp.org/2020/01/16/call-for-sponsors/\">Call for Sponsors</a> are now open, so if you’re interested in speaking at or sponsoring WordCamp Centroamérica, now is your chance! To learn more about the eent, visit and subscribe to updates on their <a href=\"https://2020.centroamerica.wordcamp.org/\">website</a>, or follow their <a href=\"https://www.facebook.com/WordCampCA\">Facebook</a>, <a href=\"https://twitter.com/WordCampCA\">Twitter</a>, and <a href=\"https://instagram.com/wccentroamerica\">Instagram</a> accounts.&nbsp;&nbsp;</p>\n\n\n\n<p>Want to get involved in the Community team and help make more amazing WordCamps happen? <a href=\"https://make.wordpress.org/community/\">Follow the blog</a> and join the #community-events channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>! You can also find out about other <a href=\"https://central.wordcamp.org/\">upcoming WordCamps here</a>.</p>\n\n\n\n<h2>Contribute to WordPress Core via GitHub</h2>\n\n\n\n<p>An experimental feature has been added to Trac to help improve collaboration between Trac and GitHub. This feature allows contributors to link GitHub pull requests opened against the official <a href=\"https://github.com/wordpress/wordpress-develop\">WordPress Develop Git mirror</a> to tickets, which will make GitHub contributions more visible in the related Trac ticket. To learn all the details and to see how it works, read <a href=\"https://make.wordpress.org/core/2020/02/21/working-on-trac-tickets-using-github-pull-requests/\">this post</a>.</p>\n\n\n\n<h2>Gutenberg Development Continues</h2>\n\n\n\n<p>There are many new exciting additions to Gutenberg! On February 5, <a href=\"https://make.wordpress.org/core/2020/02/05/whats-new-in-gutenberg-5-february/\">Gutenberg 7.4 saw two new features added</a>, including background color support to the Columns block and text color support for the Group block. Many enhancements were made, including a number of improvements to the Navigation Block.</p>\n\n\n\n<p>Gutenberg 7.5 was released on February 12, <a href=\"https://make.wordpress.org/core/2020/02/26/whats-new-in-gutenberg-26-february/\">with 7.6 following</a> on February 27. They introduced even more features, including the Social Links block as a stable block and a number of additional blocks for full-site editing, not to mention the many enhancements, new APIs, bug fixes, documentation, and updates.</p>\n\n\n\n<p>Want to get involved in building Gutenberg? Follow <a href=\"https://make.wordpress.org/core/\">the Core team blog</a>, contribute to <a href=\"https://github.com/WordPress/gutenberg/\">Gutenberg on GitHub</a>, and join the #core-editor channel in <a href=\"https://make.wordpress.org/chat/\">the Making WordPress Slack group</a>.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>Further Reading:</h2>\n\n\n\n<ul><li>Aside from WordCamp Asia, two other WordCamps have been postponed due to COVID-19: <a href=\"https://2020-soltau.retreat.wordcamp.org/2020/02/29/verschiebung-des-wordcamp-retreat-postponing-of-wordcamp-retreat/\">WordCamp Retreat Soltau</a> and <a href=\"https://2020.geneve.wordcamp.org/wordcamp-geneve-reporte/\">WordCamp Genève</a>. News about further postponements or cancellations will be posted on <a href=\"https://central.wordcamp.org/news/\">the WordCamp Central blog</a>.</li><li>Automatic updates for themes and plugins <a href=\"https://make.wordpress.org/core/2020/02/26/feature-plugin-wp-auto-updates/\">are being planned</a> for inclusion in WordPress 5.5.</li><li>Version 2.2.1 of the WordPress Coding Standards has been released.</li><li>The Community Team <a href=\"https://make.wordpress.org/community/2020/02/06/community-team-reps-for-2020-2/\">has selected new team representatives</a> for 2020.</li><li>The Core team <a href=\"https://make.wordpress.org/core/2020/02/09/what-does-it-mean-to-be-a-component-maintainer-a-refresher/\">published a useful refresher</a> on what it means to be a component maintainer, along with some tips and best practices.</li><li><a href=\"https://make.wordpress.org/support/2020/02/changes-to-the-support-guidelines-for-linking-to-off-site-resources/\">The Support Team has announced</a> some amendments to their guidelines for linking to external resources when using the support forums.</li><li>The WordPress Foundation <a href=\"https://wordpressfoundation.org/2020/wordpress-foundation-donates-to-black-girls-code-and-internet-archive/\">has published financial information</a> regarding their charitable donations from 2019.</li><li>The Core XML Sitemaps project kicked off with <a href=\"https://make.wordpress.org/core/2020/02/24/xml-sitemaps-meeting-february-25th-2020/\">their first meeting</a> this month.</li><li>The Gutenberg team have created <a href=\"https://make.wordpress.org/core/2020/02/28/new-wordpress-create-block-package-for-block-scaffolding/\">a new @wordpress/create-block package</a> for scaffolding new blocks.</li></ul>\n\n\n\n<p><em>Have a story that we should include in the next “Month in WordPress” post? Please </em><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><em>submit it here</em></a><em>.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Mar 2020 09:15:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Hugh Lashbrooke\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"WPTavern: Elementor Raises $15 Million, Plans to Invest in the Team, Product, and Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97541\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:219:\"https://wptavern.com/elementor-raises-15-million-plans-to-invest-in-the-team-product-and-community?utm_source=rss&utm_medium=rss&utm_campaign=elementor-raises-15-million-plans-to-invest-in-the-team-product-and-community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5203:\"<img />\n\n\n\n<p class=\"has-drop-cap\">Elementor, which has quickly become one of the leading <a href=\"https://wordpress.org/plugins/elementor/\">WordPress page builders</a> and companies, announced Wednesday it <a href=\"https://elementor.com/blog/elementor-funding/\">raised $15 million in its first round of funding</a>, led by <a href=\"https://lsvp.com/\">Lightspeed Venture Partners</a>.  The investment round comes on the heels of the plugin surpassing four million active installations.</p>\n\n\n\n<p>Founded in 2016, Yoni Luksenberg and Ariel Klikstein wanted to create a platform for web creators to drag and drop elements on a page to quickly build sites to their specifications.  It took two years for the plugin to gather its first million users.  Since then, the user base has continued to rapidly grow, adding an extra million users at an average rate of six months.  </p>\n\n\n\n<p>In the past 12 months, the plugin has deployed over 300 new features.  It is also currently translated into 55 languages, an effort driven by its massive community.</p>\n\n\n\n<p>&ldquo;Elementor&rsquo;s growth is a wonderful example of the power of community and open-source software,&rdquo; said Tal Morgenstern, Partner at Lightspeed. &ldquo;The founders set out to solve their own problems as web professionals and ended up with a global, highly-involved fan base that kept pushing and shaping the product from the very onset. Every single metric we looked at indicated an exceptionally strong market fit and we&rsquo;re extremely happy to partner with this team for the next chapter of their journey.&rdquo;</p>\n\n\n\n<p>The next question is how the Elementor team will utilize this funding to grow their platform.</p>\n\n\n\n<h2>Growing the Elementor Team and Platform</h2>\n\n\n\n<img />\n\n\n\n<p class=\"has-drop-cap\">Elementor currently has 130 employees, called &ldquo;Elementorists,&rdquo; who are spread across 16 countries.  The company plans to use some of its funding to grow its team by 50%.  It may not be long before they are pushing the 200-employee mark.</p>\n\n\n\n<p>The company will also use the funding to push the expansion of its global community.  The team already has 500 meetups planned around the world in 2020.</p>\n\n\n\n<p>&ldquo;We plan to utilize the funding to improve all aspects of the product and community,&rdquo; said Luksenberg.  &ldquo;That means further strengthening the infrastructure of our platform, developing more innovative features, investing in more community-enhancing efforts like WordCamp sponsorships and meetups, and building more integrations with WordPress and with other plugins.  Basically, this allows us to continue with all the efforts already in progress but at a faster pace and at a larger scale.&rdquo;</p>\n\n\n\n<p>The Elementor team is set to push out new features and products at a much faster pace than before with the funding in place.  Luksenberg was tight-lipped on the details.  &ldquo;We don&rsquo;t want to ruin the surprise by revealing the features too soon,&rdquo; he said.  However, he promises that the company plans to set new web design and marketing standards while reducing &ldquo;friction points&rdquo; for web creators using Elementor.</p>\n\n\n\n<p>One major question is where Elementor stands in terms of the block editor (Gutenberg).  In one sense, they are competitors.  However, the team also created the <a href=\"https://wordpress.org/plugins/block-builder/\">Elementor Blocks for Gutenberg</a> plugin.  While it only has 8,000 active installs, a drop in the bucket in comparison to their primary plugin, Luksenberg said the team has received positive feedback from users.</p>\n\n\n\n<p>&ldquo;We are constantly testing out new integrations with the goal of improving compatibility with Gutenberg,&rdquo; said Luksenberg.  &ldquo;We believe in democratizing the editor so different WordPress users and different personas will have their editor of choice. This way, they can pick the editor that best fits their unique needs and preferences. This is the beauty of open source. There are endless ways to build a contact form:  Contact Form 7, Gravity Forms, Jetpack Forms.  Similarly, there are endless ways to build and design a web page. The users should have the option to choose their preferred method.&rdquo;</p>\n\n\n\n<p>Despite a couple of rumors floating around, the team has no plans to build a platform that is independent of core WordPress.  The team&rsquo;s work will be deeply entrenched into WordPress.</p>\n\n\n\n<p>However, they are currently considering offering a SaaS (Software as a Service) solution around the Elementor platform.  It is unclear what such a SaaS product will look like if it happens, but it could be a natural evolution of their business growth.  It will certainly be interesting to keep an eye on and see where they take it.  &ldquo;As a growing company, now with funding, it&rsquo;s important to keep our options open,&rdquo; said Luksenberg.</p>\n\n\n\n<p>Luksenberg hopes to see other companies in the WordPress ecosystem complete similar funding rounds and feels honored for his company to be in a position to lead the way.  &ldquo;It&rsquo;s one small step for Elementor, one giant leap for the WordPress community,&rdquo; he said.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 28 Feb 2020 19:31:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Gutenberg 7.6 Includes Rotating Tips List and New Full-Site Editing Blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97195\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:213:\"https://wptavern.com/gutenberg-7-6-includes-rotating-tips-list-and-new-full-site-editing-blocks?utm_source=rss&utm_medium=rss&utm_campaign=gutenberg-7-6-includes-rotating-tips-list-and-new-full-site-editing-blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4530:\"<p>Yesterday, the Gutenberg team <a href=\"https://make.wordpress.org/core/2020/02/26/whats-new-in-gutenberg-26-february/\">released version 7.6 of the plugin</a>.  Most of the work in this update went toward the upcoming full-site editing feature.  The team continues to pump out new dynamic, placeholder blocks for post data.  The biggest user-facing feature was the addition of a rotating list of tips in the block inserter.</p>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/2020/02/12/whats-new-in-gutenberg-12-february/\">Version 7.5</a>, released two weeks ago, was the last major release of the plugin that will have features to land in WordPress 5.4, which is currently scheduled for release on March 31.  However, bug fixes from 7.6 were ported to the most recent WordPress 5.4 beta updates.</p>\n\n\n\n<p>Version 7.6 does not include as many major feature additions as earlier releases.  Aside from experimental work on full-site editing, it primarily includes bug fixes.</p>\n\n\n\n<p>The announcement post boasts a considerable speed improvement in loading time and keypress events.  In comparison to version 7.5, loading time was reduced to 7.7 seconds from 8.5 seconds and keypress event speed was reduced to 48.59 milliseconds from 55.45 milliseconds.  These tests are run against a post of approximately 36,000 words and 1,000 blocks.</p>\n\n\n\n<h2>Rotating Tips In Block Inserter</h2>\n\n\n\n<img />Block inserter tip section now rotates messages.\n\n\n\n<p>In the past, the block inserter had a single tip at the bottom right that read, &ldquo;While writing, you can press <code>/</code> to quickly insert new blocks.&rdquo; It was a useful tip, but it was easy to ignore because it never changed.  After seeing the same message a couple dozen times, it had become little better than wasted space.</p>\n\n\n\n<p>Version 7.6 creates a <a href=\"https://github.com/WordPress/gutenberg/pull/20163\">rotating list of tips</a>. Each time a user opens the inserter, a new tip appears.  At the moment, the list only contains five messages but more are sure to come in the future.</p>\n\n\n\n<p>There are open tickets to add contextual <a href=\"https://github.com/WordPress/gutenberg/issues/20196\">tips based on block search queries</a> and <a href=\"https://github.com/WordPress/gutenberg/issues/17091\">block-specific tips</a>. Both of those tickets could continue to help users learn the block system and provide a path for block creators to teach users how to use custom blocks.</p>\n\n\n\n<p>Currently, the list of tips is static.  However, it may be possible for plugin authors to extend it in the future.  I&rsquo;m already contemplating writing a plugin to replace the tips with quotes from Joss Whedon&rsquo;s <em>Firefly</em>.</p>\n\n\n\n<h2>Full Steam Ahead with Full-Site Editing</h2>\n\n\n\n<img />Growing list of post data blocks for full-site editing.\n\n\n\n<p>Gutenberg 7.6 added four new dynamic, placeholder blocks related to post data:  featured image, tags, comments count, and comments form.  This brings the total to around 12 blocks for full-site editing, which is still a few dozen short of where the platform will need to be before the feature is ready.  Most work thus far has gone toward building out blocks that handle post data.  Eventually, the team will need to expand to other areas that will need block representation on the front end.</p>\n\n\n\n<p>Theme authors looking to test out full-site editing should make sure to check out the <a href=\"https://github.com/WordPress/theme-experiments\">block-based theme experiments</a> repository, which continues to see regular updates.</p>\n\n\n\n<p>Users can now <a href=\"https://github.com/WordPress/gutenberg/pull/20361\">set the heading level</a> of the site title block.  It can also be set to a paragraph.  However, it does not include all of the design settings, such as text size or colors, that would come with a regular paragraph block. This is a good first step in recognizing the various ways the site title block will be used, but it will need to evolve into a much more robust block to allow users to do all the things they will eventually want to do with the site title.</p>\n\n\n\n<p>At this point, it is hard to gauge what full-site editing will look like. Everything is experimental.  It only covers the most basic use cases.  I am still cautious about its potential.  On the other hand, I am ready to skip ahead a year and see how it all turns out.  Every plugin update brings us a step closer, but it is tough waiting to see what the bigger picture looks like as it comes together.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 27 Feb 2020 21:48:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: Automatic Theme and Plugin Updates Slated for WordPress 5.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=97498\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:183:\"https://wptavern.com/automatic-theme-and-plugin-updates-slated-for-wordpress-5-5?utm_source=rss&utm_medium=rss&utm_campaign=automatic-theme-and-plugin-updates-slated-for-wordpress-5-5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3539:\"<img />Automatic updates column on the plugin management screen.\n\n\n\n<p class=\"has-drop-cap\">Today, Jean-Baptiste Audras <a href=\"https://make.wordpress.org/core/2020/02/26/feature-plugin-wp-auto-updates/\">announced the WordPress Auto-updates</a> feature plugin.  The project seeks to bring automatic plugin and theme updates to WordPress version 5.5.  It was originally slated as a feature project in 2019, but it was later bumped to the <a href=\"https://wptavern.com/progress-on-wordpress-2019-projects-sets-2020-roadmap\">2020 roadmap</a>.</p>\n\n\n\n<p>The <a href=\"https://wordpress.org/plugins/wp-autoupdates/\">WordPress Auto-updates</a> plugin is available for beta testing in the plugin directory.  The plugin is currently marked to work with sites running PHP 7.2 or later, which is odd considering it is a feature plugin for core and will need to be compatible with WordPress&rsquo; minimum of PHP 5.6.</p>\n\n\n\n<p>The feature feels long overdue.  We have been asking for it <a href=\"https://wptavern.com/its-time-for-wordpress-to-automatically-update-themes-plugins-and-core-by-default\">since at least 2015</a> here at the Tavern.  Hosting companies and plugins like Jetpack have taken up the load over the years, offering automatic updates for millions of users.  However, it is time for the core platform to take the reins and make this a feature available directly to all users.  This would also provide a standardized path for third-party plugins to extend the feature with more controls for end-users.</p>\n\n\n\n<p>Work toward bringing the feature into core WordPress originally began in the <a href=\"https://core.trac.wordpress.org/ticket/48850\">plugin auto-updates</a> and <a href=\"https://core.trac.wordpress.org/ticket/49199\">theme auto-updates</a> Trac tickets.  The code contributed to those tickets are now in the feature plugin.  &ldquo;WordPress contributors did a lot of work on the two related tickets during WP 5.4 development cycle, but decided to give it more time for testing as it&rsquo;s an important feature,&rdquo; wrote Audras in the announcement.</p>\n\n\n\n<p>Development is currently taking place on Audras&rsquo;s <a href=\"https://github.com/audrasjb/wp-autoupdates\">GitHub repository</a>, but it may be moved to the official WordPress GitHub account.</p>\n\n\n\n<p>One of the primary goals of the project is to create an admin UI, which would give users the ability to manage how automatic updates work.  Users will be able to enable or disable auto-updates on a plugin-by-plugin and theme-by-theme basis.  This level of fine-grain control is welcome.  While I generally prefer to auto-update everything, I have been burned by specific plugins and themes in the past.  For those, I often prefer to update within a test environment first to be on the safe side.  Undoubtedly, other users may find themselves in a similar situation.  It is nice to see this being taken into account as a goal of the project.</p>\n\n\n\n<p>The project plans to set up email notifications for site administrators that will summarize any auto-updates that happen on the site.  There will also be hooks and PHP constants to allow plugin developers to take control of the update settings.</p>\n\n\n\n<p>As usual, most of the completed work on the automatic updates roadmap has gone toward plugins.  Just once, it would be nice to see a feature that crosses into both theme and plugin territory be completed for themes first.  I only hope that themes do not end up taking a backseat due to time constraints, development hurdles, or anything else.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 26 Feb 2020 21:11:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 06 Apr 2020 23:26:11 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Mon, 06 Apr 2020 23:15:09 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:9:\"HIT ord 1\";s:16:\"content-encoding\";s:4:\"gzip\";}}s:5:\"build\";s:14:\"20130911040210\";}','no');

INSERT INTO `wp_options` (`option_id`, `option_name`, `option_value`, `autoload`)
VALUES
	(142,'_transient_timeout_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9','1586258773','no'),
	(143,'_transient_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9','1586215573','no'),
	(144,'_transient_timeout_dash_v2_88ae138922fe95674369b1cb3d215a2b','1586258773','no'),
	(145,'_transient_dash_v2_88ae138922fe95674369b1cb3d215a2b','<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2020/04/the-month-in-wordpress-march-2020/\'>The Month in WordPress: March 2020</a></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wptavern.com/proposal-to-move-wordpress-theme-review-process-to-github?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=proposal-to-move-wordpress-theme-review-process-to-github\'>WPTavern: Proposal to Move WordPress Theme Review Process to GitHub</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/proposal-to-add-a-consent-api-to-wordpress-feature-plugin-available?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=proposal-to-add-a-consent-api-to-wordpress-feature-plugin-available\'>WPTavern: Proposal to Add a Consent API to WordPress, Feature Plugin Available</a></li><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2020/04/the-month-in-wordpress-march-2020/\'>WordPress.org blog: The Month in WordPress: March 2020</a></li></ul></div>','no'),
	(146,'_site_transient_update_themes','O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1586215608;s:7:\"checked\";a:4:{s:14:\"twentynineteen\";s:3:\"1.5\";s:15:\"twentyseventeen\";s:3:\"2.3\";s:13:\"twentysixteen\";s:3:\"2.1\";s:12:\"twentytwenty\";s:3:\"1.2\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}','no');

/*!40000 ALTER TABLE `wp_options` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table wp_postmeta
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_postmeta`;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;



# Dump of table wp_posts
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_posts`;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

LOCK TABLES `wp_posts` WRITE;
/*!40000 ALTER TABLE `wp_posts` DISABLE KEYS */;

INSERT INTO `wp_posts` (`ID`, `post_author`, `post_date`, `post_date_gmt`, `post_content`, `post_title`, `post_excerpt`, `post_status`, `comment_status`, `ping_status`, `post_password`, `post_name`, `to_ping`, `pinged`, `post_modified`, `post_modified_gmt`, `post_content_filtered`, `post_parent`, `guid`, `menu_order`, `post_type`, `post_mime_type`, `comment_count`)
VALUES
	(4,1,'2020-04-06 23:26:06','0000-00-00 00:00:00','','Auto Draft','','auto-draft','open','open','','','','','2020-04-06 23:26:06','0000-00-00 00:00:00','',0,'http://localhost:32880/?p=4',0,'post','',0);

/*!40000 ALTER TABLE `wp_posts` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table wp_term_relationships
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_term_relationships`;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;



# Dump of table wp_term_taxonomy
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_term_taxonomy`;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

LOCK TABLES `wp_term_taxonomy` WRITE;
/*!40000 ALTER TABLE `wp_term_taxonomy` DISABLE KEYS */;

INSERT INTO `wp_term_taxonomy` (`term_taxonomy_id`, `term_id`, `taxonomy`, `description`, `parent`, `count`)
VALUES
	(1,1,'category','',0,0);

/*!40000 ALTER TABLE `wp_term_taxonomy` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table wp_termmeta
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_termmeta`;

CREATE TABLE `wp_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;



# Dump of table wp_terms
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_terms`;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

LOCK TABLES `wp_terms` WRITE;
/*!40000 ALTER TABLE `wp_terms` DISABLE KEYS */;

INSERT INTO `wp_terms` (`term_id`, `name`, `slug`, `term_group`)
VALUES
	(1,'Uncategorized','uncategorized',0);

/*!40000 ALTER TABLE `wp_terms` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table wp_usermeta
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_usermeta`;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

LOCK TABLES `wp_usermeta` WRITE;
/*!40000 ALTER TABLE `wp_usermeta` DISABLE KEYS */;

INSERT INTO `wp_usermeta` (`umeta_id`, `user_id`, `meta_key`, `meta_value`)
VALUES
	(1,1,'nickname','admin'),
	(2,1,'first_name',''),
	(3,1,'last_name',''),
	(4,1,'description',''),
	(5,1,'rich_editing','true'),
	(6,1,'syntax_highlighting','true'),
	(7,1,'comment_shortcuts','false'),
	(8,1,'admin_color','fresh'),
	(9,1,'use_ssl','0'),
	(10,1,'show_admin_bar_front','true'),
	(11,1,'locale',''),
	(12,1,'wp_capabilities','a:1:{s:13:\"administrator\";b:1;}'),
	(13,1,'wp_user_level','10'),
	(14,1,'dismissed_wp_pointers',''),
	(15,1,'show_welcome_panel','1'),
	(30,1,'session_tokens','a:1:{s:64:\"fcc42273f0ce4cb1ae50b0a3385636c1321d13c7b14ea3c9acddaf4cee3111d8\";a:4:{s:10:\"expiration\";i:1586388362;s:2:\"ip\";s:10:\"172.23.0.1\";s:2:\"ua\";s:121:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.162 Safari/537.36\";s:5:\"login\";i:1586215562;}}'),
	(31,1,'wp_user-settings','libraryContent=browse&editor=html&mfold=o'),
	(32,1,'wp_user-settings-time','1586215561'),
	(33,1,'wp_dashboard_quick_press_last_post_id','4'),
	(34,1,'closedpostboxes_dashboard','a:1:{i:0;s:21:\"dashboard_site_health\";}'),
	(35,1,'metaboxhidden_dashboard','a:0:{}'),
	(36,1,'community-events-location','a:1:{s:2:\"ip\";s:10:\"172.23.0.0\";}');

/*!40000 ALTER TABLE `wp_usermeta` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table wp_users
# ------------------------------------------------------------

DROP TABLE IF EXISTS `wp_users`;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

LOCK TABLES `wp_users` WRITE;
/*!40000 ALTER TABLE `wp_users` DISABLE KEYS */;

INSERT INTO `wp_users` (`ID`, `user_login`, `user_pass`, `user_nicename`, `user_email`, `user_url`, `user_registered`, `user_activation_key`, `user_status`, `display_name`)
VALUES
	(1,'admin','$P$BFhgyyPQty5lNRQOryim2LgYCASQyz0','admin','anderson@publishpress.com','http://localhost:32880','2020-04-06 23:25:34','',0,'admin');

/*!40000 ALTER TABLE `wp_users` ENABLE KEYS */;
UNLOCK TABLES;



/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
